# ODEInterface

[![Travis](https://travis-ci.org/luchr/ODEInterface.jl.svg?branch=master)](https://travis-ci.org/luchr/ODEInterface.jl)
[![Build status](https://ci.appveyor.com/api/projects/status/bu702cga2ovlio5x/branch/master?svg=true)](https://ci.appveyor.com/project/luchr/odeinterface-jl/branch/master)
[![Coverage Status](https://coveralls.io/repos/github/luchr/ODEInterface.jl/badge.svg?branch=master)](https://coveralls.io/github/luchr/ODEInterface.jl?branch=master)


This julia module provides an interface to solvers for 
ordinary differential equations (ODEs) written in Fortran
for solving initial value problems (IVP) of the form

    x' = rhs(t,x),      x(t₀) = x₀

or (for solvers supporting a "mass matrix" M)

    M⋅x' = rhs(t,x),    x(t₀) = x₀.

Additionally a boundary value solver (called `bvpsol`) is
supported for boundary value problems (BVP) of the form

    x' = rhs(t,x),      r = bc( xa, xb ) = 0

## What does "Interface" mean?

This julia module does *not* contain code for solving initial value
problems, but this module does contain code for interacting with
compiled Fortran-solvers. That's the reason, why this module is not called
ODESuite. See the requirements below how to get to the compiled
Fortran-solvers.

## What solvers are currently supported?

Currently the following Fortran-solvers, written by
Prof. E. Hairer and Prof. G. Wanner, are supported:

* dopri5: explicit Runge-Kutta method of order 5(4) due to Dormand & Prince
* dop853: explicit Runge-Kutta method of order 8(5,3) due to Dormand & Prince
* odex: GBS extrapolation-algorithm based on the explicit midpoint rule
* radau5: implicit Runge-Kutta method (Radau IIA) of order 5
* radau: implicit Runge-Kutta method (Radau IIA) of variable order between 5 and 13
* seulex: extrapolation-algorithm based on the linear implicit Euler method
* rodas: Rosenbrock method of order 4(3) (with possibly singular mass matrix)

see [Software page of Prof. Hairer](http://www.unige.ch/~hairer/software.html).

Additionally the following Fortran-solvers from the
[SLATEC Common Mathematical Library](http://www.netlib.org/slatec/)
are supported:

* ddeabm: Adams-Bashforth-Moulton Predictor-Corrector method (order between 1 and 12)
* ddebdf: Backward Differentiation Formula (orders between 1 and 5)

Also supported:

* bvpsol: a boundary value problem solver for highly nonlinear two point
  boundary value problems using either a local linear solver or a global
  sparse linear solver. **Please note: The license for `bvpsol` only 
  covers non commercial use, see [License](./LICENSE.md).**
  Written by P. Deuflhard, G. Bader, L. Weimann, see
  [CodeLib at ZIB](http://elib.zib.de/pub/elib/codelib/en/bvpode.html).
* colnew: a multi-point boundary value problem solver for mixed order
  systems using collocation.
  Written by U. Ascher, G. Bader, see
  [Colnew Homepage](https://people.sc.fsu.edu/~jburkardt/f77_src/colnew/colnew.html)
* `BVP_M-2`: a boundary value problem solver for the numerical solution of
  boundary value ordinary differential equations with defect and global error control.
  Written by J. J. Boisvert, P.H. Muir and R. J. Spiteri, see
  [BVP_M-2 Page](http://cs.stmarys.ca/~muir/BVP_SOLVER_Webpage.shtml)

Description: [Calling the Solvers](./doc/CallSolvers.md) 

The following features of the IVP-solvers are supported by this ODEInterface:

* providing an [output function](./doc/OutputFunction.md) (e.g. 
for dense output or for event location) to the solvers
* providing mass- and jacobi-matrices for the solvers (with support for
banded matrices)
* all the solvers' parameters for fine-tuning them, 
see [Options for Solvers](./doc/SolverOptions.md) 
and [Option Overview](./doc/OptionOverview.md)
* support for problems with "special structure", 
see [special structure](./doc/SpecialStructure.md)

## What are the requirements for this module

This module needs the *compiled* Fortran solvers as shared libraries 
(i.e. `.so`, `.dylib` or `.dll` files, respectively). There are three ways
to get them:

* The package [ODEInterface_jll.jl](https://github.com/JuliaBinaryWrappers/ODEInterface_jll.jl) has precompiled solvers for different platforms. Julia 1.3 or newer is needed for this. This is the default behaviour for julia versions 1.3 or newer.
* The build-script of this module: It tries to use `gfortran` and compile the solver libraries. This is the default behaviour for julia versions less than 1.3.
* You compile the solvers yourself (perhaps with different options and/or a different compiler). In this case just call `ODEInterface.help_solversupport` for further informations (help topics) on how to compile the solvers and how to create shared libraries.

Please see the help for `ODEInterface.loadODESolves` how to ignore the 
precompiled `ODEInterface_jll` package and use the/your locally built libraries.

## Further help

see `ODEInterface.help_overview` for an overview of some help topics. 

## Examples

* basic examples can be found in [examples/BasicExamples](./examples/BasicExamples/)
* more advanced examples can be found in [examples/AdvancedExamples](./examples/AdvancedExamples/)
* the Reentry Problem of the Apollo11 mission can be found in [examples/ReentryOfApollo11](./examples/ReentryOfApollo11/)

## Contacting the author of this module

The author of this julia module is 

     Dr. Christian Ludwig
     email: ludwig@ma.tum.de
       (Faculty of Mathematics, Technische Universität München)

# More advanced examples using ODEInterface

Some well-known problems described in 

* Hairer, Nørsett, Wanner: Solving Ordinary Differential Equations I - Nonstiff Problems. Springer, 1993 and 
* Hairer, Wanner: Solving Ordinary Differential Equations II - Stiff and Differential-Algebraic Problems. Springer, 1996.

are solved using die ODEInterface. For the experiments and the results, see [Experiments.pdf](./Experiments.pdf). All these examples were coded and produced by Vishal Sontakke.

## Folder Codes

It contains the standalone Julia and iJulia Notebook files for the problems as well as the separate code for plotting the graphs as PNG.

## Folder ImagesAndPDFs and Folder texFiles

They contain all the files (e.g. the plots generated by the julia examples) used by Experiments.tex to produce [Experiments.pdf](./Experiments.pdf).

# Reentry_Apollo_11

The reentry problem for Apollo 11 type space vehicles, following Stoer/Bulirsch 1973; see
J. Stoer, R. Bulirsch, Introduction to Numerical Analysis, 3rd ed., Springer-Verlag, New York, §7.3.7 (pp. 565--572).

Based on the German version written by Prof. Folkmar Bornemann, for the lectures on Numerical Mathematics III at Technical University of Munich in the winter term 2002/2003 using MATLAB and Mex-Interfaces to BVPSOL. Translation to English and Julia
by Vishal Sontakke, April 2016.

Read the [Optimal_Control.pdf](./Optimal_Control.pdf) file for details.

#### Exercises:

1. Change the passage in the Maple script which restricts the control 'u' unnecessarily to the interval [-pi/2, pi/2]. What is the condition of the minimum principle now?
2. What will be the maneuver time and the value of J if the vehicle starts the maneuver with a flight path angle of -6.5 degrees?
3. Which flight path angle at time t=0 optimizes J? How large is the gain over that studied in the lecture (-8.1 degrees)?

If you think hard, no more than a handful of changes to the Maple script and the Julia files are to be made for solving (1)-(3).

#### Solutions:

1. The limitation of the range of u is avoided by
	```    
	U [solve]: = arctan (+ lambda [2] * c [3], + lambda [1] * x [1] * c [2]):
	```
	or
  	```
  	U [solve]: = arctan (-Lambda [2] * c [3], - lambda [1] * x [1] * c [2]):
  	```
    The Pontryagin's Minimum principle is always satisfied for the second option as compared to the first, where it is never satisfied. So we choose the second option. This also eliminates the condition `lambda[1] < 0`.

	How to choose now useful initial guesses of the adjoint variables?

2. The checking of the solution of the auxiliary problem for control values u ​​in the range [-pi/2, pi/2] should be removed. The auxiliary problem should be solved with backward shooting method.

3. One has to choose natural boundary conditions for gamma at t=0, that is, the associated adjoint variable has to be zero at t = 0. This requires the following changes:

	in reentry_bc.jl
    ```c
	r[2] = xa[5];
	```
    in reentry.jl

    before the solution of the optimal control problem, force natural boundary condition by
    ```c
    x[5,1] = 0;
	```

    Also, a few more multiple shooting nodes will not hurt.

    That's it.

using ODEInterface
@ODEInterface.import_huge

# We look at (again) the boundary value problem (see, ex6.jl)
#
#                       sin⁴(x)
#    ε⋅y'(x) = sin²(x)-λ──────  ;   y(-π/2)=y(π/2)=1
#                         y
#
# Here ε is given (e.g. ε=0.1) and λ is an unknown parameter.
#
# We use bvpm2 and a "homotopy": starting with ε=0.1, using this
# solution as start-guess for smaller ε.

a, b = -pi / 2, pi / 2

found_pyplot = true
try
    using PyPlot
catch
    found_pyplot = false
end

global ε = nothing
global ε_old = nothing
global sol_old = nothing

function rhs(x, y, p, f)
    return f[1] = (sin(x)^2 - p[1] * sin(x)^4 / y[1]) / ε
end

function Drhs(x, y, p, dfdy, dfdp)
    dfdy[1, 1] = (p[1] * sin(x)^4 / y[1]^2) / ε
    return dfdp[1, 1] = (-sin(x)^4 / y[1]) / ε
end

function bc(ya, yb, p, bca, bcb)
    bca[1] = ya[1] - 1.0
    return bcb[1] = yb[1] - 1.0
end

function Dbc(ya, yb, dya, dyb, p, dpa, dpb)
    dya[1, 1] = 1.0
    dyb[1, 1] = 1.0
    dpa[1, 1] = 0.0
    return dpb[1, 1] = 0.0
end

opt = OptionsODE(
    "example 7",
    OPT_RTOL => 1.0e-6,
    OPT_METHODCHOICE => 4,
)
xx = collect(linspace(a, b, 400));

initial_guess = Bvpm2()
bvpm2_init(initial_guess, 1, 1, collect(linspace(a, b, 20)), [0.5], [1.0])

sol = nothing
for ε in [0.1, 0.05, 0.02, 0.01]
    guess = sol_old !== nothing ? sol_old : initial_guess
    sol, retcode, stats = bvpm2_solve(guess, rhs, bc, opt, Drhs = Drhs, Dbc = Dbc)
    @printf("ε=%g, retcode=%i\n", ε, retcode)
    @assert retcode ≥ 0
    zz_new = evalSolution(sol, xx)
    if sol_old === nothing
        zz_old = copy(zz_new); zz_old[1, :] = 0.5
    else
        zz_old = evalSolution(sol_old, xx)
        bvpm2_destroy(sol_old)
    end
    if found_pyplot
        plot(xx, zz_old[1, :], xx, zz_new[1, :]);grid(true)
    end
    sol_old = sol; ε_old = ε
end

xx = collect(linspace(a, b, 9))
zz = evalSolution(sol, xx)
println("Solution at some points:")

display([ xx' ; zz[1, :]' ])
println()

bvpm2_destroy(initial_guess)
bvpm2_destroy(sol)

# vim:syn=julia:cc=79:fdm=indent:

# Basic functions for ODEInterface

"""
supported (signed) Integer types for Fortran codes.
"""
FortranInt = Union{Int32, Int64}

"""
dummy function returning nothing.
"""
function dummy_func()
    return nothing
end

"""
tests if `cand` is a number.
"""
function isscalar(cand)
    return isa(cand, Base.Number)
end

"""Bitmask: log nothing."""
const LOG_NOTHING = UInt64(0)

"""Bitmask: log some general info (esp. for main call)."""
const LOG_GENERAL = UInt64(1) << 0

"""Bitmask: log calls to right-hand side."""
const LOG_RHS = UInt64(1) << 1

"""Bitmask: log arguments passed to C/Fortran solvers."""
const LOG_SOLVERARGS = UInt64(1) << 2

"""Bitmask: log calls to solout function."""
const LOG_SOLOUT = UInt64(1) << 3

"""Bitmask: log calls to julia output function."""
const LOG_OUTPUTFCN = UInt64(1) << 4

"""Bitmask: log calls to eval_sol_fcn function."""
const LOG_EVALSOL = UInt64(1) << 5

"""Bitmask: log calls to mass function."""
const LOG_MASS = UInt64(1) << 6

"""Bitmask: log calls to jacobian function (of right-hand side)."""
const LOG_JAC = UInt64(1) << 7

"""Bitmask: log calls to boundary condition function."""
const LOG_BC = UInt64(1) << 8

"""Bitmask: during boundary value problems:
log calls to initial value solver."""
const LOG_BVPIVPSOL = UInt64(1) << 9

"""Bitmask: log calls to right-hand side derivative function."""
const LOG_RHSDT = UInt64(1) << 10

"""Bitmask: log calls to jacobian function of boundary-/side-conditions."""
const LOG_JACBC = UInt64(1) << 11

"""Bitmask: log calls to guess function."""
const LOG_GUESS = UInt64(1) << 12

"""Bitmask: log everything."""
const LOG_ALL = UInt64(0xFFFFFFFFFFFFFFFF)

"""
macro for importing all the LOG bitmasks.
"""
macro import_LOG()
    return :(
        using ODEInterface: LOG_NOTHING, LOG_GENERAL, LOG_RHS,
            LOG_SOLVERARGS, LOG_SOLOUT, LOG_OUTPUTFCN,
            LOG_EVALSOL, LOG_MASS, LOG_JAC, LOG_BC,
            LOG_BVPIVPSOL, LOG_RHSDT, LOG_JACBC,
            LOG_GUESS,
            LOG_ALL
    )
end

"""
     function getVectorCheckLength(vec,T::DataType,d::Integer,copy=true)
                       -> Vector{T}

try to convert to `Vector{T}` and checks given length.
If the `docopy` argument is `true` then the return value will
always be a different object than `vec`: If `convert` didn't need to
create a copy then this is done by this function.

throws ArgumentErrorODE this is not possible.
"""
function getVectorCheckLength(vec, T::DataType, d::Integer, docopy = true)
    result = nothing
    try
        result = convert(Vector{T}, vec)
    catch e
        throw(
            ArgumentErrorODE(
                string(
                    "Cannot convert vec with type ", typeof(vec),
                    " to Vector{", T, "}"
                ), :vec, e
            )
        )
    end
    length(result) != d && throw(
        ArgumentErrorODE(
            string("vec has wrong length: expected $d found ", length(result)), :vec
        )
    )
    if docopy && result ≡ vec
        result = copy(vec)
    end
    return result
end

"""
     function getMatrixCheckSize(mat,T::DataType,
                  m::Integer,n::Integer,docopy=true) -> Matrix{T}

try to convert to `Matrix{T}' and checks the size.
if the `docopy` argument is `true` then the return value will
always be a different object than `mat`: If `convert` didn't need
to create a copy then this is done by this function.

throws ArgumentErrorODE this is not possible.
"""
function getMatrixCheckSize(mat, T::DataType, m::Integer, n::Integer, docopy = true)
    result = nothing
    try
        result = convert(Matrix{T}, mat)
    catch e
        throw(
            ArgumentErrorODE(
                string(
                    "Cannot convert mat with type ", typeof(mat),
                    "to Matrix{", T, "}"
                ), :mat, e
            )
        )
    end
    size(mat, 1) ≠ m && throw(
        ArgumentErrorODE(
            string("mat has wrong number of rows: expedted $m found ", size(mat, 1)),
            :mat
        )
    )
    size(mat, 2) ≠ n && throw(
        ArgumentErrorODE(
            string("mat has wrong number of columns: expedted $n found ", size(mat, 2)),
            :mat
        )
    )
    if docopy && result ≡ mat
        result = copy(mat)
    end
    return result
end

"""
returns function view or function sub for generating views to arrays.
"""
function get_view_function()
    return isdefined(Base, :view) ? Base.view : Base.sub
end


"""
Type encapsulating all required data for ODE-Solver-Callbacks.
"""
abstract type ODEinternalCallInfos end

# vim:syn=julia:cc=79:fdm=indent:

# Load the required packages
using ODE
using JLD
using ForwardDiff

set_bigfloat_precision(113)

# Define the system for the solver
function vdpolAD(x)
    return [x[2], ((1 - x[1]^2) * x[2] - x[1]) * 1.0e6]
end

function vdpol(t, x)
    return vdpolAD(x)
end

function getJacobian(t, x)
    J = Matrix{BigFloat}(2, 2)
    J[:, :] = ForwardDiff.jacobian(vdpolAD, x)
    return J
end

# Set up the initial conditions
tSpan = collect(zero(BigFloat):parse(BigFloat, "11.0"));
x0 = [2 * one(BigFloat), zero(BigFloat)];

# Set the tolerances
Tol = parse(BigFloat, "1e-20");

# Solve and get the solution at T = tEnd
(t, x_tmp) = ode23s(
    vdpol, x0, tSpan;
    reltol = Tol, abstol = Tol, points = :specified,
    jacobian = getJacobian
);

x_ref = Array{BigFloat}(11);

for i in 1:11
    x_ref[i] = x_tmp[i + 1, 1][1]
end

# Save the solution to a file
save("refSolVDPOL.jld", "x_ref", x_ref);

# Functions and types for banded matrices

import Base: setindex!, getindex
import Base: dump, hash, size, ==, isequal, fill!, convert

"""macro, for importing Banded Matrix types."""
macro import_bandedmatrix()
    return :(
        using ODEInterface: BandedMatrix
    )
end

"""macro, for importing Banded Matrix types and functions."""
macro import_bandedmatrixfuncs()
    return :(
        using ODEInterface: BandedMatrix, full, setdiagonal!, setdiagonals!,
            createBandedMatrix
    )
end

"""
Type for storing and changing a banded matrix.

## Introduction (connections to proposal #8240)

This is a simple type for storing banded matrices in the band storage
format used by LAPACK:

     http://www.netlib.org/lapack/lug/node124.html

The emphasis here is on *storing* and *changing* the matrix elements,
because this is needed in the ODE-context.

This is *not* an attempt to fully implement efficient arithmetic
for banded matrices. This problem is discussed in proposal #8240:

     https://github.com/JuliaLang/julia/issues/8240

## What are banded matrices?

Take a look at the diaognals of a matrix, e.g.

     ⎛1 4 2    ⎞
     ⎜5 2 3 1  ⎟
     ⎜  4 3 0 0⎟
     ⎜    3 4 8⎟
     ⎝      2 5⎠

Then we give the following names to the diagonals:

               0  1 2 3  upper diagonals
                 ↘ ↘ ↘ ↘
               1  1╲4╲2╲0╲0
       lower     ↘╲ ╲ ╲ ╲ ╲          here: l = 1
     diagonals 2  5╲2╲3╲1╲0                u = 2
                 ↘╲ ╲ ╲ ╲ ╲
               3  0╲4╲3╲0╲0
                 ↘╲ ╲ ╲ ╲ ╲
                  0╲0╲3╲4╲8
                  ╲ ╲ ╲ ╲ ╲
                  0╲0╲0╲2╲5

The 0 diagonal is the main diagonal. The 1st diagonal above this main
diagonal is called the 1st upper diagonal, etc.
The 1st digonal below the main diagonal is called the 1st lower diagonal.

A matrix has lower bandwidth l, if all diagonals below the l lower diagonal
have only zeros. In the above example the matrix has lower bandwidth l=1
because the 2nd, 3rd and 4th lower diagonals are all zero.

A matrix has upper bandwidth u, if all diagonals above the u upper diagonal
have only zeros. In the above example the matrix has upper bandwidth u=2.

A m×n matrix (with m,n ≥ 2) is called banded, if it has a
lower bandwidth l<m-2 and/or a upper bandwidth u<n-2.

## What is this type for?

This types stores banded matrices. There are functions for banded matrices
to make it easy to query and change the elements of a banded matrix.

## Why is this type immutable? Can the entries be changed?

A banded matrix is immutable, i.e. the structure (the upper and lower
bandwidths cannot be changed). The entries of a banded matrix are *not*
immutable.

For an explanation of the storage format, see the help of
`BandedMatrix_storage`.

There is a constructor, where you can give the entries array for
the non-zero elements (diagonals) as input argument.
"""
struct BandedMatrix{T} <: AbstractMatrix{T}
    m::Integer               # number of rows of banded matrix
    n::Integer               # number of columns
    #    currently: n == size(entries,2)
    l::Integer               # lower bandwidth
    u::Integer               # upper bandwidth
    entries::AbstractArray{T}      # array with entries

    function BandedMatrix{T}(
            m::Integer, n::Integer, l::Integer, u::Integer,
            entries::AbstractArray{T}
        ) where {T}
        m ≥ 1 || throw(ArgumentErrorODE("requirement m≥1", :m))
        n ≥ 1 || throw(ArgumentErrorODE("requirement n≥1", :n))
        l ≥ 0 || throw(ArgumentErrorODE("requirement l≥0", :l))
        u ≥ 0 || throw(ArgumentErrorODE("requirement u≥0", :u))
        l + 1 > m &&
            throw(ArgumentErrorODE("requirement: l=$l ≤ m-1 = $m -1", :l))
        u + 1 > n &&
            throw(ArgumentErrorODE("requirement: u=$u ≤ n-1 = $n - 1", :u))
        es = size(entries)
        es ≠ (1 + l + u, n) &&
            throw(
            ArgumentErrorODE(
                "requirement: $es=size(entries) == (1+l+u,n); l=$l, u=$u, n=$n",
                :entries
            )
        )
        fill!(entries, zero(T))
        return new{T}(m, n, l, u, entries)
    end
end

"""
## How are the non-zero entries stored (in this type)?

If M is a m×n matrix with upper bandwidth u and lower bandwidth l, then
the non-zero entries are saved in a (1+l+u)×n matrix N with

     N(i-j+u+1,j) = M(i,j) with

      max(1,j-u) ≤ i ≤ min(m,l+j)  ⎫   ⎧ -u ≤ i-j ≤ l
                                   ⎬ ⇔ ⎨  1 ≤ i   ≤ m
      max(1,i-l) ≤ j ≤ max(n,u+i)  ⎭   ⎩  1 ≤ j   ≤ n

This is the storage format described in the following URL.

     http://www.netlib.org/lapack/lug/node124.html

This is not the place to discuss, if a (1+l+u)×min(m,n) matrix is a better
format for storing the diagonals.

     M(i,j) = N(i-j+u+1,j)
     N(r,s) = M(r+s-1-u,s)

There can be entries in the matrix N that do *not* correspond to entries
in M. In this type they are also zero. Great care is taken not to change
this zeros in order not to violate the `==` and `hash` "contract": Because
this uncorresponding entries cannot be seen in M, they should have no
effect on the hash and on the `==` relation.

Keep in mind: There are two different ways of numbering the diagonals.
The (internal) form ranging from 1 to 1+u+l and the user-friendly form
ranging von -l ≤ d ≤ u, see `BandedMatrix`.

For the example

     ⎛1 4 2    ⎞
     ⎜5 2 3 1  ⎟
     ⎜  4 3 0 0⎟
     ⎜    3 4 8⎟
     ⎝      2 5⎠

one can visualize this storage format like this:

      *╲
      ╲│╲
      *╲*╲
      ╲│╲│╲
     ⎛1╲4╲2╲⋅ ⋅⎞
     ⎜╲│╲│╲│╲  ⎟       ⎛* * 2 1 0⎞      here: l = 1,  u = 2
     ⎜5╲2╲3╲1╲⋅⎟    ≅  ⎜* 4 3 0 8⎟
     ⎜╲│╲│╲│╲│╲⎟       ⎜1 2 3 4 5⎟      ⋅ : not saved "0"
     ⎜⋅╲4╲3╲0╲0⎟       ⎝5 4 3 2 *⎠      * : unused slot in storage format
     ⎜  ╲│╲│╲│╲⎟
     ⎜⋅ ⋅╲3╲4╲8⎟
     ⎜    ╲│╲│╲⎟
     ⎝⋅ ⋅ ⋅╲2╲5⎠
            ╲│╲
             ╲*

"""
const BandedMatrix_storage = nothing

function BandedMatrix(m::Integer, n::Integer, l::Integer, u::Integer, initval::Number)
    me = max(0, 1 + l + u)
    ne = max(0, n)
    bm = BandedMatrix{typeof(initval)}(
        m, n, l, u,
        Matrix{typeof(initval)}(undef, me, ne)
    )
    fill!(bm, initval)
    return bm
end

function hash(bm::BandedMatrix, h::UInt)
    return hash(bm.l, hash(bm.u, hash(bm.m, hash(bm.n, hash(bm.entries, h)))))
end

function ==(bm1::BandedMatrix, bm2::BandedMatrix)
    return (bm1.m == bm2.m) && (bm1.n == bm2.n) &&
        (bm1.l == bm2.l) && (bm1.u == bm2.u) && (bm1.entries == bm2.entries)
end

function isequal(bm1::BandedMatrix, bm2::BandedMatrix)
    return (bm1.m == bm2.m) && (bm1.n == bm2.n) &&
        (bm1.l == bm2.l) && (bm1.u == bm2.u) &&
        isequal(bm1.entries, bm2.entries)
end

function size(bm::BandedMatrix)
    return (bm.m, bm.n)
end

function size(bm::BandedMatrix, d::Integer)
    if d < 1
        throw(ArgumentErrorODE("requirement: d ≥ 1, d=$d", :d))
    end
    return 1 == d ? bm.m : 2 == d ? bm.n : 1
end

"""
The columns in `bm.entries` for diagonal 1 ≤ d ≤ 1+l+u.
"""
function rangeofdiag(bm::BandedMatrix, d::Integer)
    return max(1, 2 + bm.u - d):min(bm.n, bm.m + bm.u + 1 - d)
end

"""
tests if `(i,j)` is in the matrix and in the diagonal bands.
"""
function isvalidinband(bm, i, j)
    return (1 ≤ i ≤ bm.m) && (1 ≤ j ≤ bm.n) && (-bm.u ≤ i - j ≤ bm.l)
end

"""
tests if `(i,j)` is in the diagonal bands.

Caution: This methods does *not* test, if `i` and `j` are
inside the matrix bounds. Only the diagonal bounds are checked.

This method should only be used, if the matrix bounds/dimensions
have been checked before.
"""
function isinband(bm, i, j)
    return (-bm.u ≤ i - j ≤ bm.l)
end

function fill!(bm::BandedMatrix, x)
    for d in 1:(1 + bm.u + bm.l)
        bm.entries[d, rangeofdiag(bm, d)] .= x
    end
    return bm
end

"""
sets the diagonal with number `d` (0 is the main diagonal,see
`BandedMatrix`) to the given values.
"""
function setdiagonal!(bm::BandedMatrix, d::Integer, value)
    (-bm.l ≤ d ≤ bm.u) || throw(
        ArgumentErrorODE(
            string(
                "requirement: -l ≤ d ≤ u; d=$d, u=", bm.u, " l=", bm.l
            ), :d
        )
    )
    dIndex = 1 + bm.u - d
    ra = rangeofdiag(bm, dIndex)
    if isa(value, AbstractArray)
        length(ra) == length(value) || throw(
            ArgumentErrorODE(
                string(
                    "for d=$d expected length ", length(ra), "; but found ", length(value)
                ),
                :value
            )
        )
        bm.entries[dIndex, ra] = value
    else
        bm.entries[dIndex, ra] .= value
    end
    return value
end

"""
sets all diagonals at once. `values` must be a 1+u+l cell-array with
the diagonals starting with the upper right one.
"""
function setdiagonals!(bm::BandedMatrix, values::AbstractArray)
    if length(values) ≠ 1 + bm.u + bm.l
        throw(
            ArgumentErrorODE(
                string(
                    "expected a 1+u+l=",
                    1 + bm.u + bm.l, " array, got length ", length(values)
                ), :values
            )
        )
    end
    d = bm.u
    for value in values
        setdiagonal!(bm, d, value)
        d -= 1
    end
    return values
end

"""
sets all diagonals at once copy the diagonals from an other BandedMatrix.
The other Bandedmatrix must have the same size and same upper and
lower bandwidth.
"""
function setdiagonals!(bm::BandedMatrix{T}, other::BandedMatrix{T}) where {T}
    if bm.m ≠ other.m || bm.n ≠ other.n ||
            bm.u ≠ other.u || bm.l ≠ other.l
        throw(
            ArgumentErrorODE(
                string(
                    "bm has size ", size(bm),
                    " and l=", bm.l, ", u=", bm.u, "; but other has size ", size(other),
                    " and l=", other.l, ", u=", other.u
                ), :other
            )
        )
    end
    bm.entries[:] = other.entries
    return other
end

"""
For banded matrices: checks if inds are in bands.
"""
function setindex!(bm::BandedMatrix, value, i::Integer, j::Integer)
    isvalidinband(bm, i, j) || throw(BoundsError(bm, (i, j)))
    return bm.entries[1 + bm.u + i - j, j] = value
end

function setindex!(bm::BandedMatrix, value, ra::UnitRange, j::Integer)
    (isvalidinband(bm, ra.start, j) && isvalidinband(bm, ra.stop, j)) ||
        throw(BoundsError(bm, (ra, j)))
    return bm.entries[(ra.start + bm.u + 1 - j):(ra.stop + bm.u + 1 - j), j] = value
end

function setindex!(bm::BandedMatrix, value, i::Integer, ra::UnitRange)
    (isvalidinband(bm, i, ra.start) && isvalidinband(bm, i, ra.stop)) ||
        throw(BoundsError(bm, (i, ra)))
    ni = i + bm.u + 1 - ra.start; nj = ra.start
    for k in 1:length(ra)
        bm.entries[ni, nj] = isa(value, Number) ? value : value[k]
        ni -= 1; nj += 1
    end
    return
end

function setindex!(bm::BandedMatrix, value, zra::UnitRange, sra::UnitRange)
    (
        isvalidinband(bm, zra.start, sra.start) &&
            isvalidinband(bm, zra.stop, sra.stop)
    ) || throw(BoundsError(bm, (zra, sra)))
    s = 1
    for nj in sra
        ni = zra.start + bm.u + 1 - nj
        for z in 1:length(zra)
            bm.entries[ni, nj] = isa(value, Number) ? value : value[z, s]
            ni += 1
        end
        s += 1
    end
    return
end

function getindex(bm::BandedMatrix{T}, i::Integer, j::Integer) where {T}
    ((1 ≤ i ≤ bm.m) && (1 ≤ j ≤ bm.n)) || throw(BoundsError(bm, (i, j)))
    return isinband(bm, i, j) ? bm.entries[i - j + bm.u + 1, j] : zero(T)
end

function getindex(bm::BandedMatrix{T}, ind::Integer) where {T}
    (j, i) = divrem(ind - 1, bm.m)
    return getindex(bm, i + 1, j + 1)
end

"""
     function isdiagonalempty(A::AbstractArray{T,2},d::Integer)

method to check if all entries in a diagonal are zero.
"""
function isdiagonalempty(A::AbstractMatrix{T}, d::Integer) where {T}
    (m, n) = size(A)
    i = (d ≥ 0) ? 1 : 1 - d
    j = (d ≥ 0) ? 1 + d : 1
    z = zero(T)
    while true
        (A[i, j] ≠ z) && return false
        i += 1; j += 1
        (i > m || j > n) && break
    end
    return true
end

"""
convert full matrix to BandedMatrix.
"""
function createBandedMatrix(A::AbstractMatrix{T}) where {T}
    (m, n) = size(A)
    # find last upper diagonal with nonzero entry
    d = n - 1
    while d > 0
        !isdiagonalempty(A, d) && break
        d -= 1
    end
    u = d

    # find last lower diagonal with nonzero entry
    d = -(m - 1)
    while d < 0
        !isdiagonalempty(A, d) && break
        d += 1
    end
    l = -d

    bm = BandedMatrix(m, n, l, u, zero(T))
    for j in 1:bm.n
        for i in max(1, j - bm.u):min(bm.l + j, bm.m)
            bm.entries[i + bm.u + 1 - j, j] = A[i, j]
        end
    end

    return bm
end


"""
Convert banded matrix `bm` to full matrix. Save full matrix values in `f`.

`f` must have the right size.
"""
function fullToArray(bm::BandedMatrix{T}, f::AbstractArray{T}) where {T}
    if size(f) ≠ (bm.m, bm.n)
        throw(
            ArgumentErrorODE(
                string(
                    "f has wrong size ", size(f),
                    "extexted ", (bm.m, bm.n)
                ), :f
            )
        )
    end
    fill!(f, 0)
    for j in 1:bm.n
        for i in max(1, j - bm.u):min(bm.l + j, bm.m)
            f[i, j] = bm.entries[i + bm.u + 1 - j, j]
        end
    end
    return f
end

"""
For banded matrices: generate and return full/dense matrix.
"""
function full(bm::BandedMatrix{T}) where {T}
    return fullToArray(bm, Array{T}(undef, (bm.m, size(bm.entries, 2))))
end

function dump(io::IO, bm::BandedMatrix, n::Integer, indent)
    println(io, typeof(bm), " ", bm.m, "×", bm.n, "; l=", bm.l, " and u=", bm.u)
    return if n > 0
        print(io, indent, "  entries in diagonals ")
        dump(io, bm.entries, n - 1, string(indent, "  "))
    end
end


# vim:syn=julia:cc=79:fdm=indent:

using ODEInterface
@ODEInterface.import_huge

loadODESolvers()

function myoutputfcn(reason, told, t, x, eval_sol_func, extra_data)
    println("myoutputfcn called with reason=$reason, told=$told, t=$t, x=$x")
    return OUTPUTFCN_RET_CONTINUE
end

opt = OptionsODE(
    OPT_RTOL => 1.0e-8,
    OPT_ATOL => 1.0e-3,
    OPT_OUTPUTFCN => myoutputfcn,
    OPT_OUTPUTMODE => OUTPUTFCN_WODENSE,
)

(t, x, retcode, stats) = odecall(dopri5, (t, x) -> x, [0, 2], [1, 2], opt)

println("retcode=$retcode")
println("t=$t");
println("x=", x);
println("stats:");display(stats);println();


# vim:syn=julia:cc=79:fdm=indent:

# Functions for Boundary-Value Solver: Colsys/Colnew

"""Name for Loading colnew solver (64bit integers)."""
const DL_COLNEW               = "colnew"

"""Name for Loading colnew solver (32bit integers)."""
const DL_COLNEW_I32           = "colnew_i32"

"""macro for import colnew solver."""
macro import_colnew()
  :(
    using ODEInterface: colnew, colnew_i32, evalSolution, getSolutionGrid
  )
end

"""macro for import colnew dynamic lib names."""
macro import_DLcolnew()
  :(
    using ODEInterface: DL_COLNEW, DL_COLNEW_I32
  )
end

"""macro for importing Colnew help."""
macro import_colnew_help()
  :(
    using ODEInterface: help_colnew_compile, help_colnew_license
  )
end

"""
  colnew does not support "pass-through" arguments for FSUB, DFSUB,
  GSUB, DGSUB, GUES.
  Hence we can only support one colnew-call at a time.
  """
colnew_global_cbi = nothing

"""
  Type encapsulating all required data for colnew-Callbacks.

  Unfortunately colnew.f does not support passthrough arguments.

  We have the typical calling stack:

  """
mutable struct ColnewInternalCallInfos{FInt<:FortranInt,
        RHS_F, DRHS_F, BC_F, DBC_F, GUESS_F} <: ODEinternalCallInfos
  logio        :: IO                    # where to log
  loglevel     :: UInt64                # log level
  n            :: FInt                  # number of ODEs
  d            :: FInt                  # dimension of (1st-order) system
  # RHS:
  rhs          :: RHS_F                 # right-hand-side of ODEs
  rhs_lprefix  :: AbstractString        # saved log-prefix for rhs
  rhs_count    :: Int                   # count: number of calls to rhs
  # DRHS:
  Drhs         :: DRHS_F                # Jacobian of rhs
  Drhs_lprefix :: AbstractString        # saved log-prefix for Drhs
  Drhs_count   :: Int                   # count: number of calls to Drhs
  # BC:
  bc           :: BC_F                  # side conditions (at ζ)
  bc_lprefix   :: AbstractString        # saved log-prefix for bc
  bc_count     :: Int                   # count: number of calls to bc
  # DBC:
  Dbc          :: DBC_F                 # Jacobian of side conditions
  Dbc_lprefix  :: AbstractString        # saved log-prefix for Dbc
  Dbc_count    :: Int                   # count: number of calls to Dbc
  # guess:
  guess        :: GUESS_F               # Function for guess
  guess_lprefix:: AbstractString        # saved log-prefix for guess
end

mutable struct ColnewArguments{FInt<:FortranInt} <: AbstractArgumentsODESolver{FInt}
  NCOMP   :: Vector{FInt}      # number of diff. equations
  M       :: Vector{FInt}      # order of the j-th diff. eq.
  ALEFT   :: Vector{Float64}   # left end of (time-)interval
  ARIGHT  :: Vector{Float64}   # right end of (time-)interval
  ZETA    :: Vector{Float64}   # j-th side condition point
  IPAR    :: Vector{FInt}      # (integer) parameters
  LTOL    :: Vector{FInt}      # assign TOL[j] to component of Z(U)
  TOL     :: Vector{Float64}   # tolerances
  FIXPNT  :: Vector{Float64}   # points to be included in all meshes
  ISPACE  :: Vector{FInt}      # integer work space
  FSPACE  :: Vector{Float64}   # floating-point work space
  IFLAG   :: Vector{FInt}      # return-code of colnew
    ## Allow uninitialized construction
  function ColnewArguments{FInt}(dummy::FInt) where FInt
    return new{FInt}()
  end
end

mutable struct ColnewSolution{FInt<:FortranInt} <: AbstractODESolution{FInt}
  method_appsln :: Ptr{Cvoid}  # Ptr to Fortran-method for solution eval
  t_a     :: Float64           # a
  t_b     :: Float64           # b
  n       :: FInt              # number of ODEs
  d       :: FInt              # dimension of (1st-order) system
  ISPACE  :: Vector{FInt}      # part of integer work-space
  FSPACE  :: Vector{Float64}   # solution coefficients extracted from FSPACE
end


"""
  This function calls `rhs` saved in ColnewInternalCallInfos.
  """
function colnew_rhs(t, z, f, cbi::CI) where CI
  lprefix = cbi.rhs_lprefix
  (lio,l)=(cbi.logio,cbi.loglevel)
  l_rhs = l & LOG_RHS > 0

  cbi.rhs_count += 1

  l_rhs && println(lio, lprefix, "called with t=", t, " z=", z)
  cbi.rhs(t, z, f)
  l_rhs && println(lio, lprefix, "rhs result=", f)
  return nothing
end

"""
        function unsafe_colnew_rhs(t_::Ptr{Float64}, z_::Ptr{Float64},
          f_::Ptr{Float64})

  This is the right-hand side given as callback to colnew.

  The `unsafe` prefix in the name indicates that no validations are
  performed on the `Ptr`-arguments.
  """
function unsafe_colnew_rhs(t_::Ptr{Float64}, z_::Ptr{Float64},
  f_::Ptr{Float64})

  cbi = colnew_global_cbi :: ColnewInternalCallInfos
  n = cbi.n; d = cbi.d

  t = unsafe_load(t_)
  z = unsafe_wrap(Array, z_, (d,), own=false)
  f = unsafe_wrap(Array, f_, (n,), own=false)

  colnew_rhs(t, z, f, cbi)
  return nothing
end

function unsafe_colnew_rhs_c(fint_flag::FInt) where FInt
  return @cfunction(unsafe_colnew_rhs, Cvoid,
    (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}))
end

"""
  This function calls `Drhs` saved in ColnewInternalCallInfos.
  """
function colnew_Drhs(t, z, df, cbi::CI) where CI
  lprefix = cbi.Drhs_lprefix
  (lio,l)=(cbi.logio,cbi.loglevel)
  l_Drhs = l & LOG_JAC > 0

  cbi.Drhs_count += 1

  l_Drhs && println(lio, lprefix, "called with t=", t, " z=", z)
  cbi.Drhs(t, z, df)
  l_Drhs && println(lio, lprefix, "Drhs result=", df)
  return nothing
end

"""
        function unsafe_colnew_Drhs(t_::Ptr{Float64}, z_::Ptr{Float64},
          df_::Ptr{Float64})

  This is the Jacobian for the right-hand side given as callback to colnew.

  The `unsafe` prefix in the name indicates that no validations are
  performed on the `Ptr`-arguments.
  """
function unsafe_colnew_Drhs(t_::Ptr{Float64}, z_::Ptr{Float64},
  df_::Ptr{Float64})

  cbi = colnew_global_cbi :: ColnewInternalCallInfos
  n = cbi.n; d = cbi.d

  t = unsafe_load(t_)
  z = unsafe_wrap(Array, z_, (d,), own=false)
  df = unsafe_wrap(Array, df_, (n,d,), own=false)

  colnew_Drhs(t, z, df, cbi)
  return nothing
end

function unsafe_colnew_Drhs_c(fint_flag::FInt) where FInt
  return @cfunction(unsafe_colnew_Drhs, Cvoid,
    (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}))
end

"""
  This function calls `bc` saved in ColnewInternalCallInfos.
  """
function colnew_bc(i, z, bc, cbi::CI) where CI
  lprefix = cbi.bc_lprefix
  (lio,l)=(cbi.logio,cbi.loglevel)
  l_bc = l & LOG_BC > 0

  cbi.bc_count += 1

  l_bc && println(lio, lprefix, "called with i=", i, " z=", z)
  cbi.bc(i, z, bc)
  l_bc && println(lio, lprefix, "bc result=", bc)
  return nothing
end

"""
       function unsafe_colnew_bc(i_::Ptr{FInt},
         z_::Ptr{Float64}, bc_::Ptr{Float64}) where FInt<:FortranInt

  This is the side-/boundary-conditions given as callback
  to colnew.

  The `unsafe` prefix in the name indicates that no validations are
  performed on the `Ptr`-arguments.
  """
function unsafe_colnew_bc(i_::Ptr{FInt},
  z_::Ptr{Float64}, bc_::Ptr{Float64}) where FInt<:FortranInt

  cbi = colnew_global_cbi :: ColnewInternalCallInfos
  d = cbi.d

  i = unsafe_load(i_)
  z = unsafe_wrap(Array, z_, (d,), own=false)
  bc = unsafe_wrap(Array, bc_, (1,), own=false)

  colnew_bc(i, z, bc, cbi)
  return nothing
end

function unsafe_colnew_bc_c(fint_flag::FInt) where FInt
  return @cfunction(unsafe_colnew_bc, Cvoid,
    (Ptr{FInt}, Ptr{Float64}, Ptr{Float64}))
end

"""
  This function calls `Dbc` saved in ColnewInternalCallInfos.
  """
function colnew_Dbc(i, z, dbc, cbi::CI) where CI
  lprefix = cbi.Dbc_lprefix
  (lio,l)=(cbi.logio,cbi.loglevel)
  l_Dbc = l & LOG_JACBC > 0

  cbi.Dbc_count += 1

  l_Dbc && println(lio, lprefix, "called with i=", i, " z=", z)
  cbi.Dbc(i, z, dbc)
  l_Dbc && println(lio, lprefix, "Dbc result=", dbc)
  return nothing
end

"""
       function unsafe_colnew_Dbc(i_::Ptr{FInt},
         z_::Ptr{Float64}, Dbc_::Ptr{Float64}) where FInt<:FortranInt

  This is the jacobian for the side-/boundary-conditions given as callback
  to colnew.

  The `unsafe` prefix in the name indicates that no validations are
  performed on the `Ptr`-arguments.
  """
function unsafe_colnew_Dbc(i_::Ptr{FInt},
  z_::Ptr{Float64}, Dbc_::Ptr{Float64}) where FInt<:FortranInt

  cbi = colnew_global_cbi :: ColnewInternalCallInfos
  d = cbi.d

  i = unsafe_load(i_)
  z = unsafe_wrap(Array, z_, (d,), own=false)
  Dbc = unsafe_wrap(Array, Dbc_, (d,), own=false)

  colnew_Dbc(i, z, Dbc, cbi)
  return nothing
end

function unsafe_colnew_Dbc_c(fint_flag::FInt) where FInt
  return @cfunction(unsafe_colnew_Dbc, Cvoid,
    (Ptr{FInt}, Ptr{Float64}, Ptr{Float64}))
end

"""
  This function calls `guess` saved in ColnewInternalCallInfos.
  """
function colnew_guess(t, z, dxm, cbi::CI) where CI
  lprefix = cbi.guess_lprefix
  (lio,l)=(cbi.logio,cbi.loglevel)
  l_guess = l & LOG_GUESS > 0

  l_guess && println(lio, lprefix, "called with t=", t)
  cbi.guess(t, z, dxm)
  l_guess && println(lio, lprefix, "guess z-result=", z, "dxm-result=", dxm)
  return nothing
end

"""
  This is the guess function given as callback to colnew.

  The `unsafe` prefix in the name indicates that no validations are
  performed on the `Ptr`-arguments.
  """
function unsafe_colnew_guess(t_::Ptr{Float64}, z_::Ptr{Float64},
  dmx_::Ptr{Float64})

  cbi = colnew_global_cbi :: ColnewInternalCallInfos
  n = cbi.n; d = cbi.d

  t = unsafe_load(t_)
  z = unsafe_wrap(Array, z_, (d,), own=false)
  dmx = unsafe_wrap(Array, dmx_, (n,), own=false)

  colnew_guess(t, z, dmx, cbi)
  return nothing
end

function unsafe_colnew_guess_c(fint_flag::FInt) where FInt
  return @cfunction(unsafe_colnew_guess, Cvoid,
    (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}))
end


"""
        function colnew(interval::Vector, orders::Vector, ζ::Vector,
          rhs, Drhs,
          bc, Dbc, guess, opt::AbstractOptionsODE)
            -> (sol, retcode, stats)

  Solve multi-point boundary value problem with colnew.

  ζ∊ℝᵈ with a ≤ ζ(1)=ζ₁ ≤ ζ(2)=ζ₂ ≤ ⋯ ≤ ζ(d) ≤ b are the (time-)points
  were side/boundary conditions are given:

             bc₁   bc₂       bc₃                 bcⱼ(ζⱼ, z(x(ζⱼ))) = 0
              ∙     ∙         ∙  ⋯

        ├─────┼─────┼─────────┼─....───┼─────┤
       t=a  t=ζ(1) t=ζ(2)    t=ζ(3)  t=ζ(d)  t=b

  for the n ODEs
         ∂xᵢ
        ──────  = xᵢ⁽ᵐ⁽ⁱ⁾⁾ = fᵢ(t, z(x(t))          (i=1,2,…,n)   [*]
        ∂tᵐ⁽ⁱ⁾

  where the i-th ODE has order m(i). [x(t)∊ℝⁿ].

  z is the transformation to first order:
  z(x(t))∊ℝᵈ is the "first-order" state one gets if the n ODEs [*]
  are transformed to a first-order system:

       z(x(t)) = ( x₁(t), x₁'(t), x₁''(t), …, x₁⁽ᵐ⁽¹⁾⁻¹⁾,
                   x₂(t), x₂'(t), x₂''(t), …, x₂⁽ᵐ⁽²⁾⁻¹⁾,
                   ⋯                                    ,
                   xₙ(t), xₙ'(t), xₙ''(t), …, xₙ⁽ᵐ⁽ⁿ⁾⁻¹⁾  )

  Hence one has the requirement: ∑m(i) = d.

  The boundary-/side-conditions at the points ζⱼ=ζ(j) are given in the form

       bcⱼ(ζⱼ, z(x(ζⱼ))) = 0                         (j=1,2,…,d)

  Restrictions (in the colnew code):

  * at maximum 20 ODEs: n ≤ 20
  * at maximum 40 dimensions: d ≤ 40
  * The orders m(i) have to satisfy: 1 ≤ m(i) ≤ 4   for all i=1,2,…,n.

  All (Julia-)callback-functions (like rhs, etc.) use the in-situ call-mode,
  i.e. they have to write the result in a preallocated vector.

  ## rhs

  `rhs` must be a function of the form

      function rhs(t, z, f)

  with the input data: t (scalar) time and z∈ℝᵈ (z=z(x(t))).
  The values of the right-hand side have to be saved in f: f∈ℝⁿ!
  Only the non-trivial parts of the right-hand side must be calculated.

  ## Drhs

  `Drhs` must be a function of the form

      function Drhs(t, z, df)

  with the input data: t (scalar) time and z∈ℝᵈ (z=z(x(t))).
  The values of the jacobian of the right-hand side have to be saved
  in df: df∈ℝⁿˣᵈ!

                 ∂fᵢ
      df(i,j) = ─────      (i=1,…,n;  j=1,…,d)
                 ∂zⱼ

  ## bc

  `bc` must be a function of the form

      function bc(i, z, bc)

  with the input data: integer index i and z∈ℝᵈ (z=z(x(t))).
  The scalar(!) value of the i-th side-condition (at time ζ(i)) has to
  be saved in bc, which is a vector of length 1.

  ## Dbc

  `Dbc` must be a function of the form

      function Dbc(i, z, dbc)

  with the input data: integer index i and z∈ℝᵈ (z=z(x(t))).
  The  values of the derivative of the i-th side-condition
  (at time ζ(i)) has to be saved in dbc:

                ∂bcᵢ
      dbc(j) = ─────      (j=1,…,d)
                ∂zⱼ

  ## guess

  `guess` can be `nothing`, i.e. no initial guess given. Or
  `guess` can be the sol return value of an earilier call of `colnew`. In
  such a case the former mesh and the former solution is taken as an
  initial guess (or is coarsen, see `OPT_COARSEGUESSGRID`).

  Or `guess` is a function of the form

      function guess(t, z, dmx)

  with the input data t∈[a,b]. Guesses are needed for the following
  values: z=z(x(t))∈ℝᵈ and

                ∂xᵢ
      dmx(i) = ────────      (i=1,…,n)
                ∂tᵐ⁽ⁱ⁾

  ## return values

  `sol` is a solution object which can be evaluated with the
  `evalSolution` functions. Or you can ask for the (final) grid
  of the solution with `getSolutionGrid`.

  `retcode` can have to following values:

        >0: computation successful
         0: collocation matrix is singular
        -1: the expected no. of subintervals exceeds storage
            (try to increase `OPT_MAXSUBINTERVALS`)
        -2: the nonlinear iteration has not converged
        -3: there is an input data error

  In `opt` the following options are used:

      ╔═════════════════╤══════════════════════════════════════════╤═════════╗
      ║  Option OPT_…   │ Description                              │ Default ║
      ╠═════════════════╪══════════════════════════════════════════╪═════════╣
      ║ BVPCLASS        │ boundary value problem classification:   │       1 ║
      ║                 │ 0: linear                                │         ║
      ║                 │ 1: nonlinear and regular                 │         ║
      ║                 │ 2: nonlinear and "extra sensitive"       │         ║
      ║                 │    (first relax factor is rstart and the │         ║
      ║                 │    nonlinear iteration does not rely     │         ║
      ║                 │    on past convergence)                  │         ║
      ║                 │ 3: fail-early: return immediately upon   │         ║
      ║                 │    (a) two successive non-convergences   │         ║
      ║                 │        or                                │         ║
      ║                 │    (b) after obtaining an error estimate │         ║
      ║                 │        for the first time                │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ RTOL            │ relative *and* absolute accuracy for     │    1e-6 ║
      ║                 │ solution. Must be a vector of length d.  │         ║
      ║                 │ If a scalar is given (like the default   │         ║
      ║                 │ value of 1e-6) then the vector           │         ║
      ║                 │    RTOL*ones(Float64, d)                 │         ║
      ║                 │ is generated.                            │         ║
      ║                 │ Some entries can be NaN! If an entry     │         ║
      ║                 │ is NaN, then no error checking is done   │         ║
      ║                 │ for this component.                      │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ COLLOCATIONPTS  │ number (=k) of collocation points per    │ see left║
      ║                 │ sub-interval.                            │         ║
      ║                 │ Requirement:                             │         ║
      ║                 │   orders[i] ≤ k ≤ 7                      │         ║
      ║                 │ Default:                                 │         ║
      ║                 │   k = max( max(orders)+1, 5-max(orders) )│         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ SUBINTERVALS    │ Either a positive integer scalar or a    │       5 ║
      ║                 │ vector of (Float)-times:                 │         ║
      ║                 │                                          │         ║
      ║                 │ (a) scalar: use a "uniform-like" initial │         ║
      ║                 │ grid with the given integer as number    │         ║
      ║                 │ of subintervals.                         │         ║
      ║                 │ Why "uniform-like" and not "uniform"?    │         ║
      ║                 │ Because all values of ζ and all values of│         ║
      ║                 │ OPT_ADDGRIDPOINTS have to be in the grid.│         ║
      ║                 │ If the scalar is too small for all this  │         ║
      ║                 │ values it is increased (internally).     │         ║
      ║                 │                                          │         ║
      ║                 │ (b) vector: all points must be inside    │         ║
      ║                 │ the interval (a,b). Then this points     │         ║
      ║                 │ are used as initial grid. Values of ζ,   │         ║
      ║                 │ OPT_ADDGRIDPOINTS and a and b are added  │         ║
      ║                 │ automatically by this interface.         │         ║
      ║                 │                                          │         ║
      ║                 │ If the guess is an solution object,      │         ║
      ║                 │ then this grid saved there is used       │         ║
      ║                 │ (and not the values given in             │         ║
      ║                 │ `OPT_SUBINTERVALS`).                     │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ FREEZEINTERVALS │ Only used if OPT_SUBINTERVALS is a       │   false ║
      ║                 │ vector. In this case this flags indicates│         ║
      ║                 │ if colnew is allowed to adaptively       │         ║
      ║                 │ change the grid.                         │         ║
      ║                 │ If true, all grid adaption is turned off │         ║
      ║                 │ and no mesh selection is done.           │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ MAXSUBINTERVALS │ number of maximal subintervals.          │      50 ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ COARSEGUESSGRID │ If `guess` is an solution obtained by a  │    true ║
      ║                 │ former call of `colnew`, then this       │         ║
      ║                 │ solution is taken as guess, and the mesh │         ║
      ║                 │ provided by this solution is taken twice │         ║
      ║                 │ as coarse.                               │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ DIAGNOSTICOUTPUT│ diagnostic output for colnew:            │       1 ║
      ║                 │   -1 : full diagnostic printout          │         ║
      ║                 │    0 : selected printout                 │         ║
      ║                 │    1 : no printout                       │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ ADDGRIDPOINTS   │ additional points that are always added  │      [] ║
      ║                 │ to every (time-)grid.                    │         ║
      ║                 │ Every grid contains all values in ζ and  │         ║
      ║                 │ the values in the interval argument.     │         ║
      ╚═════════════════╧══════════════════════════════════════════╧═════════╝

  """
function colnew(interval::Vector, orders::Vector, ζ::Vector,
  rhs, Drhs,
  bc, Dbc, guess, opt::AbstractOptionsODE)

  return colnew_impl(interval, orders, ζ, rhs, Drhs, bc, Dbc, guess, opt,
    ColnewArguments{Int64}(Int64(0)))
end

"""
  colnew with 32bit integers, see colnew.
  """
function colnew_i32(interval::Vector, orders::Vector, ζ::Vector,
  rhs, Drhs,
  bc, Dbc, guess, opt::AbstractOptionsODE)

  return colnew_impl(interval, orders, ζ, rhs, Drhs, bc, Dbc, guess, opt,
    ColnewArguments{Int32}(Int32(0)))
end

function colnew_impl(
  interval::Vector, orders::Vector, ζ::Vector,
  rhs, Drhs,
  bc, Dbc, guess, opt::AbstractOptionsODE,
  args::ColnewArguments{FInt}) where FInt<:FortranInt

  (lio,l,l_g,l_solver,lprefix) = solver_init("colnew",opt)

  if l_g
    println(lio,lprefix,
      "called with interval=",interval," rhs=", rhs,
      " Drhs=", Drhs, " bc=", bc, " Dbc=", Dbc, " guess=", guess, " and opt")
    show(lio,opt); println(lio)
  end

  (method_colnew, method_appsln) = getAllMethodPtrs(
    (FInt == Int64) ? DL_COLNEW : DL_COLNEW_I32 )

  # (time-)vector with interval [a,b]
  t_ab = nothing
  try
    t_ab = getVectorCheckLength(interval, Float64, 2)
  catch e
    throw(ArgumentErrorODE(
      "cannot convert interval to Vector{Float64} with 2 components",
      :interval, e))
  end
  t_ab[1] ≥ t_ab[2] && throw(ArgumentErrorODE(
    "interval=[a,b] with a<b needed", :interval))
  args.ALEFT = [ t_ab[1] ]
  args.ARIGHT = [ t_ab[2] ]

  # n = NCOMP
  n = FInt(length(orders))
  n ≤ 0 && throw(ArgumentErrorODE(
    "orders must be a vector with length ≥ 1", :orders))
  n > 20 && throw(ArgumentErrorODE(
    string("restriction: number of ODEs must be ≤ 20, but ",
      "orders vector had length ",n), :orders))
  args.NCOMP = [ n ]

  # orders = M
  try
    orders = getVectorCheckLength(orders, FInt, n) # always copy vector
  catch e
   throw(ArgumentErrorODE(
     "cannot convert orders to Vector{Fortran Ints}", :orders, e))
  end
  any(orders.<1) && throw(ArgumentErrorODE(
    "all components of the orders vector must be positive", :orders))
  any(orders.>5) && throw(ArgumentErrorODE(
    "all components of the orders vector must be ≤ 4", :orders))
  order_max = maximum(orders)
  d = FInt(sum(orders))
  d > 40 && throw(ArgumentErrorODE(
    "the dimension=sum(orders) must be ≤ 40", :orders))
  args.M = orders

  # ζ vector
  try
    ζ = getVectorCheckLength(ζ, Float64, d)  # always copy vector
  catch e
    throw(ArgumentErrorODE(
      string("cannot convert ζ to Vector{Float64} of length ", d),
      :ζ, e))
  end
  if !( all(ζ .≥ t_ab[1]) && all(ζ .≤ t_ab[2]) )
    throw(ArgumentErrorODE(
      "all side condition points in ζ must be inside of interval",
      :ζ))
  end
  if !( all( diff(ζ) .≥ 0.0 ) )
    throw(ArgumentErrorODE("ζ must be ascending", ζ))
  end
  args.ZETA = ζ

  max_subintervals = 20
  subintervals = nothing
  # ipar
  args.IPAR = zeros(FInt, 11)
  OPT = nothing
  try
    # RTOL ( => ltol, tol)
    OPT = OPT_RTOL
    rtol = getOption(opt, OPT, 1e-6)
    if isscalar(rtol)
      rtol = rtol*ones(Float64, d)
    end
    rtol = getVectorCheckLength(rtol, Float64, d, false)
    args.LTOL = zeros(FInt, 0)
    args.TOL = zeros(Float64, 0)
    for j=1:d
      if !isnan(rtol[j])
        push!(args.LTOL, FInt(j))
        push!(args.TOL, rtol[j])
      end
    end
    @assert length(args.LTOL) == length(args.TOL)
    length(args.LTOL)==0 && throw(ArgumentErrorODE(
      "All components in RTOL were NaN!"), :opt)
    args.IPAR[4] = FInt( length(args.LTOL) )

    OPT = OPT_BVPCLASS;
    bvpclass = convert(FInt, getOption(opt, OPT, 1))
    @assert 0 ≤ bvpclass ≤ 3
    args.IPAR[1] = FInt( bvpclass == 0 ? 0 : 1)
    args.IPAR[10] = FInt( bvpclass == 0 ? 0 : bvpclass -1 )

    OPT = OPT_COLLOCATIONPTS
    opt_default = maximum([order_max + FInt(1), FInt(5)-order_max])
    args.IPAR[2] = convert(FInt, getOption(opt, OPT, opt_default))
    @assert order_max ≤ args.IPAR[2] ≤ 7

    OPT = OPT_MAXSUBINTERVALS
    max_subintervals = convert(FInt, getOption(opt, OPT, 50))
    @assert max_subintervals > 5

    OPT = OPT_SUBINTERVALS
    subintervals = getOption(opt, OPT, 5)
    if isscalar(subintervals)
      args.IPAR[8] = FInt(0) # uniform(-like) initial grid
      args.IPAR[3] = FInt(subintervals)
      @assert 0 < args.IPAR[3] ≤ max_subintervals
    else
      subintervals = getVectorCheckLength(subintervals, Float64,
        length(subintervals)) # always copy
      append!(subintervals, ζ)
      subintervals = unique(sort!(subintervals))
      subintervals = subintervals[ t_ab[1] .< subintervals .< t_ab[2] ]
      no_sub = length(subintervals)+2-1  # inner_nodes + a-node + b-node
      if no_sub > max_subintervals
        throw(ArgumentErrorODE(
          string("more than OPT_MAXSUBINTERVALS = ", max_subintervals,
            " subintervals in initial grid: ", subintervals), :opt))
      end
      args.IPAR[3] = FInt(no_sub)
      OPT = OPT_FREEZEINTERVALS
      freezeintervals = getOption(opt, OPT, false)
      args.IPAR[8] = FInt( freezeintervals ? 2 : 1 )
      # division in subintervals needs to be saved in fspace (see below)
    end

    OPT = OPT_DIAGNOSTICOUTPUT
    args.IPAR[7] = convert(FInt, getOption(opt, OPT, 1))
    @assert -1 ≤ args.IPAR[7] ≤ 1

    OPT = OPT_ADDGRIDPOINTS
    add_points = getOption(opt, OPT, [])
    add_points = getVectorCheckLength(add_points, Float64, length(add_points))
    @assert all(add_points .≥ t_ab[1]) && all(add_points .≤ t_ab[2])
    sort!(add_points)
    add_points = unique(add_points)
    args.FIXPNT = add_points
    args.IPAR[11] = FInt(length(add_points))
  catch e
    throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
  end

  # FSPACE and ISPACE
  begin
    kd = FInt(args.IPAR[2]*n)
    kdm = FInt(kd + d)
    nsizei = FInt(3 + kdm)
    nrec = sum( ζ .≥ t_ab[2] )
    nsizef = 4 + 3*d + (5+kd)*kdm + (2*d-nrec)*2*d

    args.IPAR[5] = FInt(max_subintervals*nsizef)
    args.IPAR[6] = FInt(max_subintervals*nsizei)

    args.FSPACE = zeros(Float64, args.IPAR[5])
    args.ISPACE = zeros(FInt, args.IPAR[6])

    if args.IPAR[8] ≠ 0 && args.IPAR[3] > 1
      # user given initial mesh
      args.FSPACE[2:args.IPAR[3]] = subintervals[:]
    end
  end

  if guess === nothing
    args.IPAR[9] = FInt(0)
    guess = dummy_func
  elseif isa(guess, Function)
    args.IPAR[9] = FInt(1)
  elseif isa(guess, ColnewSolution{FInt})
    sol_old = guess :: ColnewSolution{FInt}
    if sol_old.t_a ≠ t_ab[1] || sol_old.t_b ≠ t_ab[2]
      throw(ArgumentErrorODE(
        string("Given guess has different interval [a,b]: ",
          "a=", t_ab[1], " b=", t_ab[2], ", but in guess: ",
          "guess_a=", sol_old.t_a," guess_b=", sol_old.t_b), :guess))
    end
    if sol_old.n ≠ n || sol_old.d ≠ d
      throw(ArgumentErrorODE(
        string("Given guess has differnt d or n: ",
          "d=", d, " n=", n, ", but in guess: ",
          "guess_d=", sol_old.d, " guess_n=", sol_old.n), :guess))
    end
    args.IPAR[9] = getOption(opt, OPT_COARSEGUESSGRID, true) ? 3 : 2
    guess = dummy_func
    args.ISPACE[1:(7+n)] = sol_old.ISPACE[1:(7+n)]
    args.FSPACE[1:args.ISPACE[7]] = sol_old.FSPACE[1:args.ISPACE[7]]
    args.IPAR[3] = args.ISPACE[1]
  else
    throw(ArgumentErrorODE(string("guess was neither nothing, ",
      "nor a function, nor an ColnewSolution object! I don't know ",
      "what to do with the type ",typeof(guess)), :guess))
  end
  # args.IPAR[9] = 4 currently not supported by this interface

  args.IFLAG = zeros(FInt, 1)

  if colnew_global_cbi !== nothing
    throw(ArgumentErrorODE(string("The Fortran solver colnew does not ",
      "support 'pass-through' arguments. Hence this julia module does not ",
      "support concurrent/nested colnew calls. Sorry."), :opt))
  end
  cbi = nothing
  try
    global colnew_global_cbi = cbi = ColnewInternalCallInfos(lio, l, n, d,
      rhs, "unsafe_colnewrhs: ", 0,  Drhs, "unsafe_colnew_Drhs: ",0,
      bc, "unsafe_colnew_bc: ", 0,   Dbc, "unsafe_colnew_Dbc: ", 0,
      guess, "unsafe_colnew_guess")

    if l_solver
      println(lio, lprefix, "call Fortran-colnew $method_colnew with")
      dump(lio, args)
    end

    fflag = FInt(0)

    ccall( method_colnew, Cvoid,
      (Ptr{FInt}, Ptr{FInt},                      # NCOMP, M
       Ptr{Float64}, Ptr{Float64},                # ALEFT, ARIGHT
       Ptr{Float64}, Ptr{FInt},                   # ZETA, IPAR
       Ptr{FInt}, Ptr{Float64},                   # LTOL, TOL
       Ptr{Float64},                              # FIXPNT
       Ptr{FInt}, Ptr{Float64},                   # ISPACE, FSPACE
       Ptr{FInt},                                 # IFLAG
       Ptr{Cvoid}, Ptr{Cvoid},                    # rhs, Drhs
       Ptr{Cvoid}, Ptr{Cvoid},                    # bc, Dbc
       Ptr{Cvoid},                                # guess
      ),
      args.NCOMP, args.M,
      args.ALEFT, args.ARIGHT,
      args.ZETA, args.IPAR,
      args.LTOL, args.TOL,
      args.FIXPNT,
      args.ISPACE, args.FSPACE,
      args.IFLAG,
      unsafe_colnew_rhs_c(fflag), unsafe_colnew_Drhs_c(fflag),
      unsafe_colnew_bc_c(fflag), unsafe_colnew_Dbc_c(fflag),
      unsafe_colnew_guess_c(fflag),
    )
    if l_solver
      println(lio, lprefix, "Fortran-colnew $method_colnew returned")
      dump(lio, args)
    end
  finally
    global colnew_global_cbi = nothing
  end
  l_g && println(lio, lprefix, string("done IFALG=", args.IFLAG[1]))
  solobj = ColnewSolution(
    method_appsln, t_ab[1], t_ab[2], n, d,
    args.ISPACE[1:(7+n)],
    args.FSPACE[1:args.ISPACE[7]])
  stats = Dict{AbstractString,Any}(
    "no_rhs_calls"  => cbi.rhs_count,
    "no_jac_calls"  => cbi.Drhs_count,
    "no_bc_calls"   => cbi.bc_count,
    "no_Dbc_calls"  => cbi.Dbc_count,
    "no_subintervals" => args.ISPACE[1],
  )
  return (solobj, args.IFLAG[1], stats)
end

"""
       function evalSolution(sol::ColnewSolution{FInt},
         t::Real, z::Vector{Float64}) where FInt<:FortranInt

  Evaluates an already obtained solution `sol` at time `t`.
  The values of the solution are saved in `z` which must be a
  vector (of length d).
  `t` must be in the interval [a,b] where the problem was solved.
  """
function evalSolution(sol::ColnewSolution{FInt},
  t::Real, z::Vector{Float64}) where FInt<:FortranInt

  @assert length(z)==sol.d
  @assert sol.t_a ≤ t ≤ sol.t_b
  ccall( sol.method_appsln, Cvoid,
    (Ptr{Float64}, Ptr{Float64},                  # t, z
     Ptr{Float64}, Ptr{FInt},                     # FSPACE, ISPACE
    ),
    [Float64(t)], z,
    sol.FSPACE, sol.ISPACE)
  return nothing
end

"""
       function evalSolution(sol::ColnewSolution{FInt},
         t::Real) where FInt<:FortranInt

  Evaluates an already obtained solution `sol` at time `t`.
  A newly allocated vector with the solution values is retured.
  `t` must be in the interval [a,b] where the problem was solved.
  """
function evalSolution(sol::ColnewSolution{FInt},
  t::Real) where FInt<:FortranInt

  z = Vector{Float64}(undef, sol.d)
  evalSolution(sol, t, z)
  return z
end

"""
        function evalSolution(sol::ColnewSolution{FInt},
          t::Vector) where FInt<:FortranInt

  Evaluates an already obtained solution `sol` at time all
  times in the vector `t`.
  A newly allocated matrix of size `(length(t), d)` with the solution
  values is retured.
  All values of `t` must be in the interval [a,b] where the problem was solved.
  """
function evalSolution(sol::ColnewSolution{FInt},
  t::Vector) where FInt<:FortranInt

  tno = length(t)

  Z = zeros(Float64, (tno, sol.d))
  z = Vector{Float64}(undef, sol.d)
  for k=1:tno
    evalSolution(sol, t[k], z)
    Z[k,:] = z
  end
  return Z
end

"""
       function getSolutionGrid(sol::ColnewSolution{FInt})
                where FInt<:FortranInt

  returnes a Float64-vector with the (last) grid points used.
  """
function getSolutionGrid(sol::ColnewSolution{FInt}) where FInt<:FortranInt
  return sol.FSPACE[1:sol.ISPACE[1]]
end


"""
  ## Compile COLNEW

  The julia ODEInterface tries to compile and link the solvers
  automatically at the build-time of this module. The following
  calls need only be done, if one uses a different compiler and/or if
  one wants to change/add some compiler options.

  The Fortran source code can be found at:

       https://people.sc.fsu.edu/~jburkardt/f77_src/colnew/colnew.html

  See `help_colnew_license` for the licsense information.

  ### Using `gfortran` and 64bit integers (Linux and Mac)

  Here is an example how to compile BVPSOL with `Float64` reals and
  `Int64` integers with `gfortran`:

       gfortran -c -fPIC -fdefault-integer-8
                -fdefault-real-8 -fdefault-double-8
                -o colnew.o colnew.f

  In order to get create a shared library (from the object file above) use
  one of the forms below (1st for Linux, 2nd for Mac):

       gfortran -shared -fPIC -o colnew.so colnew.o
       gfortran -shared -fPIC -o colnew.dylib colnew.o

  ### Using `gfortran` and 64bit integers (Windows)

  Here is an example how to compile BVPSOL with `Float64` reals and
  `Int64` integers with `gfortran`:

       gfortran -c -fdefault-integer-8
                -fdefault-real-8 -fdefault-double-8
                -o colnew.o colnew.f

  In order to get create a shared library (from the object file above) use

       gfortran -shared -o colnew.dll colnew.o
  """
function help_colnew_compile()
  return Docs.doc(help_colnew_compile)
end

"""
  # Licence

  Colnew is licensed under the GNU LGPL license.

  See [Colnew Hompage](https://people.sc.fsu.edu/~jburkardt/f77_src/colnew/colnew.html).

  ```
                   GNU LESSER GENERAL PUBLIC LICENSE
                         Version 3, 29 June 2007

   Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
   Everyone is permitted to copy and distribute verbatim copies
   of this license document, but changing it is not allowed.


    This version of the GNU Lesser General Public License incorporates
  the terms and conditions of version 3 of the GNU General Public
  License, supplemented by the additional permissions listed below.

    0. Additional Definitions.

    As used herein, "this License" refers to version 3 of the GNU Lesser
  General Public License, and the "GNU GPL" refers to version 3 of the GNU
  General Public License.

    "The Library" refers to a covered work governed by this License,
  other than an Application or a Combined Work as defined below.

    An "Application" is any work that makes use of an interface provided
  by the Library, but which is not otherwise based on the Library.
  Defining a subclass of a class defined by the Library is deemed a mode
  of using an interface provided by the Library.

    A "Combined Work" is a work produced by combining or linking an
  Application with the Library.  The particular version of the Library
  with which the Combined Work was made is also called the "Linked
  Version".

    The "Minimal Corresponding Source" for a Combined Work means the
  Corresponding Source for the Combined Work, excluding any source code
  for portions of the Combined Work that, considered in isolation, are
  based on the Application, and not on the Linked Version.

    The "Corresponding Application Code" for a Combined Work means the
  object code and/or source code for the Application, including any data
  and utility programs needed for reproducing the Combined Work from the
  Application, but excluding the System Libraries of the Combined Work.

    1. Exception to Section 3 of the GNU GPL.

    You may convey a covered work under sections 3 and 4 of this License
  without being bound by section 3 of the GNU GPL.

    2. Conveying Modified Versions.

    If you modify a copy of the Library, and, in your modifications, a
  facility refers to a function or data to be supplied by an Application
  that uses the facility (other than as an argument passed when the
  facility is invoked), then you may convey a copy of the modified
  version:

     a) under this License, provided that you make a good faith effort to
     ensure that, in the event an Application does not supply the
     function or data, the facility still operates, and performs
     whatever part of its purpose remains meaningful, or

     b) under the GNU GPL, with none of the additional permissions of
     this License applicable to that copy.

    3. Object Code Incorporating Material from Library Header Files.

    The object code form of an Application may incorporate material from
  a header file that is part of the Library.  You may convey such object
  code under terms of your choice, provided that, if the incorporated
  material is not limited to numerical parameters, data structure
  layouts and accessors, or small macros, inline functions and templates
  (ten or fewer lines in length), you do both of the following:

     a) Give prominent notice with each copy of the object code that the
     Library is used in it and that the Library and its use are
     covered by this License.

     b) Accompany the object code with a copy of the GNU GPL and this license
     document.

    4. Combined Works.

    You may convey a Combined Work under terms of your choice that,
  taken together, effectively do not restrict modification of the
  portions of the Library contained in the Combined Work and reverse
  engineering for debugging such modifications, if you also do each of
  the following:

     a) Give prominent notice with each copy of the Combined Work that
     the Library is used in it and that the Library and its use are
     covered by this License.

     b) Accompany the Combined Work with a copy of the GNU GPL and this license
     document.

     c) For a Combined Work that displays copyright notices during
     execution, include the copyright notice for the Library among
     these notices, as well as a reference directing the user to the
     copies of the GNU GPL and this license document.

     d) Do one of the following:

         0) Convey the Minimal Corresponding Source under the terms of this
         License, and the Corresponding Application Code in a form
         suitable for, and under terms that permit, the user to
         recombine or relink the Application with a modified version of
         the Linked Version to produce a modified Combined Work, in the
         manner specified by section 6 of the GNU GPL for conveying
         Corresponding Source.

         1) Use a suitable shared library mechanism for linking with the
         Library.  A suitable mechanism is one that (a) uses at run time
         a copy of the Library already present on the user's computer
         system, and (b) will operate properly with a modified version
         of the Library that is interface-compatible with the Linked
         Version.

     e) Provide Installation Information, but only if you would otherwise
     be required to provide such information under section 6 of the
     GNU GPL, and only to the extent that such information is
     necessary to install and execute a modified version of the
     Combined Work produced by recombining or relinking the
     Application with a modified version of the Linked Version. (If
     you use option 4d0, the Installation Information must accompany
     the Minimal Corresponding Source and Corresponding Application
     Code. If you use option 4d1, you must provide the Installation
     Information in the manner specified by section 6 of the GNU GPL
     for conveying Corresponding Source.)

    5. Combined Libraries.

    You may place library facilities that are a work based on the
  Library side by side in a single library together with other library
  facilities that are not Applications and are not covered by this
  License, and convey such a combined library under terms of your
  choice, if you do both of the following:

     a) Accompany the combined library with a copy of the same work based
     on the Library, uncombined with any other library facilities,
     conveyed under the terms of this License.

     b) Give prominent notice with the combined library that part of it
     is a work based on the Library, and explaining where to find the
     accompanying uncombined form of the same work.

    6. Revised Versions of the GNU Lesser General Public License.

    The Free Software Foundation may publish revised and/or new versions
  of the GNU Lesser General Public License from time to time. Such new
  versions will be similar in spirit to the present version, but may
  differ in detail to address new problems or concerns.

    Each version is given a distinguishing version number. If the
  Library as you received it specifies that a certain numbered version
  of the GNU Lesser General Public License "or any later version"
  applies to it, you have the option of following the terms and
  conditions either of that published version or of any later version
  published by the Free Software Foundation. If the Library as you
  received it does not specify a version number of the GNU Lesser
  General Public License, you may choose any version of the GNU Lesser
  General Public License ever published by the Free Software Foundation.

    If the Library as you received it specifies that a proxy can decide
  whether future versions of the GNU Lesser General Public License shall
  apply, that proxy's public statement of acceptance of any version is
  permanent authorization for you to choose that version for the
  Library.
  ```

  """
function help_colnew_license()
  return Docs.doc(help_colnew_license)
end

# Add informations about solvers in global solverInfo-array.
push!(solverInfo,
  SolverInfo("colnew",
    "Multi-Point boundary value solver for mixed order systems with collocation",
    tuple( :OPT_BVPCLASS, :OPT_RTOL, :OPT_COLLOCATIONPTS,
           :OPT_SUBINTERVALS, :OPT_FREEZEINTERVALS,
           :OPT_ADDGRIDPOINTS, :OPT_MAXSUBINTERVALS,
           :OPT_DIAGNOSTICOUTPUT, :OPT_COARSEGUESSGRID,
          ),
    tuple(
      SolverVariant("colnew_i64",
        "Colnew with 64bit integers",
        DL_COLNEW,
        tuple("colnew", "appsln")),
      SolverVariant("colnew_i32",
        "Colnew with 32bit integers",
        DL_COLNEW_I32,
        tuple("colnew", "appsln")),
    ),
    help_colnew_compile,
    help_colnew_license,
  )
)


# vim:syn=julia:cc=79:fdm=indent:

using Gadfly
using Colors

######################## Function for saving plots #################################
# Input:
# fileName = Name of the file where the plot is to be stored
#            (with or without extension)
# f_e = Array containing function evaluations as columns for each solver
# err = Array containing errors as columns for each solver
# solverNames = Array containing the names of solvers used in respective order
# plotSize = size of the plot to be created
#
# Values have been tuned for a graph similar to the one in
# Solving Ordinary Differential Equations I by
# Hairer, Ernst, Nørsett, Syvert P., Wanner, Gerhard
# page: 252
###################################################################################
function savePlotPNG(
        fileName, f_e, err, solverNames,
        plotSize = [30cm, 30cm]
    )

    numOfLayers = length(solverNames)

    if !contains(fileName, ".")
        fileName = string(fileName, ".png")
    end

    plotColorsHex = [
        "#4D4D4D", "#5DA5DA", "#FAA43A", "#60BD68",
        "#F17CB0", "#B2912F", "#B276B2", "#DECF3F", "#F15854",
    ]
    plotColors = [parse(Colorant, c) for c in plotColorsHex]

    majorFontSize = 24pt
    minorFontSize = 20pt
    pointSize = 5pt

    myplot = plot(
        Scale.x_log10, Scale.y_log10,
        Coord.cartesian(xflip = true),
        Guide.manual_color_key("Legend", solverNames, plotColorsHex[1:numOfLayers]),
        Guide.xlabel("error"), Guide.ylabel("#Function Evaluations"),
        Theme(
            major_label_font_size = majorFontSize, panel_stroke = colorant"black",
            minor_label_font_size = minorFontSize, key_title_font_size = majorFontSize,
            key_label_font_size = minorFontSize, key_position = :top, key_max_columns = 1
        )
    )

    for i in 1:numOfLayers
        push!(
            myplot, layer(
                x = err[:, i], y = f_e[:, i], Geom.point, Geom.path,
                Theme(default_color = plotColors[i], default_point_size = pointSize)
            )
        )
    end

    draw(PNG(fileName, plotSize[1], plotSize[2]), myplot)
    return nothing
end

using Pkg

Pkg.develop(path = joinpath(@__DIR__, ".."))
Pkg.instantiate()

using Documenter, ODEInterface

makedocs(;
    modules = [ODEInterface],
    sitename = "ODEInterface.jl",
    repo = "github.com/luchr/ODEInterface.jl",
    checkdocs = :public,
    pages = ["Public API" => "index.md"],
)

# Functions for Boundary-Value Solver: Bvpsol

"""Name for Loading bvpsol solver (64bit integers)."""
const DL_BVPSOL = "bvpsol"

"""Name for Loading bvpsol solver (32bit integers)."""
const DL_BVPSOL_I32 = "bvpsol_i32"

"""macro for import bvp solver."""
macro import_bvpsol()
    return :(
        using ODEInterface: bvpsol, bvpsol_i32
    )
end

"""macro for import bvpsol dynamic lib names."""
macro import_DLbvpsol()
    return :(
        using ODEInterface: DL_BVPSOL, DL_BVPSOL_I32
    )
end

"""macro for importing Bvpsol help."""
macro import_bvpsol_help()
    return :(
        using ODEInterface: help_bvpsol_compile, help_bvpsol_license
    )
end

@enum(
    ODE_SOLVER_USAGE,
    ODE_SOLVER_INTERNAL, ODE_SOLVER_JULIA
)

@doc """
The ode-solver to use for the initial value problems.
"""
ODE_SOLVER_USAGE

@doc """
Use the DIFEX1-solver builtin in bvpsol.
"""
ODE_SOLVER_INTERNAL

@doc """
Use the julia-function for solving the initial value problems.
"""
ODE_SOLVER_JULIA


"""
bvpsol does not support "pass-through" arguments for FCN and BC.
Hence we can only support one bvpsol-call at a time.
"""
bvpsol_global_cbi = nothing

"""
Type encapsulating all required data for Bvpsol-Callbacks.

Unfortunately bvpsol.f does not support passthrough arguments.

We have the typical calling stack:

     bvpsol
         ccall( BVPSOL_  ... )
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_bvpsolrhs                           │  ⎬ cb. rhs
            │    rhs                                    │  ⎪
            └───────────────────────────────────────────┘  ⎭
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_bvpssolbc                           │  ⎬ cb. boundary
            │    bc                                     │  ⎪     conditions
            └───────────────────────────────────────────┘  ⎭
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_bvpsolivp                           │  ⎬ cb. solving
            │    odesolver(rhs,t,tEnd,x,opt)            │  ⎪ IVP
            └───────────────────────────────────────────┘  ⎭
"""
mutable struct BvpsolInternalCallInfos{
        FInt <: FortranInt, RHS_F,
        BC_F, ODESOL_F,
    } <: ODEinternalCallInfos
    logio::IO                    # where to log
    loglevel::UInt64                # log level
    # RHS:
    rhs::RHS_F                 # right-hand-side
    rhs_mode::RHS_CALL_MODE         # how to call rhs
    rhs_lprefix::AbstractString        # saved log-prefix for rhs
    # BC:
    bc::BC_F                  # julia: functions for b-conditions
    bc_lprefix::AbstractString        # saved log-prefix for bc
    # problem specific
    N::FInt                  # Dimension of the problem
    # ODE-Solver
    odesol_usage::ODE_SOLVER_USAGE      # what IVP-Solver to use?
    odesol_julia::ODESOL_F              # a Julia-Function
    odeopt::OptionsODE            # Options for IVP-Solver
    ivp_lprefix::AbstractString        # saved log-prefix for ivp-call
end

mutable struct BvpsolArguments{FInt <: FortranInt} <: AbstractArgumentsODESolver{FInt}
    FCN::Ptr{Cvoid}        # rhs callback
    BC::Ptr{Cvoid}        # boundary conditions
    IVPSOL::Ptr{Cvoid}        # Initial Value Problem Solver
    N::Vector{FInt}      # Dimension
    M::Vector{FInt}      # Number of shooting nodes
    T::Vector{Float64}   # shooting nodes
    X::Matrix{Float64}   # start data at shooting nodes
    EPS::Vector{Float64}   # required rel. accuracy for solution
    IOPT::Vector{FInt}      # Option array
    INFO::Vector{FInt}      # Return code
    IRW::Vector{FInt}      # length of workspace RW
    RW::Vector{Float64}   # real workspace
    IIW::Vector{FInt}      # length of workspace IW
    IW::Vector{FInt}      # integer workspace
    ## Allow uninitialized construction
    function BvpsolArguments{FInt}(dummy::FInt) where {FInt}
        return new{FInt}()
    end
end

"""
     function unsafe_bvpsolrhs(n_::Ptr{FInt}, t_::Ptr{Float64},
             x_::Ptr{Float64}, f_::Ptr{Float64}) where FInt<:FortranInt

This is the right-hand side given as callback to bvpsol.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.

uses hw1rhs
"""
function unsafe_bvpsolrhs(
        n_::Ptr{FInt}, t_::Ptr{Float64},
        x_::Ptr{Float64}, f_::Ptr{Float64}
    ) where {FInt <: FortranInt}

    n = unsafe_load(n_); t = unsafe_load(t_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    f = unsafe_wrap(Array, f_, (n,), own = false)
    cbi = bvpsol_global_cbi::BvpsolInternalCallInfos
    hw1rhs(n, t, x, f, cbi)
    return nothing
end

"""
     function unsafe_bvpsolrhs_c(fint_flag::FInt) where FInt
"""
function unsafe_bvpsolrhs_c(fint_flag::FInt) where {FInt}
    return @cfunction(
        unsafe_bvpsolrhs, Cvoid, (
            Ptr{FInt}, Ptr{Float64},
            Ptr{Float64}, Ptr{Float64},
        )
    )
end

"""
      function bvpsolbc{CI}(xa,xb,r,cbi::CI)

This function calls `bc` saved in `BvpsolInternalCallInfos`.
"""
function bvpsolbc(xa, xb, r, cbi::CI) where {CI}
    lprefix = cbi.bc_lprefix

    (lio, l) = (cbi.logio, cbi.loglevel)
    l_bc = l & LOG_BC > 0

    l_bc && println(lio, lprefix, "called with xa=", xa, " xb=", xb)
    cbi.bc(xa, xb, r)
    l_bc && println(lio, lprefix, "bc result=", r)
    return nothing
end

"""
     function unsafe_bvpsolbc(xa_::Ptr{Float64}, xb_::Ptr{Float64},
       r_::Ptr{Float64}) -> nothing

This is the callback for the boundary conditions given to bvpsol.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.

uses bvpsolbc
"""
function unsafe_bvpsolbc(
        xa_::Ptr{Float64}, xb_::Ptr{Float64},
        r_::Ptr{Float64}
    )

    cbi = bvpsol_global_cbi::BvpsolInternalCallInfos
    n = cbi.N
    xa = unsafe_wrap(Array, xa_, (n,), own = false)
    xb = unsafe_wrap(Array, xb_, (n,), own = false)
    r = unsafe_wrap(Array, r_, (n,), own = false)
    bvpsolbc(xa, xb, r, cbi)
    return nothing
end

"""
      function unsafe_bvpsolbc_c()
"""
function unsafe_bvpsolbc_c()
    return @cfunction(
        unsafe_bvpsolbc, Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64})
    )
end

function bvpsolivp(
        t::Vector{Float64},
        x::Vector{Float64}, tend, tol, hmax, h::Vector{Float64},
        kflag::Vector{FInt}, cbi::CI
    ) where {FInt, CI}

    @assert cbi.odesol_usage == ODE_SOLVER_JULIA

    (lio, l) = (cbi.logio, cbi.loglevel)
    lprefix = cbi.ivp_lprefix
    l_ivp = l & LOG_BVPIVPSOL > 0

    opt = cbi.odeopt
    setOptions!(
        opt,
        OPT_RTOL => tol, OPT_MAXSS => hmax,
        OPT_INITIALSS => h[1], "KFLAG" => kflag[1]
    )

    l_ivp && println(
        lio, lprefix, "calling ivp solver with rhs=", cbi.rhs,
        " tStart=", t[1], " tEnd=", tend, " x=", x, " opt=", opt
    )

    (ret_t, ret_x, ret_code, ret_stats) =
        cbi.odesol_julia(cbi.rhs, t[1], tend, x, opt)
    l_ivp && println(
        lio, lprefix, "ivp solver returned ret_t=", ret_t,
        " ret_x=", ret_x, " ret_code=", ret_code, " ret_stats=", ret_stats
    )
    t[1] = ret_t
    x[:] = ret_x
    kflag[1] = ret_code
    if haskey(ret_stats, "step_predict")
        h[1] = ret_stats["step_predict"]
    else
        throw(
            OutputErrorODE(
                "IVP-solver had no field 'step_predict' in stats", cbi.odesol_julia
            )
        )
    end
    if ret_t ≠ tend
        h[1] = 0
    end
    l_ivp && println(lio, lprefix, "returning h=", h[1], " kflag=", kflag[1])

    return nothing
end

"""
     function unsafe_bvpsolivp(n_::Ptr{FInt},
             fcn_::Ptr{Cvoid}, t_::Ptr{Float64}, x_::Ptr{Float64},
             tend_::Ptr{Float64}, tol_::Ptr{Float64}, hmax_::Ptr{Float64},
             h_::Ptr{Float64}, kflag_::Ptr{FInt}) where FInt<:FortranInt

This is the callback for bvpsol to solve initial value problems.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.

uses bvpsolivp
"""
function unsafe_bvpsolivp(
        n_::Ptr{FInt},
        fcn_::Ptr{Cvoid}, t_::Ptr{Float64}, x_::Ptr{Float64},
        tend_::Ptr{Float64}, tol_::Ptr{Float64}, hmax_::Ptr{Float64},
        h_::Ptr{Float64}, kflag_::Ptr{FInt}
    ) where {FInt <: FortranInt}

    cbi = bvpsol_global_cbi::BvpsolInternalCallInfos
    n = cbi.N
    t = unsafe_wrap(Array, t_, (1,), own = false)
    tend = unsafe_load(tend_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    tol = unsafe_load(tol_); hmax = unsafe_load(hmax_)
    h = unsafe_wrap(Array, h_, (1,), own = false)
    kflag = unsafe_wrap(Array, kflag_, (1,), own = false)
    bvpsolivp(t, x, tend, tol, hmax, h, kflag, cbi)
    return nothing
end

function unsafe_bvpsolivp_c(fint_flag::FInt) where {FInt}
    return @cfunction(
        unsafe_bvpsolivp, Cvoid,
        (
            Ptr{FInt}, Ptr{Cvoid}, Ptr{Float64},
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ptr{Float64},
            Ptr{FInt},
        )
    )
end


function bvpsol_ivp_dummy(rhs, t, tend, x, opt)
    throw(InternalErrorODE("bvpsol_ivp_dummy was called"))
end

"""
     function bvpsol(rhs, bc,
       t::Vector, x::Matrix, odesolver, opt::AbstractOptionsODE)
         -> (t,x,retcode,stats)

The `bc` has to be a function of the following form:

     function bc(xa,xb,r) -> nothing

It has to calculate the residual for the boundary conditions and save
them in `r`.

`t` is a Vector with all the multiple-shooting nodes.

`x` gives the initial guess for all multiple-shooting nodes. Hence
`size(x,2)==length(t)`.

`odesolver`: Either `nothing`: then the internal solver of `bvpsol` is
used. Or `odesolver` is a ode-solver (like `dopri5`, `dop853`, `seulex`,
etc.).

`retcode` can have the following values:

      >0: computation successful: number of iterations
      -1:        Iteration stops at stationary point for OPT_SOLMETHOD==0
                 Gaussian elimination failed due to singular
                 Jacobian for OPT_SOLMETHOD==1
      -2: Iteration stops after OPT_MAXSTEPS
      -3: Integrator failed to complete the trajectory
      -4: Gauss Newton method failed to converge
      -5: Given initial values inconsistent with separable linear bc
      -6:        Iterative refinement failed to converge for OPT_SOLMETHOD==0
                 Termination since multiple shooting condition or
                 condition of Jacobian is too bad for OPT_SOLMETHOD==1
      -7: wrong EPS (should not happen; checked by ODEInterface module)
      -8: Condensing algorithm for linear block system fails, try
          OPT_SOLMETHOD==1
      -9: Sparse linear solver failed
     -10: Real or integer work-space exhausted
     -11: Rank reduction failed - resulting rank is zero

In `opt` the following options are used:

    ╔═════════════════╤══════════════════════════════════════════╤═════════╗
    ║  Option OPT_…   │ Description                              │ Default ║
    ╠═════════════════╪══════════════════════════════════════════╪═════════╣
    ║ RTOL            │ relative accuracy for solution           │    1e-6 ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSTEPS        │ maximum permitted number of iteration    │      40 ║
    ║                 │ steps                                    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ BVPCLASS        │ boundary value problem classification:   │       2 ║
    ║                 │ 0: linear                                │         ║
    ║                 │ 1: nonlinear with good initial data      │         ║
    ║                 │ 2: highly nonlinear & bad initial data   │         ║
    ║                 │ 3: highly nonlinear & bad initial data & │         ║
    ║                 │    initial rank reduction to separable   │         ║
    ║                 │    linear boundary conditions            │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ SOLMETHOD       │ switch for solution method               │       0 ║
    ║                 │ 0: use local linear solver with          │         ║
    ║                 │    condensing algorithm                  │         ║
    ║                 │ 1: use global sparse linear solver       │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ IVPOPT          │ An OptionsODE-object with the options    │ empty   ║
    ║                 │ for the solver of the initial value      │ options ║
    ║                 │ problem.                                 │         ║
    ║                 │ In this OptionsODE-object bvpsol changes │         ║
    ║                 │ OPT_MAXSS, OPT_INITIALSS, OPT_RTOL       │         ║
    ║                 │ to give the IVP-solver solution hints.   │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ RHS_CALLMODE    │ see help_callsolvers()                   │         ║
    ╚═════════════════╧══════════════════════════════════════════╧═════════╝
"""
function bvpsol(
        rhs, bc,
        t::Vector, x::Matrix, odesolver, opt::AbstractOptionsODE
    )
    return bvpsol_impl(rhs, bc, t, x, odesolver, opt, BvpsolArguments{Int64}(Int64(0)))
end

"""
bvpsol with 32bit integers, see bvpsol.
"""
function bvpsol_i32(
        rhs, bc,
        t::Vector, x::Matrix, odesolver, opt::AbstractOptionsODE
    )
    return bvpsol_impl(rhs, bc, t, x, odesolver, opt, BvpsolArguments{Int32}(Int32(0)))
end

function bvpsol_impl(
        rhs, bc,
        t::Vector, x::Matrix, odesolver,
        opt::AbstractOptionsODE, args::BvpsolArguments{FInt}
    ) where {FInt <: FortranInt}

    (lio, l, l_g, l_solver, lprefix) = solver_init("bvpsol", opt)

    if l_g
        println(
            lio, lprefix,
            "called with rhs=", rhs, " t=", t, " x=", x, " and opt"
        )
        show(lio, opt); println(lio)
    end

    (method_bvpsol, method_bldfx1) = getAllMethodPtrs(
        (FInt == Int64) ? DL_BVPSOL : DL_BVPSOL_I32
    )

    d = FInt(0)
    try
        d = convert(FInt, size(x, 1))
    catch e
        throw(ArgumentErrorODE("Cannot convert size(x,1) to $FInt", :x, e))
    end
    0 == d && throw(ArgumentErrorODE("x has no rows", :x))
    N = d; args.N = [d]

    m = FInt(0)
    try
        m = convert(FInt, size(x, 2))
    catch e
        throw(ArgumentErrorODE("Cannot convert size(x,2) to $FInt", :x, e))
    end
    m < 2 && throw(ArgumentErrorODE("x has less than 2 columns", :x))
    try
        @assert length(t) == m
    catch e
        throw(ArgumentErrorODE("size(x,2) ≠ length(t)", :t, e))
    end
    M = m; args.M = [m]

    try
        args.T = getVectorCheckLength(t, Float64, m)
    catch e
        throw(ArgumentErrorODE("cannot convert t to Vector{Float64}", :t, e))
    end

    try
        args.X = getMatrixCheckSize(x, Float64, d, m)
    catch e
        throw(ArgumentErrorODE("cannot convert x to Matrix{Float64}", :x, e))
    end

    rhs_mode = solver_extract_rhsMode(opt)
    rhs_lprefix = "unsafe_bvpsolrhs: "
    bc_lprefix = "unsafe_bvpsolbc: "

    try
        args.EPS = [convert(Float64, getOption(opt, OPT_RTOL, 1.0e-6))]
        @assert 0 < args.EPS[1] <= 1.0e-2
    catch e
        throw(ArgumentErrorODE("Cannot convert OPT_RTOL to Float64", :opt, e))
    end

    args.IOPT = Vector{FInt}(undef, 6)
    ivpopt = nothing
    ivp_lprefix = "unsafe_bvpsolivp: "
    OPT = nothing
    try
        OPT = OPT_MAXSTEPS; args.IOPT[1] = convert(FInt, getOption(opt, OPT, 40))
        @assert args.IOPT[1] > 0

        OPT = OPT_BVPCLASS; args.IOPT[2] = convert(FInt, getOption(opt, OPT, 2))
        @assert 0 ≤ args.IOPT[2] ≤ 3

        OPT = OPT_SOLMETHOD; args.IOPT[3] = convert(FInt, getOption(opt, OPT, 0))
        @assert 0 ≤ args.IOPT[3] ≤ 1

        args.IOPT[4] = -1; args.IOPT[5] = 0

        OPT = OPT_IVPOPT; ivpopt = getOption(opt, OPT, nothing)
        if ivpopt === nothing
            ivpopt = OptionsODE("Autogenerated by bvpsol")
        end
        @assert isa(ivpopt, OptionsODE)
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    if args.IOPT[3] == 0
        args.IIW = [FInt(4 * N + 2 * N * N)]
        args.IRW = [FInt(N * N * (M + 5) + 10 * M * N + 10 * N + M)]
    elseif args.IOPT[3] == 1
        NZ = N * N * (M + 1) * N * (M - 1)
        LICN = 2 * NZ
        h1 = FInt(ceil(1.5 * NZ))
        h2 = NZ + 4 * M * N
        LIRN = min(max(h1, h2), LICN)
        args.IIW = [FInt(2 * N * N + 3 * N + 16 * M * N + 2 * NZ + LICN + LIRN)]
        args.IRW = [FInt(N * N * (M + 1) + 12 * N * M + 4 * N + M - 1 + LICN)]
    end
    args.RW = zeros(Float64, args.IRW[1])
    args.IW = zeros(FInt, args.IIW[1])
    args.FCN = unsafe_bvpsolrhs_c(FInt(0))
    args.BC = unsafe_bvpsolbc_c()
    args.INFO = zeros(FInt, 1)

    if odesolver === nothing && d > 1024
        throw(
            ArgumentErrorODE(
                string(
                    "internal solver of bvpsol cannot handle ",
                    "more than 1024 equations"
                )
            )
        )
    end
    if odesolver === nothing
        args.IVPSOL = method_bldfx1
    else
        args.IVPSOL = unsafe_bvpsolivp_c(FInt(0))
    end

    if bvpsol_global_cbi !== nothing
        throw(
            ArgumentErrorODE(
                string(
                    "The Fortran solver bvpsol does not ",
                    "support 'pass-through' arguments. Hence this julia module does not ",
                    "support concurrent/nested bvpsol calls. Sorry."
                ), :opt
            )
        )
    end

    try
        global bvpsol_global_cbi = BvpsolInternalCallInfos(
            lio, l, rhs, rhs_mode,
            rhs_lprefix, bc, bc_lprefix, N,
            odesolver === nothing ? ODE_SOLVER_INTERNAL : ODE_SOLVER_JULIA,
            odesolver === nothing ? bvpsol_ivp_dummy : odesolver,
            ivpopt, ivp_lprefix
        )

        if l_solver
            println(lio, lprefix, "call Fortran-bvpsol $method_bvpsol with")
            dump(lio, args)
        end

        ccall(
            method_bvpsol, Cvoid,
            (
                Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid},        # Rightsidefunc, BC, IVPSOL
                Ptr{FInt}, Ptr{FInt},                      # N, M
                Ptr{Float64}, Ptr{Float64}, Ptr{Float64},  # t, x, EPS
                Ptr{FInt}, Ptr{FInt},                      # IOPT, INFO
                Ptr{FInt}, Ptr{Float64},                   # IRW, RW
                Ptr{FInt}, Ptr{FInt},                      # IIW, IW
            ),
            args.FCN, args.BC, args.IVPSOL,
            args.N, args.M,
            args.T, args.X, args.EPS,
            args.IOPT, args.INFO,
            args.IRW, args.RW,
            args.IIW, args.IW,
        )

        if l_solver
            println(lio, lprefix, "Fortran-bvpsol $method_bvpsol returned")
            dump(lio, args)
        end
    finally
        global bvpsol_global_cbi = nothing
    end
    l_g && println(lio, lprefix, string("done INFO=", args.INFO[1]))
    stats = Dict{AbstractString, Any}()
    return (args.T, args.X, args.INFO[1], stats)
end


"""
## Compile BVPSOL

The julia ODEInterface tries to compile and link the solvers
automatically at the build-time of this module. The following
calls need only be done, if one uses a different compiler and/or if
one wants to change/add some compiler options.

The Fortran source code can be found at:

     http://elib.zib.de/pub/elib/codelib/bvpsol/

See `help_bvpsol_license` for the license information.

### Using `gfortran` and 64bit integers (Linux and Mac)

Here is an example how to compile BVPSOL with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o bvpsol.o bvpsol.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o linalg_bvpsol.o linalg_bvpsol.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o zibconst.o zibconst.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o ma28_bvpsol.o ma28_bvpsol.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o bvpsol.so
              bvpsol.o linalg_bvpsol.o zibconst.o ma28_bvpsol.o
     gfortran -shared -fPIC -o bvpsol.dylib
              bvpsol.o linalg_bvpsol.o zibconst.o ma28_bvpsol.o

### Using `gfortran` and 64bit integers (Windows)

Here is an example how to compile BVPSOL with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o bvpsol.o bvpsol.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o linalg_bvpsol.o linalg_bvpsol.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o zibconst.o zibconst.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o ma28_bvpsol.o ma28_bvpsol.f

In order to get create a shared library (from the object file above) use

     gfortran -shared -o bvpsol.so
              bvpsol.o linalg_bvpsol.o zibconst.o ma28_bvpsol.o

### Using `gfortran` and 32bit integers (Linux and Mac)

Here is an example how to compile BVPSOL with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o bvpsol_i32.o bvpsol.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o linalg_bvpsol_i32.o linalg_bvpsol.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o zibonst_i32.o zibconst.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o ma28_bvpsol_i32.o ma28_bvpsol.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o bvpsol_i32.so
               bvpsol_i32.o linalg_bvpsol_i32.o zibconst_i32.o ma28_bvpsol_i32.o
     gfortran -shared -fPIC -o bvpsol_i32.dylib
               bvpsol_i32.o linalg_bvpsol_i32.o zibconst_i32.o ma28_bvpsol_i32.o

### Using `gfortran` and 32bit integers (Windows)

Here is an example how to compile BVPSOL with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o bvpsol_i32.o bvpsol.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o linalg_bvpsol_i32.o linalg_bvpsol.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o zibconst_i32.o zibconst.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o ma28_bvpsol_i32.o ma28_bvpsol.f

In order to get create a shared library (from the object file above) use:

     gfortran -shared -o bvpsol_i32.dll
               bvpsol_i32.o linalg_bvplsol_i32.o zibconst_i32.o
               ma28_bvpsol_i32.o

"""
function help_bvpsol_compile()
    return Docs.doc(help_bvpsol_compile)
end

"""
# Licence
You may use or modify this code for your own non commercial
purposes for an unlimited time.
This code can be distributed in unmodified form as part of the
complete ODEInterface packet. Apart from that, you should not
deliver it without a special permission of the Zuse Institute
Berlin (ZIB).
In case you intend to use the code commercially, we oblige you
to sign an according licence agreement with ZIB.

# Warranty
This code has been tested up to a certain level. Defects and
weaknesses, which may be included in the code, do not establish
any warranties by ZIB. ZIB does not take over any liabilities
which may follow from acquisition or application of this code.
"""
function help_bvpsol_license()
    return Docs.doc(help_bvpsol_license)
end


# Add information about solvers in global solverInfo-array.
push!(
    solverInfo,
    SolverInfo(
        "bvpsol",
        "Boundary Value Problem Solver for highly nonlinear problems",
        tuple(
            :OPT_RTOL, :OPT_MAXSTEPS, :OPT_BVPCLASS, :OPT_SOLMETHOD,
            :OPT_RHS_CALLMODE, :OPT_IVPOPT
        ),
        tuple(
            SolverVariant(
                "bvpsol_i64",
                "Bvpsol with 64bit integers",
                DL_BVPSOL,
                tuple("bvpsol", "bldfx1")
            ),
            SolverVariant(
                "bvpsol_i32",
                "Bvplsolwith 32bit integers",
                DL_BVPSOL_I32,
                tuple("bvpsol", "bldfx1")
            ),
        ),
        help_bvpsol_compile,
        help_bvpsol_license,
    )
)

# vim:syn=julia:cc=79:fdm=indent:

# Load the required packages
using ODE
using JLD
using ForwardDiff

set_bigfloat_precision(113)

# Define the system for the solver
function roberAD(x)
    k1 = parse(BigFloat, "0.04")
    k2 = parse(BigFloat, "1e4")
    k3 = parse(BigFloat, "3e7")

    return [
        -k1 * x[1] + k2 * x[2] * x[3],
        k1 * x[1] - k2 * x[2] * x[3] - k3 * (x[2])^2,
        k3 * (x[2])^2,
    ]
end

function rober(t, x)
    return roberAD(x)
end

function getJacobian(t, x)
    return ForwardDiff.jacobian(roberAD, x)
end

# Set up the initial conditions
tSpan = [zero(BigFloat);parse(BigFloat, "10.0") .^ collect(0:11)];
x0 = [one(BigFloat), zero(BigFloat), zero(BigFloat)];

# Set the tolerances
# ATol = RTol*1e-6
RTol = parse(BigFloat, "1e-20");
ATol = parse(BigFloat, "1e-26");

# Solve and get the solution at T = tEnd
(t, x_tmp) = ode23s(
    rober, x0, tSpan;
    reltol = RTol, abstol = ATol, points = :specified,
    jacobian = getJacobian,
    minstep = parse(BigFloat, "1e-8")
);

x_ref = Array{BigFloat}(11, 3);

for i in 1:11
    x_ref[i, :] = x_tmp[i + 1, 1][:]
end

# Save the solution to a file
save("refSolRober.jld", "x_ref", x_ref);

# Some help texts for the ODEInterface

"""macro for importing all the help-functions."""
macro import_help()
    return quote
        using ODEInterface: help_overview, help_callsolvers, help_options,
            help_outputfcn, help_solversupport, help_install,
            help_loadsolvers, help_specialstructure,
            help_internals
        @ODEInterface.import_dopri5_help
        @ODEInterface.import_odex_help
        @ODEInterface.import_radau5_help
        @ODEInterface.import_radau_help
        @ODEInterface.import_seulex_help
        @ODEInterface.import_rodas_help
        @ODEInterface.import_ddeabm_help
        @ODEInterface.import_ddebdf_help
        @ODEInterface.import_bvpsol_help
        @ODEInterface.import_colnew_help
        @ODEInterface.import_bvpm2_help
    end
end

buf2str(buf) = String(take!(buf))

try
    using Markdown
catch
end

"""
# Overview

## Importing all help topics

You can use

     using ODEInterface
     @ODEInterface.import_help

to have all `help_...` commands imported; so you can use

     ?help_overview
     help_overview()

## Help topics

     help_install          requirements, installation, compiling the solvers
     help_solversupport    supported ODE solvers
     help_loadsolvers      loading the ODE solvers
     help_callsolvers      how to call the ODE solvers
     help_options          how to use parameters/options for solvers
     help_outputfcn        how to use "output functions", dense output
     help_specialstructure support for problems with "special structure"

     help_internals        some internal/developer information

## Help for each solver

Each solver has its own help page. Just look at the documentation of
`dopri5`, `dop853`, `odex`, `radau5`, `radau`, `rodas`, `seulex`,
`bvpsol`, `ddeabm` and `Bvpm2`.
"""
function help_overview()
    return Docs.doc(help_overview)
end

"""
     function help_solversupport()

This function (when called) produces a (markdown) object with
information about the supported solvers.
"""
function help_solversupport()
    io = IOBuffer()
    write(io, "## Supported solvers\n\n")
    for solver in solverInfo
        write(io, "### ", solver.name, "\n\n", solver.description, "\n\n")
        for variant in solver.variants
            write(io, "* `", variant.name, "`: ", variant.description, "\n")
        end
        write(io, "\nHelp for compiling: `", string(solver.help_compile), "`")
        write(io, "\n\nLicense: `", string(solver.help_license), "`\n\n")
    end
    write(
        io, "## Load status\n\n",
        "     ╔═════════════╤═══════════════╤══════════",
        "╤═══════════════════════════════╗\n",
        "     ║    Name     │   libname     │  loaded  ",
        "│       method                  ║\n",
        "     ╠═════════════╪═══════════════╪══════════",
        "╪═══════════════════════════════╣\n"
    )
    first = Vector{Bool}(undef, 4)
    first_solver = true
    for solver in solverInfo
        if !first_solver
            write(
                io, "     ╟─────────────┼───────────────┼──────────",
                "┼───────────────────────────────╢\n"
            )
        end
        first_solver = false
        first[1] = true
        first_variant = true
        for variant in solver.variants
            if !first_variant
                write(
                    io, "     ║             ├───────────────┼──────────",
                    "┼───────────────────────────────╢\n"
                )
            end
            loaded = true
            try
                v = dlSolversInfo[variant.libname]
                @assert v.error === nothing
                @assert v.libhandle ≠ C_NULL
            catch
                loaded = false
            end

            first[2] = first[3] = true
            for method in variant.methods
                found = true
                try
                    index = findfirst(
                        x -> x.generic_name == method,
                        dlSolversInfo[variant.libname].methods
                    )
                    m = dlSolversInfo[variant.libname].methods[index]
                    @assert m.error === nothing
                    @assert m.method_ptr ≠ C_NULL
                catch e
                    found = false
                end
                method_name = method
                if length(method_name) > 22
                    method_name = string(method_name[1:19], "...")
                end
                write(
                    io, "     ║ ",
                    rpad(first[1] ? solver.name : "", 12), "│ ",
                    rpad(first[2] ? variant.libname : "", 14), "│ ",
                    rpad(first[3] ? (loaded ? "yes" : " no") : "", 9), "│ ",
                    rpad(method_name, 23), found ? "  OK  " : "FAILED", " ║\n"
                )
                first[1] = first[2] = first[3] = false
            end
            first[1] = false
            first_variant = false
        end
    end
    write(
        io, "     ╚═════════════╧═══════════════╧══════════",
        "╧═══════════════════════════════╝\n\n",
        "For more information: see result of `loadODESolvers`.\n"
    )
    return Markdown.parse(buf2str(io))
end

"""
## Installation

This module needs the *compiled* Fortran solvers as shared libraries 
(i.e. `.so`, `.dylib` or `.dll` files, respectively). There are three ways
to get them:

* The package [ODEInterface_jll.jl](https://github.com/JuliaBinaryWrappers/ODEInterface_jll.jl) has precompiled solvers for different platforms. Julia 1.3 or newer is needed for this. This is the default behaviour for julia versions 1.3 or newer.
* The build-script of this module: It tries to use `gfortran` and compile the solver libraries. This is the default behaviour for julia versions less than 1.3. A `gfortran` compiler is needed for this.
* You compile the solvers yourself (perhaps with different options and/or a different compiler). In this case just call `ODEInterface.help_solversupport` for further information (help topics) on how to compile the solvers and how to create shared libraries.
"""
function help_install()
    return Docs.doc(help_install)
end

"""
## Loading the solvers

All ODE solvers are dynamically loaded. See `help_install` for
information how to get or create such shared libraries for the solvers.

Before using a solver for the 1st time, it has to be loaded by
a call of `loadODESolvers`.
"""
function help_loadsolvers()
    return Docs.doc(help_loadsolvers)
end

"""
## Calling the Solvers

There are two ways of calling the solvers.

1. A calling convention close to the original Fortran-call,
   trying to provide/expose all the features the Fortran-codes have.
1. A simplified version, closer to odecalls like in MATLAB.

### The full-featured calling-method

All ODE-solvers have the same calling convention:

    (t,x,retcode,stats) =
        odesolver(rhs, t0::Real, T::Real,
                  x0::Vector, opt::AbstractOptionsODErhs)

    function rhs(t::Float64,x::Vector{Float64}) -> Vector{Float64}
        if OPT_RHS_CALLMODE == RHS_CALL_RETURNS_ARRAY

    function rhs(t::Float64,x::Vector{Float64},dx::Vector{Float64})
        if OPT_RHS_CALLMODE == RHS_CALL_INSITU

The input arguments are:

1. a julia function `rhs` for evaluating the right-hand side of the ODE,
   see below.
   It's OK to return something, that `convert` can transform
   to a `Vector{Float64}`.
1. the initial time `t0`. `(t0,x0)` is the initial value of the
   initial value problem.
1. the final time `T`.
1. the initial state `x0`. `(t0,x0)` is the initial value of the
   initial value problem.
1. further parameters/options in `opt` for the solver and for the interface.
   There is a separate section for the explanation of the options, see
   help_options.

The output arguments are:

1. `t` the *last* time for which the solution has been computed
   (if the whole computation was successful, then `t==T`)
1. `x` the numerical solation at time `t`
1. `retcode` the return code of the solver (interpretation is solver dependent)

There are two possible ways to provide the Julia right-hand side:

    function rhs(t::Float64,x::Vector{Float64}) -> Vector{Float64}

This is used, if `OPT_RHS_CALLMODE == RHS_CALL_RETURNS_ARRAY`. So you can
use anonymous functions like `(t,x) -> x` as right-hand sides. But this
form has a price: every time the right-hand side is called, a temporary
Array is created (the result). The form

    function rhs(t::Float64,x::Vector{Float64},dx::Vector{Float64})
                 -> nothing

used if `OPT_RHS_CALLMODE == RHS_CALL_INSITU` does not have this problem.
But the right-hand side must be a function filling in the values of `x'`
in `dx`.

### The simplified version

There is a simplified calling convention (using the methods above) to
provide a method like odecalls in MATLAB,
see `odecall`.
"""
function help_callsolvers()
    return Docs.doc(help_callsolvers)
end

"""
## The `opt` Argument: the Options

All options are handled by `OptionsODE`. See `OptionsODE` how to
query, set and change options.

There are the following classes of options.

1. Options for this ODEInterface (common for all solvers)
1. Options for the ODE solvers

### Options of this ODEInterface

* `OPT_RHS_CALLMODE`:
  There are two possible ways to call the Julia right-hand side:
  `RHS_CALL_RETURNS_ARRAY` and `RHS_CALL_INSITU`, see
  `help_callsolvers` for an explanation.
  difference.
* `OPT_LOGIO`:
  This option sets the `IO` that is used for logging messages
* `OPT_LOGLEVEL`:
  This is a bitmask for activating different logging messages.
  The following bitmasks are available.

         LOG_NOTHING     log nothing
         LOG_GENERAL     log some general information,
                         especially the main julia call of the solver
         LOG_RHS         log all calls of the right-hand side
         LOG_SOLVERARGS  log the arguments for the C-/Fortran-calls
                         before and after the call
         LOG_OUTPUTFCN   log calls of the julia output function
         LOG_SOLOUT      log calls of the solution output routine
         LOG_EVALSOL     log calls of the eval_sol_fcn
         LOG_MASS        log call(s) of the mass function
         LOG_JAC         log calls of the jacobian function of RHS
         LOG_BC          log calls of the boundary condition function
         LOG_BVPIVPSOL   log (during boundary value problems) calls to
                         initial value solvers
         LOG_RHSDT       log calls of the right-hand side time-derivative
         LOG_JACBC       log calls of the jacobian of the boundary condition
         LOG_GUESS       log calls to the guess function
         LOG_ALL         all of the above

### Options for the solvers

Different solvers support different options. All the options a solver
supports are listed in the help-command of the specific solver, e.g.
`help_dopri5`.

To get an overview, what options are supported by what solvers,
call `ODEInterface.help_options()`.
"""
function help_options()
    # sort solvers alphabetically and give each solver a number
    solvers = sort(solverInfo, by = x -> x.name)
    # get for every option all the solvers that use this option
    opt_usage = Dict{Symbol, Set{SolverInfo}}()
    for solver in solvers
        for opt in solver.supported_opts
            if !haskey(opt_usage, opt)
                opt_usage[opt] = Set{SolverInfo}()
            end
            push!(opt_usage[opt], solver)
        end
    end
    # produce output: alphab. order for options
    io = IOBuffer()
    write(io, "## Solvers\n\n")
    for solver in solvers
        write(io, "1. ", solver.name, "\n")
    end
    write(io, "\n## Options used by Solvers\n\n")

    opts = collect(keys(opt_usage))
    sort!(opts)

    write(io, "      ╔══════════════════════")
    for k in 1:length(solvers)
        write(io, "╤══")
    end
    write(io, "╗\n")

    write(io, "      ║        Option        ")
    for k in 1:length(solvers)
        write(io, "│", lpad(string(k), 2))
    end
    write(io, "║\n")

    write(io, "      ╠══════════════════════")
    for k in 1:length(solvers)
        write(io, "╪══")
    end
    write(io, "╣\n")

    for opt in opts
        write(io, "      ║ ", rpad(opt, 21))
        for solver in solvers
            write(io, "│ ", (solver ∈ opt_usage[opt]) ? "✔" : " ")
        end
        write(io, "║\n")
    end

    write(io, "      ╚══════════════════════")
    for k in 1:length(solvers)
        write(io, "╧══")
    end
    write(io, "╝\n")

    return Markdown.parse(buf2str(io))
end

"""
## `OPT_OUTPUTMODE`

This option determines if the `OPT_OUTPUTFCN` is
called, and if dense output (the `eval_sol_fcn`) is prepared/supported.

* `OUTPUTFCN_NEVER`: don't call the output function
* `OUTPUTFCN_WODENSE`: call the output function, but `eval_sol_fcn`
  is not used
* `OUTPUTFCN_DENSE`: call the output function and prepare `eval_sol_fcn`

## `OPT_OUTPUTFCN`

     function outputfcn(reason::OUTPUTFCN_CALL_REASON,
      told::Float64,t::Float64, x::Vector{Float64},eval_sol_fcn::Function,
      extra_data::Dict)  -> OUTPUTFCN_RETURN_VALUE

A (julia) function that is called

1. at beginning of the solution process with
   `reason == OUTPUTFCN_CALL_INIT`, `told=t0`, `t`=`T`, `x=x0`,
   `eval_sol_fcn` a dummy function throwing an error if called,
   `extra_data` a `Dict` persistent until the last call of the output
   function. The return value is *ignored*.
1. after every successful integration step with
   `reason == OUTPUTFCN_CALL_STEP`, `[told,t]` the time interval of the
   last step, `x` the numerical solution at time `t`,
   `eval_sol_fcn` a function to evaluate the solution in `t1 ∊ [told,t]`, if
   requested by `OPT_OUTPUTMODE`, otherwise a call to this function will
   result in an error.
1. at the end (after the last step) with
   `reason == OUTPUTFCN_CALL_DONE`.
   The return value is *ignored*.

With `eval_sol_fcn`

        function eval_sol_fcn(t1::Float64) -> Vector{Float64}

the numerical solution can be evaluated in the
time interval `[told,t]` (if `OPT_OUTPUTMODE == OUTPUTFCN_DENSE`).

If supported by the solver, the numerical solution may be changed
in the `outputfcn` (if `reason == OUTPUTFCN_CALL_STEP`) and the solver
continues the process with the changed solution.
The return value `OUTPUTFCN_RET_CONTINUE_XCHANGED` indicates
this. `OUTPUTFCN_RET_CONTINUE` tells the solver to continue (without
changes in `x`) and `OUTPUTFCN_RET_STOP` tells the solver to stop the
solver.
"""
function help_outputfcn()
    return Docs.doc(help_outputfcn)
end

"""
## Special Structure

Some solvers (e.g. radau5 and radau) supports ODEs with a
"special structure". In this context an ODE has special structure
if there exists M1>0 and M2>0 and M1 = M⋅M2 for some integer M
and

                 x'(k) = x(k+M2)   for all k = 1,…,M1            (*)

There are the options `OPT_M1` and `OPT_M2` to tell the solvers, if the
ODE has this special structure. In this case only the non-trivial parts
of the right-hand side, of the mass matrix and of the Jacobian matrix
had to be supplied.

If an ODE has the special structure, then the right-hand side
for `OPT_RHS_CALLMODE == RHS_CALL_RETURNS_ARRAY` has to return
a vector of length d-M1 because the right-hand side for the first M1 entries
are known from (*). For `OPT_RHS_CALLMODE == RHS_CALL_INSITU` the
right-hand side gets (a reference) to the array of length d, but only
the last d-M1 components need to be filled in.

The mass matrix has the form

         ⎛ 1    │    ⎞ ⎫
         ⎜  ⋱   │    ⎟ ⎪
         ⎜   ⋱  │    ⎟ ⎬ M1
         ⎜    ⋱ │    ⎟ ⎪
    M =  ⎜     1│    ⎟ ⎭
         ⎜──────┼────⎟
         ⎜      │    ⎟ ⎫
         ⎜      │ M̃  ⎟ ⎬ d-M1
         ⎝      │    ⎠ ⎭

Then there has to be only the (d-M1)×(d-M1) matrix M̃ in `OPT_MASSMATRIX`.
Of course, M̃ can be banded. Then `OPT_MASSMATRIX` is a `BandedMatrix` with
lower bandwidth < d-M1.

If an ODE has the special structure, then the Jacobian matrix has the form

         ⎛0   1      ⎞ ⎫
         ⎜ ⋱   ⋱     ⎟ ⎪
         ⎜  ⋱   ⋱    ⎟ ⎬ M1
         ⎜   ⋱   ⋱   ⎟ ⎪
    J =  ⎜    0   1  ⎟ ⎭
         ⎜───────────⎟
         ⎜           ⎟ ⎫
         ⎜      J̃    ⎟ ⎬ d-M1
         ⎝           ⎠ ⎭

Then there has to be only the (d-M1)×d matrix J̃ in `OPT_JACOBIMATRIX`.
In this case banded Jacobian matrices are only supported for the
case M1 + M2 == d. Then in this case J̃ is divided into d/M2 = 1+(M1/M2)
blocks of the size M2×M2. All this blocks can be banded with a (common)
lower bandwidth < M2.

The option `OPT_JACOBIBANDSTRUCT` is used to describe the banded structure
of the Jacobian. It is eigher `nothing` if the Jacobian is full or a
tuple `(l,u)` with the lower and upper bandwidth.

The function for providing the Jacobian for ∂f/∂x can have the following
forms:

     function (t,x,J)       -> nothing       (A)
     function (t,x,J1,…,JK) -> nothing       (B)

The following table shows when `OPT_JACOBIMATRIX` has the form (A)
and when it has the form (B):

     ╔══════╤═════════════════════════════╤════════════════════════════════╗
     ║      │ JACOBIBANDSTRUCT == nothing │ JACOBIBANDSTRUCT == (l,u)      ║
     ╟──────┼─────────────────────────────┼────────────────────────────────╢
     ║ M1==0│ (A), J full, size: d×d      │ (A) J (l,u)-banded, size d×d   ║
     ╟──────┼─────────────────────────────┼────────────────────────────────╢
     ║ M1>0 │ (A), J full, size: (d-M1)×d │ (B) J1,…,JK (l,u)-banded       ║
     ║      │                             │     each with size M2×M2 and   ║
     ║      │                             │     K = 1 + M1/M2              ║
     ║      │                             │     M1 + M2 == d               ║
     ╚══════╧═════════════════════════════╧════════════════════════════════╝
"""
function help_specialstructure()
    return Docs.doc(help_specialstructure)
end

"""
## Internals

1. What is the typical "call stack" for all this callbacks? see
   documentation of `DopriInternalCallInfos`,  `OdexInternalCallInfos` and
   `Radau5InternalCallInfos`.
1. What closures (and how many) are generated to support the `eval_sol_fcn`?
   see `create_radau_eval_sol_fcn_closure`
"""
function help_internals()
    return Docs.doc(help_internals)
end

# vim:syn=julia:cc=79:fdm=indent:

# Load the required packages
using ODE
using JLD

# Set precision to quadruple precision (QP)
# QP has 113 bits
set_bigfloat_precision(113);

# Define the right-hand function
function arenstorf(t, x)

    mu = parse(BigFloat, "0.012277471"); ms = 1 - mu
    r1 = vecnorm(x[1:2] - [-mu, 0])
    r2 = vecnorm(x[1:2] - [ms, 0])

    dx = Vector{BigFloat}(4)
    dx[1] = x[3]
    dx[2] = x[4]
    dx[3] = x[1] + 2 * x[4] - ms * (x[1] + mu) / r1^3 - mu * (x[1] - ms) / r2^3
    dx[4] = x[2] - 2 * x[3] - ms * x[2] / r1^3 - mu * x[2] / r2^3
    return dx
end

# Set up the initial conditions
t0 = parse(BigFloat, "0.0");
T = parse(BigFloat, "17.0652165601579625588917206249");
x0 = [
    parse(BigFloat, "0.994"),
    parse(BigFloat, "0.0"), parse(BigFloat, "0.0"),
    parse(BigFloat, "-2.00158510637908252240537862224"),
];

# Set the tolerance as machine epsilon
Tol = parse(BigFloat, "1e-33");

# Solve and get the solution at T = tEnd
(t, x_ref) = ode78(
    arenstorf, x0, [t0, T];
    reltol = Tol, abstol = Tol, points = :specified
);

# Save the solution to a file
save("refSolAren.jld", "x_ref", x_ref[2]);

# Functions used for SLATEC Solvers like DDEABM

"""
Some solvers have the concept of continuation calls (CC). This can be used
to get some "kind" of dense output support. How does this work?

Typically the solver "overshoots" beyond T for calculating the solution
at T (then with the help of interpolation):

                                                ↓ intermediate steps
     ──╫───┼────┼────┼─╫───┼─────             ──┼──
       t₀              T

[Use `OPT_TSTOP` if the right-hand side is not defined for some t>T or
if there are singularities.]

If you do a CC and you want the solution at new Tₙ, then in the situation

     ──╫───┼────┼────┼─╫──╫┼─────
       t₀              T  Tₙ

where Tₙ is in the already computed interval, the solution at Tₙ can be
computed simply by interpolation.
If Tₙ is beyond the last computed interval then the solver continues with
the process of numerical integration.

So CC can be cheap and the solver is optimized for CC. CC are much more
efficient than a "restart" at T.
"""
const SLATEC_continuation_call = nothing

"""
## License

The solver ddeabm is part of the SLATEC Common Mathematical Library which
is in the public domain. More information can be found at

     http://www.netlib.org/slatec/guide

"""
const SLATEC_license = nothing

"""
checks if output mode is supported and gives hint to
`OPT_OUTPUTATTIMES` if the mode `OUTPUTFCN_DENSE` was requested.
"""
function check_slatec_output_mode(output_mode::OUTPUTFCN_MODE)
    if output_mode == OUTPUTFCN_DENSE
        throw(
            ArgumentErrorODE(
                string(
                    "Option 'OPT_OUTPUTMODE': Dense output not supported by this ",
                    "solver. See description of 'OPT_OUTPUTMODE' and ",
                    "'OPT_OUTPUTATTIMES' for the possibility to get the solution at ",
                    "predefined time values"
                ),
                :opt
            )
        )
    end
    return nothing
end

"""
     function extractSlatecJacobiOpt(d::FInt,
             opt::AbstractOptionsODE) where FInt<:FortranInt

extracts jacobi options for some SLATEC solvers, like ddebdf.
"""
function extractSlatecJacobiOpt(
        d::FInt,
        opt::AbstractOptionsODE
    ) where {FInt <: FortranInt}
    OPT, jacobimatrix, jacobibandstruct = nothing, nothing, nothing
    try
        OPT = OPT_JACOBIMATRIX
        jacobimatrix = getOption(opt, OPT, nothing)
        # @assert jacobimatrix === nothing || isa(jacobimatrix,Function)

        OPT = OPT_JACOBIBANDSTRUCT
        bs = getOption(opt, OPT, nothing)

        if bs !== nothing
            jacobibandstruct = (convert(FInt, bs[1]), convert(FInt, bs[2]))
            @assert 0 ≤ jacobibandstruct[1] ≤ d
            @assert 0 ≤ jacobibandstruct[2] ≤ d
        end
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end
    return (jacobimatrix, jacobibandstruct)
end

"""
handles OPT_OUTPUTATTIMES for some SLATEC solvers, like ddeabm, ddebdf.

returns always an Float64-Vector. Even if nothing was given by the user.
If there was a vector given then it is copied and checked for
monotonicity.
"""
function extractSlatecOutputAtTimes(t0, T, opt::AbstractOptionsODE)
    t_values = getOption(opt, OPT_OUTPUTATTIMES, nothing)
    if t_values === nothing
        t_values = zeros(Float64, 0)
    end
    output_attimes_given = length(t_values) > 0

    # convert *and* copy given OPT_OUTPUTATTIMES
    # "copy", because t_values will (typically) be changed by the caller
    try
        t_values = getVectorCheckLength(t_values, Float64, length(t_values), true)
    catch e
        throw(
            ArgumentErrorODE(
                string(
                    "I've a problem converting OPT_OUTPUTATTIMES to a ",
                    "Float64-Vector"
                ), :opt, e
            )
        )
    end

    if output_attimes_given
        s = sign(T - t0)
        if any(x -> sign(x) != s, diff(t_values))
            throw(
                ArgumentErrorODE(
                    string(
                        "Because sign(T-t0)=sign($T-$t0)=$s ",
                        "the vector in OPT_OUTPUTATTIMES has to be ",
                        (T ≥ t0 ? "ascending" : "descending"),
                        ". But this is not the case."
                    ), :opt
                )
            )
        end
        if s * (t0 - t_values[1]) ≥ 0 || s * (t_values[end] - T) ≥ 0
            throw(
                ArgumentErrorODE(
                    string(
                        "All values of OPT_OUTPUTATTIMES ",
                        "must be between t0=$t0 and T=$T"
                    ), :opt
                )
            )
        end
    end

    return t_values::Vector{Float64}
end

"""
     function unsafe_SLATEC1RHSCallback(
             t_::Ptr{Float64}, x_::Ptr{Float64}, f_::Ptr{Float64},
             rpar_::Ptr{Float64}, cbi::CI) where CI<:ODEinternalCallInfos

This is the right-hand side given as callback to SLATEC solvers,
e.g. ddeabm.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.
"""
function unsafe_SLATEC1RHSCallback(
        t_::Ptr{Float64}, x_::Ptr{Float64}, f_::Ptr{Float64},
        rpar_::Ptr{Float64}, cbi::CI
    ) where {CI <: ODEinternalCallInfos}
    n = cbi.N
    t = unsafe_load(t_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    f = unsafe_wrap(Array, f_, (n,), own = false)

    cbi.rhs_count += 1
    hw1rhs(n, t, x, f, cbi)
    return nothing
end

"""
     function unsafe_SLATEC1RHSCallback_c(cbi::CI,
             fint_flag::FInt) where {FInt,CI}
        -> C-callable function pointer

This method generates a Pointer to C-callable instructions.
The two method type parameters `FInt` and `CI` are important:
`FInt` is the used Fortran integer type and `CI` is the used
`ODEinternalCallInfos` *SubType*.
Because `unsafe_SLATEC1RHSCallback` is a parameterized method,
special variants are compiled, if `FInt` or `CI` changes.
If `CI` itself is a parameterized type (depending on all the
user-given Julia-functions like right-hand side, etc.) then
calls to such Julia-functions can be resolved at compile-time
(instead of dynamic calls during run-time).
"""
function unsafe_SLATEC1RHSCallback_c(
        cbi::CI,
        fint_flag::FInt
    ) where {FInt, CI}
    return @cfunction(
        unsafe_SLATEC1RHSCallback, Cvoid, (
            Ptr{Float64},
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ref{CI},
        )
    )
end


function unsafe_SLATEC1JacCallback(
        t_::Ptr{Float64}, x_::Ptr{Float64},
        dfx_::Ptr{Float64}, dfx_rows_::Ptr{FInt}, rpar_::Ptr{Float64},
        cbi::CI
    ) where {FInt <: FortranInt, CI <: ODEinternalCallInfos}
    n = cbi.N
    t = unsafe_load(t_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    dfx_rows = unsafe_load(dfx_rows_)
    M = unsafe_wrap(Array, dfx_, (dfx_rows, n), own = false)

    cbi.jac_count += 1

    lprefix = cbi.jac_lprefix
    (lio, l) = (cbi.logio, cbi.loglevel)
    l_jac = l & LOG_JAC > 0

    l_jac && println(lio, lprefix, "called with dfx_rows=", dfx_rows, " t=", t)
    jac = cbi.jacobimatrix
    jb = cbi.jacobibandstruct
    if jb === nothing
        @assert dfx_rows == n
        J = M
        jac(t, x, J)
    else
        @assert dfx_rows ≥ 1 + 2 * jb[1] + jb[2]
        banded_memory = cbi.submatrix(M, (1 + jb[1]):(1 + 2 * jb[1] + jb[2]), :)
        J = BandedMatrix{Float64}(n, n, jb[1], jb[2], banded_memory)
        jac(t, x, J)
    end
    l_jac && println(lio, lprefix, "dfx=", M)
    return nothing
end

"""
     function unsafe_SLATEC1JacCallback_c(cbi::CI,
             fint_flag::FInt) where {FInt, CI}
        -> C-callable function pointer
"""
function unsafe_SLATEC1JacCallback_c(
        cbi::CI,
        fint_flag::FInt
    ) where {FInt, CI}
    return @cfunction(
        unsafe_SLATEC1JacCallback, Cvoid, (
            Ptr{Float64},
            Ptr{Float64}, Ptr{Float64}, Ptr{FInt}, Ptr{Float64}, Ref{CI},
        )
    )
end

# vim:syn=julia:cc=79:fdm=indent:

# Functions used for several Hairer-Wanner Solvers

function hw1rhs(
        n::FInt, t::Float64, x::Array{Float64},
        f::Array{Float64}, cbi::CI
    ) where {FInt, CI}

    lprefix = cbi.rhs_lprefix

    (lio, l) = (cbi.logio, cbi.loglevel)
    l_rhs = l & LOG_RHS > 0

    l_rhs && println(lio, lprefix, "called with n=", n, " t=", t, " x=", x)
    if cbi.rhs_mode == RHS_CALL_INSITU
        cbi.rhs(t, x, f)
    elseif cbi.rhs_mode == RHS_CALL_RETURNS_ARRAY
        result = cbi.rhs(t, x)
        try
            f[:] = getVectorCheckLength(result, Float64, n, false)
        catch e
            throw(
                OutputErrorODE(
                    string(
                        "Cannot convert result $result of ", cbi.rhs, " to ",
                        "Vector{Float64} of length $n"
                    ), cbi.rhs, e
                )
            )
        end
    else
        throw(InternalErrorODE("Unknown cbi.rhs_mode"))
    end
    l_rhs && println(lio, lprefix, "rhs result=", f)
    return nothing
end

"""
     function unsafe_HW1RHSCallback(
             n_::Ptr{FInt}, t_::Ptr{Float64}, x_::Ptr{Float64},
             f_::Ptr{Float64}, rpar_::Ptr{Float64},
             cbi::CI) where {FInt<:FortranInt, CI<:ODEinternalCallInfos}
              -> nothing

This is the right-hand side given as callback to several Fortran-solvers,
e.g. dopri5, dop853, odex.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.
"""
function unsafe_HW1RHSCallback(
        n_::Ptr{FInt}, t_::Ptr{Float64}, x_::Ptr{Float64},
        f_::Ptr{Float64}, rpar_::Ptr{Float64},
        cbi::CI
    ) where {FInt <: FortranInt, CI <: ODEinternalCallInfos}

    n = unsafe_load(n_); t = unsafe_load(t_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    f = unsafe_wrap(Array, f_, (n,), own = false)

    hw1rhs(n, t, x, f, cbi)
    return nothing
end

"""
     function unsafe_HW1RHSCallback_c(cbi::CI,
             fint_flag::FInt) where {FInt,CI}
        -> C-callable function pointer

This method generates a Pointer to C-callable instructions.
The two method type parameters `FInt` and `CI` are important:
`FInt` is the used Fortran integer type and `CI` is the used
`ODEinternalCallInfos` *SubType*.
Because `unsafe_HW1RHSCallback` is a parameterized method,
special variants are compiled, if `FInt` or `CI` changes.
If `CI` itself is a parameterized type (depending on all the
user-given Julia-functions like right-hand side, etc.) then
calls to such Julia-functions can be resolved at compile-time
(instead of dynamic calls during run-time).
"""
function unsafe_HW1RHSCallback_c(
        cbi::CI,
        fint_flag::FInt
    ) where {FInt, CI}
    return @cfunction(
        unsafe_HW1RHSCallback, Cvoid, (
            Ptr{FInt}, Ptr{Float64},
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ref{CI},
        )
    )
end

"""
     function unsafe_HW2RHSCallback(
             n_::Ptr{FInt}, t_::Ptr{Float64}, x_::Ptr{Float64},
             f_::Ptr{Float64}, rpar_::Ptr{Float64},
             cbi::CI) where {FInt<:FortranInt, CI<:ODEinternalCallInfos}
              -> nothing

This is the right-hand side given as callback to Fortran-solvers
(e.g. radau5 and radau) that can handle problems with "special structure",
see `help_specialstructure`.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.
"""
function unsafe_HW2RHSCallback(
        n_::Ptr{FInt}, t_::Ptr{Float64}, x_::Ptr{Float64},
        f_::Ptr{Float64}, rpar_::Ptr{Float64},
        cbi::CI
    ) where {FInt <: FortranInt, CI <: ODEinternalCallInfos}

    n = unsafe_load(n_); t = unsafe_load(t_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    f = unsafe_wrap(Array, f_, (n,), own = false)

    lprefix = cbi.rhs_lprefix

    (lio, l) = (cbi.logio, cbi.loglevel)
    l_rhs = l & LOG_RHS > 0

    l_rhs && println(lio, lprefix, "called with n=", n, " t=", t, " x=", x)
    if cbi.M1 > 0
        # Problem with special structure, fill in special structure in f
        for k in 1:cbi.M1
            f[k] = x[k + cbi.M2]
        end
    end
    if cbi.rhs_mode == RHS_CALL_INSITU
        cbi.rhs(t, x, f)
    elseif cbi.rhs_mode == RHS_CALL_RETURNS_ARRAY
        result = cbi.rhs(t, x)
        try
            f[(cbi.M1 + 1):n] = getVectorCheckLength(result, Float64, n - cbi.M1, false)
        catch e
            throw(
                OutputErrorODE(
                    string(
                        "Cannot convert result $result of ", cbi.rhs, " to ",
                        "Vector{Float64} of length d-M1=", n, "-", cbi.M1, "=", n - cbi.M1
                    ),
                    cbi.rhs, e
                )
            )
        end
    else
        throw(InternalErrorODE("Unknown cbi.rhs_mode"))
    end
    l_rhs && println(lio, lprefix, "rhs result=", f)
    return nothing
end

"""
     function unsafe_HW2RHSCallback_c(cbi::CI,
             fint_flag::FInt) where {FInt,CI}
        -> C-callable function pointer

see `unsafe_HW1RHSCallback_c` for an explanation of `FInt`, `CI`.
"""
function unsafe_HW2RHSCallback_c(
        cbi::CI,
        fint_flag::FInt
    ) where {FInt, CI}
    return @cfunction(
        unsafe_HW2RHSCallback, Cvoid, (
            Ptr{FInt}, Ptr{Float64},
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ref{CI},
        )
    )
end

"""
     function unsafe_HW1MassCallback(n_::Ptr{FInt}, am_::Ptr{Float64},
             lmas_::Ptr{FInt}, rpar_::Ptr{Float64},
             cbi::CI) where {FInt<:FortranInt,CI<:ODEinternalCallInfos}
              -> nothing

This is the MAS callback given to radau5, radau and seulex.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-pointers.

This function takes the values of  the mass matrix saved in
the InternalCallInfos.
"""
function unsafe_HW1MassCallback(
        n_::Ptr{FInt}, am_::Ptr{Float64},
        lmas_::Ptr{FInt}, rpar_::Ptr{Float64},
        cbi::CI
    ) where {FInt <: FortranInt, CI <: ODEinternalCallInfos}
    n = unsafe_load(n_)
    lmas = unsafe_load(lmas_)
    am = unsafe_wrap(Array, am_, (lmas, n), own = false)
    lprefix = "unsafe_HW1MassCallback: "

    (lio, l) = (cbi.logio, cbi.loglevel)
    l_mas = l & LOG_MASS > 0

    l_mas && println(lio, lprefix, "called with n=", n, " lmas=", lmas)

    mas = cbi.massmatrix

    if isa(mas, BandedMatrix)
        @assert n == size(mas, 2)
        @assert lmas == 1 + mas.l + mas.u
        bm = BandedMatrix{Float64}(mas.m, mas.n, mas.l, mas.u, am::Matrix{Float64})
        setdiagonals!(bm, mas)
    else
        @assert (lmas, n) == size(mas)
        am[:] = mas
    end

    l_mas && println(lio, lprefix, "am=", am)
    return nothing
end

"""
     function unsafe_HW1MassCallback_c(cbi::CI,
             fint_flag::FInt) where {FInt,CI}
        -> C-callable function pointer
"""
function unsafe_HW1MassCallback_c(
        cbi::CI,
        fint_flag::FInt
    ) where {FInt, CI}
    return @cfunction(
        unsafe_HW1MassCallback, Cvoid, (
            Ptr{FInt},
            Ptr{Float64}, Ptr{FInt}, Ptr{Float64}, Ref{CI},
        )
    )
end

"""
     function extractSpecialStructureOpt(
             d::FInt,opt::AbstractOptionsODE) where FInt<:FortranInt

extracts parameters for special structure (M1, M2).

reads options: `OPT_M1`, `OPT_M2`
"""
function extractSpecialStructureOpt(
        d::FInt, opt::AbstractOptionsODE
    ) where {FInt <: FortranInt}
    OPT = nothing
    M1 = 0; M2 = 0; NM1 = 0
    try
        OPT = OPT_M1; M1 = convert(FInt, getOption(opt, OPT, 0))
        @assert M1 ≥ 0
        OPT = OPT_M2; M2 = convert(FInt, getOption(opt, OPT, M1))
        @assert M2 ≥ 0

        OPT = string(OPT_M1, " & ", OPT_M2)
        @assert M1 + M2 ≤ d
        @assert (M1 == M2 == 0) || (M1 ≠ 0 ≠ M2)
        @assert (M1 == 0) || (0 == M1 % M2)
        NM1 = d - M1
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end
    return (M1, M2, NM1)
end

"""
     function extractMassMatrix(M1::FInt, M2::FInt,
             NM1::FInt, args::AbstractArgumentsODESolver{FInt},
             opt::AbstractOptionsODE) where FInt<:FortranInt

extracts mass matrix and fills `IMAS`, `MLMAS` und `MUMAS` in args.

reads options: `OPT_MASSMATRIX`
"""
function extractMassMatrix(
        M1::FInt, M2::FInt,
        NM1::FInt, args::AbstractArgumentsODESolver{FInt},
        opt::AbstractOptionsODE
    ) where {FInt <: FortranInt}
    OPT = nothing
    massmatrix = nothing
    try
        OPT = OPT_MASSMATRIX
        massmatrix = getOption(opt, OPT, nothing)
        if massmatrix === nothing
            args.IMAS = [0]; args.MLMAS = [0]; args.MUMAS = [0]
        else
            @assert 2 == ndims(massmatrix)
            @assert (NM1, NM1) == size(massmatrix)
            massmatrix = deepcopy(massmatrix)
            args.IMAS = [1]
            # A BandedMatrix with lower bandwidth == NM1 is treated as full!
            if isa(massmatrix, BandedMatrix) && massmatrix.l == NM1
                massmatrix = full(massmatrix)
            end
            if isa(massmatrix, BandedMatrix)
                @assert massmatrix.l < NM1
                args.MLMAS = [massmatrix.l]
                args.MUMAS = [massmatrix.u]
            else
                massmatrix = convert(Matrix{Float64}, massmatrix)
                args.MLMAS = [NM1]; args.MUMAS = [NM1]
            end
        end
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end
    return massmatrix
end

"""
     function unsafe_HW1JacCallback(n_::Ptr{FInt},
             t_::Ptr{Float64},x_::Ptr{Float64},dfx_::Ptr{Float64},
             ldfx_::Ptr{FInt}, rpar_::Ptr{Float64},
             cbi::CI) where {FInt<:FortranInt, CI<:ODEinternalCallInfos}
              -> nothing

This is the JAC callback given to radau5, radau and seulex.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-pointers.

This function calls the user-given Julia function cbi.jacobimatrix
with the appropriate arguments (depending on M1 and jacobibandstruct).
"""
function unsafe_HW1JacCallback(
        n_::Ptr{FInt},
        t_::Ptr{Float64}, x_::Ptr{Float64}, dfx_::Ptr{Float64},
        ldfx_::Ptr{FInt}, rpar_::Ptr{Float64},
        cbi::CI
    ) where {FInt <: FortranInt, CI <: ODEinternalCallInfos}
    n = unsafe_load(n_)
    t = unsafe_load(t_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    ldfx = unsafe_load(ldfx_)

    lprefix = cbi.jac_lprefix
    (lio, l) = (cbi.logio, cbi.loglevel)
    l_jac = l & LOG_JAC > 0

    l_jac && println(lio, lprefix, "called with n=", n, " ldfx=", ldfx)
    jac = cbi.jacobimatrix
    jb = cbi.jacobibandstruct
    M = unsafe_wrap(Array, dfx_, (ldfx, n), own = false)::Matrix{Float64}
    if jb === nothing
        @assert ldfx == n - cbi.M1
        J = M
        jac(t, x, J)
    else
        @assert ldfx == 1 + jb[1] + jb[2]
        if cbi.M1 == 0
            J = BandedMatrix{Float64}(n, n, jb[1], jb[2], M)
            jac(t, x, J)
        else
            no = Int(cbi.M1 / cbi.M2 + 1)
            J = Vector{BandedMatrix{Float64}}(undef, no)
            for k in 1:no
                ptr = dfx_ + (k - 1) * ldfx * cbi.M2 * sizeof(Float64)
                darr = unsafe_wrap(Array, ptr, (ldfx, cbi.M2), own = false)
                J[k] = BandedMatrix{Float64}(cbi.M2, cbi.M2, jb[1], jb[2], darr)
            end
            jac(t, x, J...)
        end
    end

    l_jac && println(lio, lprefix, "dfx=", M)
    return nothing
end

"""
     function unsafe_HW1JacCallback_c(cbi::CI,
             fint_flag::FInt) where {FInt,CI}
        -> C-callable function pointer
"""
function unsafe_HW1JacCallback_c(
        cbi::CI,
        fint_flag::FInt
    ) where {FInt, CI}
    return @cfunction(
        unsafe_HW1JacCallback, Cvoid, (
            Ptr{FInt},
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64},
            Ptr{FInt}, Ptr{Float64}, Ref{CI},
        )
    )
end


"""
     function unsafe_HWRhsTimeDerivCallback(
             n_::Ptr{FInt}, t_::Ptr{Float64},x_::Ptr{Float64},
             dfdt_::Ptr{Float64}, rpar_::Ptr{Float64},
             cbi::CI) where {FInt<:FortranInt, CI<:ODEinternalCallInfos}
              -> nothing

This is the DFX callback given to rodas.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-pointers.

This function calls the user-given Julia function cbi.rhstimederiv
with the appropriate arguments.
"""
function unsafe_HWRhsTimeDerivCallback(
        n_::Ptr{FInt}, t_::Ptr{Float64}, x_::Ptr{Float64},
        dfdt_::Ptr{Float64}, rpar_::Ptr{Float64},
        cbi::CI
    ) where {FInt <: FortranInt, CI <: ODEinternalCallInfos}
    n = unsafe_load(n_)
    t = unsafe_load(t_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    dfdt = unsafe_wrap(Array, dfdt_, (n,), own = false)

    lprefix = cbi.rhsdt_prefix
    (lio, l) = (cbi.logio, cbi.loglevel)
    l_rhsdt = l & LOG_RHSDT > 0

    l_rhsdt && println(lio, lprefix, "called with n=", n, " t=", t)
    cbi.rhsdt(t, x, dfdt)
    l_rhsdt && println(lio, lprefix, "dfdt=", dfdt)

    return nothing
end

"""
     function unsafe_HWRhsTimeDerivCallback_c(cbi::CI,
             fint_flag::FInt) where {FInt,CI}
        -> C-callable function pointer
"""
function unsafe_HWRhsTimeDerivCallback_c(
        cbi::CI,
        fint_flag::FInt
    ) where {FInt, CI}
    return @cfunction(
        unsafe_HWRhsTimeDerivCallback, Cvoid, (
            Ptr{FInt},
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ref{CI},
        )
    )
end

"""
     function extractJacobiOpt(d::FInt,
             M1::FInt,M2::FInt, NM1::FInt,
             args::AbstractArgumentsODESolver{FInt},
             opt::AbstractOptionsODE) where FInt<:FortranInt

extracts jacobi options and
fills `IJAC`, `MLJAC` and `MUJAC` in args.

reads options: `OPT_JACOBIMATRIX`, `OPT_JACOBIBANDSTRUCT`
"""
function extractJacobiOpt(
        d::FInt,
        M1::FInt, M2::FInt, NM1::FInt,
        args::AbstractArgumentsODESolver{FInt},
        opt::AbstractOptionsODE
    ) where {FInt <: FortranInt}
    OPT = nothing
    jacobimatrix = nothing
    jacobibandstruct = nothing
    try
        OPT = OPT_JACOBIMATRIX
        jacobimatrix = getOption(opt, OPT, nothing)
        # @assert (jacobimatrix === nothing) || isa(jacobimatrix,Function)

        OPT = OPT_JACOBIBANDSTRUCT
        bs = getOption(opt, OPT, nothing)

        if bs !== nothing
            jacobibandstruct = (convert(FInt, bs[1]), convert(FInt, bs[2]))
            if jacobibandstruct[1] == NM1
                # A BandedMatrix with lower bandwidth == NM1 is treated as full!
                jacobibandstruct = nothing
            end
        end
        if jacobibandstruct !== nothing
            @assert (M1 == 0) || (M1 + M2 == d)
            @assert 0 ≤ jacobibandstruct[1] < NM1
            @assert  (M1 == 0 && 0 ≤ jacobibandstruct[2] ≤ d)  ||
                (M1 > 0  && 0 ≤ jacobibandstruct[2] ≤ M2)
        end
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    args.IJAC = [jacobimatrix === nothing ? 0 : 1]
    args.MLJAC = [jacobibandstruct === nothing ? d : jacobibandstruct[1]]
    args.MUJAC = [jacobibandstruct === nothing ? d : jacobibandstruct[2]]
    jac_lprefix = "unsafe_HW1JacCallback: "
    return (jacobimatrix, jacobibandstruct, jac_lprefix)
end

"""
     function extractRhsTimeDerivOpt(
             args::AbstractArgumentsODESolver{FInt},
             opt::AbstractOptionsODE) where FInt<:FortranInt

extracts options for callback function for time-derivatives
of the right-hand-side and
fills `IDFX` in args.
"""
function extractRhsTimeDerivOpt(
        args::AbstractArgumentsODESolver{FInt},
        opt::AbstractOptionsODE
    ) where {FInt <: FortranInt}
    OPT = OPT_RHSTIMEDERIV
    rhstimederiv = nothing
    try
        rhstimederiv = getOption(opt, OPT, nothing)
        # @assert (rhstimederiv === nothing) || isa(rhstimederiv,Function)
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    args.IDFX = [rhstimederiv === nothing ? 0 : 1]
    rhsdt_prefix = "unsafe_HWRhsTimeDerivCallback: "
    return (rhstimederiv, rhsdt_prefix)
end

"""
## License

This is the license text, which can also be found at

     http://www.unige.ch/~hairer/prog/licence.txt

Copyright (c) 2004, Ernst Hairer

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

- Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS “AS
IS” AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""
const hw_license = nothing

# vim:syn=julia:cc=79:fdm=indent:

# Functions for ODE-Solver: Radau5 and Radau

"""Name for Loading radau5 solver (64bit integers)."""
const DL_RADAU5 = "radau5"

"""Name for Loading radau5 solver (32bit integers)."""
const DL_RADAU5_I32 = "radau5_i32"

"""Name for Loading radau solver (64bit integers)."""
const DL_RADAU = "radau"

"""Name for Loading radau solver (32bit integers)."""
const DL_RADAU_I32 = "radau_i32"

"""macro for import Radau5 solver."""
macro import_radau5()
    return :(
        using ODEInterface: radau5, radau5_i32
    )
end

"""macro for import Radau solver."""
macro import_radau()
    return :(
        using ODEInterface: radau, radau_i32
    )
end

"""macro for import Radau5 dynamic lib names."""
macro import_DLradau5()
    return :(
        using ODEInterface: DL_RADAU5, DL_RADAU5_I32
    )
end

"""macro for import Radau dynamic lib names."""
macro import_DLradau()
    return :(
        using ODEInterface: DL_RADAU, DL_RADAU_I32
    )
end

"""macro for importing Radau5 help."""
macro import_radau5_help()
    return :(
        using ODEInterface: help_radau5_compile, help_radau5_license
    )
end

"""macro for importing Radau help."""
macro import_radau_help()
    return :(
        using ODEInterface: help_radau_compile, help_radau_license
    )
end

"""
Type encapsulating all required data for Radau5/Radau-Solver-Callbacks.

We have the typical calling stack:

     radau5/radau
         call_julia_output_fcn(  ... INIT ... )
             output_fcn ( ... INIT ...)
         ccall( RADAU5_/RADAU_ ... )
             unsafe_HW1MassCallback
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_HW2RHSCallback                      │  ⎬ cb. rhs
            │    rhs                                    │  ⎪
            └───────────────────────────────────────────┘  ⎭
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_radauSoloutCallback                 │  ⎪
            │    call_julia_output_fcn( ... STEP ...)   │  ⎪ cb. solout
            │        output_fcn ( ... STEP ...)         │  ⎬ with eval
            │            eval_sol_fcn                   │  ⎪
            │                ccall(CONTR5_/CONTRA_ ... )│  ⎪
            └───────────────────────────────────────────┘  ⎭
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_HW1JacCallback:                     │  ⎬ cb. jacobian
            │    call_julia_jac_fcn(             )      │  ⎪
            └───────────────────────────────────────────┘  ⎭
         call_julia_output_fcn(  ... DONE ... )
             output_fcn ( ... DONE ...)
"""
mutable struct RadauInternalCallInfos{
        FInt <: FortranInt, RHS_F,
        OUT_F, JAC_F,
    } <: ODEinternalCallInfos
    logio::IO                    # where to log
    loglevel::UInt64                # log level
    # special structure
    M1::FInt
    M2::FInt
    # RHS:
    rhs::RHS_F                 # right-hand-side
    rhs_mode::RHS_CALL_MODE         # how to call rhs
    rhs_lprefix::AbstractString        # saved log-prefix for rhs
    # SOLOUT & output function
    output_mode::OUTPUTFCN_MODE        # what mode for output function
    output_fcn::OUT_F                 # the output function to call
    output_data::Dict                  # extra_data for output_fcn
    out_lprefix::AbstractString        # saved log-prefix for solout
    eval_sol_fcn::Function              # eval_sol_fcn
    eval_lprefix::AbstractString        # saved log-prefix for eval_sol
    tOld::Float64               # tOld and
    tNew::Float64               # tNew and
    xNew::Vector{Float64}       # xNew of current solout interval
    cont_i::Vector{FInt}          # argument to contex
    cont_s::Vector{Float64}       # argument to contex
    cont_cont::Ptr{Float64}          # saved pointers for contr5
    cont_lrc::Ptr{FInt}             # saved pointers for contr5
    # Massmatrix
    massmatrix::AbstractArray{Float64} # saved mass matrix
    # Jacobimatrix
    jacobimatrix::JAC_F                 # function for jacobi matrix
    jacobibandstruct                      # (l,u) bandstructure or nothing
    jac_lprefix::AbstractString        # saved log-prefix for jac
end

"""
     type RadauArguments{FInt<:FortranInt} <:
              AbstractArgumentsODESolver{FInt}

Stores Arguments for Radau5 and Radau solver.

FInt is the Integer type used for the fortran compilation.
"""
mutable struct RadauArguments{FInt <: FortranInt} <: AbstractArgumentsODESolver{FInt}
    N::Vector{FInt}      # Dimension
    FCN::Ptr{Cvoid}        # rhs callback
    t::Vector{Float64}   # start time (and current)
    tEnd::Vector{Float64}   # end time
    x::Vector{Float64}   # initial value (and current state)
    H::Vector{Float64}   # initial step size
    RTOL::Vector{Float64}   # relative tolerance
    ATOL::Vector{Float64}   # absolute tolerance
    ITOL::Vector{FInt}      # switch for RTOL, ATOL
    JAC::Ptr{Cvoid}        # jacobian callback
    IJAC::Vector{FInt}      # jacobian given as callback?
    MLJAC::Vector{FInt}      # lower bandwidth of jacobian
    MUJAC::Vector{FInt}      # upper bandwidth of jacobian
    MAS::Ptr{Cvoid}
    IMAS::Vector{FInt}      # mass matrix given as callback?
    MLMAS::Vector{FInt}      # lower bandwidth of mass matrix
    MUMAS::Vector{FInt}      # upper bandwidth of mass matrix
    SOLOUT::Ptr{Cvoid}        # solout callback
    IOUT::Vector{FInt}      # switch for SOLOUT
    WORK::Vector{Float64}   # double working array
    LWORK::Vector{FInt}      # length of WORK
    IWORK::Vector{FInt}      # integer working array
    LIWORK::Vector{FInt}      # length of IWORK
    RPAR::Vector{Float64}   # add. double-array
    IPAR::Ref{RadauInternalCallInfos} # misuse IPAR
    IDID::Vector{FInt}      # Status code
    ## Allow uninitialized construction
    function RadauArguments{FInt}(dummy::FInt) where {FInt}
        return new{FInt}()
    end
end


"""
     function unsafe_radauSoloutCallback(
             nr_::Ptr{FInt}, told_::Ptr{Float64}, t_::Ptr{Float64},
             x_::Ptr{Float64}, cont_::Ptr{Float64}, lrc_::Ptr{FInt},
             n_::Ptr{FInt}, rpar_::Ptr{Float64},
             cbi::CI, irtrn_::Ptr{FInt}) where {FInt<:FortranInt,
                                                CI<:RadauInternalCallInfos}

This is the solout given as callback to Fortran radau5/radau.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-pointers.

This function saves the state information of the solver in
`RadauInternalCallInfos`, where they can be found by
the `eval_sol_fcn`, see `create_radau_eval_sol_fcn_closure`.

Then the user-supplied `output_fcn` is called (which in turn can use
`eval_sol_fcn`, to evaluate the solution at intermediate points).

The return value of the `output_fcn` is propagated to `RADAU5_`/`RADAU_`.

For the typical calling sequence, see `RadauInternalCallInfos`.
"""
function unsafe_radauSoloutCallback(
        nr_::Ptr{FInt}, told_::Ptr{Float64}, t_::Ptr{Float64},
        x_::Ptr{Float64}, cont_::Ptr{Float64}, lrc_::Ptr{FInt},
        n_::Ptr{FInt}, rpar_::Ptr{Float64},
        cbi::CI, irtrn_::Ptr{FInt}
    ) where {
        FInt <: FortranInt,
        CI <: RadauInternalCallInfos,
    }

    nr = unsafe_load(nr_); told = unsafe_load(told_); t = unsafe_load(t_)
    n = unsafe_load(n_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    irtrn = unsafe_wrap(Array, irtrn_, (1,), own = false)

    (lio, l, lprefix) = (cbi.logio, cbi.loglevel, cbi.out_lprefix)
    l_sol = l & LOG_SOLOUT > 0

    l_sol && println(
        lio, lprefix, "called with nr=", nr, " told=", told,
        " t=", t, " x=", x
    )

    cbi.tOld = told; cbi.tNew = t; cbi.xNew = x
    cbi.cont_cont = cont_; cbi.cont_lrc = lrc_
    cbi.output_data["nr"] = nr

    ret = call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_STEP, told, t, x,
        cbi.eval_sol_fcn
    )

    if ret == OUTPUTFCN_RET_STOP
        irtrn[1] = -1
    elseif ret == OUTPUTFCN_RET_CONTINUE
        irtrn[1] = 0
    elseif ret == OUTPUTFCN_RET_CONTINUE_XCHANGED
        throw(
            FeatureNotSupported(
                string(
                    "Sorry; radau5/radau does not support ",
                    "to change the solution inside the output function."
                )
            )
        )
    else
        throw(InternalErrorODE(string("Unknown ret=", ret, " of output function")))
    end

    return nothing
end

"""
     function unsafe_radauSoloutCallback_c(cbi::CI,
             fint_flag::FInt) where {FInt,CI}
"""
function unsafe_radauSoloutCallback_c(
        cbi::CI,
        fint_flag::FInt
    ) where {FInt, CI}
    return @cfunction(
        unsafe_radauSoloutCallback, Cvoid, (
            Ptr{FInt},
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64},
            Ptr{Float64}, Ptr{FInt}, Ptr{FInt},
            Ptr{Float64}, Ref{CI}, Ptr{FInt},
        )
    )
end

"""
     function create_radau_eval_sol_fcn_closure(cbi::CI, d::FInt,
             method_cont::Ptr{Cvoid}) where {FInt<:FortranInt,
                                            CI<:RadauInternalCallInfos}

generates a `eval_sol_fcn` for radau and radau5.

Why is a closure needed? We need a function `eval_sol_fcn`
that calls `CONTR5_` OR `CONTRA_` (with `ccall`).
But `CONTR5_`/`CONTRA_` need the information for the current state. This
information were saved by `unsafe_radauSoloutCallback` in the
`RadauInternalCallInfos`. `eval_sol_fcn` needs to get this information.
Here comes `create_radau_eval_sol_fcn_closure` into play: this function
takes call information and generates a `eval_sol_fcn` with this data.

Why doesn't `unsafe_radauSoloutCallback` generate a closure (then
the current state needs not to be saved in `RadauInternalCallInfos`)?
Because then every call to `unsafe_radauSoloutCallback` would have
generated a closure function. That's a lot of overhead: 1 closure function
for every solout call. With the strategy above, we have 1 closure function
per ODE-solver-call, i.e. 1 closure function per ODE.

For the typical calling sequence, see `RadauInternalCallInfos`.
"""
function create_radau_eval_sol_fcn_closure(
        cbi::CI, d::FInt,
        method_cont::Ptr{Cvoid}
    ) where {
        FInt <: FortranInt,
        CI <: RadauInternalCallInfos,
    }

    function eval_sol_fcn_closure(s::Float64)
        (lio, l, lprefix) = (cbi.logio, cbi.loglevel, cbi.eval_lprefix)
        l_eval = l & LOG_EVALSOL > 0

        l_eval && println(lio, lprefix, "called with s=", s)
        cbi.cont_s[1] = s
        result = Vector{Float64}(undef, d)
        if s == cbi.tNew
            result[:] = cbi.xNew
            l_eval && println(lio, lprefix, "not calling cont because s==tNew")
        else
            for k in 1:d
                cbi.cont_i[1] = k
                result[k] = ccall(
                    method_cont, Float64,
                    (Ptr{FInt}, Ptr{Float64}, Ptr{Float64}, Ptr{FInt}),
                    cbi.cont_i, cbi.cont_s, cbi.cont_cont, cbi.cont_lrc,
                )
            end
        end

        l_eval && println(lio, lprefix, "contr5 returned ", result)
        return result
    end
    return eval_sol_fcn_closure
end


"""
extracts options specific to radau5 and to radau.
Fills in `args`: `IWORK[1,2,4,5,6,7,8]`, `WORK[1,2,3,5,6]`,
`RPAR`, `IDID`, `FCN`, `SOLOUT`
"""
function extractCommonRadauOpt(
        d::FInt, T, t0, args::RadauArguments,
        opt::AbstractOptionsODE
    ) where {FInt <: FortranInt}
    OPT = nothing
    try
        # fill IWORK
        OPT = OPT_TRANSJTOH
        transjtoh = convert(Bool, getOption(opt, OPT, false))
        @assert (!transjtoh) ||
            ((!flag_jband) && (!flag_implct))  string(
            "Does not work, if the jacobian is banded or if the system ",
            " has a mass matrix ( ≠ Id)."
        )
        args.IWORK[1] = transjtoh ? 1 : 0

        OPT = OPT_MAXSTEPS; args.IWORK[2] = convert(FInt, getOption(opt, OPT, 100000))
        @assert 0 < args.IWORK[2]

        OPT = OPT_NEWTONSTARTZERO; zflag = convert(Bool, getOption(opt, OPT, false))
        args.IWORK[4] = zflag ? 1 : 0

        OPT = OPT_DIMOFIND1VAR; args.IWORK[5] = convert(FInt, getOption(opt, OPT, d))
        @assert 0 < args.IWORK[5]
        OPT = OPT_DIMOFIND2VAR; args.IWORK[6] = convert(FInt, getOption(opt, OPT, 0))
        @assert 0 ≤ args.IWORK[6]
        OPT = OPT_DIMOFIND3VAR; args.IWORK[7] = convert(FInt, getOption(opt, OPT, 0))
        @assert 0 ≤ args.IWORK[7]

        OPT = string(
            OPT_DIMOFIND1VAR, ", ", OPT_DIMOFIND2VAR, ", ",
            OPT_DIMOFIND3VAR
        )
        @assert(
            d == args.IWORK[5] + args.IWORK[6] + args.IWORK[7], string(
                "Sum of dim1, dim2 and dim3 variables must be the dimension of the ",
                "system."
            )
        )

        OPT = OPT_STEPSIZESTRATEGY
        args.IWORK[8] = convert(FInt, getOption(opt, OPT, 1))
        @assert args.IWORK[8] ∈ (1, 2)

        # fill WORK
        OPT = OPT_EPS; args.WORK[1] = convert(Float64, getOption(opt, OPT, 1.0e-16))
        @assert 1.0e-19 < args.WORK[1] < 1.0

        OPT = OPT_RHO
        args.WORK[2] = convert(Float64, getOption(opt, OPT, 0.9))
        @assert 0.001 < args.WORK[2] < 1.0

        OPT = OPT_JACRECOMPFACTOR
        args.WORK[3] = convert(Float64, getOption(opt, OPT, 0.001))
        @assert !(args.WORK[3] == 0)

        OPT = OPT_FREEZESSLEFT
        args.WORK[5] = convert(Float64, getOption(opt, OPT, 1.0))
        @assert args.WORK[5] ≤ 1.0

        OPT = OPT_FREEZESSRIGHT
        args.WORK[6] = convert(Float64, getOption(opt, OPT, 1.2))
        @assert args.WORK[6] ≥ 1.0

        OPT = OPT_MAXSS; args.WORK[7] = convert(Float64, getOption(opt, OPT, T - t0))
        @assert 0 ≠ args.WORK[7]

        OPT = OPT_SSMINSEL; args.WORK[8] = convert(Float64, getOption(opt, OPT, 0.2))
        @assert args.WORK[8] ≤ 1
        OPT = OPT_SSMAXSEL; args.WORK[9] = convert(Float64, getOption(opt, OPT, 8.0))
        @assert args.WORK[9] ≥ 1

        # H
        OPT = OPT_INITIALSS
        args.H = [convert(Float64, getOption(opt, OPT, 1.0e-6))]
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end
    args.RPAR = zeros(Float64, 0)
    args.IDID = zeros(FInt, 1)

    rhs_lprefix = "unsafe_HW2RHSCallback: "
    out_lprefix = "unsafe_radauSoloutCallback: "
    eval_lprefix = "eval_sol_fcn_closure: "

    return (rhs_lprefix, out_lprefix, eval_lprefix)
end

"""
calls the radau5 or radau solver after all solver arguments are prepared.
"""
function doRadauSolverCall(
        lio, l, l_g, l_solver, lprefix, d::FInt, M1::FInt, M2::FInt,
        rhs, rhs_mode, rhs_lprefix, output_mode, output_fcn, out_lprefix,
        eval_lprefix, massmatrix, jacobimatrix, jacobibandstruct,
        jac_lprefix, args, method_solver, method_cont
    ) where {FInt <: FortranInt}

    cbi = RadauInternalCallInfos(
        lio, l, M1, M2, rhs, rhs_mode, rhs_lprefix,
        output_mode, output_fcn,
        Dict(), out_lprefix, eval_sol_fcn_noeval, eval_lprefix,
        NaN, NaN, Vector{Float64}(),
        Vector{FInt}(undef, 1), Vector{Float64}(undef, 1),
        Ptr{Float64}(C_NULL), Ptr{FInt}(C_NULL),
        massmatrix === nothing ? zeros(0, 0) : massmatrix,
        jacobimatrix === nothing ? dummy_func : jacobimatrix,
        jacobibandstruct, jac_lprefix
    )

    if output_mode == OUTPUTFCN_DENSE
        cbi.eval_sol_fcn = create_radau_eval_sol_fcn_closure(cbi, d, method_cont)
    end

    args.FCN = unsafe_HW2RHSCallback_c(cbi, FInt(0))
    args.SOLOUT = output_mode ≠ OUTPUTFCN_NEVER ?
        unsafe_radauSoloutCallback_c(cbi, FInt(0)) :
        @cfunction(dummy_func, Cvoid, ())
    args.IPAR = cbi
    args.MAS = unsafe_HW1MassCallback_c(cbi, FInt(0))
    args.JAC = unsafe_HW1JacCallback_c(cbi, FInt(0))

    output_mode ≠ OUTPUTFCN_NEVER &&
        call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_INIT,
        args.t[1], args.tEnd[1], args.x, eval_sol_fcn_init
    ) # ignore result

    if l_solver
        println(lio, lprefix, "call Fortran radau5/radau $method_solver with")
        dump(lio, args)
    end

    ccall(
        method_solver, Cvoid,
        (
            Ptr{FInt}, Ptr{Cvoid},                     # N=d, Rightsidefunc
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64},   # t, x, tEnd
            Ptr{Float64},                               # h
            Ptr{Float64}, Ptr{Float64}, Ptr{FInt},      # RTOL, ATOL, ITOL
            Ptr{Cvoid}, Ptr{FInt}, Ptr{FInt}, Ptr{FInt}, # JAC, IJAC, MLJAC, MUJAC
            Ptr{Cvoid}, Ptr{FInt}, Ptr{FInt}, Ptr{FInt}, # MAS, IJAC, MLJAC, MUJAC
            Ptr{Cvoid}, Ptr{FInt},                      # Soloutfunc, IOUT
            Ptr{Float64}, Ptr{FInt},                    # WORK, LWORK
            Ptr{FInt}, Ptr{FInt},                       # IWORK, LIWORK
            Ptr{Float64}, Ref{RadauInternalCallInfos},  # RPAR, IPAR
            Ptr{FInt},                                  # IDID
        ),
        args.N, args.FCN,
        args.t, args.x, args.tEnd,
        args.H,
        args.RTOL, args.ATOL, args.ITOL,
        args.JAC, args.IJAC, args.MLJAC, args.MUJAC,
        args.MAS, args.IMAS, args.MLMAS, args.MUMAS,
        args.SOLOUT, args.IOUT,
        args.WORK, args.LWORK,
        args.IWORK, args.LIWORK,
        args.RPAR, args.IPAR, args.IDID,
    )

    if l_solver
        println(lio, lprefix, "Fortran radau5/radau $method_solver returned")
        dump(lio, args)
    end

    output_mode ≠ OUTPUTFCN_NEVER &&
        call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_DONE,
        args.t[1], args.tEnd[1], args.x, eval_sol_fcn_done
    ) # ignore result

    l_g && println(lio, lprefix, string("done IDID=", args.IDID[1]))
    stats = Dict{AbstractString, Any}(
        "step_predict" => args.H[1],
        "no_rhs_calls" => args.IWORK[14],
        "no_jac_calls" => args.IWORK[15],
        "no_steps" => args.IWORK[16],
        "no_steps_accepted" => args.IWORK[17],
        "no_steps_rejected" => args.IWORK[18],
        "no_lu_decomp" => args.IWORK[19],
        "no_fw_bw_subst" => args.IWORK[20],
    )
    return (args.t[1], args.x, args.IDID[1], stats)
end

# Same documentation than for radau, is copied after
# the definition of the radau function.
function radau5(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return radau5_impl(rhs, t0, T, x0, opt, RadauArguments{Int64}(Int64(0)))
end

"""
radau5 with 32bit integers, see radau5.
"""
function radau5_i32(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return radau5_impl(rhs, t0, T, x0, opt, RadauArguments{Int32}(Int32(0)))
end

"""
     function radau5_impl(rhs,
             t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
             args::RadauArguments{FInt}) where FInt<:FortranInt

implementation of radau5 for FInt.
"""
function radau5_impl(
        rhs,
        t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
        args::RadauArguments{FInt}
    ) where {FInt <: FortranInt}

    (lio, l, l_g, l_solver, lprefix) = solver_start("radau5", rhs, t0, T, x0, opt)

    (method_radau5, method_contr5) = getAllMethodPtrs(
        (FInt == Int64) ? DL_RADAU5 : DL_RADAU5_I32
    )

    (d, nrdense, scalarFlag, rhs_mode, output_mode, output_fcn) =
        solver_extract_commonOpt(t0, T, x0, opt, args)

    args.ITOL = [scalarFlag ? 0 : 1]
    args.IOUT = [output_mode == OUTPUTFCN_NEVER ? 0 : 1]

    (M1, M2, NM1) = extractSpecialStructureOpt(d, opt)
    massmatrix = extractMassMatrix(M1, M2, NM1, args, opt)

    (jacobimatrix, jacobibandstruct, jac_lprefix) =
        extractJacobiOpt(d, M1, M2, NM1, args, opt)

    flag_implct = args.IMAS[1] ≠ 0
    flag_jband = args.MLJAC[1] < NM1

    # WORK memory
    ljac = flag_jband ? 1 + args.MLJAC[1] + args.MUJAC[1] : NM1
    lmas = (!flag_implct) ? 0 :
        (args.MLMAS[1] == NM1) ? NM1 : 1 + args.MLMAS[1] + args.MUMAS[1]
    le = flag_jband ? 1 + 2 * args.MLJAC[1] + args.MUJAC[1] : NM1

    args.LWORK = [
        (M1 == 0) ? d * (ljac + lmas + 3 * le + 12) + 20 :
            d * (ljac + 12) + NM1 * (lmas + 3 * le) + 20,
    ]
    args.WORK = zeros(Float64, args.LWORK[1])

    # IWORK memory
    args.LIWORK = [3 * d + 20]
    args.IWORK = zeros(FInt, args.LIWORK[1])

    args.IWORK[9] = M1; args.IWORK[10] = M2
    (rhs_lprefix, out_lprefix, eval_lprefix) =
        extractCommonRadauOpt(d, T, t0, args, opt)

    OPT = nothing
    try
        OPT = OPT_MAXNEWTONITER; args.IWORK[3] = convert(FInt, getOption(opt, OPT, 7))
        @assert 0 < args.IWORK[3]

        OPT = OPT_NEWTONSTOPCRIT
        args.WORK[4] = convert(
            Float64, getOption(
                opt, OPT,
                max(
                    10 * args.WORK[1] / args.RTOL[1],
                    min(0.03, sqrt(args.RTOL[1]))
                )
            )
        )
        @assert args.WORK[4] > args.WORK[1] / args.RTOL[1]
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    return doRadauSolverCall(
        lio, l, l_g, l_solver, lprefix, d, M1, M2,
        rhs, rhs_mode, rhs_lprefix, output_mode, output_fcn,
        out_lprefix, eval_lprefix, massmatrix,
        jacobimatrix, jacobibandstruct, jac_lprefix, args,
        method_radau5, method_contr5
    )
end

"""
     function radau(rhs, t0::Real, T::Real,
                     x0::Vector, opt::AbstractOptionsODE)
         -> (t,x,retcode,stats)

     function radau5(rhs, t0::Real, T::Real,
                     x0::Vector, opt::AbstractOptionsODE)
         -> (t,x,retcode,stats)

`retcode` can have the following values:

      1: computation successful
      2: computation. successful, but interrupted by output function
     -1: input is not consistent
     -2: larger OPT_MAXSTEPS is needed
     -3: step size becomes too small
     -4: matrix is repeatedly singular

main call for using Fortran radau or radau5 solver.

This solver support problems with special structure, see
`help_specialstructure`.

Remark:
Because radau and radau5 are collocation methods, there is no difference
in the computational costs for OUTPUTFCN_WODENSE and OUTPUTFCN_DENSE.

In `opt` the following options are used:

    ╔═════════════════╤══════════════════════════════════════════╤═════════╗
    ║  Option OPT_…   │ Description                              │ Default ║
    ╠═════════════════╪══════════════════════════════════════════╪═════════╣
    ║ M1 & M2         │ parameter for special structure, see     │       0 ║
    ║                 │ above                                    │      M1 ║
    ║                 │ M1, M2 ≥ 0                               │         ║
    ║                 │ M1 +M2 ≤ length(x0)                      │         ║
    ║                 │ (M1==M2==0) || (M1≠0≠M2)                 │         ║
    ║                 │ M1 % M2 == 0 or M1==0                    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ RTOL         &  │ relative and absolute error tolerances   │    1e-3 ║
    ║ ATOL            │ both scalars or both vectors with the    │    1e-6 ║
    ║                 │ length of length(x0)                     │         ║
    ║                 │ error(xₖ) ≤ OPT_RTOLₖ⋅|xₖ|+OPT_ATOLₖ     │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTFCN       │ output function                          │ nothing ║
    ║                 │ see help_outputfcn                       │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTMODE      │ OUTPUTFCN_NEVER:                         │   NEVER ║
    ║                 │   dont't call OPT_OUTPUTFCN              │         ║
    ║                 │ OUTPUTFCN_WODENSE                        │         ║
    ║                 │   call OPT_OUTPUTFCN, but without        │         ║
    ║                 │   possibility for dense output           │         ║
    ║                 │ OUTPUTFCN_DENSE                          │         ║
    ║                 │   call OPT_OUTPUTFCN with support for    │         ║
    ║                 │   dense output                           │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ EPS             │ the rounding unit                        │   1e-16 ║
    ║                 │ 1e-19 < OPT_EPS < 1.0                    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ TRANSJTOH       │ The solver transforms the jacobian       │   false ║
    ║                 │ matrix to Hessenberg form.               │         ║
    ║                 │ This option is not supported if the      │         ║
    ║                 │ system is "implicit" (i.e. a mass matrix │         ║
    ║                 │ is given) or if jacobian is banded.      │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXNEWTONITER   │ maximum number of Newton iterations for  │       7 ║
    ║                 │ the solution of the implicit system in   │         ║
    ║                 │ each step.                               │         ║
    ║                 │ for radau: MAXNEWTONITER + (NS-3)*2.5    │         ║
    ║                 │   where NS is number of current stages   │         ║
    ║                 │ for radau5:     OPT_MAXNEWTONITER > 0    │         ║
    ║                 │ for radau: 50 > OPT_MAXNEWTONITER > 0    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ NEWTONSTARTZERO │ if `false`, the extrapolated collocation │   false ║
    ║                 │ solution is taken as starting vector for │         ║
    ║                 │ Newton's method. If `true` zero starting │         ║
    ║                 │ values are used. The latter is           │         ║
    ║                 │ recommended if Newton's method has       │         ║
    ║                 │ difficulties with convergence.           │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ NEWTONSTOPCRIT  │ only for radau5:                         │ see     ║
    ║                 │ Stopping criterion for Newton's method.  │   left  ║
    ║                 │ Smaller values make the code slower, but │         ║
    ║                 │ safer.                                   │         ║
    ║                 │ Default:                                 │         ║
    ║                 │  max(10*OPT_EPS/OPT_RTOL[1],             │         ║
    ║                 │       min(0.03,sqrt(OPT_RTOL[1])))       │         ║
    ║                 │ OPT_NEWTONSTOPCRIT > OPT_EPS/OPT_RTOL[1] │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ DIMOFIND1VAR  & │ For differential-algebraic systems of    │ len(x0) ║
    ║ DIMOFIND2VAR  & │ index > 1. The right-hand side should be │       0 ║
    ║ DIMOFIND3VAR    │ written such that the index 1,2,3        │       0 ║
    ║                 │ variables appear in this order.          │         ║
    ║                 │ DIMOFINDzVAR: number of index z vars.    │         ║
    ║                 │ ∑ DIMOFINDzVAR == length(x0)             │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSTEPS        │ maximal number of allowed steps          │  100000 ║
    ║                 │ OPT_MAXSTEPS > 0                         │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSS           │ maximal step size                        │  T - t0 ║
    ║                 │ OPT_MAXSS ≠ 0                            │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ INITIALSS       │ initial step size guess                  │    1e-6 ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MINSTAGES     & │ only for radau:                          │       3 ║
    ║ MAXSTAGES       │ minimal and maximal number of stages.    │       7 ║
    ║                 │ The order is given by: 2⋅stages-1        │         ║
    ║                 │ MINSTAGES,MAXSTAGES ∈ (1,3,5,7)          │         ║
    ║                 │ MINSTAGES ≤ MAXSTAGES                    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ INITSTAGES      │ only for radau:                          │MINSTAGES║
    ║                 │ number of stages to start with.          │         ║
    ║                 │ MINSTAGES ≤ INITSTAGES ≤ MAXSTAGES       │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ STEPSIZESTRATEGY│ Switch for step size strategy            │       1 ║
    ║                 │   1: mod. predictive controller          │         ║
    ║                 │      (Gustafsson)                        │         ║
    ║                 │   2: classical step size control         │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OPT_RHO         │ safety factor for step control algorithm │     0.9 ║
    ║                 │ 0.001 < OPT_RHO < 1.0                    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ JACRECOMPFACTOR │ decides whether the jacobian should be   │   0.001 ║
    ║                 │ recomputed.                              │         ║
    ║                 │ <0: recompute after every accepted step  │         ║
    ║                 │ small (≈ 0.001): recompute often         │         ║
    ║                 │ large (≈ 0.1): recompute rarely          │         ║
    ║                 │ i.e. this number represents how costly   │         ║
    ║                 │ Jacobia evaluations are.                 │         ║
    ║                 │ OPT_JACRECOMPFACTOR ≠ 0                  │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ FREEZESSLEFT  & │ Step size freezing: If                   │     1.0 ║
    ║ FREEZESSRIGHT   │ FREEZESSLEFT < hnew/hold < FREEZESSRIGHT │     1.2 ║
    ║                 │ then the step size is not changed. This  │         ║
    ║                 │ saves, together with a large             │         ║
    ║                 │ JACRECOMPFACTOR, LU-decompositions and   │         ║
    ║                 │ computing time for large systems.        │         ║
    ║                 │ small systems:                           │         ║
    ║                 │    FREEZESSLEFT  ≈ 1.0                   │         ║
    ║                 │    FREEZESSRIGHT ≈ 1.2                   │         ║
    ║                 │ large full systems:                      │         ║
    ║                 │    FREEZESSLEFT  ≈ 0.99                  │         ║
    ║                 │    FREEZESSRIGHT ≈ 2.0                   │         ║
    ║                 │                                          │         ║
    ║                 │ OPT_FREEZESSLEFT  ≤ 1.0                  │         ║
    ║                 │ OPT_FREEZESSRIGHT ≥ 1.0                  │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ SSMINSEL   &    │ parameters for step size selection       │     0.2 ║
    ║ SSMAXSEL        │ The new step size is chosen subject to   │     8.0 ║
    ║                 │ the restriction                          │         ║
    ║                 │ OPT_SSMINSEL ≤ hnew/hold ≤ OPT_SSMAXSEL  │         ║
    ║                 │ OPT_SSMINSEL ≤ 1, OPT_SSMAXSEL ≥ 1       │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MASSMATRIX      │ the mass matrix of the problem. If not   │ nothing ║
    ║                 │ given (nothing) then the identity matrix  │         ║
    ║                 │ is used.                                 │         ║
    ║                 │ The size has to be (d-M1)×(d-M1).        │         ║
    ║                 │ It can be an full matrix or a banded     │         ║
    ║                 │ matrix (BandedMatrix).                   │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ JACOBIMATRIX    │ A function providing the Jacobian for    │ nothing ║
    ║                 │ ∂f/∂x or nothing. For nothing the solver │         ║
    ║                 │ uses finite differences to calculate the │         ║
    ║                 │ Jacobian.                                │         ║
    ║                 │ The function has to be of the form:      │         ║
    ║                 │   function (t,x,J) -> nothing       (A)  │         ║
    ║                 │ or for M1>0 & JACOBIBANDSTRUCT ≠ nothing │         ║
    ║                 │   function (t,x,J1,…,JK) -> nothing (B)  │         ║
    ║                 │ with K = 1+M1/M2 and (M1+M2==d)          │         ║
    ║                 │ see help_specialstructure                │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ JACOBIBANDSTRUCT│ A tuple (l,u) describing the banded      │ nothing ║
    ║                 │ structure of the Jacobian or nothing if  │         ║
    ║                 │ the Jacobian is full.                    │         ║
    ║                 │ see help_specialstructure                │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ ORDERDECFACTOR &│ only for radau:                          │     0.8 ║
    ║ ORDERINCFACTOR  │ Order is decreased, if the contractivity │   0.002 ║
    ║                 │ factor is smaller than ORDERDECFACTOR.   │         ║
    ║                 │ Order is increased, if the contractivity │         ║
    ║                 │ factor is larger than ORDERINCFACTOR.    │         ║
    ║                 │ ORDERDECFACTOR > ORDERINCFACTOR > 0      │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ ORDERDECSTEPFAC1│ only for radau:                          │     1.2 ║
    ║ ORDERDECSTEPFAC2│ the order is only decreased if the       │     0.8 ║
    ║                 │ stepsize ratio satisfies                 │         ║
    ║                 │  ORDERDECSTEPFAC2 ≤ hnew/hold ≤          │         ║
    ║                 │               ORDERDECSTEPFAC1           │         ║
    ║                 │ 0 < ORDERDECSTEPFAC2 < ORDERDECSTEPFAC1  │         ║
    ║                 │                                          │         ║
    ╚═════════════════╧══════════════════════════════════════════╧═════════╝
"""
function radau(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return radau_impl(rhs, t0, T, x0, opt, RadauArguments{Int64}(Int64(0)))
end

@doc(@doc(radau), radau5)

"""
radau with 32bit integers, see radau.
"""
function radau_i32(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return radau_impl(rhs, t0, T, x0, opt, RadauArguments{Int32}(Int32(0)))
end

"""
     function radau_impl(rhs,
             t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
             args::RadauArguments{FInt}) where FInt<:FortranInt

implementation of radau for FInt.
"""
function radau_impl(
        rhs,
        t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
        args::RadauArguments{FInt}
    ) where {FInt <: FortranInt}

    (lio, l, l_g, l_solver, lprefix) = solver_start("radau5", rhs, t0, T, x0, opt)

    (method_radau, method_contra) = getAllMethodPtrs(
        (FInt == Int64) ? DL_RADAU : DL_RADAU_I32
    )

    (d, nrdense, scalarFlag, rhs_mode, output_mode, output_fcn) =
        solver_extract_commonOpt(t0, T, x0, opt, args)

    args.ITOL = [scalarFlag ? 0 : 1]
    args.IOUT = [output_mode == OUTPUTFCN_NEVER ? 0 : 1]

    (M1, M2, NM1) = extractSpecialStructureOpt(d, opt)
    massmatrix = extractMassMatrix(M1, M2, NM1, args, opt)

    (jacobimatrix, jacobibandstruct, jac_lprefix) =
        extractJacobiOpt(d, M1, M2, NM1, args, opt)

    flag_implct = args.IMAS[1] ≠ 0
    flag_jband = args.MLJAC[1] < NM1

    OPT = nothing
    NSMAX = 0
    try
        OPT = OPT_MAXSTAGES; NSMAX = convert(FInt, getOption(opt, OPT, 7))
        @assert NSMAX ∈ (1, 3, 5, 7)
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    # WORK memory
    ljac = flag_jband ? 1 + args.MLJAC[1] + args.MUJAC[1] : NM1
    lmas = (!flag_implct) ? 0 :
        (args.MLMAS[1] == NM1) ? NM1 : 1 + args.MLMAS[1] + args.MUMAS[1]
    le = flag_jband ? 1 + 2 * args.MLJAC[1] + args.MUJAC[1] : NM1

    args.LWORK = [
        (M1 == 0) ? d * (ljac + lmas + NSMAX * le + 3 * NSMAX + 3) + 20 :
            d * (ljac + 3 * NSMAX + 3) + NM1 * (lmas + NSMAX * le) + 20,
    ]
    args.WORK = zeros(Float64, args.LWORK[1])

    # IWORK memory
    args.LIWORK = [(2 + (NSMAX - 1) ÷ 2) * d + 20]
    args.IWORK = zeros(FInt, args.LIWORK[1])

    args.IWORK[9] = M1; args.IWORK[10] = M2
    (rhs_lprefix, out_lprefix, eval_lprefix) =
        extractCommonRadauOpt(d, T, t0, args, opt)

    try
        OPT = OPT_MAXNEWTONITER; args.IWORK[3] = convert(FInt, getOption(opt, OPT, 7))
        @assert 0 < args.IWORK[3] < 50

        OPT = OPT_MINSTAGES; NSMIN = convert(FInt, getOption(opt, OPT, 3))
        @assert NSMIN ∈ (1, 3, 5, 7) && NSMIN ≤ NSMAX
        args.IWORK[11] = NSMIN

        OPT = OPT_INITSTAGES; NSINIT = convert(FInt, getOption(opt, OPT, NSMIN))
        @assert NSINIT ∈ (1, 3, 5, 7) && NSMIN ≤ NSINIT ≤ NSMAX
        args.IWORK[13] = NSINIT

        OPT = OPT_ORDERINCFACTOR
        orderincfactor = convert(Float64, getOption(opt, OPT, 0.002))
        OPT = OPT_ORDERDECFACTOR
        orderdecfactor = convert(Float64, getOption(opt, OPT, 0.8))
        OPT = string(OPT_ORDERDECFACTOR, " & ", OPT_ORDERINCFACTOR)
        @assert 0 < orderincfactor < orderdecfactor
        args.WORK[10] = orderincfactor
        args.WORK[11] = orderdecfactor

        OPT = OPT_ORDERDECSTEPFAC1
        orderdecstepfac1 = convert(Float64, getOption(opt, OPT, 1.2))
        OPT = OPT_ORDERDECSTEPFAC2
        orderdecstepfac2 = convert(Float64, getOption(opt, OPT, 0.8))
        OPT = string(OPT_ORDERDECSTEPFAC1, " & ", OPT_ORDERDECSTEPFAC2)
        @assert 0 < orderdecstepfac2 < orderdecstepfac1
        args.WORK[12] = orderdecstepfac1
        args.WORK[13] = orderdecstepfac2
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    return doRadauSolverCall(
        lio, l, l_g, l_solver, lprefix, d, M1, M2,
        rhs, rhs_mode, rhs_lprefix, output_mode, output_fcn,
        out_lprefix, eval_lprefix, massmatrix,
        jacobimatrix, jacobibandstruct, jac_lprefix, args,
        method_radau, method_contra
    )
end

"""
## Compile RADAU5

The julia ODEInterface tries to compile and link the solvers
automatically at the build-time of this module. The following
calls need only be done, if one uses a different compiler and/or if
one wants to change/add some compiler options.

The Fortran source code can be found at:

     http://www.unige.ch/~hairer/software.html

See `help_radau5_license` for the license information.

### Using `gfortran` and 64bit integers (Linux and Mac)

Here is an example how to compile RADAU5 with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o dc_lapack.o dc_lapack.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapack.o lapack.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapackc.o lapackc.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o radau5.o radau5.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o radau5.so
              radau5.o dc_lapack.o lapack.o lapackc.o
     gfortran -shared -fPIC -o radau5.dylib
              radau5.o dc_lapack.o lapack.o lapackc.o

### Using `gfortran` and 64bit integers (Windows)

Here is an example how to compile RADAU5 with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o dc_lapack.o dc_lapack.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapack.o lapack.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapackc.o lapackc.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o radau5.o radau5.f

In order to get create a shared library (from the object file above) use

     gfortran -shared -o radau5.so
              radau5.o dc_lapack.o lapack.o lapackc.o

### Using `gfortran` and 32bit integers (Linux and Mac)

Here is an example how to compile RADAU5 with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o dc_lapack_i32.o dc_lapack.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o lapack_i32.o lapack.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o lapackc_i32.o lapackc.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o radau5_i32.o radau5.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o radau5_i32.so
               radau5_i32.o dc_lapack_i32.o lapack_i32.o lapackc_i32.o
     gfortran -shared -fPIC -o radau5_i32.dylib
               radau5_i32.o dc_lapack_i32.o lapack_i32.o lapackc_i32.o

### Using `gfortran` and 32bit integers (Windows)

Here is an example how to compile RADAU5 with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o dc_lapack_i32.o dc_lapack.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o lapack_i32.o lapack.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o lapackc_i32.o lapackc.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o radau5_i32.o radau5.f

In order to get create a shared library (from the object file above) use:

     gfortran -shared -o radau5_i32.dll
               radau5_i32.o dc_lapack_i32.o lapack_i32.o lapackc_i32.o

"""
function help_radau5_compile()
    return Docs.doc(help_radau5_compile)
end

function help_radau5_license()
    return Docs.doc(help_radau5_license)
end

@doc(@doc(hw_license), help_radau5_license)

"""
## Compile RADAU

The julia ODEInterface tries to compile and link the solvers
automatically at the build-time of this module. The following
calls need only be done, if one uses a different compiler and/or if
one wants to change/add some compiler options.

The Fortran source code can be found at:

     http://www.unige.ch/~hairer/software.html

See `help_radau_license` for the license information.

### Using `gfortran` and 64bit integers (Linux and Mac)

Here is an example how to compile RADAU with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o dc_lapack.o dc_lapack.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapack.o lapack.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapackc.o lapackc.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o radau.o radau.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o radau.so
              radau.o dc_lapack.o lapack.o lapackc.o
     gfortran -shared -fPIC -o radau.dylib
              radau.o dc_lapack.o lapack.o lapackc.o

### Using `gfortran` and 64bit integers (Windows)

Here is an example how to compile RADAU with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o dc_lapack.o dc_lapack.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapack.o lapack.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapackc.o lapackc.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o radau.o radau.f

In order to get create a shared library (from the object file above) use

     gfortran -shared -o radau.so
              radau.o dc_lapack.o lapack.o lapackc.o

### Using `gfortran` and 32bit integers (Linux and Mac)

Here is an example how to compile RADAU with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o dc_lapack_i32.o dc_lapack.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o lapack_i32.o lapack.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o lapackc_i32.o lapackc.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o radau_i32.o radau.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o radau_i32.so
               radau_i32.o dc_lapack_i32.o lapack_i32.o lapackc_i32.o
     gfortran -shared -fPIC -o radau_i32.dylib
               radau_i32.o dc_lapack_i32.o lapack_i32.o lapackc_i32.o

### Using `gfortran` and 32bit integers (Windows)

Here is an example how to compile RADAU with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o dc_lapack_i32.o dc_lapack.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o lapack_i32.o lapack.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o lapackc_i32.o lapackc.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o radau_i32.o radau.f

In order to get create a shared library (from the object file above) use:

     gfortran -shared -o radau_i32.dll
               radau_i32.o dc_lapack_i32.o lapack_i32.o lapackc_i32.o

"""
function help_radau_compile()
    return Docs.doc(help_radau_compile)
end

function help_radau_license()
    return Docs.doc(help_radau_license)
end

@doc(@doc(hw_license), help_radau_license)

# Add information about solvers in global solverInfo-array.
push!(
    solverInfo,
    SolverInfo(
        "radau5",
        "Implicit Runge-Kutta method (Radau IIA) of order 5",
        tuple(
            :OPT_RTOL, :OPT_ATOL,
            :OPT_OUTPUTMODE, :OPT_OUTPUTFCN,
            :OPT_M1, :OPT_M2,
            :OPT_MASSMATRIX,
            :OPT_TRANSJTOH, :OPT_MAXSTEPS, :OPT_MAXNEWTONITER,
            :OPT_NEWTONSTARTZERO,
            :OPT_DIMOFIND1VAR, :OPT_DIMOFIND2VAR, :OPT_DIMOFIND3VAR,
            :OPT_STEPSIZESTRATEGY,
            :OPT_RHO, :OPT_JACRECOMPFACTOR, :OPT_NEWTONSTOPCRIT,
            :OPT_FREEZESSLEFT, :OPT_FREEZESSRIGHT,
            :OPT_SSMINSEL, :OPT_SSMAXSEL, :OPT_INITIALSS,
            :OPT_JACOBIMATRIX, :OPT_JACOBIBANDSTRUCT
        ),
        tuple(
            SolverVariant(
                "radau5_i64",
                "Radau5 with 64bit integers",
                DL_RADAU5,
                tuple("radau5", "contr5")
            ),
            SolverVariant(
                "radau5_i32",
                "Radau5 with 32bit integers",
                DL_RADAU5_I32,
                tuple("radau5", "contr5")
            ),
        ),
        help_radau5_compile,
        help_radau5_license,
    )
)

push!(
    solverInfo,
    SolverInfo(
        "radau",
        "Implicit Runge-Kutta method (Radau IIA) of variable order ∈ (5,9,13)",
        tuple(
            :OPT_RTOL, :OPT_ATOL,
            :OPT_OUTPUTMODE, :OPT_OUTPUTFCN,
            :OPT_M1, :OPT_M2,
            :OPT_MASSMATRIX,
            :OPT_TRANSJTOH, :OPT_MAXSTEPS, :OPT_MAXNEWTONITER,
            :OPT_NEWTONSTARTZERO,
            :OPT_DIMOFIND1VAR, :OPT_DIMOFIND2VAR, :OPT_DIMOFIND3VAR,
            :OPT_STEPSIZESTRATEGY,
            :OPT_RHO, :OPT_JACRECOMPFACTOR, :OPT_NEWTONSTOPCRIT,
            :OPT_FREEZESSLEFT, :OPT_FREEZESSRIGHT,
            :OPT_SSMINSEL, :OPT_SSMAXSEL, :OPT_INITIALSS,
            :OPT_JACOBIMATRIX, :OPT_JACOBIBANDSTRUCT,
            :OPT_MAXSTAGES, :OPT_MINSTAGES, :OPT_INITSTAGES,
            :OPT_ORDERDECFACTOR, :OPT_ORDERINCFACTOR,
            :OPT_ORDERDECSTEPFAC1, :OPT_ORDERDECSTEPFAC2
        ),
        tuple(
            SolverVariant(
                "radau_i64",
                "Radau with 64bit integers",
                DL_RADAU,
                tuple("radau", "contra")
            ),
            SolverVariant(
                "radau5_i32",
                "Radau with 32bit integers",
                DL_RADAU_I32,
                tuple("radau", "contra")
            ),
        ),
        help_radau_compile,
        help_radau_license,
    )
)

# vim:syn=julia:cc=79:fdm=indent:

# ODE-Options for ODEInterface

import Base: show

import Dates
using Dates: DateTime, now

"""macro for importing OptionsODE and option handling."""
macro import_options()
    return :(
        using ODEInterface: OptionsODE, getOption, setOption!, setOptions!,
            copyOptions!
    )
end

"""
Ancestor for all types storing options for ODE-solvers.

ODE-solvers often have several parameters for fine-tuning them.
In this ODEInterface this parameters are called 'options' and
they are stored in key/value paris. For the key a
`AbstractString` is used. The value can be `Any`-thing.
The key is often called the option-name.

All types for this purpose have this abstract type as super-type.

Required fields are: `name`, `lastchanged`, `options`
"""
abstract type AbstractOptionsODE end

"""
Stores options for ODE-Solver(s) together with a name.
Additionally the time of the last change is saved.

Options can be set at construction time, e.g.

     opt=OptionsODE("test",
                    "loglevel" => ODEInterface.LOG_ALL,
                    "logio"    => stderr)

or later. For changing single options

     oldValue = setOption!(opt,"myopt","new value")
     oldValue = setOption!(opt,"myopt" => "new value")

and for changing many options at once:

     oldValues = setOption!(opt,
                 "myopt" => "new value",
                 "oldopt" => 56)

see also: `setOption!`, `setOptions!`
"""
mutable struct OptionsODE <: AbstractOptionsODE
    name::AbstractString
    lastchanged::DateTime
    options::Dict{AbstractString, Any}

    function OptionsODE(name::AbstractString = "")
        obj = new(name, now(), Dict{AbstractString, Any}())
        return obj
    end
end

function OptionsODE(name::AbstractString, copyOptionsFrom::AbstractOptionsODE)
    opt = OptionsODE(name)
    copyOptions!(opt, copyOptionsFrom)
    return opt
end

function OptionsODE(copyOptionsFrom::AbstractOptionsODE)
    return OptionsODE("", copyOptionsFrom)
end

function OptionsODE(name::AbstractString, pairs::Pair...)
    opt = OptionsODE(name)
    setOptions!(opt, pairs...)
    return opt
end

function OptionsODE(pairs::Pair...)
    return OptionsODE("", pairs...)
end

"""
   function getOption(opt::AbstractOptionsODE,name::AbstractString,
                      default::Any=nothing)

get saved value of option with given `name` or `default`
if option is unknown.
"""
function getOption(
        opt::AbstractOptionsODE, name::AbstractString,
        default::Any = nothing
    )
    return haskey(opt.options, name) ? opt.options[name] : default
end

"""
   function setOption!(opt::AbstractOptionsODE,name::AbstractString,value::Any)

set ODE-Option with given `name` and return old value
(or `nothing` if there was no old value).
"""
function setOption!(opt::AbstractOptionsODE, name::AbstractString, value::Any)
    oldValue = getOption(opt, name)
    opt.options[name] = value
    opt.lastchanged = now()
    return oldValue
end

"""
   function setOption!(opt::AbstractOptionsODE,pair::Pair)

set ODE-Option with given (`name`,`value`) pair and return old value
(or `nothing` if there was no old value).
"""
function setOption!(opt::AbstractOptionsODE, pair::Pair)
    return setOption!(opt, pair.first, pair.second)
end

"""
   function setOptions!(opt::AbstractOptionsODE,pairs::Pair...)

set many ODE-Options and return an array with the old option values.
"""
function setOptions!(opt::AbstractOptionsODE, pairs::Pair...)
    oldValues = Any[]
    for (name, value) in pairs
        push!(oldValues, setOption!(opt, name, value))
    end
    return oldValues
end

"""
   function copyOptions!(dest::AbstractOptionsODE,source::AbstractOptionsODE)

copy all options from other ODE-Option object.
"""
function copyOptions!(dest::AbstractOptionsODE, source::AbstractOptionsODE)
    merge!(dest.options, source.options)
    dest.lastchanged = now()
    return dest
end

function show(io::IO, opt::AbstractOptionsODE)
    print(io, typeof(opt), " ")
    isempty(opt.name) || print(io, "'", opt.name, "' ")
    len = length(opt.options)
    print(io, "with ", len, " option", len != 1 ? "s" : "", len > 0 ? ":" : "."); println(io)
    if len > 0
        maxLen = 2 + max(0, Set(length(k) for k in keys(opt.options))...)
        for key in sort(collect(keys(opt.options)))
            print(io, lpad(key, maxLen), ": ")
            show(io, opt.options[key]); println(io)
        end
    end
    print(io, "lasted changed ")
    return show(io, opt.lastchanged)
end

# vim:syn=julia:cc=79:fdm=indent:

using ODEInterface, SciMLTesting

# Allow-listed non-public accesses, kept so that tightening QA does not change
# the released API:
#
# * `Markdown.parse` is the only way to build a `Markdown.MD` from a string
#   assembled at runtime (`@md_str` needs a literal), and the stdlib neither
#   exports it nor declares it public.
# * `Base.WrappedException` is the supertype of `WrappedODEException`. It is
#   undocumented, but it is part of this package's released type hierarchy, so
#   it can only be dropped in a breaking release.
# * `Base.dump`'s 4-argument form is Base's internal recursion hook, not public
#   API. `dump(::IO, ::BandedMatrix, ::Integer, ::Any)` is ambiguous with
#   `Base.dump(::IOContext, ::Any, ::Int, ::Any)`, so `ambiguities` excludes
#   `dump` rather than the method being removed.
run_qa(
    ODEInterface;
    aqua_kwargs = (; ambiguities = (; exclude = [Base.dump])),
    ei_kwargs = (;
        all_qualified_accesses_are_public = (; ignore = (:parse, :WrappedException)),
    )
)

# Load all the required packages
using ODEInterface
using ForwardDiff
using Gadfly
using Colors
@ODEInterface.import_huge
loadODESolvers();

# Define the right-hand function for Automatic Differentiation
function roberAD(x)
    return [
        -0.04 * x[1] + 1.0e4 * x[2] * x[3],
        0.04 * x[1] - 1.0e4 * x[2] * x[3] - 3.0e7 * (x[2])^2,
        3 * 10^7 * (x[2])^2,
    ]
end

# Define the system for the solver
function rober(t, x, dx)
    dx[1] = -0.04 * x[1] + 1.0e4 * x[2] * x[3]
    dx[2] = 0.04 * x[1] - 1.0e4 * x[2] * x[3] - 3.0e7 * (x[2])^2
    dx[3] = 3.0e7 * (x[2])^2
    return nothing
end

# Automatic Differentiation for a more general problem
function getJacobian(t, x, J)
    J[:, :] = ForwardDiff.jacobian(roberAD, x)
    return nothing
end

# Flag to check whether plot is to be generated and saved or not
# Also checks if all solvers are successful
printFlag = true;

# Initial conditions
t0 = 0.0; T = 10.0 .^ [0.0:11.0;]; x0 = [1.0, 0.0, 0.0];

# Get "reference solution"
# TolMin < 1e-14 gives error "TOLERANCES ARE TOO SMALL"
Tol = 1.0e-14;
opt = OptionsODE(
    OPT_RHS_CALLMODE => RHS_CALL_INSITU,
    OPT_RTOL => Tol, OPT_ATOL => Tol * 1.0e-6, OPT_EPS => 1.11e-16,
    OPT_JACOBIMATRIX => getJacobian
);

(t, x, retcode, stats) = odecall(seulex, rober, [t0, T[end]], x0, opt);
t = [t0;t];
x = [x0';x];

plotColorsHex = ["#4D4D4D", "#5DA5DA", "#FAA43A"];
plotColors = [parse(Colorant, c) for c in plotColorsHex];

p = plot(
    layer(x = t, y = x[:, 1], Geom.path, Theme(line_width = 2pt, default_color = plotColors[1])),
    layer(x = t, y = 1.0e4 * x[:, 2], Geom.path, Theme(line_width = 2pt, default_color = plotColors[2])),
    layer(x = t, y = x[:, 3], Geom.path, Theme(line_width = 2pt, default_color = plotColors[3])), Scale.x_log10,
    Guide.xlabel("time (s)"), Guide.ylabel("Species concentration"),
    Guide.manual_color_key("Legend", ["Specie 1", "(Specie 2)*1e4", "Specie 3"], plotColorsHex[1:3]),
    Theme(
        panel_stroke = colorant"black", highlight_width = 0.1pt, key_position = :top,
        key_max_columns = 1, major_label_font_size = 14pt, minor_label_font_size = 10pt,
        key_title_font_size = 12pt, key_label_font_size = 10pt
    ),
    Guide.xticks(ticks = [11:-1:-8;]), Guide.yticks(ticks = [1.0:-0.1:0.0;])
);

draw(PNG("../../ImagesAndPDFs/Plots/RoberPlot.png", 20cm, 15cm), p)

# Functions for ODE-Solver: Dopri5

"""Name for Loading dopri5 solver (64bit integers)."""
const DL_DOPRI5               = "dopri5"

"""Name for Loading dopri5 solver (32bit integers)."""
const DL_DOPRI5_I32           = "dopri5_i32"

"""macro for import Dopri5 solver."""
macro import_dopri5()
  :(
    using ODEInterface: dopri5, dopri5_i32
  )
end

"""macro for import Dopri5 dynamic lib names."""
macro import_DLdopri5()
  :(
    using ODEInterface: DL_DOPRI5, DL_DOPRI5_I32
  )
end

"""macro for importing Dopri5 help."""
macro import_dopri5_help()
  :(
    using ODEInterface: help_dopri5_compile, help_dopri5_license
  )
end

"""
      function dopri5(rhs, t0::Real, T::Real,
                      x0::Vector, opt::AbstractOptionsODE)
           -> (t,x,retcode,stats)

  `retcode` can have the following values:

        1: computation successful
        2: computation. successful, but interrupted by output function
       -1: input is not consistent
       -2: larger OPT_MAXSTEPS is needed
       -3: step size becomes too small
       -4: problem is probably stiff (interrupted)

  main call for using Fortran-dopri5 solver. In `opt` the following
  options are used:

      ╔═════════════════╤══════════════════════════════════════════╤═════════╗
      ║  Option         │ Description                              │ Default ║
      ╠═════════════════╪══════════════════════════════════════════╪═════════╣
      ║ RTOL     &      │ relative and absolute error tolerances   │    1e-3 ║
      ║ ATOL            │ both scalars or both vectors with the    │    1e-6 ║
      ║                 │ length of length(x0)                     │         ║
      ║                 │ error(xₖ) ≤ OPT_RTOLₖ⋅|xₖ|+OPT_ATOLₖ     │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ OUTPUTFCN       │ output function                          │ nothing ║
      ║                 │ see help_outputfcn                       │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ OUTPUTMODE      │ OUTPUTFCN_NEVER:                         │   NEVER ║
      ║                 │   dont't call OPT_OUTPUTFCN              │         ║
      ║                 │ OUTPUTFCN_WODENSE                        │         ║
      ║                 │   call OPT_OUTPUTFCN, but without        │         ║
      ║                 │   possibility for dense output           │         ║
      ║                 │ OUTPUTFCN_DENSE                          │         ║
      ║                 │   call OPT_OUTPUTFCN with support for    │         ║
      ║                 │   dense output                           │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ MAXSTEPS        │ maximal number of allowed steps          │  100000 ║
      ║                 │ OPT_MAXSTEPS > 0                         │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ STEST           │ stiffness test                           │    1000 ║
      ║                 │ done after every step number k*OPT_STEST │         ║
      ║                 │ OPT_STEST < 0 for turning test off       │         ║
      ║                 │ OPT_STEST ≠ 0                            │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ EPS             │ the rounding unit                        │ 2.3e-16 ║
      ║                 │ 1e-35 < OPT_EPS < 1.0                    │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ RHO             │ safety factor in step size predcition    │     0.9 ║
      ║                 │ 1e-4  < OPT_RHO < 1.0                    │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ SSMINSEL   &    │ parameters for step size selection       │     0.2 ║
      ║ SSMAXSEL        │ The new step size is chosen subject to   │    10.0 ║
      ║                 │ the restriction                          │         ║
      ║                 │ OPT_SSMINSEL ≤ hnew/hold ≤ OPT_SSMAXSEL  │         ║
      ║                 │ OPT_SSMINSEL, OPT_SSMAXSEL > 0           │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ SSBETA          │ β for stabilized step size control       │    0.04 ║
      ║                 │ OPT_SSBETA ≤ 0.2                         │         ║
      ║                 │ if OPT_SSBETA < 0 then OPT_SSBETA = 0    │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ MAXSS           │ maximal step size                        │  T - t0 ║
      ║                 │ OPT_MAXSS ≠ 0                            │         ║
      ╟─────────────────┼──────────────────────────────────────────┼─────────╢
      ║ INITIALSS       │ initial step size                        │     0.0 ║
      ║                 │ if OPT_INITIALSS == 0 then a initial     │         ║
      ║                 │ guess is computed                        │         ║
      ╚═════════════════╧══════════════════════════════════════════╧═════════╝

  """
function dopri5(rhs, t0::Real, T::Real,
                x0::Vector, opt::AbstractOptionsODE)
  return dopri5_impl(rhs,t0,T,x0,opt,DopriArguments{Int64}(Int64(0)))
end

"""
  dopri5 with 32bit integers, see dopri5
  """
function dopri5_i32(rhs, t0::Real, T::Real,
                x0::Vector, opt::AbstractOptionsODE)
  return dopri5_impl(rhs,t0,T,x0,opt,DopriArguments{Int32}(Int32(0)))
end

"""
       function dopri5_impl(rhs,
               t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
               args::DopriArguments{FInt}) where FInt<:FortranInt

  implementation of dopri5 for FInt.
  """
function dopri5_impl(rhs,
        t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
        args::DopriArguments{FInt}) where FInt<:FortranInt

  (lio,l,l_g,l_solver,lprefix) = solver_start("dopri5",rhs,t0,T,x0,opt)

  (method_dopri5,method_contd5) = getAllMethodPtrs(
     (FInt == Int64) ? DL_DOPRI5 : DL_DOPRI5_I32 )

  (d,nrdense,rhs_mode,output_mode,output_fcn) =
    dopri_extract_commonOpt(t0,T,x0,opt,args)

  # WORK memory
  args.LWORK = [ 8*d+5*nrdense+21 ]
  args.WORK = zeros(Float64,args.LWORK[1])

  # IWORK memory
  args.LIWORK = [ nrdense+21 ]
  args.IWORK = zeros(FInt,args.LIWORK[1])

  # fill IWORK
  OPT = nothing
  try
    OPT=OPT_MAXSTEPS; args.IWORK[1] = convert(FInt,getOption(opt,OPT,100000))
    @assert 0 < args.IWORK[1]
    args.IWORK[2]=1        # choice for coefficients
    args.IWORK[3]=-1       # don't print anything
    OPT=OPT_STEST; args.IWORK[4]=convert(FInt,getOption(opt,OPT_STEST,1000))
    @assert 0 ≠ args.IWORK[4]
    args.IWORK[5]=nrdense
  catch e
    throw(ArgumentErrorODE("Option '$OPT': Not valid",:opt,e))
  end

  # fill WORK
  try
    OPT=OPT_EPS; args.WORK[1]=convert(Float64,getOption(opt,OPT,2.3e-16))
    @assert 1e-35 < args.WORK[1] < 1.0
    OPT=OPT_RHO; args.WORK[2]=convert(Float64,getOption(opt,OPT,0.9))
    @assert 1e-4  < args.WORK[2] < 1.0
    OPT=OPT_SSMINSEL; args.WORK[3]=convert(Float64,getOption(opt,OPT,0.2))
    @assert 0.0 < args.WORK[3]
    OPT=OPT_SSMAXSEL; args.WORK[4]=convert(Float64,getOption(opt,OPT,10.0))
    @assert 0.0 < args.WORK[4]
    OPT=OPT_SSBETA; args.WORK[5]=convert(Float64,getOption(opt,OPT,0.04))
    @assert args.WORK[5] ≤ 0.2
    OPT=OPT_MAXSS; args.WORK[6]=convert(Float64,getOption(opt,OPT,T-t0))
    @assert 0 ≠ args.WORK[6]
    OPT=OPT_INITIALSS; args.WORK[7]=convert(Float64,getOption(opt,OPT,0.0))
  catch e
    throw(ArgumentErrorODE("Option '$OPT': Not valid",:opt,e))
  end

  args.RPAR=zeros(Float64,0)
  args.IDID=zeros(FInt,1)
  rhs_lprefix = "unsafe_HW1RHSCallback: "
  out_lprefix = "unsafe_dopriSoloutCallback: "
  eval_lprefix = "eval_sol_fcn_closure: "

  cbi = DopriInternalCallInfos(lio,l,rhs,rhs_mode,rhs_lprefix,
      output_mode,output_fcn,
      Dict(), out_lprefix,eval_sol_fcn_noeval,eval_lprefix,
      NaN,NaN,Vector{Float64}(),
      Vector{FInt}(undef, 1),Vector{Float64}(undef, 1),
      Ptr{Float64}(C_NULL),Ptr{FInt}(C_NULL),Ptr{FInt}(C_NULL))

  if output_mode == OUTPUTFCN_DENSE
    cbi.eval_sol_fcn = create_dopri_eval_sol_fcn_closure(cbi,d,method_contd5)
  end

  args.FCN = unsafe_HW1RHSCallback_c(cbi, FInt(0))
  args.SOLOUT = output_mode ≠ OUTPUTFCN_NEVER ?
     unsafe_dopriSoloutCallback_c(cbi, FInt(0)) :
     @cfunction(dummy_func, Cvoid, ())
  args.IPAR = cbi

  output_mode ≠ OUTPUTFCN_NEVER &&
    call_julia_output_fcn(cbi,OUTPUTFCN_CALL_INIT,
      args.t[1],args.tEnd[1],args.x,eval_sol_fcn_init) # ignore result

  if l_solver
    println(lio,lprefix,"call Fortran-dopri5 $method_dopri5 with")
    dump(lio,args);
  end

  ccall( method_dopri5, Cvoid,
    (Ptr{FInt},  Ptr{Cvoid},                    # N=d, Rightsidefunc
     Ptr{Float64}, Ptr{Float64}, Ptr{Float64},  # t, x, tEnd
     Ptr{Float64}, Ptr{Float64}, Ptr{FInt},     # RTOL, ATOL, ITOL
     Ptr{Cvoid}, Ptr{FInt},                     # Soloutfunc, IOUT
     Ptr{Float64}, Ptr{FInt},                   # WORK, LWORK
     Ptr{FInt}, Ptr{FInt},                      # IWORK, LIWORK
     Ptr{Float64}, Ref{DopriInternalCallInfos}, # RPAR, IPAR,
     Ptr{FInt},                                 # IDID
    ),
    args.N, args.FCN,
    args.t, args.x, args.tEnd,
    args.RTOL, args.ATOL, args.ITOL,
    args.SOLOUT, args.IOUT,
    args.WORK, args.LWORK,
    args.IWORK, args.LIWORK,
    args.RPAR, args.IPAR, args.IDID,
  )

  if l_solver
    println(lio,lprefix,"Fortran-dopri5 $method_dopri5 returned")
    dump(lio,args);
  end

  output_mode ≠ OUTPUTFCN_NEVER &&
    call_julia_output_fcn(cbi,OUTPUTFCN_CALL_DONE,
      args.t[1],args.tEnd[1],args.x,eval_sol_fcn_done) # ignore result

  l_g && println(lio,lprefix,string("done IDID=",args.IDID[1]))
  stats = Dict{AbstractString,Any}(
    "step_predict"       => args.WORK[7],
    "no_rhs_calls"       => args.IWORK[17],
    "no_steps"           => args.IWORK[18],
    "no_steps_accepted"  => args.IWORK[19],
    "no_steps_rejected"  => args.IWORK[20]
          )
  return ( args.t[1], args.x, args.IDID[1], stats)
end

"""
  ## Compile DOPRI5

  The julia ODEInterface tries to compile and link the solvers
  automatically at the build-time of this module. The following
  calls need only be done, if one uses a different compiler and/or if
  one wants to change/add some compiler options.

  The Fortran source code can be found at:

       http://www.unige.ch/~hairer/software.html

  See `help_dopri5_license` for the licsense information.

  ### Using `gfortran` and 64bit integers (Linux and Mac)

  Here is an example how to compile DOPRI5 with `Float64` reals and
  `Int64` integers with `gfortran`:

       gfortran -c -fPIC -fdefault-integer-8
                -fdefault-real-8 -fdefault-double-8
                -o dopri5.o dopri5.f

  In order to get create a shared library (from the object file above) use
  one of the forms below (1st for Linux, 2nd for Mac):

       gfortran -shared -fPIC -o dopri5.so dopri5.o
       gfortran -shared -fPIC -o dopri5.dylib dopri5.o

  ### Using `gfortran` and 64bit integers (Windows)

  Here is an example how to compile DOPRI5 with `Float64` reals and
  `Int64` integers with `gfortran`:

       gfortran -c -fdefault-integer-8
                -fdefault-real-8 -fdefault-double-8
                -o dopri5.o dopri5.f

  In order to get create a shared library (from the object file above) use

       gfortran -shared -o dopri5.dll dopri5.o

  ### Using `gfortran` and 32bit integers (Linux and Mac)

  Here is an example how to compile DOPRI5 with `Float64` reals and
  `Int32` integers with `gfortran`:

       gfortran -c -fPIC
                -fdefault-real-8 -fdefault-double-8
                -o dopri5_i32.o   dopri5.f

  In order to get create a shared library (from the object file above) use
  one of the forms below (1st for Linux, 2nd for Mac):

       gfortran -shared -fPIC -o dopri5_i32.so dopri5_i32.o
       gfortran -shared -fPIC -o dopri5_i32.dylib dopri5_i32.o

  ### Using `gfortran` and 32bit integers (Windows)

  Here is an example how to compile DOPRI5 with `Float64` reals and
  `Int32` integers with `gfortran`:

       gfortran -c
                -fdefault-real-8 -fdefault-double-8
                -o dopri5_i32.o   dopri5.f

  In order to get create a shared library (from the object file above) use:

       gfortran -shared -o dopri5_i32.dll dopri5_i32.o

  """
function help_dopri5_compile()
  return Docs.doc(help_dopri5_compile)
end

function help_dopri5_license()
  return Docs.doc(help_dopri5_license)
end

@doc(@doc(hw_license),help_dopri5_license)

# Add informations about solver in global solverInfo-array.
push!(solverInfo,
  SolverInfo("dopri5",
    "Runge-Kutta method of order 5(4) due to Dormand & Prince",
    tuple(:OPT_RTOL, :OPT_ATOL,
          :OPT_OUTPUTMODE, :OPT_OUTPUTFCN,
          :OPT_MAXSTEPS, :OPT_STEST, :OPT_EPS, :OPT_RHO,
          :OPT_SSMINSEL, :OPT_SSMAXSEL, :OPT_SSBETA,
          :OPT_MAXSS, :OPT_INITIALSS),
    tuple(
      SolverVariant("dopri5_i64",
        "Dopri5 with 64bit integers",
        DL_DOPRI5,
        tuple("dopri5", "contd5")),
      SolverVariant("dopri5_i32",
        "Dopri5 with 32bit integers",
        DL_DOPRI5_I32,
        tuple("dopri5", "contd5")),
    ),
    help_dopri5_compile,
    help_dopri5_license,
  )
)


# vim:syn=julia:cc=79:fdm=indent:

# Check if all the packages are installed or not
cond = "Gadfly" in keys(Pkg.installed()) &&
    "Colors" in keys(Pkg.installed()) &&
    "ODEInterface" in keys(Pkg.installed()) &&
    "ForwardDiff" in keys(Pkg.installed());
@assert cond "Please check if the following package(s) are installed:\
    Gadfly\
    Colors\
    ODEInterface\
    ForwardDiff"

# Load all the required packages
using Gadfly
using Colors
using ODEInterface
using ForwardDiff
@ODEInterface.import_huge
loadODESolvers();

######################## Function for saving plots #################################
# Input:
# fileName = Name of the file where the plot is to be stored
#            (with or without extension)
# f_e = Array containing function evaluations as columns for each solver
# err = Array containing errors as columns for each solver
# solverNames = Array containing the names of solvers used in respective order
# plotSize = size of the plot to be created
###################################################################################
function savePlotPNG(
        fileName, f_e, err, solverNames,
        plotSize = [30cm, 30cm]
    )

    numOfLayers = length(solverNames)

    if !contains(fileName, ".")
        fileName = string(fileName, ".png")
    end

    plotColorsHex = [
        "#4D4D4D", "#5DA5DA", "#FAA43A", "#60BD68",
        "#F17CB0", "#B2912F", "#B276B2", "#DECF3F", "#F15854",
    ]
    plotColors = [parse(Colorant, c) for c in plotColorsHex]

    majorFontSize = 24pt
    minorFontSize = 20pt
    pointSize = 5pt

    myplot = plot(
        Scale.x_log10, Scale.y_log10,
        Coord.cartesian(xflip = true),
        Guide.manual_color_key("Legend", solverNames, plotColorsHex[1:numOfLayers]),
        Guide.xlabel("error"), Guide.ylabel("#Function evaluations"),
        Theme(
            major_label_font_size = majorFontSize, panel_stroke = colorant"black",
            minor_label_font_size = minorFontSize, key_title_font_size = majorFontSize,
            key_label_font_size = minorFontSize, key_position = :top, key_max_columns = 1
        )
    )

    for i in 1:numOfLayers
        push!(
            myplot, layer(
                x = err[:, i], y = f_e[:, i], Geom.point, Geom.path,
                Theme(default_color = plotColors[i], default_point_size = pointSize)
            )
        )
    end

    draw(PNG(fileName, plotSize[1], plotSize[2]), myplot)
    return nothing
end

# Define the right-hand function for Automatic Differentiation
function roberAD(x)
    return [
        -0.04 * x[1] + 1.0e4 * x[2] * x[3],
        0.04 * x[1] - 1.0e4 * x[2] * x[3] - 3.0e7 * (x[2])^2,
        3 * 10^7 * (x[2])^2,
    ]
end

# Define the system for the solver
function rober(t, x, dx)
    dx[1] = -0.04 * x[1] + 1.0e4 * x[2] * x[3]
    dx[2] = 0.04 * x[1] - 1.0e4 * x[2] * x[3] - 3.0e7 * (x[2])^2
    dx[3] = 3.0e7 * (x[2])^2
    return nothing
end

# Automatic Differentiation for a more general problem
function getJacobian(t, x, J)
    J[:, :] = ForwardDiff.jacobian(roberAD, x)
    return nothing
end

# Flag to check whether plot is to be generated and saved or not
# Also checks if all solvers are successful
printFlag = true;

# Initial conditions
t0 = 0.0; T = 10.0 .^ [0.0:11.0;]; x0 = [1.0, 0.0, 0.0];

# Get "reference solution"
f = open("roberRefSol.txt")
lines = readlines(f)
numLines = length(lines)
lenArray = convert(Int64, numLines / 3)

x_ref = Array{Float64}(lenArray, 3);
tmp = Array{Float64}(numLines)

counter = 1
for l in lines
    tmp[counter] = parse(Float64, l)
    counter += 1
end

x_ref = [tmp[1:3:end] tmp[2:3:end] tmp[3:3:end]];

close(f)

# Store the solver names for plotting
solverNames = ["RADAU", "RADAU5", "SEULEX"];

# Initialize the variables for plots
# err = error wrt ref solution over all time steps and components
err = zeros(33, 3);
# f_e = number of function evaluations
f_e = zeros(33, 3);
# flops = Floating point operations
flops = zeros(33, 3);

# Weights for computing flops
dim = 3; # dimension of the system
flopsRHS = 13; # Counted
flopsLU = ceil(2 * ((dim)^3) / 3); # As per LU algorithm (can be less)
flopsFW_BW = (dim)^2; # As per FW/BW algorithm (can be less)
flopsJac = ceil(1.5 * flopsRHS); # A guess at the moment

# Loop over all the tolerances
for m in 0:32

    # Set the tolerance for current run
    Tol = 10^(-2 - m / 4)

    # Set solver options
    opt = OptionsODE(
        OPT_EPS => 1.11e-16, OPT_ATOL => Tol * 1.0e-6, OPT_RTOL => Tol,
        OPT_RHS_CALLMODE => RHS_CALL_INSITU,
        OPT_JACOBIMATRIX => getJacobian
    )

    # Store the stats of the last t_end
    # for computing flops
    stats = Dict{AbstractString, Any}

    # Restart the solution for each end time
    # to ensure a more accurate solution
    # compared to dense output

    # Solve using RADAU
    x_radau = Array{Float64}(12, 3)
    for j in 1:12
        (t, x, retcode, stats) = radau(rober, t0, T[j], x0, opt)
        # If solver fails do not continue further
        if retcode != 1
            println("Solver RADAU failed")
            printFlag = false
            break
        end
        x_radau[j, 1] = x[1]
        x_radau[j, 2] = x[2]
        x_radau[j, 3] = x[3]
        f_e[m + 1, 1] = stats.vals[13]
    end
    # If solver fails do not continue further
    if !printFlag
        break
    end
    err[m + 1, 1] = norm(
        [
            norm(x_radau[:, 1] - x_ref[:, 1], Inf),
            norm(x_radau[:, 2] - x_ref[:, 2], Inf),
            norm(x_radau[:, 3] - x_ref[:, 3], Inf),
        ], Inf
    )
    flops[m + 1, 1] = stats["no_rhs_calls"] * flopsRHS +
        stats["no_fw_bw_subst"] * flopsFW_BW +
        stats["no_jac_calls"] * flopsJac +
        stats["no_lu_decomp"] * flopsLU

    # Solve using RADAU5
    x_radau5 = Array{Float64}(12, 3)
    for j in 1:12
        (t, x, retcode, stats) = radau5(rober, t0, T[j], x0, opt)
        # If solver fails do not continue further
        if retcode != 1
            println("Solver RADAU5 failed")
            printFlag = false
            break
        end
        x_radau5[j, 1] = x[1]
        x_radau5[j, 2] = x[2]
        x_radau5[j, 3] = x[3]
        f_e[m + 1, 2] = stats.vals[13]
    end
    # If solver fails do not continue further
    if !printFlag
        break
    end
    err[m + 1, 2] = norm(
        [
            norm(x_radau5[:, 1] - x_ref[:, 1], Inf),
            norm(x_radau5[:, 2] - x_ref[:, 2], Inf),
            norm(x_radau5[:, 3] - x_ref[:, 3], Inf),
        ], Inf
    )
    flops[m + 1, 2] = stats["no_rhs_calls"] * flopsRHS +
        stats["no_fw_bw_subst"] * flopsFW_BW +
        stats["no_jac_calls"] * flopsJac +
        stats["no_lu_decomp"] * flopsLU

    # Solve using SEULEX
    x_seulex = Array{Float64}(12, 3)
    for j in 1:12
        (t, x, retcode, stats) = seulex(rober, t0, T[j], x0, opt)
        # If solver fails do not continue further
        if retcode != 1
            println("Solver seulex failed")
            printFlag = false
            break
        end
        x_seulex[j, 1] = x[1]
        x_seulex[j, 2] = x[2]
        x_seulex[j, 3] = x[3]
        f_e[m + 1, 3] = stats.vals[13]
    end
    # If solver fails do not continue further
    if !printFlag
        break
    end
    err[m + 1, 3] = norm(
        [
            norm(x_seulex[:, 1] - x_ref[:, 1], Inf),
            norm(x_seulex[:, 2] - x_ref[:, 2], Inf),
            norm(x_seulex[:, 3] - x_ref[:, 3], Inf),
        ], Inf
    )
    flops[m + 1, 3] = stats["no_rhs_calls"] * flopsRHS +
        stats["no_fw_bw_subst"] * flopsFW_BW +
        stats["no_jac_calls"] * flopsJac +
        stats["no_lu_decomp"] * flopsLU
end

if printFlag
    savePlotPNG("RoberPrecisionTest", f_e, err, solverNames)
else
    println("Plot cannot be generated due to failure")
end

## Old reference solution
## TolMin < 1e-14 gives error "TOLERANCES ARE TOO SMALL"

#Tol = 1e-14;
#opt = OptionsODE(OPT_RHS_CALLMODE => RHS_CALL_INSITU,
#    OPT_RTOL => Tol, OPT_ATOL=>Tol*1e-6,OPT_EPS => 1.11e-16,
#    OPT_JACOBIMATRIX => getJacobian);

#x_ref = Array{Float64}(12,3)

# Due to a bug in seulex solver for dense output,
# we restart the solution for each required output time

#for i=1:12
#    (t,x,retcode,stats) = seulex(rober,t0, T[i], x0, opt);
#    # If solver fails do not continue further
#    if retcode!=1
#        printFlag=false;
#        break;
#    end
#    x_ref[i,1] = x[1];
#    x_ref[i,2] = x[2];
#    x_ref[i,3] = x[3];
#end

# Errors and Exceptions for ODEInterface

import Base: showerror

"""macro for importing the ODE Exceptions."""
macro import_exceptions()
    return :(
        using ODEInterface: WrappedODEException, ArgumentErrorODE,
            OutputErrorODE, SolverODEnotLoaded,
            FunctionCallNotSupported, FeatureNotSupported,
            StateErrorODE,
            InternalErrorODE
    )
end

"""
The ancestor for all wrapped exceptions in ODEInterface.

Required fields: msg, error
"""
abstract type WrappedODEException <: Base.WrappedException end

function showerror(io::IO, e::WrappedODEException)
    println(io, e.msg)
    return if e.error !== nothing
        println(io, "Wrapped exception:")
        showerror(io, e.error)
    end
end

"""
This error indicates that one input argument is invalid.

This is a WrappedException: If the invalidity of the argument
was detected by some error/exception then, this initial
error/exception can be found in the `error` field.
"""
mutable struct ArgumentErrorODE <: WrappedODEException
    msg::AbstractString
    argname::Symbol
    error
end

function ArgumentErrorODE(msg, argname)
    return ArgumentErrorODE(msg, argname, nothing)
end

function showerror(io::IO, e::ArgumentErrorODE)
    println(io, e.msg)
    e.argname !== nothing && println(io, string("in argument ", e.argname))
    return if e.error !== nothing
        println(io, "Wrapped exception:")
        showerror(io, e.error)
    end
end

"""
This error indicates that a function returned invalid output.
"""
mutable struct OutputErrorODE <: WrappedODEException
    msg::AbstractString
    func
    error
end

function OutputErrorODE(msg, func)
    return OutputErrorODE(msg, func, nothing)
end

function showerror(io::IO, e::OutputErrorODE)
    println(io, e.msg)
    e.func !== nothing && println(io, string("function ", e.func))
    return if e.error !== nothing
        println(io, "Wrapped exception:")
        showerror(io, e.error)
    end
end

"""
This error indicates that a Fortran/C-solver is not loaded.
"""
mutable struct SolverODEnotLoaded <: WrappedODEException
    msg::AbstractString
    error
end

function SolverODEnotLoaded(msg)
    return SolverODEnotLoaded(msg, nothing)
end

"""
This error indicates that a function was called at a time, where
this is not possible.
"""
mutable struct FunctionCallNotSupported <: WrappedODEException
    msg::AbstractString
    error
end

function FunctionCallNotSupported(msg)
    return FunctionCallNotSupported(msg, nothing)
end

"""
This error indicates that a requested feature is not supported or
is not possible.
"""
mutable struct FeatureNotSupported <: WrappedODEException
    msg::AbstractString
    error
end

function FeatureNotSupported(msg)
    return FeatureNotSupported(msg, nothing)
end

"""
This error indicates that an object is in the wrong state, e.g.
is not initialized.
"""
mutable struct StateErrorODE <: WrappedODEException
    msg::AbstractString
    error
end

function StateErrorODE(msg)
    return StateErrorODE(msg, nothing)
end

"""
This error indicates an internal error.
"""
mutable struct InternalErrorODE <: WrappedODEException
    msg::AbstractString
    error
end

function InternalErrorODE(msg)
    return InternalErrorODE(msg, nothing)
end


# vim:syn=julia:cc=79:fdm=indent:

"""
Module for testing ODEInterface
"""
module ODEInterfaceTest

using Test

using ODEInterface
@ODEInterface.import_huge

const dl_solvers = (
    DL_DOPRI5, DL_DOPRI5_I32,
    DL_DOP853, DL_DOP853_I32,
    DL_ODEX, DL_ODEX_I32,
    DL_RADAU5, DL_RADAU5_I32, DL_RADAU, DL_RADAU_I32,
    DL_SEULEX, DL_SEULEX_I32,
    DL_RODAS, DL_RODAS_I32,
    DL_BVPSOL, DL_BVPSOL_I32,
    DL_DDEABM, DL_DDEABM_I32,
    DL_DDEBDF, DL_DDEBDF_I32,
    DL_BVPM2,
)
const solvers = (
    dopri5, dopri5_i32,
    dop853, dop853_i32,
    odex, odex_i32,
    radau5, radau5_i32, radau, radau_i32,
    seulex, seulex_i32,
    rodas, rodas_i32,
    ddeabm, ddeabm_i32,
    ddebdf, ddebdf_i32,
)

const solvers_without_dense_output = (ddeabm, ddeabm_i32, ddebdf, ddebdf_i32)

const solvers_without_special_struct_support = (ddebdf, ddebdf_i32)

const solvers_mas = (
    radau5, radau5_i32, radau, radau_i32,
    seulex, seulex_i32,
    rodas, rodas_i32,
)

const solvers_jac = (
    radau5, radau5_i32, radau, radau_i32,
    seulex, seulex_i32,
    rodas, rodas_i32,
    ddebdf, ddebdf_i32,
)

const solvers_rhsdt = (
    rodas, rodas_i32,
)

const solvers_bvpsol = (
    bvpsol, bvpsol_i32,
)

const solvers_colnew = (
    colnew, colnew_i32,
)

"""
create a callable-type in order to check, if solvers
can handle callable-types (which are not a subclass of
Function) as right-hand sides.
"""
mutable struct Callable_Type
    param::Float64
end

function (ct::Callable_Type)(t, x)
    return ct.param * x
end

function mylinspace(a, b, length::Integer)
    return collect(range(a, stop = b, length = length))
end

function test_ode1(solver::Function)
    opt = OptionsODE(
        "ode1",
        OPT_RTOL => 1.0e-10,
        OPT_ATOL => 1.0e-10
    )
    t0 = 0; T = 1; x0 = [1, 2]; rhs = (t, x) -> x

    (t, x, retcode, stats) = solver(rhs, t0, T, x0, opt)
    @assert 1 == retcode
    @assert t == T
    @assert x0 == [1, 2]
    @assert isapprox(x[1], exp(1), rtol = 1.0e-7, atol = 1.0e-7)
    @assert isapprox(x[2], 2 * exp(1), rtol = 1.0e-7, atol = 1.0e-7)
    if haskey(stats, "step_predict")
        @assert isa(stats["step_predict"], Number)
    end
    return true
end

function test_ode2(solver::Function)
    dense_flag = !(solver in solvers_without_dense_output)
    x3 = NaN
    called_init = false
    called_done = false

    function outputfcn(reason, told, t, x, eval_sol_fcn, extra_data)
        if reason == OUTPUTFCN_CALL_INIT
            called_init = true
            extra_data["test_ode2_data"] = 56
        end
        if reason == OUTPUTFCN_CALL_DONE
            called_done = true
            @assert extra_data["test_ode2_data"] == 56
        end
        if reason == OUTPUTFCN_CALL_STEP
            if told ≤ 3.0 ≤ t
                if dense_flag
                    x3 = eval_sol_fcn(3.0)[1]
                end
                return OUTPUTFCN_RET_STOP
            end
        end
        return OUTPUTFCN_RET_CONTINUE
    end
    opt = OptionsODE(
        "ode2",
        OPT_RTOL => 1.0e-8,
        OPT_ATOL => 1.0e-8,
        OPT_OUTPUTFCN => outputfcn,
        OPT_OUTPUTMODE => dense_flag ? OUTPUTFCN_DENSE : OUTPUTFCN_WODENSE,
    )
    t0 = 0; T = 5000; x0 = [1, 2]; rhs = (t, x) -> x
    (t, x, retcode, stats) = solver(rhs, t0, T, x0, opt)
    @assert called_init && called_done
    @assert 2 == retcode
    @assert t < T
    if dense_flag
        @assert isapprox(x3, exp(3), rtol = 1.0e-7, atol = 1.0e-7)
    end
    return true
end

function test_ode3(solver::Function)
    opt = OptionsODE(
        "ode3",
        OPT_RTOL => 1.0e-10,
        OPT_ATOL => 1.0e-10,
        OPT_RHS_CALLMODE => RHS_CALL_INSITU,
    )
    function rhs(t, x, dx)
        dx[1] = x[1]; dx[2] = x[2]
        return nothing
    end
    t0 = 0; T = 1; x0 = [1, 2]

    (t, x, retcode, stats) = solver(rhs, t0, T, x0, opt)
    @assert 1 == retcode
    @assert t == T
    @assert x0 == [1, 2]
    @assert isapprox(x[1], exp(1), rtol = 1.0e-7, atol = 1.0e-7)
    @assert isapprox(x[2], 2 * exp(1), rtol = 1.0e-7, atol = 1.0e-7)
    return true
end

function test_ode4(solver::Function)
    opt = OptionsODE(
        "ode1",
        OPT_RTOL => 1.0e-10,
        OPT_ATOL => 1.0e-10
    )
    t0 = 0; T = 1; x0 = [1, 2]
    rhs = Callable_Type(1.0)

    (t, x, retcode, stats) = solver(rhs, t0, T, x0, opt)
    @assert 1 == retcode
    @assert t == T
    @assert x0 == [1, 2]
    @assert isapprox(x[1], exp(1), rtol = 1.0e-7, atol = 1.0e-7)
    @assert isapprox(x[2], 2 * exp(1), rtol = 1.0e-7, atol = 1.0e-7)
    if haskey(stats, "step_predict")
        @assert isa(stats["step_predict"], Number)
    end
    return true
end

function test_massode1(solver::Function)
    mas = [ 2.0 1.0; 1.0 2.0]
    x1_exact = t -> 1.5 * exp(t / 3) - 0.5 * exp(t)
    x2_exact = t -> 1.5 * exp(t / 3) + 0.5 * exp(t)
    opt = OptionsODE(
        "massode1",
        OPT_RTOL => 1.0e-8,
        OPT_ATOL => 1.0e-8,
        OPT_MASSMATRIX => mas,
    )
    t0 = 0; T = 1; x0 = [1, 2]; rhs = (t, x) -> x
    (t, x, retcode, stats) = solver(rhs, t0, T, x0, opt)
    @assert 1 == retcode
    @assert isapprox(x[1], x1_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    @assert isapprox(x[2], x2_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    return true
end

function test_massode2(solver::Function)
    mas = BandedMatrix(5, 5, 1, 1, 0.0)
    setdiagonal!(mas, 0, 2); setdiagonal!(mas, 1, 1); setdiagonal!(mas, -1, 1)

    x1_exact = t -> 0.5 * (
        -3 * exp(t / 3) + 2 * exp(t / 2) - exp(t) +
            (2 + sqrt(3)) * exp((2 - sqrt(3)) * t) -
            (sqrt(3) - 2) * exp((2 + sqrt(3)) * t)
    )
    x3_exact = t -> -exp(t / 2) + (2 + sqrt(3)) * exp((2 - sqrt(3)) * t) -
        (sqrt(3) - 2) * exp((2 + sqrt(3)) * t)

    opt = OptionsODE(
        "massode2",
        OPT_RTOL => 1.0e-8,
        OPT_ATOL => 1.0e-8,
        OPT_MASSMATRIX => mas,
    )
    t0 = 0; T = 1; x0 = [1, 2, 3, 4, 5]; rhs = (t, x) -> x

    (t, x, retcode, stats) = solver(rhs, t0, T, x0, opt)
    @assert 1 == retcode
    @assert isapprox(x[1], x1_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    @assert isapprox(x[3], x3_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    return true
end

function test_massode3(solver::Function)
    mas = [2 1 ; 1 2 ]

    x5_exact = t -> -0.5 * exp(t / 3) * (exp(2 * t / 3) - 11)
    x6_exact = t -> 0.5 * exp(t / 3) * (exp(2 * t / 3) + 11)

    opt = OptionsODE(
        "massode3",
        OPT_RTOL => 1.0e-8,
        OPT_ATOL => 1.0e-8,
        OPT_M1 => 4,
        OPT_M2 => 2,
        OPT_MASSMATRIX => mas,
    )
    t0 = 0; T = 1; x0 = [1, 2, 3, 4, 5, 6]
    rhs = (t, x) -> [x[5], x[6]]

    (t, x, retcode, stats) = solver(rhs, t0, T, x0, opt)
    @assert 1 == retcode
    @assert isapprox(x[5], x5_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    @assert isapprox(x[6], x6_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    return true
end

function test_massode4(solver::Function)
    mas = BandedMatrix(3, 3, 1, 1, 0.0)
    setdiagonal!(mas, 0, 2); setdiagonal!(mas, 1, 1); setdiagonal!(mas, -1, 1)

    x4_exact = t -> 4 * exp(t) * (cosh(t / sqrt(2)) - sqrt(2) * sinh(t / sqrt(2)))

    opt = OptionsODE(
        "massode4",
        OPT_RTOL => 1.0e-10,
        OPT_ATOL => 1.0e-10,
        OPT_M1 => 2,
        OPT_M2 => 2,
        OPT_MASSMATRIX => mas,
    )
    t0 = 0; T = 1; x0 = [1, 2, 3, 4, 5]
    rhs = (t, x) -> [x[3], x[4], x[5]]

    (t, x, retcode, stats) = solver(rhs, t0, T, x0, opt)
    @assert 1 == retcode
    @assert isapprox(x[4], x4_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    return true
end

function test_jacode1(solver::Function)
    x1_exact = t -> exp(2 * t) / (2 - exp(2 * t))
    x2_exact = t -> 2 * sqrt(1.0 / (2 - exp(2 * t)))

    function myjac(t, x, J)
        @assert isa(J, Array{Float64})
        J[1, 1] = x[2]^2
        J[1, 2] = 2 * x[1] * x[2]
        J[2, 1] = x[2]
        return J[2, 2] = x[1]
    end

    opt = OptionsODE(
        "odejac1",
        OPT_RTOL => 1.0e-10,
        OPT_ATOL => 1.0e-10,
        OPT_JACOBIMATRIX => myjac,
    )
    t0 = 0; T = 0.2; x0 = [1, 2]
    (t, x, retcode, stats) = solver(
        (t, x) -> [x[1] * (x[2])^2, x[1] * x[2]],
        t0, T, x0, opt
    )
    @assert 1 == retcode
    @assert isapprox(x[1], x1_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    @assert isapprox(x[2], x2_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    return true
end

function test_jacode2(solver::Function)
    function myrhs(t, x)
        return [x[1], x[1] + x[2], x[2] + x[3], x[3] + x[4]]
    end

    function myjac(t, x, J)
        @assert isa(J, BandedMatrix{Float64})
        setdiagonal!(J, 0, 1.0)
        return setdiagonal!(J, -1, 1.0)
    end

    x1_exact = t -> exp(t)
    x2_exact = t -> (2 + t) * exp(t)
    x4_exact = t -> exp(t) / 6 * (24 + 18 * t + 6 * t^2 + t^3)

    opt = OptionsODE(
        "odejac2",
        OPT_RTOL => 1.0e-10,
        OPT_ATOL => 1.0e-10,
        OPT_JACOBIMATRIX => myjac,
        OPT_JACOBIBANDSTRUCT => (1, 0),
        OPT_JACRECOMPFACTOR => -1,
    )
    t0 = 0; T = 1; x0 = [1, 2, 3, 4]

    (t, x, retcode, stats) = solver(myrhs, t0, T, x0, opt)
    @assert 1 == retcode
    @assert isapprox(x[1], x1_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    @assert isapprox(x[2], x2_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    @assert isapprox(x[4], x4_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    return true
end

function test_jacode3(solver::Function)
    if solver ∈ solvers_without_special_struct_support
        return true
    end
    function myrhs(t, x)
        return [ # x[3], x[4],
            x[1] + x[2] + x[4],
            x[1] + x[2] + x[3],
        ]
    end

    function myjac(t, x, J)
        @assert isa(J, Array{Float64})
        @assert (2, 4) == size(J)
        J[1, 1] = 1; J[1, 2] = 1; J[1, 3] = 0; J[1, 4] = 1
        J[2, 1] = 1; J[2, 2] = 1; J[2, 3] = 1
        return J[2, 4] = 0
    end

    x1_exact = t -> exp(-t) / 3 * (1 - 3 * exp(t) + 5 * exp(3 * t))
    x4_exact = t -> 2 * exp(-t) / 3 * (1 + 5 * exp(3 * t))

    opt = OptionsODE(
        "odejac3",
        OPT_RTOL => 1.0e-8,
        OPT_ATOL => 1.0e-8,
        OPT_M1 => 2,
        OPT_M2 => 2,
        OPT_JACOBIMATRIX => myjac,
        OPT_JACOBIBANDSTRUCT => nothing,
        OPT_JACRECOMPFACTOR => -1,
    )
    t0 = 0; T = 1; x0 = [1, 2, 3, 4]

    (t, x, retcode, stats) = solver(myrhs, t0, T, x0, opt)
    @assert 1 == retcode
    @assert isapprox(x[1], x1_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    @assert isapprox(x[4], x4_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    return true
end

function test_jacode4(solver::Function)
    if solver ∈ solvers_without_special_struct_support
        return true
    end
    function myrhs(t, x)
        return [ # x[3], x[4],
            2 * x[1] + 2 * x[3],
            x[2] + x[4],
        ]
    end

    function myjac(t, x, J1, J2)
        @assert isa(J1, BandedMatrix{Float64}) && isa(J2, BandedMatrix{Float64})
        @assert (2, 2) == size(J1) && (2, 2) == size(J2)
        setdiagonal!(J1, 0, [2, 1])
        return setdiagonal!(J2, 0, [2, 2])
    end

    hp = 1 + sqrt(3); hm = 1 - sqrt(3)

    x3_exact = t -> (
        -5 * exp(hm * t) + 3 * sqrt(3) * exp(hm * t) +
            5 * exp(hp * t) + 3 * sqrt(3) * exp(hp * t)
    ) / (2 * sqrt(3))

    opt = OptionsODE(
        "odejac3",
        OPT_RTOL => 1.0e-8,
        OPT_ATOL => 1.0e-8,
        OPT_M1 => 2,
        OPT_M2 => 2,
        OPT_JACOBIMATRIX => myjac,
        OPT_JACOBIBANDSTRUCT => (0, 0),
        OPT_JACRECOMPFACTOR => -1,
    )
    t0 = 0; T = 1; x0 = [1, 2, 3, 4]

    (t, x, retcode, stats) = solver(myrhs, t0, T, x0, opt)
    @assert 1 == retcode
    @assert isapprox(x[3], x3_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    return true
end

function test_rhstimederiv1(solver::Function)
    myrhs = (t, x) -> [t * x[2], 4 * t * x[1]]

    function myjac(t, x, J)
        @assert isa(J, Array{Float64})
        @assert (2, 2) == size(J)
        J[1, 1] = 0; J[1, 2] = t
        J[2, 1] = 4 * t; J[2, 2] = 0
        return nothing
    end

    function myrhstimederiv(t, x, drhsdt)
        @assert isa(drhsdt, Array{Float64})
        @assert (2,) == size(drhsdt)
        drhsdt[1] = x[2]
        drhsdt[2] = 4 * x[1]
        return nothing
    end

    x1_exact = t -> cosh(t * t) + 0.5 * sinh(t * t)
    x2_exact = t -> cosh(t * t) + 2.0 * sinh(t * t)

    opt = OptionsODE(
        "odetimederiv1",
        OPT_RTOL => 1.0e-8,
        OPT_ATOL => 1.0e-8,
        OPT_JACOBIMATRIX => myjac,
        OPT_RHSTIMEDERIV => myrhstimederiv,
    )
    t0 = 0; T = 1; x0 = [1.0, 1]

    (t, x, retcode, stats) = solver(myrhs, t0, T, x0, opt)
    @assert 1 == retcode
    @assert isapprox(x[1], x1_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    @assert isapprox(x[2], x2_exact(T), rtol = 1.0e-7, atol = 1.0e-7)
    return true
end

function test_odecall1(solver::Function)
    opt = OptionsODE(
        "odecall1",
        OPT_RTOL => 1.0e-8,
        OPT_ATOL => 1.0e-8
    )
    t = mylinspace(0, 1, 10)
    x0 = [1, 2]; rhs = (t, x) -> x
    (tVec, xVec, retcode, stats) = odecall(solver, rhs, t, x0, opt)
    @assert 1 == retcode
    @assert t == tVec
    return true
end

function test_odecall2(solver::Function)
    opt = OptionsODE(
        "odecall2",
        OPT_RTOL => 1.0e-8,
        OPT_ATOL => 1.0e-8
    )
    t = [0, 1]
    x0 = [1, 2]; rhs = (t, x) -> x
    (tVec, xVec, retcode, stats) = odecall(solver, rhs, t, x0, opt)
    @assert 1 == retcode
    @assert length(tVec) > 2
    return true
end

function test_bvp1(solver::Function)
    ivpopt = OptionsODE(
        "ivpoptions",
        OPT_RHS_CALLMODE => RHS_CALL_INSITU
    )

    opt = OptionsODE(
        "bvp1",
        OPT_RHS_CALLMODE => RHS_CALL_INSITU,
        OPT_MAXSTEPS => 10,
        OPT_RTOL => 1.0e-6,
        OPT_BVPCLASS => 0,
        OPT_SOLMETHOD => 0,
        OPT_IVPOPT => ivpopt
    )

    tNodes = [0, 5]
    xInit = [ 5.0  0.45938665265299; 1  1]
    odesolver = nothing

    function f(t, x, dx)
        dx[1] = x[2]
        dx[2] = -x[1]
        return nothing
    end

    function bc(xa, xb, r)
        r[1] = xa[1] - 5
        r[2] = xb[1] - 0.45938665265299
        return nothing
    end

    (t, x, code, stats) = solver(f, bc, tNodes, xInit, odesolver, opt)
    @assert tNodes == [0, 5]
    @assert code > 0
    @assert t == tNodes
    @assert isapprox(x[1, 1], 5.0, rtol = 1.0e-4, atol = 1.0e-4)
    @assert isapprox(x[2, 1], 1.0, rtol = 1.0e-4, atol = 1.0e-4)
    @assert isapprox(x[1, 2], 0.459387, rtol = 1.0e-4, atol = 1.0e-4)
    @assert isapprox(x[2, 2], 5.07828, rtol = 1.0e-4, atol = 1.0e-4)

    return true
end

function test_bvp2(solver::Function)
    ivpopt = OptionsODE(
        "ivpoptions",
        OPT_RHS_CALLMODE => RHS_CALL_INSITU
    )

    opt = OptionsODE(
        "bvp2",
        OPT_RHS_CALLMODE => RHS_CALL_INSITU,
        OPT_MAXSTEPS => 10,
        OPT_RTOL => 1.0e-6,
        OPT_BVPCLASS => 0,
        OPT_SOLMETHOD => 0,
        OPT_IVPOPT => ivpopt
    )

    tNodes = [0, 5]
    xInit = [ 5.0  0.45938665265299; 1  1]
    odesolver = dop853

    function f(t, x, dx)
        dx[1] = x[2]
        dx[2] = -x[1]
        return nothing
    end

    function bc(xa, xb, r)
        r[1] = xa[1] - 5
        r[2] = xb[1] - 0.45938665265299
        return nothing
    end

    (t, x, code, stats) = solver(f, bc, tNodes, xInit, odesolver, opt)
    @assert tNodes == [0, 5]
    @assert code > 0
    @assert t == tNodes
    @assert isapprox(x[1, 1], 5.0, rtol = 1.0e-4, atol = 1.0e-4)
    @assert isapprox(x[2, 1], 1.0, rtol = 1.0e-4, atol = 1.0e-4)
    @assert isapprox(x[1, 2], 0.459387, rtol = 1.0e-4, atol = 1.0e-4)
    @assert isapprox(x[2, 2], 5.07828, rtol = 1.0e-4, atol = 1.0e-4)

    return true
end

function test_bvp3(solver::Function)
    ivpopt = OptionsODE(
        "ivpoptions",
        OPT_RHS_CALLMODE => RHS_CALL_INSITU
    )

    opt = OptionsODE(
        "bvp3",
        OPT_RHS_CALLMODE => RHS_CALL_INSITU,
        OPT_MAXSTEPS => 100,
        OPT_RTOL => 1.0e-6,
        OPT_BVPCLASS => 2,
        OPT_SOLMETHOD => 1,
        OPT_IVPOPT => ivpopt
    )

    tNodes = mylinspace(0, 5, 11)
    xInit = [ones(1, length(tNodes) - 1) 0 ; ones(1, length(tNodes)) ]
    odesolver = dop853

    function f(t, x, dx)
        dx[1] = t * x[2]
        dx[2] = 4 * max(0, x[1])^1.5
        return nothing
    end

    function bc(xa, xb, r)
        r[1] = xa[1] - 1
        r[2] = xb[1] - 0
        return nothing
    end

    (t, x, code, stats) = solver(f, bc, tNodes, xInit, odesolver, opt)
    @assert code > 0
    @assert isapprox(x[1, 1], 1, rtol = 1.0e-4, atol = 1.0e-4)
    @assert isapprox(x[2, 1], -3.17614, rtol = 1.0e-4, atol = 1.0e-4)
    @assert isapprox(x[1, 2], 0.755201, rtol = 1.0e-4, atol = 1.0e-4)

    return true
end

function test_colnew1(solver::Function)
    a, b = -pi / 2, pi / 2
    orders = [1, 1]
    ζ = [a, b]

    ε = nothing
    ε_old = nothing
    sol_old = nothing

    function rhs(x, z, f)
        s² = sin(x)^2
        f[1] = (s² - z[2] * s² * s² / z[1]) / ε
        return f[2] = 0.0
    end

    function Drhs(x, z, df)
        df[:] .= 0.0
        s⁴ = sin(x)^4
        df[1, 1] = z[2] * s⁴ / (z[1]^2)
        return df[1, 2] = -s⁴ / z[1]
    end

    function bc(i, z, bc)
        return bc[1] = z[1] - 1.0
    end

    function Dbc(i, z, dbc)
        dbc[1] = 1.0
        return dbc[2] = 0.0
    end

    function initial_guess(x, z, dmz)
        z[1] = 0.5
        z[2] = 1.0
        return rhs(x, z, dmz)
    end

    opt = OptionsODE(
        "colnew1",
        OPT_BVPCLASS => 2, OPT_COLLOCATIONPTS => 7,
        OPT_RTOL => [1.0e-4, 1.0e-4], OPT_MAXSUBINTERVALS => 200
    )

    sol = nothing
    for ε_new in [1.0, 0.5, 0.2, 0.1]
        ε = ε_new
        guess = sol_old !== nothing ? sol_old : initial_guess
        sol, retcode, stats = colnew(
            [a, b], orders, ζ, rhs, Drhs, bc, Dbc,
            guess, opt
        )
        @assert retcode > 0
        sol_old = sol; ε_old = ε
    end

    z₀ = evalSolution(sol, 0.0)
    @assert isapprox(z₀[1], 0.161671, rtol = 1.0e-3, atol = 1.0e-3)
    @assert isapprox(z₀[2], 1.01863, rtol = 1.0e-3, atol = 1.0e-3)
    return true
end

function test_bvpm2_1()
    ε = 0.1
    a, b = -pi / 2.0, pi / 2.0

    function rhs(x, y, p, f)
        @assert length(y) == length(f) == 1
        @assert length(p) == 1
        return f[1] = (sin(x)^2 - p[1] * sin(x)^4 / y[1]) / ε
    end

    function Drhs(x, y, p, dfdy, dfdp)
        @assert length(y) == 1
        @assert length(p) == 1
        @assert size(dfdy) == (1, 1)
        @assert size(dfdp) == (1, 1)

        dfdy[1, 1] = (p[1] * sin(x)^4 / y[1]^2) / ε
        return dfdp[1, 1] = (-sin(x)^4 / y[1]) / ε
    end

    function bc(ya, yb, p, bca, bcb)
        @assert length(ya) == length(yb) == 1
        @assert length(bca) == length(bcb) == 1
        @assert length(p) == 1
        bca[1] = ya[1] - 1.0
        return bcb[1] = yb[1] - 1.0
    end

    function Dbc(ya, yb, dya, dyb, p, dpa, dpb)
        @assert length(ya) == length(yb) == 1
        @assert size(dya) == size(dyb) == (1, 1)
        @assert length(p) == 1
        @assert size(dpa) == size(dpb) == (1, 1)
        dya[1, 1] = 1.0
        dyb[1, 1] = 1.0
        dpa[1, 1] = 0.0
        return dpb[1, 1] = 0.0
    end

    opt = OptionsODE(
        "test_bvpm2_1",
        OPT_RTOL => 1.0e-6,
        OPT_METHODCHOICE => 4,
    )
    guess_obj = Bvpm2()
    bvpm2_init(guess_obj, 1, 1, mylinspace(a, b, 20), [0.5], [1.0])
    retcode = Vector{Int64}(undef, 4)
    sol = Vector{ODEInterface.Bvpm2}(undef, 4)
    stat = Vector{Dict}(undef, 4)
    z = Vector{Matrix}(undef, 4)

    (sol[1], retcode[1], stat[1]) = bvpm2_solve(guess_obj, rhs, bc, opt)
    (sol[2], retcode[2], stat[2]) = bvpm2_solve(
        guess_obj, rhs, bc, opt,
        Drhs = Drhs
    )
    (sol[3], retcode[3], stat[3]) = bvpm2_solve(
        guess_obj, rhs, bc, opt,
        Dbc = Dbc
    )
    (sol[4], retcode[4], stat[4]) = bvpm2_solve(
        guess_obj, rhs, bc, opt,
        Drhs = Drhs, Dbc = Dbc
    )
    for k in 1:length(retcode)
        @assert retcode[k] == 0
        @assert stat[k]["no_rhs_calls"] > 0
        @assert stat[k]["no_bc_calls"] > 0
        z[k] = evalSolution(sol[k], mylinspace(a, b, 5))
    end
    @assert stat[1]["no_jac_calls"] == stat[3]["no_jac_calls"] == 0
    @assert stat[1]["no_Dbc_calls"] == stat[2]["no_Dbc_calls"] == 0
    @assert stat[2]["no_jac_calls"] > 0
    @assert stat[4]["no_jac_calls"] > 0
    @assert stat[1]["no_rhs_calls"] > stat[2]["no_rhs_calls"]
    @assert stat[1]["no_rhs_calls"] > stat[4]["no_rhs_calls"]

    for k in 1:(length(retcode) - 1)
        @assert isapprox(z[k], z[k + 1], rtol = 1.0e-4, atol = 1.0e-4)
    end

    bvpm2_destroy(guess_obj)
    for k in 1:length(retcode)
        bvpm2_destroy(sol[k])
    end
    return true
end

function test_bvpm2_2()
    exact_sol = x -> [1 / sqrt(1 + x^2 / 3), -9 / (9 + 3 * x^2)^1.5 * x]
    a, b = 0.0, 1.0

    function rhs(x, y, f)
        @assert length(y) == length(f) == 2
        f[1] = y[2]
        return f[2] = -y[1]^5
    end

    function Drhs(x, y, dfdy)
        @assert length(y) == 2
        @assert size(dfdy) == (2, 2)
        dfdy[:] .= 0
        dfdy[1, 2] = 1.0
        return dfdy[2, 1] = -5 * y[1]^4
    end

    function bc(ya, yb, bca, bcb)
        @assert length(ya) == length(yb) == 2
        @assert length(bca) == length(bcb) == 1
        bca[1] = ya[2]
        return bcb[1] = yb[1] - sqrt(0.75)
    end

    function Dbc(ya, yb, dya, dyb)
        @assert length(ya) == length(yb) == 2
        @assert size(dya) == (1, 2)
        @assert size(dyb) == (1, 2)
        dya[:] .= 0
        dya[1, 2] = 1.0
        dyb[:] .= 0
        return dyb[1, 1] = 1.0
    end

    opt = OptionsODE(
        "test_bvpm2_2",
        OPT_RTOL => 1.0e-6,
        OPT_METHODCHOICE => 6,
        OPT_SINGULARTERM => [ 0 0 ; 0 -2 ],
    )

    guess_obj = Bvpm2()
    bvpm2_init(guess_obj, 2, 1, mylinspace(a, b, 10), [sqrt(0.75), 1.0e-4])
    retcode = Vector{Int64}(undef, 4)
    sol = Vector{ODEInterface.Bvpm2}(undef, 4)
    stat = Vector{Dict}(undef, 4)
    z = Vector{Matrix}(undef, 4)

    (sol[1], retcode[1], stat[1]) = bvpm2_solve(guess_obj, rhs, bc, opt)
    (sol[2], retcode[2], stat[2]) = bvpm2_solve(
        guess_obj, rhs, bc, opt,
        Drhs = Drhs
    )
    (sol[3], retcode[3], stat[3]) = bvpm2_solve(
        guess_obj, rhs, bc, opt,
        Dbc = Dbc
    )
    (sol[4], retcode[4], stat[4]) = bvpm2_solve(
        guess_obj, rhs, bc, opt,
        Drhs = Drhs, Dbc = Dbc
    )
    xx = mylinspace(a, b, 5)
    for k in 1:length(retcode)
        @assert retcode[k] == 0
        @assert stat[k]["no_rhs_calls"] > 0
        @assert stat[k]["no_bc_calls"] > 0
        z[k] = evalSolution(sol[k], xx)
    end
    @assert stat[1]["no_jac_calls"] == stat[3]["no_jac_calls"] == 0
    @assert stat[1]["no_Dbc_calls"] == stat[2]["no_Dbc_calls"] == 0
    @assert stat[2]["no_jac_calls"] > 0
    @assert stat[4]["no_jac_calls"] > 0
    @assert stat[1]["no_rhs_calls"] > stat[2]["no_rhs_calls"]
    @assert stat[1]["no_rhs_calls"] > stat[4]["no_rhs_calls"]

    for k in 1:length(retcode)
        for j in 1:length(xx)
            @assert isapprox(z[k][:, j], exact_sol(xx[j]), rtol = 1.0e-4, atol = 1.0e-4)
        end
    end

    bvpm2_destroy(guess_obj)
    for k in 1:length(retcode)
        bvpm2_destroy(sol[k])
    end
    return true
end

function test_bvpm2_3()
    exact_sol = x -> [exp(x), exp(x)]
    a, b = 0.0, 1.0

    function rhs(x, y, f)
        @assert length(y) == length(f) == 2
        f[1] = y[2]
        return f[2] = y[1]
    end

    function Drhs(x, y, dfdy)
        @assert length(y) == 2
        @assert size(dfdy) == (2, 2)
        dfdy[:] .= 0
        dfdy[1, 2] = 1.0
        return dfdy[2, 1] = 1.0
    end

    function bc(ya, yb, bca, bcb)
        @assert length(ya) == length(yb) == 2
        @assert length(bca) == length(bcb) == 1
        bca[1] = ya[1] - 1.0
        return bcb[1] = yb[1] - exp(1)
    end

    function Dbc(ya, yb, dya, dyb)
        @assert length(ya) == length(yb) == 2
        @assert size(dya) == (1, 2)
        @assert size(dyb) == (1, 2)
        dya[:] .= 0
        dya[1, 1] = 1.0
        dyb[:] .= 0
        return dyb[1, 1] = 1.0
    end

    function guess(x, y)
        @assert length(y) == 2
        y[1] = 1 + x
        return y[2] = 1.0
    end

    opt = OptionsODE(
        "test_bvpm2_3",
        OPT_RTOL => 1.0e-6
    )

    guess_obj = Bvpm2()
    bvpm2_init(guess_obj, 2, 1, mylinspace(a, b, 3), guess)
    retcode = Vector{Int64}(undef, 4)
    sol = Vector{ODEInterface.Bvpm2}(undef, 4)
    stat = Vector{Dict}(undef, 4)
    z = Vector{Matrix}(undef, 4)

    (sol[1], retcode[1], stat[1]) = bvpm2_solve(guess_obj, rhs, bc, opt)
    (sol[2], retcode[2], stat[2]) = bvpm2_solve(
        guess_obj, rhs, bc, opt,
        Drhs = Drhs
    )
    (sol[3], retcode[3], stat[3]) = bvpm2_solve(
        guess_obj, rhs, bc, opt,
        Dbc = Dbc
    )
    (sol[4], retcode[4], stat[4]) = bvpm2_solve(
        guess_obj, rhs, bc, opt,
        Drhs = Drhs, Dbc = Dbc
    )
    xx = mylinspace(a, b, 5)
    for k in 1:length(retcode)
        @assert retcode[k] == 0
        @assert stat[k]["no_rhs_calls"] > 0
        @assert stat[k]["no_bc_calls"] > 0
        z[k] = evalSolution(sol[k], xx)
    end
    @assert stat[1]["no_jac_calls"] == stat[3]["no_jac_calls"] == 0
    @assert stat[1]["no_Dbc_calls"] == stat[2]["no_Dbc_calls"] == 0
    @assert stat[2]["no_jac_calls"] > 0
    @assert stat[4]["no_jac_calls"] > 0
    @assert stat[1]["no_rhs_calls"] > stat[2]["no_rhs_calls"]
    @assert stat[1]["no_rhs_calls"] > stat[4]["no_rhs_calls"]

    for k in 1:length(retcode)
        for j in 1:length(xx)
            @assert isapprox(z[k][:, j], exact_sol(xx[j]), rtol = 1.0e-4, atol = 1.0e-4)
        end
    end

    bvpm2_destroy(guess_obj)
    for k in 1:length(retcode)
        bvpm2_destroy(sol[k])
    end
    return true
end

function test_bvpm2_4()
    exact_sol = x -> [exp(x), exp(x)]
    a, b = 0.0, 1.0

    function rhs(x, y, p, f)
        @assert length(y) == length(f) == 2
        @assert length(p) == 1
        f[1] = y[2]
        return f[2] = y[1] * p[1]
    end

    function Drhs(x, y, p, dfdy, dfdp)
        @assert length(y) == 2
        @assert length(p) == 1
        @assert size(dfdy) == (2, 2)
        @assert size(dfdp) == (2, 1)
        dfdy[:] .= 0
        dfdy[1, 2] = 1.0
        dfdy[2, 1] = p[1]

        dfdp[:] .= 0
        return dfdp[2, 1] = y[1]
    end

    function bc(ya, yb, p, bca, bcb)
        @assert length(ya) == length(yb) == 2
        @assert length(bca) == 2
        @assert length(bcb) == 1
        @assert length(p) == 1
        bca[1] = ya[1] - 1.0
        bca[2] = ya[2] - 1.0
        return bcb[1] = yb[1] - exp(1)
    end

    function Dbc(ya, yb, dya, dyb, p, dpa, dpb)
        @assert length(ya) == length(yb) == 2
        @assert length(p) == 1
        @assert size(dya) == (2, 2)
        @assert size(dyb) == (1, 2)
        @assert size(dpa) == (2, 1)
        @assert size(dpb) == (1, 1)
        dya[:] .= 0
        dya[1, 1] = 1.0
        dya[2, 2] = 1.0
        dyb[:] .= 0
        dyb[1, 1] = 1.0
        return dpa[:] .= 0
    end

    function guess(x, y)
        y[1] = 1 + x
        return y[2] = 1.0
    end

    opt = OptionsODE(
        "test_bvpm2_4",
        OPT_RTOL => 1.0e-6
    )

    guess_obj = Bvpm2()
    bvpm2_init(guess_obj, 2, 2, mylinspace(a, b, 3), guess, [0.9])
    retcode = Vector{Int64}(undef, 4)
    sol = Vector{ODEInterface.Bvpm2}(undef, 4)
    stat = Vector{Dict}(undef, 4)
    z = Vector{Matrix}(undef, 4)

    (sol[1], retcode[1], stat[1]) = bvpm2_solve(guess_obj, rhs, bc, opt)
    (sol[2], retcode[2], stat[2]) = bvpm2_solve(
        guess_obj, rhs, bc, opt,
        Drhs = Drhs
    )
    (sol[3], retcode[3], stat[3]) = bvpm2_solve(
        guess_obj, rhs, bc, opt,
        Dbc = Dbc
    )
    (sol[4], retcode[4], stat[4]) = bvpm2_solve(
        guess_obj, rhs, bc, opt,
        Drhs = Drhs, Dbc = Dbc
    )
    xx = mylinspace(a, b, 5)
    for k in 1:length(retcode)
        @assert retcode[k] == 0
        @assert stat[k]["no_rhs_calls"] > 0
        @assert stat[k]["no_bc_calls"] > 0
        z[k] = evalSolution(sol[k], xx)
    end
    @assert stat[1]["no_jac_calls"] == stat[3]["no_jac_calls"] == 0
    @assert stat[1]["no_Dbc_calls"] == stat[2]["no_Dbc_calls"] == 0
    @assert stat[2]["no_jac_calls"] > 0
    @assert stat[4]["no_jac_calls"] > 0
    @assert stat[1]["no_rhs_calls"] > stat[2]["no_rhs_calls"]
    @assert stat[1]["no_rhs_calls"] > stat[4]["no_rhs_calls"]

    for k in 1:length(retcode)
        for j in 1:length(xx)
            @assert isapprox(z[k][:, j], exact_sol(xx[j]), rtol = 1.0e-4, atol = 1.0e-4)
        end
        @assert isapprox(bvpm2_get_params(sol[k]), [1.0], rtol = 1.0e-4, atol = 1.0e-4)
    end

    bvpm2_destroy(guess_obj)
    for k in 1:length(retcode)
        bvpm2_destroy(sol[k])
    end
    return true
end

function test_Banded()
    return @testset "Banded" begin
        @test_throws ArgumentErrorODE  BandedMatrix{Float64}(
            5, 4, 1, 2, zeros(Float64, (4, 5))
        )
        @test_throws ArgumentErrorODE  BandedMatrix{Float64}(
            5, 4, 1, 2, zeros(Float64, (5, 4))
        )
        @test_throws ArgumentErrorODE  BandedMatrix{Float64}(
            5, 4, 5, 1, zeros(Float64, (7, 5))
        )

        bm = BandedMatrix(5, 4, 1, 2, NaN)
        @test   (bm[1, 1] = 1.0) == 1.0
        @test   (bm[2, 1] = 2) == 2.0
        @test   (bm[2, 4] = 7) == 7.0
        @test   (bm[3, 2] = 8) == 8.0
        @test_throws BoundsError  bm[1, 4] = 1.1
        @test_throws BoundsError  bm[3, 1] = 1.1
        @test_throws BoundsError  bm[4, 1] = 1.1
        @test_throws BoundsError  bm[4, 2] = 1.1
        @test_throws BoundsError  bm[5, 3] = 1.1

        bm = BandedMatrix(5, 4, 1, 2, NaN)
        @test (bm[1:2, 1] = [1, 5]) == [1, 5]
        @test (bm[1:3, 2] = [4, 2, 4]) == [4, 2, 4]
        @test (bm[1:4, 3] = [2, 3, 3, 3]) == [2, 3, 3, 3]
        @test (bm[2:5, 4] = [1, 0, 4, 2]) == [1, 0, 4, 2]
        @test full(bm) == [1 4 2 0; 5 2 3 1; 0 4 3 0; 0 0 3 4; 0 0 0 2]
        bm_test = createBandedMatrix(
            [1.0 4 2 0; 5.0 2 3 1; 0 4.0 3 0; 0 0 3 4.0; 0 0 0 2.0]
        )
        @test bm_test == bm

        bm = BandedMatrix(5, 4, 1, 2, NaN)
        @test setdiagonal!(bm, 2, [2, 1]) == [2, 1]
        @test setdiagonal!(bm, 1, [4, 3, 0]) == [4, 3, 0]
        @test setdiagonal!(bm, 0, [1, 2, 3, 4]) == [1, 2, 3, 4]
        @test setdiagonal!(bm, -1, [5, 4, 3, 2]) == [5, 4, 3, 2]
        @test full(bm) == [1 4 2 0; 5 2 3 1; 0 4 3 0; 0 0 3 4; 0 0 0 2]

        bm = BandedMatrix(5, 4, 1, 2, NaN)
        diagonals = Any[[2 1], [4 3 0], [1, 2, 3, 4], [5 4 3 2]]
        @test setdiagonals!(bm, diagonals) == diagonals
        @test full(bm) == [1 4 2 0; 5 2 3 1; 0 4 3 0; 0 0 3 4; 0 0 0 2]

        bm2 = BandedMatrix(5, 4, 1, 2, NaN)
        setdiagonals!(bm2, bm)
        @test bm ≢ bm2
        @test bm == bm2

        buffer = IOBuffer()
        show(IOContext(buffer, :limit => true), MIME"text/plain"(), bm)
        shown = String(take!(buffer))
        @test occursin("BandedMatrix", shown)
        @test occursin("5×4", shown)
    end
end

function test_Options()
    return @testset "Options" begin
        opt1 = OptionsODE("test1")
        @test isa(opt1, OptionsODE)
        @test isa(opt1, ODEInterface.AbstractOptionsODE)
        @test setOption!(opt1, "test_key", 56) === nothing
        @test setOption!(opt1, "test_key", 82) == 56
        @test getOption(opt1, "test_key", 0) == 82
        @test getOption(opt1, "nokey", nothing) === nothing
        @test getOption(opt1, "nokey", "none") == "none"
        @test setOptions!(opt1, "test_key" => 100, "new_key" => "bla") ==
            [82, nothing]

        opt2 = OptionsODE("test2", opt1)
        @test getOption(opt1, "test_key", 0) == 100
    end
end

function test_DLSolvers()
    result = nothing
    @testset "DLSolvers" begin
        result = loadODESolvers()
        @testset for dl in dl_solvers
            @test result[dl].error === nothing
            @test result[dl].libhandle ≠ C_NULL
        end

        @testset for dl in dl_solvers
            @testset for method in result[dl].methods
                @test method.error === nothing
                @test method.method_ptr ≠ C_NULL
                @test method.generic_name ≠ ""
                @test method.methodname_found ≠ ""
            end
        end
    end
    return result
end

function test_vanilla()
    problems = (test_ode1, test_ode2, test_ode3, test_ode4)
    return @testset "solvers" begin
        @testset for solver in solvers,
                problem in problems
            @test problem(solver)
        end
    end
end

function test_mas_solvers()
    problems = (test_massode1, test_massode2, test_massode3, test_massode4)
    return @testset "mas-solvers" begin
        @testset for solver in solvers_mas,
                problem in problems
            @test problem(solver)
        end
    end
end

function test_jac_solvers()
    problems = (test_jacode1, test_jacode2, test_jacode3, test_jacode4)
    return @testset "jac-solvers" begin
        @testset for solver in solvers_jac,
                problem in problems
            @test problem(solver)
        end
    end
end

function test_rhsdt_solvers()
    problems = (test_rhstimederiv1,)
    return @testset "rhs_dt-sol." begin
        @testset for solver in solvers_rhsdt,
                problem in problems
            @test problem(solver)
        end
    end
end

function test_solvers()
    test_vanilla()
    test_mas_solvers()
    test_jac_solvers()
    return test_rhsdt_solvers()
end

function test_odecall()
    problems = (test_odecall1, test_odecall2)
    return @testset "odecall" begin
        @testset for solver in solvers,
                problem in problems
            @test problem(solver)
        end
    end
end

function test_bvp()
    problems = (test_bvp1, test_bvp2, test_bvp3)
    return @testset "bvpsol" begin
        @testset for solver in solvers_bvpsol,
                problem in problems
            @test problem(solver)
        end
    end
end

function test_colnew()
    problems = (test_colnew1,)
    return @testset "colnew" begin
        @testset for solver in solvers_colnew,
                problem in problems
            @test problem(solver)
        end
    end
end

function test_bvpm2()
    problems = (test_bvpm2_1, test_bvpm2_2, test_bvpm2_3, test_bvpm2_4)
    return @testset "bvpm2" begin
        @testset for problem in problems
            @test problem()
        end
    end
end

function test_all()
    test_Banded()
    test_Options()
    solvers = test_DLSolvers()
    test_solvers()
    test_odecall()
    test_bvp()
    test_colnew()
    test_bvpm2()

    println("Solver information:")
    for info in values(solvers)
        println(info.libname, ": ", info.libhandle, "; ", info.libfilepath)
    end
    return
end

test_all()

include("public_api_tests.jl")

end

# vim:syn=julia:cc=79:fdm=indent:

# boundary conditions for the auxiliary problem of the reentry problem
# following Stoer/Bulirsch 1973

# authors: Folkmar Bornemann, Vishal Sontakke, 2016/04/23

function aux_bc(xa, xb, r)
    if dir == "forward"
        aux_bc_(xa, xb, r)
    elseif dir == "backward"
        aux_bc_(xb, xa, r)
    end
    return nothing
end

function aux_bc_(xa, xb, r)
    r[1] = (xa[1] - v0)
    r[2] = xa[2] - gamma0
    r[3] = xa[3] - h0

    r[4] = (xb[1] - v1)
    r[5] = xb[2] - gamma1
    r[6] = xb[3] - h1
    return nothing
end

"""
# ODEInterface

This julia module provides an interface to solvers for
ordinary differential equations (ODEs) written in Fortran
for solving initial value problems of the form

    x' = rhs(t,x),      x(t₀) = x₀

or (for solvers supporting a "mass matrix" M)

    M⋅x' = rhs(t,x),    x(t₀) = x₀.

## What does "Interface" mean?

This julia module does *not* contain code for solving initial value
problems, but this module does contain code for interacting with
compiled Fortran-solvers. That's the reason, why this module is not called
ODESuite.

## What solvers are currently supported?

Currently the following Fortran-solvers, written by
Prof. E. Hairer and Prof. G. Wanner, are supported:

* dopri5: explicit Runge-Kutta method of order 5(4) due to Dormand & Prince
* dop853: explicit Runge-Kutta method of order 8(5,3) due to Dormand & Prince
* odex: GBS extrapolation-algorithm based on the explicit midpoint rule
* radau5: implicit Runge-Kutta method (Radau IIA) of order 5
* radau: implicit Runge-Kutta method (Radau IIA) of variable order
  between 5 and 13
* seulex: extrapolation-algorithm based on the linear implicit Euler method
* rodas: Rosenbrock method of order 4(3) (with possibly singular mass matrix)

see [Software page of Prof. Hairer](http://www.unige.ch/~hairer/software.html).

Additionally the following Fortran-solvers from the
[SLATEC Common Mathematical Library](http://www.netlib.org/slatec/)
are supported:

* ddeabm: Adams-Bashforth-Moulton Predictor-Corrector method (order between 1 and 12)
* ddebdf: Backward Differentiation Formula (orders between 1 and 5)

The following features of this solvers are supported by this ODEInterface:

* providing an output function (e.g. for dense output or for event location)
  to the solvers
* providing mass- and jacobi-matrices for the solvers (with support for
  banded matrices)
* all the solvers' parameters for fine-tuning them
* support for problems with "special structure", see `help_specialstructure`

Also supported:

* bvpsol: a boundary value problem solver for highly nonlinear two point
  boundary value problems using either a local linear solver or a global
  sparse linear solver. **Please note: The license for `bvpsol` only
  covers non commercial use, see [License](https://github.com/luchr/ODEInterface.jl/blob/master/LICENSE.md).**
  written by P. Deuflhard, G. Bader, L. Weimann, see
  [CodeLib at ZIB](http://elib.zib.de/pub/elib/codelib/en/bvpode.html).
* colnew: a multi-point boundary value problem solver for mixed order
  systems using collocation.
  Written by U. Ascher, G. Bader, see
  [Colnew Homepage](https://people.sc.fsu.edu/~jburkardt/f77_src/colnew/colnew.html).
* BVP_M-2: a boundary value problem solver for the numerical solution of
  boundary value ordinary differential equations with defect and global error control.
  Written by J. J. Boisvert, P.H. Muir and R. J. Spiteri, see
  [BVP_M-2 Page](http://cs.stmarys.ca/~muir/BVP_SOLVER_Webpage.shtml).

## What are the requirements for this module

In order to use this module, you have to *compile* the supported
Fortran solvers and provide a shared library for each solver.
The build-script of this module tries to compile all solvers
automatically. But you can use your own compiled versions (with
different compile-time options or compilers). Just call
`ODEInterface.help_solversupport` for further information (help topics)
on how to compile the solvers and how to create shared libraries.

## Further help

see `ODEInterface.help_overview` for an overview of some help topics.

## Contacting the author of this module

The author of this julia module is

     Dr. Christian Ludwig
     email: ludwig@ma.tum.de
       (Faculty of Mathematics, Technische Universität München)

"""
module ODEInterface

import LinearAlgebra
import Markdown
import ODEInterface_jll
import Unicode

include("./Error.jl")
include("./Options.jl")
include("./DLSolvers.jl")
include("./Base.jl")
include("./SoloutEval.jl")
include("./Banded.jl")

"""macro for importing the *huge* set of symbols."""
macro import_huge()
    return quote
        @ODEInterface.import_RHScallmode
        @ODEInterface.import_bandedmatrixfuncs
        @ODEInterface.import_LOG
        @ODEInterface.import_dynamicload
        @ODEInterface.import_exceptions
        @ODEInterface.import_options
        @ODEInterface.import_outputfcn
        @ODEInterface.import_OPTcommon
        @ODEInterface.import_odecall
        @ODEInterface.import_dopri5
        @ODEInterface.import_DLdopri5
        @ODEInterface.import_dop853
        @ODEInterface.import_DLdop853
        @ODEInterface.import_DLodex
        @ODEInterface.import_odex
        @ODEInterface.import_radau5
        @ODEInterface.import_DLradau5
        @ODEInterface.import_radau
        @ODEInterface.import_DLradau
        @ODEInterface.import_seulex
        @ODEInterface.import_DLseulex
        @ODEInterface.import_rodas
        @ODEInterface.import_DLrodas
        @ODEInterface.import_bvpsol
        @ODEInterface.import_DLbvpsol
        @ODEInterface.import_ddeabm
        @ODEInterface.import_DLddeabm
        @ODEInterface.import_ddebdf
        @ODEInterface.import_DLddebdf
        @ODEInterface.import_colnew
        @ODEInterface.import_DLcolnew
        @ODEInterface.import_bvpm2
        @ODEInterface.import_DLbvpm2
    end
end

"""macro for importing the *normal* set of symbols."""
macro import_normal()
    return quote
        @ODEInterface.import_RHScallmode
        @ODEInterface.import_bandedmatrix
        @ODEInterface.import_dynamicload
        @ODEInterface.import_dopri5
        @ODEInterface.import_dop853
        @ODEInterface.import_odex
        @ODEInterface.import_radau5
        @ODEInterface.import_radau
        @ODEInterface.import_seulex
        @ODEInterface.import_rodas
        @ODEInterface.import_bvpsol
        @ODEInterface.import_bvpm2
        @ODEInterface.import_ddeabm
        @ODEInterface.import_ddebdf
        @ODEInterface.import_colnew
        @ODEInterface.import_options
        @ODEInterface.import_OPTcommon
    end
end

"""
Type describing a "variant" of a solver.

What is a variant of a solver? Some solvers support more than one
forms of dynamic libraries, e.g. with 32bit integers and with 64bit
integers. The purpose of this type is to have enough fields for
describing such an variant.
"""
struct SolverVariant
    name::AbstractString   # name of the variant
    description::AbstractString   # a short description of the variant
    libname::AbstractString   # the name of the dynamic library
    methods::Tuple            # tuples with strings of methods to load
end

"""
Type describing a solver.
"""
struct SolverInfo
    name::AbstractString   # name of the Solver
    description::AbstractString   # a short description of the solver
    supported_opts::Tuple            # Supported OPT_... Symbols
    variants::Tuple            # Tuple with SolverVariant(s)
    help_compile::Function         # Function with compile info
    help_license::Function         # Function with license info
end

"""
In this array every (supported) solver appends its SolverInfo-record.
"""
const solverInfo = Vector{SolverInfo}()


"""
Ancestor for all types storing arguments for ODE-(C-/Fortran-)solvers.
"""
abstract type AbstractArgumentsODESolver{FInt} end

"""
Ancestor for all types that represent solutions (of IVPs or BVPs).

Typically such solutions can be evaluated later.
"""
abstract type AbstractODESolution{FInt} end

# Common options
"""macro for importing common OPT options."""
macro import_OPTcommon()
    return :(
        using ODEInterface: OPT_LOGIO, OPT_LOGLEVEL, OPT_RHS_CALLMODE,
            OPT_RTOL, OPT_ATOL, OPT_MAXSTEPS, OPT_EPS,
            OPT_METHODCHOICE,
            OPT_OUTPUTFCN, OPT_OUTPUTMODE, OPT_OUTPUTATTIMES,
            OPT_STEST, OPT_RHO, OPT_SSMINSEL,
            OPT_SSMAXSEL, OPT_SSBETA, OPT_MAXSS, OPT_INITIALSS,
            OPT_TSTOP,
            OPT_MAXEXCOLUMN, OPT_MAXSTABCHECKS,
            OPT_MAXSTABCHECKLINE, OPT_INTERPOLDEGREE,
            OPT_ORDERDECFRAC, OPT_ORDERINCFRAC,
            OPT_STEPSIZESEQUENCE,
            OPT_SSREDUCTION, OPT_SSSELECTPAR1, OPT_SSSELECTPAR2,
            OPT_RHO2, OPT_DENSEOUTPUTWOEE,
            OPT_TRANSJTOH,
            OPT_MAXNEWTONITER, OPT_NEWTONSTARTZERO,
            OPT_DIMOFIND1VAR, OPT_DIMOFIND2VAR, OPT_DIMOFIND3VAR,
            OPT_STEPSIZESTRATEGY, OPT_M1, OPT_M2,
            OPT_JACRECOMPFACTOR, OPT_NEWTONSTOPCRIT,
            OPT_FREEZESSLEFT, OPT_FREEZESSRIGHT, OPT_MASSMATRIX,
            OPT_JACOBIMATRIX, OPT_JACOBIBANDSTRUCT,
            OPT_MAXSTAGES, OPT_MINSTAGES, OPT_INITSTAGES,
            OPT_ORDERDECFACTOR, OPT_ORDERINCFRAC,
            OPT_ORDERDECSTEPFAC1, OPT_ORDERDECSTEPFAC2,
            OPT_RHSAUTONOMOUS, OPT_LAMBDADENSE,
            OPT_WORKFORRHS, OPT_WORKFORJAC, OPT_WORKFORDEC,
            OPT_WORKFORSOL, OPT_RHSTIMEDERIV,
            OPT_BVPCLASS, OPT_SOLMETHOD,
            OPT_IVPOPT,
            OPT_COLLOCATIONPTS, OPT_SUBINTERVALS,
            OPT_FREEZEINTERVALS, OPT_DIAGNOSTICOUTPUT,
            OPT_ADDGRIDPOINTS, OPT_MAXSUBINTERVALS,
            OPT_COARSEGUESSGRID, OPT_ERRORCONTROL,
            OPT_SINGULARTERM
    )
end

"""macro for importing RHS_CALL_MODE."""
macro import_RHScallmode()
    return :(
        using ODEInterface: RHS_CALL_MODE, RHS_CALL_RETURNS_ARRAY,
            RHS_CALL_INSITU
    )
end

const OPT_LOGIO = "logio"
const OPT_LOGLEVEL = "loglevel"
const OPT_RHS_CALLMODE = "RightHandSideCallMode"

const OPT_RTOL = "RelTol"
const OPT_ATOL = "AbsTol"
const OPT_MAXSTEPS = "MaxNumberOfSteps"
const OPT_EPS = "eps"
const OPT_METHODCHOICE = "MethodChoice"

const OPT_OUTPUTFCN = "OutputFcn"
const OPT_OUTPUTMODE = "OutputFcnMode"
const OPT_OUTPUTATTIMES = "OutputAtTimes"

const OPT_STEST = "StiffTestAfterStep"
const OPT_RHO = "rho"
const OPT_SSMINSEL = "StepSizeMinSelection"
const OPT_SSMAXSEL = "StepSizeMaxSelection"
const OPT_SSBETA = "StepSizeBeta"
const OPT_MAXSS = "MaxStep"
const OPT_INITIALSS = "InitialStep"
const OPT_TSTOP = "StopTime"

const OPT_MAXEXCOLUMN = "MaxExtrapolationColumn"
const OPT_MAXSTABCHECKS = "MaxNumberOfStabilityChecks"
const OPT_MAXSTABCHECKLINE = "MaxLineForStabilityCheck"
const OPT_INTERPOLDEGREE = "DegreeOfInterpolation"
const OPT_ORDERDECFRAC = "OrderDecreaseFraction"
const OPT_ORDERINCFRAC = "OrderIncreaseFraction"
const OPT_STEPSIZESEQUENCE = "StepSizeSequence"
const OPT_SSREDUCTION = "StepSizeReduction"
const OPT_SSSELECTPAR1 = "StepSizeSelectionParam1"
const OPT_SSSELECTPAR2 = "StepSizeSelectionParam2"
const OPT_RHO2 = "rho2"
const OPT_DENSEOUTPUTWOEE = "DeactivateErrorEstInDenseOutput"

const OPT_TRANSJTOH = "TransformJACtoHess"
const OPT_MAXNEWTONITER = "MaxNewtonIterations"
const OPT_NEWTONSTARTZERO = "StartNewtonWithZeros"
const OPT_DIMOFIND1VAR = "DimensionOfIndex1Vars"
const OPT_DIMOFIND2VAR = "DimensionOfIndex2Vars"
const OPT_DIMOFIND3VAR = "DimensionOfIndex3Vars"
const OPT_STEPSIZESTRATEGY = "StepSizeStrategy"
const OPT_M1 = "M1"
const OPT_M2 = "M2"
const OPT_JACRECOMPFACTOR = "RecomputeJACFactor"
const OPT_NEWTONSTOPCRIT = "NewtonStopCriterion"
const OPT_FREEZESSLEFT = "FreezeStepSizeLeftBound"
const OPT_FREEZESSRIGHT = "FreezeStepSizeRightBound"
const OPT_MASSMATRIX = "MassMatrix"
const OPT_JACOBIMATRIX = "JacobiMatrix"
const OPT_JACOBIBANDSTRUCT = "JacobiBandStructure"

const OPT_MAXSTAGES = "MaximalNumberOfStages"
const OPT_MINSTAGES = "MinimalNumberOfStages"
const OPT_INITSTAGES = "InitialNumberOfStages"
const OPT_ORDERINCFACTOR = "OrderIncreaseFactor"
const OPT_ORDERDECFACTOR = "OrderDecreaseFactor"
const OPT_ORDERDECSTEPFAC1 = "OrderDecreaseStepFactor1"
const OPT_ORDERDECSTEPFAC2 = "OrderDecreaseStepFactor2"

const OPT_RHSAUTONOMOUS = "AutonomousRHS"
const OPT_LAMBDADENSE = "LambdaForDenseOutput"
const OPT_WORKFORRHS = "WorkForRightHandSide"
const OPT_WORKFORJAC = "WorkForJacobimatrix"
const OPT_WORKFORDEC = "WorkForLuDecomposition"
const OPT_WORKFORSOL = "WorkForSubstitution"

const OPT_RHSTIMEDERIV = "RhsTimeDerivative"

const OPT_BVPCLASS = "BoundaryValueProblemClass"
const OPT_SOLMETHOD = "SolutionMethod"
const OPT_IVPOPT = "OptionsForIVPsolver"

const OPT_COLLOCATIONPTS = "NumberOfCollocationPoints"
const OPT_SUBINTERVALS = "Subintervals"
const OPT_FREEZEINTERVALS = "FreezeIntervals"
const OPT_DIAGNOSTICOUTPUT = "DiagnosticOutput"
const OPT_ADDGRIDPOINTS = "AdditionalGridPoints"
const OPT_MAXSUBINTERVALS = "MaximalNumberOfSubintervals"
const OPT_COARSEGUESSGRID = "CoarseGuessGrid"

const OPT_ERRORCONTROL = "ErrorControl"
const OPT_SINGULARTERM = "SingularTerm"


@enum(
    RHS_CALL_MODE,
    RHS_CALL_RETURNS_ARRAY, RHS_CALL_INSITU
)

@doc """
The right-hand side has to return `x'` as Array.

The right-hand side must be a function of the form

     function (t,x) -> dx

`dx` is a `Vector{Float64}` with the same length as `x`.
"""
RHS_CALL_RETURNS_ARRAY

@doc """
The right-hand side has to return `nothing`. It gets an additional Array
where it has to save the the values of `x'`.

The right-hand side must be a function of the form

     function (t,x,dx) -> nothing

`dx` is a `Vector{Float64}` with the same length as `x`. In `dx` the
function has to fill in the values of `x'`.
"""
RHS_CALL_INSITU

"""
     function extractTOLs(d::Integer, opt::AbstractOptionsODE)
            -> (scalarFlag,rtol,atol)

extract `OPT_RTOL` and `OPT_ATOL` and convert to `Vector{Float64}`.

Supports scalar `OPT_RTOL` and `OPT_ATOL` and converts them to a
`Vector{Float64}` of length 1.

reads options: `OPT_RTOL`, `OPT_ATOL`
"""
function extractTOLs(d::Integer, opt::AbstractOptionsODE)
    rtol = getOption(opt, OPT_RTOL, 1.0e-3)
    atol = getOption(opt, OPT_ATOL, 1.0e-6)
    scalarFlag = false

    if isscalar(rtol) && isscalar(atol)
        scalarFlag = true
        try
            rtol = [convert(Float64, rtol)]
            atol = [convert(Float64, atol)]
        catch e
            throw(
                ArgumentErrorODE(
                    string(
                        "OPT_RTOL and OPT_ATOL are scalars. ",
                        "But I've a problem converting rtol=$rtol,",
                        " and/or atol=$atol to Float64"
                    ), :opt, e
                )
            )
        end
    else
        try
            rtol = getVectorCheckLength(rtol, Float64, d)
            atol = getVectorCheckLength(atol, Float64, d)
        catch e
            throw(
                ArgumentErrorODE(
                    string(
                        "OPT_RTOL and/or OPT_ATOL is not a real scalar. ",
                        "But I've also a problem converting them to Float64 ",
                        "vectors of length $d"
                    ), :opt, e
                )
            )
        end
    end

    return (scalarFlag, rtol, atol)
end

"""
     function extractLogOptions(opt::AbstractOptionsODE) -> (lio, lev)

Extract options for logging.

throws ArgumentErrorODE if logio is not an IO or
if loglevel is not convertible to UInt64.

reads options: `OPT_LOGIO`, `OPT_LOGLEVEL`
"""
function extractLogOptions(opt::AbstractOptionsODE)
    lio = getOption(opt, OPT_LOGIO, stderr)
    if !isa(lio, IO)
        throw(ArgumentErrorODE("option '$OPT_LOGIO' was not an Base.IO", :opt))
    end
    lev = nothing
    try
        lev = convert(UInt64, getOption(opt, OPT_LOGLEVEL, 0))
    catch e
        throw(
            ArgumentErrorODE(
                "option '$OPT_LOGLEVEL' cannot be converted to UInt64", :opt, e
            )
        )
    end
    return (lio, lev)
end

"""
     function extractOutputFcn(opt::AbstractOptionsODE)
            -> (output_mode, output_fcn)

reads options: `OPT_OUTPUTMODE`, `OPT_OUTPUTFCN`
"""
function extractOutputFcn(opt::AbstractOptionsODE)
    OPT = nothing
    output_mode = OUTPUTFCN_NEVER; output_fcn = output_fcn_donothing
    try
        OPT = OPT_OUTPUTMODE; output_mode = getOption(opt, OPT, OUTPUTFCN_NEVER)
        @assert isa(output_mode, OUTPUTFCN_MODE)

        if output_mode ≠ OUTPUTFCN_NEVER
            OPT = OPT_OUTPUTFCN
            output_fcn = getOption(opt, OPT, nothing)
            @assert isa(output_fcn, Function)
        end
    catch e
        throw(ArgumentErrorODE("Option '$OPT' invalid", :opt, e))
    end

    return (output_mode, output_fcn)
end

"""
     function solver_init(solver_name::AbstractString,
                          opt::AbstractOptionsODE)
        ->  (lio,l,l_g,l_solver,lprefix)

reads options: `OPT_LOGIO`, `OPT_LOGLEVEL`
"""
function solver_init(solver_name::AbstractString, opt::AbstractOptionsODE)
    (lio, l) = extractLogOptions(opt)
    (l_g, l_solver) = (l & LOG_GENERAL > 0, l & LOG_SOLVERARGS > 0)
    lprefix = string(solver_name, ": ")
    return (lio, l, l_g, l_solver, lprefix)
end

"""
     function solver_start(solver_name::AbstractString, rhs,
                 t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE)
        ->  (lio,l,l_g,l_solver,lprefix)

initialization for a (typical) solver call/start.

reads options: `OPT_LOGIO`, `OPT_LOGLEVEL`
"""
function solver_start(
        solver_name::AbstractString, rhs,
        t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE
    )

    (lio, l, l_g, l_solver, lprefix) = solver_init(solver_name, opt)

    if l_g
        println(
            lio, lprefix,
            "called with rhs=", rhs, " t0=", t0, " T=", T, " x0=", x0, " and opt"
        )
        show(lio, opt); println(lio)
    end

    return (lio, l, l_g, l_solver, lprefix)
end

"""
     function solver_extract_rhsMode(opt::AbstractOptionsODE)
                 -> rhs_mode

reads options: `OPT_RHS_CALLMODE`
"""
function solver_extract_rhsMode(opt::AbstractOptionsODE)
    try
        rhs_mode = getOption(opt, OPT_RHS_CALLMODE, RHS_CALL_RETURNS_ARRAY)
        @assert rhs_mode ∈ (RHS_CALL_RETURNS_ARRAY, RHS_CALL_INSITU)
        return rhs_mode
    catch e
        throw(ArgumentErrorODE("Option 'OPT_RHS_CALLMODE' is invalid", :opt, e))
    end
end

"""
     function solver_extract_commonOpt(t0::Real, T::Real, x0::Vector,
                  opt::AbstractOptionsODE,
                  args::AbstractArgumentsODESolver{FInt}) where FInt
       -> (d,nrdense,scalarFlag,rhs_mode,output_mode,output_fcn)

get d, fill args.N, args.x, args.t, args.tEnd, args.RTOL, args.ATOL

reads options: `OPT_RTOL`, `OPT_ATOL`, `OPT_RHS_CALLMODE`,
`OPT_OUTPUTMODE`, `OPT_OUTPUTFCN`
"""
function solver_extract_commonOpt(
        t0::Real, T::Real, x0::Vector,
        opt::AbstractOptionsODE,
        args::AbstractArgumentsODESolver{FInt}
    ) where {FInt}

    d = FInt(0)
    try
        d = convert(FInt, length(x0))
    catch e
        throw(ArgumentErrorODE("Cannot convert length(x0) to $FInt", :x0, e))
    end
    0 == d && throw(ArgumentErrorODE("x0 was empty vector", :x0))
    args.N = [d]
    try
        args.x = getVectorCheckLength(x0, Float64, d)
    catch e
        throw(ArgumentErrorODE("Cannot convert x0 to Vector{Float64}", :x0, e))
    end

    try
        args.t = [convert(Float64, t0)]
    catch e
        throw(ArgumentErrorODE("Cannot convert t0=$t0 to Float64", :t0, e))
    end
    try
        args.tEnd = [convert(Float64, T)]
    catch e
        throw(ArgumentErrorODE("Cannot convert T=$T to Float64", :T, e))
    end

    (scalarFlag, args.RTOL, args.ATOL) = extractTOLs(d, opt)

    rhs_mode = solver_extract_rhsMode(opt)

    (output_mode, output_fcn) = extractOutputFcn(opt)
    if output_mode == OUTPUTFCN_NEVER
        nrdense = FInt(0)
    else
        nrdense = d
    end

    return (d, nrdense, scalarFlag, rhs_mode, output_mode, output_fcn)
end

include("./HWcommon.jl")
include("./SLATECcommon.jl")

# Solvers:
include("./Dopri.jl")
include("./Dopri5.jl")
include("./Dop853.jl")
include("./Odex.jl")
include("./Radau.jl")
include("./Seulex.jl")
include("./Rodas.jl")
include("./Bvpsol.jl")
include("./Deabm.jl")
include("./Debdf.jl")
include("./Colnew.jl")
include("./Bvpm2.jl")

include("./Call.jl")
include("./Help.jl")

"""
will be called once after the module is loaded at runtime.
"""
function __init__()
    # at this stage dlSolversInfo should be empty, but
    # just to be sure
    return empty!(dlSolversInfo)
end

# `public` needs the Julia 1.11 parser, so while 1.10 is supported the
# declaration cannot be written literally here. On 1.10 the names carry no
# public marker, but they are reachable the same way
# (`ODEInterface.dopri5`, `using ODEInterface: dopri5`).
@static if VERSION ≥ v"1.11"
    include_string(
        @__MODULE__,
        """
        public OptionsODE, RHS_CALL_INSITU, OUTPUTFCN_CALL_REASON,
            OUTPUTFCN_CALL_STEP, OUTPUTFCN_WODENSE, OUTPUTFCN_DENSE,
            OUTPUTFCN_RET_CONTINUE, OUTPUTFCN_RET_CONTINUE_XCHANGED,
            dopri5, dop853, odex, seulex, radau, radau5, rodas, ddeabm,
            ddebdf
        """
    )
end

end


# vim:syn=julia:cc=79:fdm=indent:

# Functions for ODE-Solver: Rodas

"""Name for Loading rodas solver (64bit integers)."""
const DL_RODAS = "rodas"

"""Name for Loading rodas solver (32bit integers)."""
const DL_RODAS_I32 = "rodas_i32"

"""macro for import rodas solver."""
macro import_rodas()
    return :(
        using ODEInterface: rodas, rodas_i32
    )
end

"""macro for import rodas dynamic lib names."""
macro import_DLrodas()
    return :(
        using ODEInterface: DL_RODAS, DL_RODAS_I32
    )
end

"""macro for importing Rodas help."""
macro import_rodas_help()
    return :(
        using ODEInterface: help_rodas_compile, help_rodas_license
    )
end

"""
Type encapsulating all required data for Rodas-Solver-Callbacks.

We have the typical calling stack:

     rodas
         call_julia_output_fcn(  ... INIT ... )
             output_fcn ( ... INIT ...)
         ccall( RODAS_  ... )
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_HW2RHSCallback                      │  ⎬ cb. rhs
            │    rhs                                    │  ⎪
            └───────────────────────────────────────────┘  ⎭
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_rodasSoloutCallback:                │  ⎪
            │    call_julia_output_fcn( ... STEP ...)   │  ⎪ cb. solout
            │        output_fcn ( ... STEP ...)         │  ⎬ with eval
            │            eval_sol_fcn                   │  ⎪
            │                ccall(CONTRO_ ... )        │  ⎪
            └───────────────────────────────────────────┘  ⎭
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_HW1JacCallback:                     │  ⎬ cb. jacobian
            │    call_julia_jac_fcn                     │  ⎪
            └───────────────────────────────────────────┘  ⎭
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_HWRhsTimeDerivCallback:             │  ⎬ cb. ∂f/∂t
            │    rhsdt                                  │  ⎪
            └───────────────────────────────────────────┘  ⎭
         call_julia_output_fcn(  ... DONE ... )
             output_fcn ( ... DONE ...)
"""
mutable struct RodasInternalCallInfos{
        FInt <: FortranInt, RHS_F,
        OUT_F, JAC_F, RHSDT_F,
    } <: ODEinternalCallInfos
    logio::IO                    # where to log
    loglevel::UInt64                # log level
    # special structure
    M1::FInt
    M2::FInt
    # RHS
    rhs::RHS_F                 # right-hand-side
    rhs_mode::RHS_CALL_MODE         # how to call rhs
    rhs_lprefix::AbstractString        # saved log-prefix for rhs
    # RHS time derivative
    rhsdt::RHSDT_F               # right-hand side time derivative
    rhsdt_prefix::AbstractString        # saved log-prefix for rhsdt
    # SOLOUT & output function
    output_mode::OUTPUTFCN_MODE        # what mode for output function
    output_fcn::OUT_F                 # the output function to call
    output_data::Dict                  # extra_data for output_fcn
    out_lprefix::AbstractString        # saved log-prefix for solout
    eval_sol_fcn::Function              # eval_sol_fcn
    eval_lprefix::AbstractString        # saved log-prefix for eval_sol
    tOld::Float64               # tOld and
    tNew::Float64               # tNew and
    xNew::Vector{Float64}       # xNew of current solout interval
    cont_i::Vector{FInt}          # argument to contro
    cont_s::Vector{Float64}       # argument to contro
    cont_cont::Ptr{Float64}          # saved pointers for contro
    cont_lrc::Ptr{FInt}             # saved pointers for contro
    # Massmatrix
    massmatrix::AbstractArray{Float64} # saved mass matrix
    # Jacobimatrix
    jacobimatrix::JAC_F                 # function for jacobi matrix
    jacobibandstruct                      # (l,u) bandstructure or nothing
    jac_lprefix::AbstractString        # saved log-prefix for jac
end

"""
     mutable struct RodasArguments{FInt<:FortranInt} <:
              AbstractArgumentsODESolver{FInt}

Stores Arguments for Rodas solver.

FInt is the Integer type used for the fortran compilation.
"""
mutable struct RodasArguments{FInt <: FortranInt} <: AbstractArgumentsODESolver{FInt}
    N::Vector{FInt}      # Dimension
    FCN::Ptr{Cvoid}        # rhs callback
    IFCN::Vector{FInt}      # autonomous (0) or not (1)
    t::Vector{Float64}   # start time (and current)
    tEnd::Vector{Float64}   # end time
    x::Vector{Float64}   # initial value (and current state)
    H::Vector{Float64}   # initial step size
    RTOL::Vector{Float64}   # relative tolerance
    ATOL::Vector{Float64}   # absolute tolerance
    ITOL::Vector{FInt}      # switch for RTOL, ATOL
    JAC::Ptr{Cvoid}        # jacobian callback
    IJAC::Vector{FInt}      # jacobian given as callback?
    MLJAC::Vector{FInt}      # lower bandwidth of jacobian
    MUJAC::Vector{FInt}      # upper bandwidth of jacobian
    DFX::Ptr{Cvoid}        # dFCN/dt callback
    IDFX::Vector{FInt}      # DFX given as callback?
    MAS::Ptr{Cvoid}
    IMAS::Vector{FInt}      # mass matrix given as callback?
    MLMAS::Vector{FInt}      # lower bandwidth of mass matrix
    MUMAS::Vector{FInt}      # upper bandwidth of mass matrix
    SOLOUT::Ptr{Cvoid}        # solout callback
    IOUT::Vector{FInt}      # switch for SOLOUT
    WORK::Vector{Float64}   # double working array
    LWORK::Vector{FInt}      # length of WORK
    IWORK::Vector{FInt}      # integer working array
    LIWORK::Vector{FInt}      # length of IWORK
    RPAR::Vector{Float64}   # add. double-array
    IPAR::Ref{RodasInternalCallInfos} # misuse IPAR
    IDID::Vector{FInt}      # Status code
    ## Allow uninitialized construction
    function RodasArguments{FInt}(dummy::FInt) where {FInt}
        return new{FInt}()
    end
end


"""
     function unsafe_rodasSoloutCallback(
             nr_::Ptr{FInt}, told_::Ptr{Float64}, t_::Ptr{Float64},
             x_::Ptr{Float64}, cont_::Ptr{Float64}, lrc_::Ptr{FInt},
             n_::Ptr{FInt}, rpar_::Ptr{Float64}, cbi::CI,
             irtrn_::Ptr{FInt}) where {FInt<:FortranInt,
                                       CI<:RodasInternalCallInfos}

This is the solout given as callback to Fortran-rodas.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-pointers.

This function saves the state information of the solver in
`RodasInternalCallInfos`, where they can be found by
the `eval_sol_fcn`, see `create_rodas_eval_sol_fcn_closure`.

Then the user-supplied `output_fcn` is called (which in turn can use
`eval_sol_fcn`, to evaluate the solution at intermediate points).

The return value of the `output_fcn` is propagated to `RODAS_`.

For the typical calling sequence, see `RodasInternalCallInfos`.
"""
function unsafe_rodasSoloutCallback(
        nr_::Ptr{FInt}, told_::Ptr{Float64}, t_::Ptr{Float64},
        x_::Ptr{Float64}, cont_::Ptr{Float64}, lrc_::Ptr{FInt},
        n_::Ptr{FInt}, rpar_::Ptr{Float64}, cbi::CI,
        irtrn_::Ptr{FInt}
    ) where {
        FInt <: FortranInt,
        CI <: RodasInternalCallInfos,
    }

    nr = unsafe_load(nr_); told = unsafe_load(told_); t = unsafe_load(t_)
    n = unsafe_load(n_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    irtrn = unsafe_wrap(Array, irtrn_, (1,), own = false)

    (lio, l, lprefix) = (cbi.logio, cbi.loglevel, cbi.out_lprefix)
    l_sol = l & LOG_SOLOUT > 0

    l_sol && println(
        lio, lprefix, "called with nr=", nr, " told=", told,
        " t=", t, " x=", x
    )

    cbi.tOld = told; cbi.tNew = t; cbi.xNew = x
    cbi.cont_cont = cont_; cbi.cont_lrc = lrc_
    cbi.output_data["nr"] = nr

    ret = call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_STEP, told, t, x,
        cbi.eval_sol_fcn
    )

    if ret == OUTPUTFCN_RET_STOP
        irtrn[1] = -1
    elseif ret == OUTPUTFCN_RET_CONTINUE
        irtrn[1] = 0
    elseif ret == OUTPUTFCN_RET_CONTINUE_XCHANGED
        throw(
            FeatureNotSupported(
                string(
                    "Sorry; rodas does not support ",
                    "to change the solution inside the output function."
                )
            )
        )
    else
        throw(InternalErrorODE(string("Unknown ret=", ret, " of output function")))
    end

    return nothing
end

"""
     function unsafe_rodasSoloutCallback_c(cbi::CI,
             fint_flag::FInt) where {FInt,CI}
"""
function unsafe_rodasSoloutCallback_c(
        cbi::CI,
        fint_flag::FInt
    ) where {FInt, CI}
    return @cfunction(
        unsafe_rodasSoloutCallback, Cvoid, (
            Ptr{FInt},
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64},
            Ptr{Float64}, Ptr{FInt},
            Ptr{FInt}, Ptr{Float64}, Ref{CI}, Ptr{FInt},
        )
    )
end

"""
     function create_rodas_eval_sol_fcn_closure(cbi::CI, d::FInt,
             method_contro::Ptr{Cvoid}) where {FInt<:FortranInt,
                                              CI<:RodasInternalCallInfos}

generates a eval_sol_fcn for rodas.

Why is a closure needed? We need a function `eval_sol_fcn`
that calls `CONTRO_` (with `ccall`).
But `CONTRO_` needs the information for the current state. This
information were saved by `unsafe_rodasSoloutCallback` in the
`RodasInternalCallInfos`. `eval_sol_fcn` needs to get this information.
Here comes `create_rodas_eval_sol_fcn_closure` into play: this function
takes the call information and generates a `eval_sol_fcn` with this data.

Why doesn't `unsafe_rodasSoloutCallback` generate a closure (then
the current state needs not to be saved in `RodasInternalCallInfos`)?
Because then every call to `unsafe_rodasSoloutCallback` would have
generated a closure function. That's a lot of overhead: 1 closure function
for every solout call. With the strategy above, we have 1 closure function
per ODE-solver-call, i.e. 1 closure function per ODE.

For the typical calling sequence, see `RodasInternalCallInfos`.
"""
function create_rodas_eval_sol_fcn_closure(
        cbi::CI, d::FInt,
        method_contro::Ptr{Cvoid}
    ) where {
        FInt <: FortranInt,
        CI <: RodasInternalCallInfos,
    }

    function eval_sol_fcn_closure(s::Float64)
        (lio, l, lprefix) = (cbi.logio, cbi.loglevel, cbi.eval_lprefix)
        l_eval = l & LOG_EVALSOL > 0

        l_eval && println(lio, lprefix, "called with s=", s)
        cbi.cont_s[1] = s
        result = Vector{Float64}(undef, d)
        if s == cbi.tNew
            result[:] = cbi.xNew
            l_eval && println(lio, lprefix, "not calling contro because s==tNew")
        else
            for k in 1:d
                cbi.cont_i[1] = k
                result[k] = ccall(
                    method_contro, Float64,
                    (Ptr{FInt}, Ptr{Float64}, Ptr{Float64}, Ptr{FInt}),
                    cbi.cont_i, cbi.cont_s, cbi.cont_cont, cbi.cont_lrc
                )
            end
        end

        l_eval && println(lio, lprefix, "contro returned ", result)
        return result
    end
    return eval_sol_fcn_closure
end


"""
      function rodas(rhs, t0::Real, T::Real,
                     x0::Vector, opt::AbstractOptionsODE)
         -> (t,x,retcode,stats)


`retcode` can have the following values:

      1: computation successful
      2: computation. successful, but interrupted by output function
     -1: computation unsuccessful


main call for using Fortran rodas solver.

This solver support problems with special structure, see
`help_specialstructure`.

In `opt` the following options are used:

    ╔═════════════════╤══════════════════════════════════════════╤═════════╗
    ║  Option OPT_…   │ Description                              │ Default ║
    ╠═════════════════╪══════════════════════════════════════════╪═════════╣
    ║ RHSAUTONOMOUS   │ Flag, if right-hand side is autonomous.  │   false ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ M1 & M2         │ parameter for special structure, see     │       0 ║
    ║                 │ above                                    │      M1 ║
    ║                 │ M1, M2 ≥ 0                               │         ║
    ║                 │ M1 +M2 ≤ length(x0)                      │         ║
    ║                 │ (M1==M2==0) || (M1≠0≠M2)                 │         ║
    ║                 │ M1 % M2 == 0 or M1==0                    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ RTOL         &  │ relative and absolute error tolerances   │    1e-3 ║
    ║ ATOL            │ both scalars or both vectors with the    │    1e-6 ║
    ║                 │ length of length(x0)                     │         ║
    ║                 │ error(xₖ) ≤ OPT_RTOLₖ⋅|xₖ|+OPT_ATOLₖ     │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTFCN       │ output function                          │ nothing ║
    ║                 │ see help_outputfcn                       │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTMODE      │ OUTPUTFCN_NEVER:                         │   NEVER ║
    ║                 │   dont't call OPT_OUTPUTFCN              │         ║
    ║                 │ OUTPUTFCN_WODENSE                        │         ║
    ║                 │   call OPT_OUTPUTFCN, but without        │         ║
    ║                 │   possibility for dense output           │         ║
    ║                 │ OUTPUTFCN_DENSE                          │         ║
    ║                 │   call OPT_OUTPUTFCN with support for    │         ║
    ║                 │   dense output                           │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ EPS             │ the rounding unit                        │   1e-16 ║
    ║                 │ 0 < OPT_EPS < 1.0                        │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ METHODCHOICE    │ Choice of coefficients:                  │       1 ║
    ║                 │ 1: Hairer, Wanner: Solving ODE II,       │         ║
    ║                 │    page 452                              │         ║
    ║                 │ 2: same as 1, with different params      │         ║
    ║                 │ 3: G. Steinbach (1993)                   │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSTEPS        │ maximal number of allowed steps          │  100000 ║
    ║                 │ OPT_MAXSTEPS > 0                         │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSS           │ maximal step size                        │  T - t0 ║
    ║                 │ OPT_MAXSS ≠ 0                            │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ INITIALSS       │ initial step size guess                  │    1e-6 ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ STEPSIZESTRATEGY│ Switch for step size strategy            │       1 ║
    ║                 │   1: mod. predictive controller          │         ║
    ║                 │      (Gustafsson)                        │         ║
    ║                 │   2: classical step size control         │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OPT_RHO         │ safety factor for step control algorithm │     0.9 ║
    ║                 │ 0.001 < OPT_RHO < 1.0                    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ SSMINSEL   &    │ parameters for step size selection       │     0.2 ║
    ║ SSMAXSEL        │ The new step size is chosen subject to   │     6.0 ║
    ║                 │ the restriction                          │         ║
    ║                 │ OPT_SSMINSEL ≤ hnew/hold ≤ OPT_SSMAXSEL  │         ║
    ║                 │ OPT_SSMINSEL ≤ 1, OPT_SSMAXSEL ≥ 1       │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ RHSTIMEDERIV    │ A function providing the time derivative │ nothing ║
    ║                 │ ∂f/∂t of the right-hand side or nothing. │         ║
    ║                 │ If the value given is nothing the solver │         ║
    ║                 │ uses finite differences to approximate   │         ║
    ║                 │ ∂f/∂t.                                   │         ║
    ║                 │ Obviously this options is only relevant  │         ║
    ║                 │ for non-autonomous problems.             │         ║
    ║                 │ The function has to be of the form:      │         ║
    ║                 │   function (t,x,dfdt) -> nothing         │         ║
    ║                 │ Even if the problem has special structure│         ║
    ║                 │ (M1>0, see help_specialstructure) x and  │         ║
    ║                 │ dfdt are always vectors with full length,│         ║
    ║                 │ i.e. length(x)==length(dfdt)==length(x0).│         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ JACOBIMATRIX    │ A function providing the Jacobian for    │ nothing ║
    ║                 │ ∂f/∂x or nothing. For nothing the solver │         ║
    ║                 │ uses finite differences to calculate the │         ║
    ║                 │ Jacobian.                                │         ║
    ║                 │ The function has to be of the form:      │         ║
    ║                 │   function (t,x,J) -> nothing       (A)  │         ║
    ║                 │ or for M1>0 & JACOBIBANDSTRUCT ≠ nothing │         ║
    ║                 │   function (t,x,J1,…,JK) -> nothing (B)  │         ║
    ║                 │ with K = 1+M1/M2 and (M1+M2==d)          │         ║
    ║                 │ see help_specialstructure                │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ JACOBIBANDSTRUCT│ A tuple (l,u) describing the banded      │ nothing ║
    ║                 │ structure of the Jacobian or nothing if  │         ║
    ║                 │ the Jacobian is full.                    │         ║
    ║                 │ see help_specialstructure                │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MASSMATRIX      │ the mass matrix of the problem. If not   │ nothing ║
    ║                 │ given (nothing) then the identity matrix  │         ║
    ║                 │ is used.                                 │         ║
    ║                 │ The size has to be (d-M1)×(d-M1).        │         ║
    ║                 │ It can be an full matrix or a banded     │         ║
    ║                 │ matrix (BandedMatrix).                   │         ║
    ╚═════════════════╧══════════════════════════════════════════╧═════════╝
"""
function rodas(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return rodas_impl(rhs, t0, T, x0, opt, RodasArguments{Int64}(Int64(0)))
end

"""
rodas with 32bit integers, see rodas.
"""
function rodas_i32(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return rodas_impl(rhs, t0, T, x0, opt, RodasArguments{Int32}(Int32(0)))
end

function rodas_impl(
        rhs,
        t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
        args::RodasArguments{FInt}
    ) where {FInt <: FortranInt}

    (lio, l, l_g, l_solver, lprefix) = solver_start("rodas", rhs, t0, T, x0, opt)

    (method_rodas, method_contro) = getAllMethodPtrs(
        (FInt == Int64) ? DL_RODAS : DL_RODAS_I32
    )

    (d, nrdense, scalarFlag, rhs_mode, output_mode, output_fcn) =
        solver_extract_commonOpt(t0, T, x0, opt, args)

    args.ITOL = [scalarFlag ? 0 : 1]
    args.IOUT = [
        FInt(
            output_mode == OUTPUTFCN_NEVER ? 0 :
                (output_mode == OUTPUTFCN_DENSE ? 2 : 1)
        ),
    ]

    (M1, M2, NM1) = extractSpecialStructureOpt(d, opt)
    massmatrix = extractMassMatrix(M1, M2, NM1, args, opt)

    (jacobimatrix, jacobibandstruct, jac_lprefix) =
        extractJacobiOpt(d, M1, M2, NM1, args, opt)

    (rhsdt, rhsdt_prefix) = extractRhsTimeDerivOpt(args, opt)

    flag_implct = args.IMAS[1] ≠ 0
    flag_jband = args.MLJAC[1] < NM1

    # WORK memory
    ljac = flag_jband ? 1 + args.MLJAC[1] + args.MUJAC[1] : NM1
    lmas = (!flag_implct) ? 0 :
        (args.MLMAS[1] == NM1) ? NM1 : 1 + args.MLMAS[1] + args.MUMAS[1]
    le = flag_jband ? 1 + 2 * args.MLJAC[1] + args.MUJAC[1] : NM1

    args.LWORK = [
        (M1 == 0) ? d * (ljac + lmas + le + 14) + 20 :
            d * (ljac + 14) + NM1 * (lmas + le) + 20,
    ]
    args.WORK = zeros(Float64, args.LWORK[1])

    # IWORK memory
    args.LIWORK = [d + 20]
    args.IWORK = zeros(FInt, args.LIWORK[1])

    OPT = nothing
    try
        OPT = OPT_RHSAUTONOMOUS
        rhsautonomous = convert(Bool, getOption(opt, OPT, false))
        args.IFCN = [FInt(rhsautonomous ? 0 : 1)]

        OPT = OPT_MAXSTEPS; args.IWORK[1] = convert(FInt, getOption(opt, OPT, 100000))
        @assert 0 < args.IWORK[1]

        OPT = OPT_METHODCHOICE; args.IWORK[2] = convert(FInt, getOption(opt, OPT, 1))
        @assert 1 ≤ args.IWORK[2] ≤ 3

        OPT = OPT_STEPSIZESTRATEGY
        args.IWORK[3] = convert(FInt, getOption(opt, OPT, 1))
        @assert args.IWORK[3] ∈ (1, 2)

        args.IWORK[9] = M1
        args.IWORK[10] = M2

        OPT = OPT_EPS; args.WORK[1] = convert(Float64, getOption(opt, OPT, 1.0e-16))
        @assert 0 < args.WORK[1] < 1.0

        OPT = OPT_MAXSS; args.WORK[2] = convert(Float64, getOption(opt, OPT, T - t0))
        @assert 0 ≠ args.WORK[2]

        OPT = OPT_SSMINSEL; args.WORK[3] = convert(Float64, getOption(opt, OPT, 0.2))
        @assert args.WORK[3] ≤ 1
        OPT = OPT_SSMAXSEL; args.WORK[4] = convert(Float64, getOption(opt, OPT, 6.0))
        @assert args.WORK[4] ≥ 1

        OPT = OPT_RHO
        args.WORK[5] = convert(Float64, getOption(opt, OPT, 0.9))
        @assert 0.001 < args.WORK[5] < 1.0

        OPT = OPT_INITIALSS
        args.H = [convert(Float64, getOption(opt, OPT, 1.0e-6))]
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    args.RPAR = zeros(Float64, 0)
    args.IDID = zeros(FInt, 1)
    rhs_lprefix = "unsafe_HW2RHSCallback: "
    out_lprefix = "unsafe_rodasSoloutCallback: "
    eval_lprefix = "eval_sol_fcn_closure: "

    cbi = RodasInternalCallInfos(
        lio, l, M1, M2, rhs, rhs_mode, rhs_lprefix,
        rhsdt === nothing ? dummy_func : rhsdt, rhsdt_prefix,
        output_mode, output_fcn, Dict(),
        out_lprefix, eval_sol_fcn_noeval, eval_lprefix,
        NaN, NaN, Vector{Float64}(), Vector{FInt}(undef, 1),
        Vector{Float64}(undef, 1),
        Ptr{Float64}(C_NULL), Ptr{FInt}(C_NULL),
        massmatrix === nothing ? zeros(0, 0) : massmatrix,
        jacobimatrix === nothing ? dummy_func : jacobimatrix,
        jacobibandstruct, jac_lprefix
    )

    if output_mode == OUTPUTFCN_DENSE
        cbi.eval_sol_fcn = create_rodas_eval_sol_fcn_closure(cbi, d, method_contro)
    end

    args.FCN = unsafe_HW2RHSCallback_c(cbi, FInt(0))

    args.SOLOUT = output_mode ≠ OUTPUTFCN_NEVER ?
        unsafe_rodasSoloutCallback_c(cbi, FInt(0)) :
        @cfunction(dummy_func, Cvoid, ())
    args.IPAR = cbi
    args.MAS = unsafe_HW1MassCallback_c(cbi, FInt(0))
    args.JAC = unsafe_HW1JacCallback_c(cbi, FInt(0))
    args.DFX = unsafe_HWRhsTimeDerivCallback_c(cbi, FInt(0))

    output_mode ≠ OUTPUTFCN_NEVER &&
        call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_INIT,
        args.t[1], args.tEnd[1], args.x, eval_sol_fcn_init
    ) # ignore result

    if l_solver
        println(lio, lprefix, "call Fortran-rodas $method_rodas with")
        dump(lio, args)
    end

    ccall(
        method_rodas, Cvoid,
        (
            Ptr{FInt}, Ptr{Cvoid}, Ptr{FInt},          # N=d, Rightsidefunc, IFCN
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64},   # t, x, tEnd
            Ptr{Float64},                               # h
            Ptr{Float64}, Ptr{Float64}, Ptr{FInt},      # RTOL, ATOL, ITOL
            Ptr{Cvoid}, Ptr{FInt}, Ptr{FInt}, Ptr{FInt}, # JAC, IJAC, MLJAC, MUJAC
            Ptr{Cvoid}, Ptr{FInt},                      # DFX, IDFX
            Ptr{Cvoid}, Ptr{FInt}, Ptr{FInt}, Ptr{FInt}, # MAS, IMAS, MLMAS, MUMAS
            Ptr{Cvoid}, Ptr{FInt},                      # Soloutfunc, IOUT
            Ptr{Float64}, Ptr{FInt},                    # WORK, LWORK
            Ptr{FInt}, Ptr{FInt},                       # IWORK, LIWORK
            Ptr{Float64}, Ref{RodasInternalCallInfos},  # RPAR, IPAR
            Ptr{FInt},                                  # IDID
        ),
        args.N, args.FCN, args.IFCN,
        args.t, args.x, args.tEnd,
        args.H,
        args.RTOL, args.ATOL, args.ITOL,
        args.JAC, args.IJAC, args.MLJAC, args.MUJAC,
        args.DFX, args.IDFX,
        args.MAS, args.IMAS, args.MLMAS, args.MUMAS,
        args.SOLOUT, args.IOUT,
        args.WORK, args.LWORK,
        args.IWORK, args.LIWORK,
        args.RPAR, args.IPAR, args.IDID,
    )

    if l_solver
        println(lio, lprefix, "Fortran-rodas $method_rodas returned")
        dump(lio, args)
    end

    output_mode ≠ OUTPUTFCN_NEVER &&
        call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_DONE,
        args.t[1], args.tEnd[1], args.x, eval_sol_fcn_done
    ) # ignore result

    l_g && println(lio, lprefix, string("done IDID=", args.IDID[1]))
    stats = Dict{AbstractString, Any}(
        "step_predict" => args.H[1],
        "no_rhs_calls" => args.IWORK[14],
        "no_jac_calls" => args.IWORK[15],
        "no_steps" => args.IWORK[16],
        "no_steps_accepted" => args.IWORK[17],
        "no_steps_rejected" => args.IWORK[18],
        "no_lu_decomp" => args.IWORK[19],
        "no_fw_bw_subst" => args.IWORK[20],
    )
    return (args.t[1], args.x, args.IDID[1], stats)
end

"""
## Compile RODAS

The julia ODEInterface tries to compile and link the solvers
automatically at the build-time of this module. The following
calls need only be done, if one uses a different compiler and/or if
one wants to change/add some compiler options.

The Fortran source code can be found at:

     http://www.unige.ch/~hairer/software.html

See `help_rodas_license` for the license information.

### Using `gfortran` and 64bit integers (Linux and Mac)

Here is an example how to compile RODAS with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o dc_lapack.o dc_lapack.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapack.o lapack.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o rodas.o rodas.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o rodas.so
              rodas.o dc_lapack.o lapack.o
     gfortran -shared -fPIC -o rodas.dylib
              rodas.o dc_lapack.o lapack.o

### Using `gfortran` and 64bit integers (Windows)

Here is an example how to compile RODAS with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o dc_lapack.o dc_lapack.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapack.o lapack.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o rodas.o rodas.f

In order to get create a shared library (from the object file above) use

     gfortran -shared -o rodas.so
              rodas.o dc_lapack.o lapack.o

### Using `gfortran` and 32bit integers (Linux and Mac)

Here is an example how to compile RODAS with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o dc_lapack_i32.o dc_lapack.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o lapack_i32.o lapack.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o rodas_i32.o rodas.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o rodas_i32.so
               rodas_i32.o dc_lapack_i32.o lapack_i32.o
     gfortran -shared -fPIC -o rodas_i32.dylib
               rodas_i32.o dc_lapack_i32.o lapack_i32.o

### Using `gfortran` and 32bit integers (Windows)

Here is an example how to compile RODAS with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o dc_lapack_i32.o dc_lapack.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o lapack_i32.o lapack.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o rodas_i32.o rodas.f

In order to get create a shared library (from the object file above) use:

     gfortran -shared -o rodas_i32.dll
               rodas_i32.o dc_lapack_i32.o lapack_i32.o

"""
function help_rodas_compile()
    return Docs.doc(help_rodas_compile)
end

function help_rodas_license()
    return Docs.doc(help_rodas_license)
end

@doc(@doc(hw_license), help_rodas_license)

# Add information about solvers in global solverInfo-array.
push!(
    solverInfo,
    SolverInfo(
        "rodas",
        "Rosenbrock method of order 4(3)",
        tuple(
            :OPT_RTOL, :OPT_ATOL,
            :OPT_OUTPUTMODE, :OPT_OUTPUTFCN,
            :OPT_M1, :OPT_M2,
            :OPT_RHSAUTONOMOUS,
            :OPT_MASSMATRIX,
            :OPT_JACOBIMATRIX, :OPT_JACOBIBANDSTRUCT,
            :OPT_RHSTIMEDERIV,
            :OPT_MAXSTEPS, :OPT_METHODCHOICE, :OPT_STEPSIZESTRATEGY,
            :OPT_RHO,
            :OPT_EPS, :OPT_MAXSS,
            :OPT_SSMINSEL, :OPT_SSMAXSEL, :OPT_INITIALSS,
        ),
        tuple(
            SolverVariant(
                "rodas_i64",
                "Rodas with 64bit integers",
                DL_RODAS,
                tuple("rodas", "contro")
            ),
            SolverVariant(
                "rodas_i32",
                "Rodas with 32bit integers",
                DL_RODAS_I32,
                tuple("rodas", "contro")
            ),
        ),
        help_rodas_compile,
        help_rodas_license,
    )
)

# vim:syn=julia:cc=79:fdm=indent:

# solution of the reentry problem of an Apollo capsule
# following Stoer/Bulirsch 1973

# authors: Folkmar Bornemann, Vishal Sontakke, 2016/04/23

# import required modules
using ODEInterface
@ODEInterface.import_huge

include("reentry_f.jl");
include("reentry_bc.jl");
include("aux_f.jl");
include("aux_bc.jl");
include("showSolution.jl");
include("multiplier_start.jl");

# parameters
R = 209.0;
beta = 4.26;
rho0 = 2.704e-3;
g = 3.2172e-4;
Sm = 53200.0;
c = [1.174, 0.9, 0.6];
alpha = 25; # shape parameter for control profile in auxiliary problem

# boundary Conditions
v0 = 0.36;
v1 = 0.27;
gamma0 = -8.1pi / 180;
gamma1 = 0.0;
h0 = 4 / 209;
h1 = 2.5 / 209;

# bvpsol IVP solver
function odesolver(f, t, T, x, opt)
    setOption!(opt, OPT_ATOL => getOption(opt, OPT_RTOL))
    return odex(f, t, T, x, opt)
end

# tolerance
tol = 1.0e-8;

function reentry(T0)

    # plotting parameters
    global plotVar = Array{Gadfly.Plot}(8)

    # labels and titles for plotting
    xAxis = "relative maneuver time"
    yAxis = [
        "[10<sup>5</sup> ft/sec]", "[degrees]", "[10<sup>5</sup> ft]",
        "[degrees]", "", "", "", "",
    ]
    titles = [
        "velocity v", "flight-path angle γ",
        "height ξ", "trimming angle (control) u", "adjoint variable λ<sub>ν</sub>",
        "adjoint variable λ<sub>γ</sub>", "adjoint variable λ<sub>ξ</sub>",
        "Hamilton function",
    ]

    # set up empty plots
    for i in 1:8
        plotVar[i] = plot(
            Guide.xlabel(xAxis, orientation = :horizontal), Guide.ylabel(yAxis[i]),
            Guide.title(titles[i]), Guide.xticks(ticks = [0:0.2:1;])
        )
    end

    println("§§ Solution with estimated duration T0 = $T0 §§")

    J_opt = -Inf
    flag = 1

    p = [1.0, 0.5]

    # forward Shooting
    println("** solution of the auxiliary problem, 1st attempt: forward shooting...")
    global dir = "forward"
    th = [0.0, 1.0]

    # initial guesses of states = boundary values
    x = Matrix(6, 2)

    x[1:3, 1] = [v0; gamma0; h0]
    x[1:3, 2] = [v1; gamma1; h1]

    # initial guesses for the control profile and for the maneuver time
    x[4:6, 1] = [p[1]; p[2]; T0]
    x[4:6, 2] = x[4:6, 1]

    # solver options
    # IVP solver options
    ivpopt = OptionsODE(
        OPT_RHS_CALLMODE => RHS_CALL_INSITU,
        OPT_RTOL => tol, OPT_ATOL => tol
    )

    # BVP solver options
    opt = OptionsODE(
        OPT_RHS_CALLMODE => RHS_CALL_INSITU,
        OPT_MAXSTEPS => 100, OPT_RTOL => tol, OPT_BVPCLASS => 3,
        OPT_SOLMETHOD => 0, OPT_IVPOPT => ivpopt
    )

    tic()
    (_, yh, retcode, _) = bvpsol(aux_f, aux_bc, th, x, odesolver, opt)
    elapsedTime = toq()

    println(@sprintf "    CPU-time BVP solver = %3.1f sec" elapsedTime)

    if retcode > 0
        println("    # Newton-iterations = $retcode")
    end

    p[1] = yh[4, 1]    # amplitude of the control u
    p[2] = yh[5, 1]    # switching point of the control u
    T1 = yh[6, 1]    # maneuver time

    if retcode < 0
        println("-- termination of the BVP solver with error code $retcode")
        flag = 0
    elseif p[1] <= 0 || p[1] >= 1 || p[2] <= 0 || p[2] >= 1
        println("-- invalid solution: incorrect control profile")
        flag = 0
    end

    if flag == 0
        # backward shooting
        println("** solution of the auxiliary problem, 2nd attempt: backward shooting...")
        dir = "backward"

        x = x[:, end:-1:1]

        # solver options
        # IVP Solver options
        ivpopt = OptionsODE(
            OPT_RHS_CALLMODE => RHS_CALL_INSITU,
            OPT_RTOL => tol, OPT_ATOL => tol
        )

        # BVP solver options
        opt = OptionsODE(
            OPT_RHS_CALLMODE => RHS_CALL_INSITU,
            OPT_MAXSTEPS => 100, OPT_RTOL => tol, OPT_BVPCLASS => 3,
            OPT_SOLMETHOD => 0, OPT_IVPOPT => ivpopt
        )

        tic()
        (_, yh, retcode, _) = bvpsol(aux_f, aux_bc, th, x, odesolver, opt)
        elapsedTime = toq()

        println(@sprintf "    CPU-time BVP solver = %3.1f sec" elapsedTime)

        if retcode > 0
            println("    # Newton-iterations = $retcode")
        end

        p[1] = yh[4, 1]    # amplitude of the control
        p[2] = yh[5, 1]    # switching point of the control
        T1 = yh[6, 1]    # maneuver time

        if retcode < 0
            println("-- termination of the BVP solver with error code $retcode")
            return nothing
        elseif (p[1] <= 0 || p[1] >= pi / 2 || p[2] <= 0 || p[2] >= 1)
            println("-- invalid solution: incorrect control profile")
            return nothing
        end
    end

    # generating the initial guesses for the optimal control problem
    println("** calculation of initial guesses for the optimal control problem...")

    # K nodes for multiple shooting method

    t_msm = unique(collect([linspace(0, p[2], 3);linspace(p[2], 1, 3)]))
    K = length(t_msm)
    t = zeros(K)
    t[:] = t_msm

    if dir == "backward"
        t[:] = 1 - t_msm[end:-1:1]
    end

    # solver options
    # IVP Solver options
    ivpopt = OptionsODE(
        OPT_RHS_CALLMODE => RHS_CALL_INSITU,
        OPT_RTOL => tol, OPT_ATOL => tol
    )

    tic()
    (t, x, retcode, _) = odecall(odesolver, aux_f, t, yh[:, 1], ivpopt)
    elapsedTime = toq()

    println(@sprintf "    CPU-time integrator = %3.1f sec" elapsedTime)

    x = x'
    if dir == "backward"
        t = 1 - t[end:-1:1]
        x = x[:, end:-1:1]
    end

    # restore separated linear boundary conditions
    if norm(x[1:3, 1] - [v0; gamma0; h0]) / norm([v0; gamma0; h0]) > 0.1 ||
            norm(x[1:3, end] - [v1; gamma1; h1]) / norm([v0; gamma0; h0]) > 0.1

        println("-- invalid solution of the auxiliary problem: more than 10% deviation in the boundary values")
        return nothing
    else
        println("++ solution of the auxiliary problem will be used as the starting trajectory")
        println(@sprintf "** time of the auxiliary maneuver T = %5.2f sec" T1)
    end

    x[1:3, 1] = [v0; gamma0; h0]
    x[1:3, end] = [v1; gamma1; h1]

    lambda = zeros(3, K)
    u = zeros(K)

    for i in 1:K
        (lambda[:, i], u[i]) = multiplier_start(t[i], x[:, i])
    end

    x = [x[1:3, :]; lambda; T1 * ones(K)']
    x[isinf(x)] = 0.0

    # solution of the optimal control problem with the multiple shooting method
    println("** solution of the optimal control problem...")

    # calling bvpsol
    # solver options
    # IVP solver options
    ivpopt = OptionsODE(
        OPT_RHS_CALLMODE => RHS_CALL_INSITU,
        OPT_RTOL => tol, OPT_ATOL => tol
    )

    # BVP solver options
    opt = OptionsODE(
        OPT_RHS_CALLMODE => RHS_CALL_INSITU,
        OPT_MAXSTEPS => 100, OPT_RTOL => tol, OPT_BVPCLASS => 3,
        OPT_SOLMETHOD => 0, OPT_IVPOPT => ivpopt
    )

    tic()
    (_, y, retcode, _) = bvpsol(reentry_f, reentry_bc, t_msm, x, odesolver, opt)
    elapsedTime = toq()

    println(@sprintf "    CPU-time BVP solver = %3.1f sec" elapsedTime)

    if retcode > 0
        println("    # Newton-iterations = $retcode")
        T = y[7, 1]
        println(@sprintf "** maneuver time T = %5.2f" T)

        # Plot the optimal solution
        J_opt = showSolution(t_msm, y, T, false, false, colorant"#00FF00", "")

        # Plot 0th iteration of the Multiple shooting method
        showSolution(t, x, T0, false, false, colorant"#FF0000", "")

        # Plot solution of auxiliary problem
        J_aux = showSolution(th, yh, T1, true, true, colorant"#0000FF", string("T0_", string(convert(Int64, T0)), ".pdf"))

        saving = (J_aux - J_opt) / J_aux * 100

        println(@sprintf "** improvement of cost functional by %3.1f%% compared to the auxiliary problem!" saving)
    else
        println("-- program terminated with error code $retcode")
    end

    println(@sprintf "the optimal heating per unit area is J = %8.6f" J_opt)

    return nothing
end

@testset "Public IVP wrapper API" begin
    public_names = (
        :OptionsODE,
        :RHS_CALL_INSITU,
        :OUTPUTFCN_CALL_REASON,
        :OUTPUTFCN_CALL_STEP,
        :OUTPUTFCN_WODENSE,
        :OUTPUTFCN_DENSE,
        :OUTPUTFCN_RET_CONTINUE,
        :OUTPUTFCN_RET_CONTINUE_XCHANGED,
        :dopri5,
        :dop853,
        :odex,
        :seulex,
        :radau,
        :radau5,
        :rodas,
        :ddeabm,
        :ddebdf,
    )

    @test all(name -> isdefined(ODEInterface, name), public_names)
    @test all(name -> haskey(Docs.meta(ODEInterface), Docs.Binding(ODEInterface, name)), public_names)

    # `public` only exists from Julia 1.11 on; see the declaration in
    # src/ODEInterface.jl.
    @static if VERSION ≥ v"1.11"
        @test all(name -> Base.ispublic(ODEInterface, name), public_names)
        @test !any(name -> Base.isexported(ODEInterface, name), public_names)
    end
end

# Functions for ODE-Solver: ddebdf

"""Name for Loading ddebdf solver (64bit integers)."""
const DL_DDEBDF = "ddebdf"

"""Name for Loading ddebdf solver (32bit integers)."""
const DL_DDEBDF_I32 = "ddebdf_i32"

"""macro for import Ddebdf solver."""
macro import_ddebdf()
    return :(
        using ODEInterface: ddebdf, ddebdf_i32
    )
end

"""macro for import Ddebdf dynamic lib names."""
macro import_DLddebdf()
    return :(
        using ODEInterface: DL_DDEBDF, DL_DDEBDF_I32
    )
end

"""macro for importing Ddebdf help."""
macro import_ddebdf_help()
    return :(
        using ODEInterface: help_ddebdf_compile, help_ddebdf_license
    )
end

"""
Type encapsulating all required data for Ddebdf-Solver-Callbacks.

We have the typical calling stack:

     ddebdf
         call_julia_output_fcn(  ... INIT ... )
             output_fcn ( ... INIT ...)
         loop with iterations (intermediate-mode and/or OPT_OUTPUTATTIMES)
         │ ccall( DDEBDF_ ... ) # after 1st call: continuation call
         │    ┌───────────────────────────────────────────┐  ⎫
         │    │unsafe_SLATEC1RHSCallback                  │  ⎬ cb. rhs
         │    │    rhs                                    │  ⎪
         │    └───────────────────────────────────────────┘  ⎭
         │    ┌───────────────────────────────────────────┐  ⎫
         │    │unsafe_SLATEC1JacCallback                  │  ⎬ cb. jacobian
         │    │    call_julia_jac_fcn(             )      │  ⎪
         │    └───────────────────────────────────────────┘  ⎭
         └ call_julia_output_fcn( ... STEP ...)
         call_julia_output_fcn(  ... DONE ... )
             output_fcn ( ... DONE ...)

see also help of `ODEInterface.SLATEC_continuation_call`.
"""
mutable struct DdebdfInternalCallInfos{
        FInt <: FortranInt,
        RHS_F, OUT_F, JAC_F, VIEW_F,
    } <: ODEinternalCallInfos
    logio::IO                    # where to log
    loglevel::UInt64                # log level
    # RHS:
    N::FInt                  # Dimension of Problem
    rhs::RHS_F                 # right-hand-side
    rhs_mode::RHS_CALL_MODE         # how to call rhs
    rhs_lprefix::AbstractString        # saved log-prefix for rhs
    rhs_count::Int                   # count: number of calls to rhs
    # SOLOUT & output function
    output_mode::OUTPUTFCN_MODE        # what mode for output function
    output_fcn::OUT_F                 # the output function to call
    output_data::Dict                  # extra_data for output_fcn
    # Jacobimatrix
    jacobimatrix::JAC_F                 # function for jacobi matrix
    jacobibandstruct                      # (l,u) bandstructure or nothing
    jac_lprefix::AbstractString        # saved log-prefix for jac
    jac_count::Int                   # count: number of calls to jac
    #
    submatrix::VIEW_F                # method for generating view/sub
end

"""
     mutable struct DdebdfArguments{FInt} <: AbstractArgumentsODESolver{FInt}

Stores Arguments for Ddebdf solver.

FInt is the Integer type used for the fortran compilation.
"""
mutable struct DdebdfArguments{FInt <: FortranInt} <: AbstractArgumentsODESolver{FInt}
    FCN::Ptr{Cvoid}        # rhs callback
    N::Vector{FInt}      # Dimension: NEQ
    t::Vector{Float64}   # start time (and current)
    x::Vector{Float64}   # initial value (and current state)
    tEnd::Vector{Float64}   # (current) end time
    INFO::Vector{FInt}      # INFO-Array
    RTOL::Vector{Float64}   # relative tolerance
    ATOL::Vector{Float64}   # absolute tolerance
    IDID::Vector{FInt}      # Status code
    RWORK::Vector{Float64}   # double working array
    LRW::Vector{FInt}      # length of WORK
    IWORK::Vector{FInt}      # integer working array
    LIW::Vector{FInt}      # length of IWORK
    RPAR::Vector{Float64}   # add. double-array
    IPAR::Ref{DdebdfInternalCallInfos} # misuse IPAR
    JAC::Ptr{Cvoid}        # Jacobian callback
    ## Allow uninitialized construction
    function DdebdfArguments{FInt}(dummy::FInt) where {FInt}
        return new{FInt}()
    end
end

"""
     function ddebdf(rhs, t0::Real, T::Real,
                     x0::Vector, opt::AbstractOptionsODE)
         -> (t,x,retcode,stats)

`retcode` can have the following values:

      1: computation successful
      2: computation. successful, but interrupted by output function
     <0: error

main call for using Fortran-ddebdf solver. In `opt` the following
options are used:

    ╔═════════════════╤══════════════════════════════════════════╤═════════╗
    ║  Option OPT_…   │ Description                              │ Default ║
    ╠═════════════════╪══════════════════════════════════════════╪═════════╣
    ║ RTOL         &  │ relative and absolute error tolerances   │    1e-3 ║
    ║ ATOL            │ both scalars or both vectors with the    │    1e-6 ║
    ║                 │ length of length(x0)                     │         ║
    ║                 │ error(xₖ) ≤ OPT_RTOLₖ⋅|xₖ|+OPT_ATOLₖ     │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTFCN       │ output function                          │ nothing ║
    ║                 │ see help_outputfcn                       │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTMODE      │ OUTPUTFCN_NEVER:                         │   NEVER ║
    ║                 │   dont't call OPT_OUTPUTFCN              │         ║
    ║                 │ OUTPUTFCN_WODENSE                        │         ║
    ║                 │   call OPT_OUTPUTFCN either              │         ║
    ║                 │   (a) either for all intermediate steps  │         ║
    ║                 │       chosen by the solver or           │         ║
    ║                 │   (b) at the times given in the option   │         ║
    ║                 │       OPT_OUTPUTATTIMES                  │         ║
    ║                 │ OUTPUTFCN_DENSE                          │         ║
    ║                 │   is *not* supported!                    │         ║
    ║                 │   but see OUTPUTATTIMES for an           │         ║
    ║                 │   alternative approach                   │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTATTIMES   │ If OPT_OUTPUTMODE is OUTPUTFCN_WODENSE   │ nothing ║
    ║                 │ then one can specify with this vector    │         ║
    ║                 │ the time points where the OPT_OUTPUTFCN  │         ║
    ║                 │ should be called.                        │         ║
    ║                 │ All values of OPT_OUTPUTATTIMES *must*   │         ║
    ║                 │ be sorted (ascending, if T>t0, and       │         ║
    ║                 │ descending, if T<t0) and they must be    │         ║
    ║                 │ between t0 and T.                        │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ TSTOP           │ tell the solver, that it is not          │     NaN ║
    ║                 │ permissible to integrate past the point  │         ║
    ║                 │ TSTOP. If TSTOP is NaN then the solver   │         ║
    ║                 │ may integrate past T and interpolate the │         ║
    ║                 │ result at T. Sometimes there are         │         ║
    ║                 │ right-hand sides, where this is not      │         ║
    ║                 │ possible.                                │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSTEPS        │ maximal number of allowed steps          │  100000 ║
    ║                 │ (allowed intermediate steps)             │         ║
    ║                 │ between t0, T and the values given       │         ║
    ║                 │ in OPT_OUTPUTATTIMES.                    │         ║
    ║                 │ The value will be rounded up to a        │         ║
    ║                 │ multiple of 500.                         │         ║
    ║                 │ OPT_MAXSTEPS > 0                         │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ JACOBIMATRIX    │ A function providing the Jacobian for    │ nothing ║
    ║                 │ ∂f/∂x or nothing. For nothing the solver │         ║
    ║                 │ uses finite differences to calculate the │         ║
    ║                 │ Jacobian.                                │         ║
    ║                 │ The function has to be of the form:      │         ║
    ║                 │   function (t,x,J) -> nothing            │         ║
    ║                 │ Depending on OPT_JACOBIBANDSTRUCT the    │         ║
    ║                 │ argument J will then by a full or a      │         ║
    ║                 │ banded matrix, where the user-given      │         ║
    ║                 │ function has to fill in the entries.     │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ JACOBIBANDSTRUCT│ A tuple (l,u) describing the banded      │ nothing ║
    ║                 │ structure of the Jacobian or nothing if  │         ║
    ║                 │ the Jacobian is full.                    │         ║
    ║                 │ Even if the option JACOBIMATRIX is empty,│         ║
    ║                 │ the solver will perform much better if   │         ║
    ║                 │ the Jacobian matrix is banded and the    │         ║
    ║                 │ code is told this.                       │         ║
    ║                 │ see also help of BandedMatrix            │         ║
    ╚═════════════════╧══════════════════════════════════════════╧═════════╝

"""
function ddebdf(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return ddebdf_impl(rhs, t0, T, x0, opt, DdebdfArguments{Int64}(Int64(0)))
end

"""
ddebdf with 32bit integers, see ddebdf.
"""
function ddebdf_i32(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return ddebdf_impl(rhs, t0, T, x0, opt, DdebdfArguments{Int32}(Int32(0)))
end

"""
MAXNUM value in ddebdf.
"""
const ddebdf_maxnum = 500

"""
     function ddebdf_impl(rhs,
             t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
             args::DdebdfArguments{FInt}) where FInt<:FortranInt

implementation of ddebdf-call for FInt.

This solver has the concept of continuation calls (CC), see
help for `ODEInterface.SLATEC_continuation_call`.

This CC are used in this method to get the solution at user-given
t-values (see `OPT_OUTPUTATTIMES`) in order to support some alternative
method for dense output.

The solver also has an intermediate-output mode. If activated then
the numerical integration is stopped at every (solver-chosen) intermediate
step and can be continued with a CC.

Different cases for this method:

    ╔═══════════════════╤═══════════════════╤════════════════════╤═════════╗
    ║ OPT_OUTPUTMODE    │ OPT_OUTPUTATTIMES │ intermediate-mode? │  case   ║
    ╠═══════════════════╪═══════════════════╪════════════════════╪═════════╣
    ║ OUTPUTFCN_NEVER   │ <ignored>         │ no   INFO(3)=0     │  C1     ║
    ║ OUTPUTFCN_WODENSE │ nothing or empty  │ yes  INFO(3)=1     │  C2     ║
    ║ OUTPUTFCN_WODENSE │ given vector      │ no   INFO(3)=0     │  C3     ║
    ╠═══════════════════╪═══════════════════╧════════════════════╧═════════╣
    ║ OUTPUTFCN_DENSE   │        N O T    S U P P O R T E D !              ║
    ╚═══════════════════╧══════════════════════════════════════════════════╝

"""
function ddebdf_impl(
        rhs,
        t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
        args::DdebdfArguments{FInt}
    ) where {FInt <: FortranInt}

    (lio, l, l_g, l_solver, lprefix) = solver_start("ddebdf", rhs, t0, T, x0, opt)

    method_ddebdf, = getAllMethodPtrs(
        (FInt == Int64) ? DL_DDEBDF : DL_DDEBDF_I32
    )

    (d, nrdense, scalarFlag, rhs_mode, output_mode, output_fcn) =
        solver_extract_commonOpt(t0, T, x0, opt, args)

    check_slatec_output_mode(output_mode)

    (jacobimatrix, jacobibandstruct) = extractSlatecJacobiOpt(d, opt)

    # INFO
    args.INFO = zeros(FInt, 15)

    # RWORK
    args.LRW = [
        FInt(
            jacobibandstruct === nothing ?
                250 + 10 * d + d * d : 250 + 10 * d + (2 * jacobibandstruct[1] + jacobibandstruct[2] + 1) * d
        ),
    ]
    args.RWORK = zeros(Float64, args.LRW[1])

    # IWORK
    args.LIW = [FInt(56 + d)]
    args.IWORK = zeros(FInt, args.LIW[1])

    args.INFO[1] = 0
    args.INFO[2] = scalarFlag ? 0 : 1

    maxsteps = 0
    try
        maxsteps = convert(Int, getOption(opt, OPT_MAXSTEPS, 100000))
        @assert 0 < maxsteps
    catch e
        throw(ArgumentErrorODE("OPT_MAXSTEPS is not valid", :opt, e))
    end

    tstop = NaN
    try
        tstop = convert(Float64, getOption(opt, OPT_TSTOP, NaN))
    catch e
        throw(ArgumentErrorODE("Cannot convert OPT_TSTOP to Float64", :opt, e))
    end
    args.INFO[4] = isnan(tstop) ? 0 : 1
    if !isnan(tstop)
        args.RWORK[1] = tstop
    end

    args.INFO[5] = jacobimatrix === nothing ? 0 : 1
    if jacobibandstruct !== nothing
        args.INFO[6] = 1
        args.IWORK[1] = jacobibandstruct[1]
        args.IWORK[2] = jacobibandstruct[2]
    else
        args.INFO[6] = 0
    end

    t_values = extractSlatecOutputAtTimes(t0, T, opt)
    output_attimes_given = length(t_values) > 0
    push!(t_values, args.tEnd[1])

    args.RPAR = zeros(Float64, 0)
    args.IDID = zeros(FInt, 1)
    rhs_lprefix = "unsafe_SLATEC1RHSCallback: "
    jac_lprefix = "unsafe_SLATEC1JacCallback: "

    case = output_mode == OUTPUTFCN_NEVER ? 1 : (output_attimes_given ? 3 : 2)

    args.INFO[3] = (case == 2) ? 1 : 0
    retcode = -100

    cbi = DdebdfInternalCallInfos(
        lio, l, d, rhs, rhs_mode, rhs_lprefix,
        0, output_mode, output_fcn, Dict(),
        jacobimatrix === nothing ? dummy_func : jacobimatrix,
        jacobibandstruct, jac_lprefix, 0, get_view_function()
    )

    args.IPAR = cbi
    args.FCN = unsafe_SLATEC1RHSCallback_c(cbi, FInt(0))
    args.JAC = unsafe_SLATEC1JacCallback_c(cbi, FInt(0))

    if output_mode ≠ OUTPUTFCN_NEVER
        call_julia_output_fcn(
            cbi, OUTPUTFCN_CALL_INIT,
            args.t[1], args.tEnd[1], args.x, eval_sol_fcn_init
        ) # ignore result
        call_julia_output_fcn(
            cbi, OUTPUTFCN_CALL_STEP,
            args.t[1], args.t[1], args.x, eval_sol_fcn_noeval
        )  # 1 step
    end

    if l_solver
        println(lio, lprefix, "call Fortran-ddebdf $method_ddebdf with")
        dump(lio, args)
    end

    maxsteps_seen = 0
    while (true)
        told = args.t[1]
        args.tEnd[1] = t_values[1]
        ccall(
            method_ddebdf, Cvoid,
            (
                Ptr{Cvoid}, Ptr{FInt},                       # Rightsidefunc, N=NEQ=d
                Ptr{Float64}, Ptr{Float64}, Ptr{Float64},    # t, x, tEnd
                Ptr{FInt}, Ptr{Float64}, Ptr{Float64},       # INFO, RTOL, ATOL,
                Ptr{FInt},                                   # IDID
                Ptr{Float64}, Ptr{FInt},                     # RWORK, LRW
                Ptr{FInt}, Ptr{FInt},                        # IWORK, LIW
                Ptr{Float64}, Ref{DdebdfInternalCallInfos},  # RPAR, IPAR=CBI
                Ptr{Cvoid},                                  # DJAC
            ),
            args.FCN, args.N,
            args.t, args.x, args.tEnd,
            args.INFO, args.RTOL, args.ATOL,
            args.IDID,
            args.RWORK, args.LRW,
            args.IWORK, args.LIW,
            args.RPAR, args.IPAR,
            args.JAC
        )
        if l_solver
            println(lio, lprefix, "call Fortran-ddebdf $method_ddebdf returned")
            dump(lio, args)
        end
        if args.IDID[1] < -1     # -1 handled below
            retcode = Int(args.IDID[1])
            break
        end
        if args.IDID[1] ≥ 0 && output_mode ≠ OUTPUTFCN_NEVER
            out_result = call_julia_output_fcn(
                cbi, OUTPUTFCN_CALL_STEP,
                told, args.t[1], args.x, eval_sol_fcn_noeval
            )
            if out_result == OUTPUTFCN_RET_CONTINUE_XCHANGED
                throw(
                    FeatureNotSupported(
                        string(
                            "Sorry; ddebdf does not support ",
                            "to change the solution inside the output function."
                        )
                    )
                )
            elseif out_result == OUTPUTFCN_RET_STOP
                retcode = 2
                break
            end
        end
        if args.IDID[1] == -1
            # => MAXNUM steps done
            maxsteps_seen += ddebdf_maxnum
            if maxsteps_seen ≥ maxsteps
                retcode = -1
                break
            end
        elseif args.IDID[1] == 1
            # => intermediate-output mode => case C2
            # args.tEnd[1] yet not reached => continue
            args.INFO[1] = 1
        elseif args.IDID[1] ∈ (2, 3)
            # => args.tEnd[1] reached
            popfirst!(t_values)     # next t-value to compute
            maxsteps_seen = 0
            if length(t_values) == 0
                retcode = 1   # reached T
                break
            end
        else
            throw(
                InternalErrorODE(
                    string("unknown IDID=", args.IDID[1], " result of ddebdf")
                )
            )
        end
        args.INFO[1] = 1  # continuation call
    end

    output_mode ≠ OUTPUTFCN_NEVER &&
        call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_DONE,
        args.t[1], args.tEnd[1], args.x, eval_sol_fcn_done
    ) # ignore result

    l_g && println(lio, lprefix, string("done IDID=", args.IDID[1]))
    stats = Dict{AbstractString, Any}(
        "no_rhs_calls" => cbi.rhs_count,
        "no_jac_calls" => cbi.jac_count,
        "ddebdf_idid" => args.IDID[1],
    )

    return (args.t[1], args.x, retcode, stats)
end

"""
## Compile DDEBDF

The julia ODEInterface tries to compile and link the solvers
automatically at the build-time of this module. The following
calls need only be done, if one uses a different compiler and/or if
one wants to change/add some compiler options.

The Fortran source code can be found at:

     http://www.netlib.org/slatec/src/

See `help_ddebdf_license` for the license information.

### Using `gfortran` and 64bit integers (Linux, Mac and Windows)

Here is an example how to compile DDEBDF with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8 -o slatec.o slatec.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8 -o ddebdf.o ddbdfm.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac, 3rd for Window):

     gfortran -shared -fPIC -o ddebdf.so ddebdf.o slatec.o
     gfortran -shared -fPIC -o ddebdf.dylib ddebdf.o slatec.o
     gfortran -shared       -o ddebdf.dll ddebdf.o slatec.o
"""
function help_ddebdf_compile()
    return Docs.doc(help_ddebdf_compile)
end

function help_ddebdf_license()
    return Docs.doc(help_ddebdf_license)
end

@doc(@doc(SLATEC_license), help_ddebdf_license)

# Add information about solver in global solverInfo-array.
push!(
    solverInfo,
    SolverInfo(
        "ddebdf",
        "Backward Differentiation Formula (orders: 1-5)",
        tuple(
            :OPT_RTOL, :OPT_ATOL, :OPT_RHS_CALLMODE,
            :OPT_OUTPUTMODE, :OPT_OUTPUTFCN,
            :OPT_OUTPUTATTIMES,
            :OPT_TSTOP, :OPT_MAXSTEPS,
            :OPT_JACOBIMATRIX, :OPT_JACOBIBANDSTRUCT,
        ),
        tuple(
            SolverVariant(
                "ddebdf_i64",
                "Ddebdf with 64bit integers",
                DL_DDEBDF,
                tuple("ddebdf")
            ),
            SolverVariant(
                "ddebdf_i32",
                "Ddebdf with 32bit integers",
                DL_DDEBDF_I32,
                tuple("ddebdf")
            ),
        ),
        help_ddebdf_compile,
        help_ddebdf_license,
    )
)


# vim:syn=julia:cc=79:fdm=indent:

# Functions for Boundary-Value Solver: BVP_M-2

import Base: show

"""Name for Loading bvpm2 solver (64bit integers)."""
const DL_BVPM2 = "bvp_m_proxy"

# There is *no* 32-bit variant

"""macro for import bvpm2 solver."""
macro import_bvpm2()
    return :(
        using ODEInterface: Bvpm2, bvpm2_copy, bvpm2_terminate, bvpm2_destroy,
            bvpm2_init, bvpm2_show_details,
            bvpm2_get_details,
            bvpm2_get_x, bvpm2_solve, bvpm2_extend,
            evalSolution,
            bvpm2_get_params
    )
end

"""macro for import bvpm2 dynamic lib name."""
macro import_DLbvpm2()
    return :(
        using ODEInterface: DL_BVPM2
    )
end

"""macro for importing Bvpm2 help."""
macro import_bvpm2_help()
    return :(
        using ODEInterface: help_bvpm2_compile, help_bvpm2_license,
            help_bvpm2_proxy
    )
end

"""
BVP_M-2 uses global variables during the solution process.
Hence we can only support one bvpm2 solve-call at a time.
"""
bvpm2_global_cbi = nothing

"""
structure to save guess-function for use in Fortran callbacks.

How to make a julia function (which typically cannot be put in `cfunction`,
because it may be a closure, etc.) callable from Fortran2003 code that
uses no ISO_C_BINDING and has no pass-through arguments?

Use a Fortran2003 proxy with ISO_C_BINDING. Here is the calling stack:

```
bvpm2_guess( ...  guess_fcn ... )
─────────────────────────────────
│ [ cbi created with guess_fcn ]
│ call init_guess3_c( ... guess_fcn_ptr=unsafe_bvpm2_guess_cb_c,
│ │    ━━━━━━━━━━━━━      guess_pthrough=cbi ... )
│ │ call bvp_init( ... guess = guess_fcn_proxy ... )
│ │ │    ════════
│ │ │ call guess_fcn_proxy(x_point, guess_vector)
│ │ │ │    ━━━━━━━━━━━━━━━
│ │ │ │ [nested guess_fcn_proxy in scope of init_guess3_c, so
│ │ │ │  the guess_pthrough info is available.]
│ │ │ │ [convert Fortran Arrays to C-Pointer-Array]
│ │ │ │ call guess_fcn_ptr/unsafe_bvpm2_guess_cb_c(x_point, ...,
│ │ │ │ │                  ───────────────────────   guess_vector
│ │ │ │ │                                            guess_pthrough)
│ │ │ │ │   [ use guess_pthrough to recover cbi ]
│ │ │ │ │   call cbi.guess_fcn(x, guess_vector)
│ │ │ │ │   │    ─────────────
└ └ └ └ └   └

Legend:
   ─────────  julia code
   ━━━━━━━━━  Fortran2003 code in BVP_M_Proxy with ISO_C_BINDING
   ═════════  Fortran2003 code in BVP_M-2 (without ISO_C_BINDING)
```

For more details of this concept/idea call `help_bvpm2_proxy`.
"""
mutable struct Bvpm2_guess_cbi{GUESS_FCN} <: ODEinternalCallInfos
    no_odes::Int64            # number of ODEs, used for assertion
    # GUESS:
    guess::GUESS_FCN        # Julia-function to call for guess
end

mutable struct Bvpm2_solve_cbi{
        RHS_FCN, DRHS_FCN,
        BC_FCN, DBC_FCN,
    } <: ODEinternalCallInfos
    logio::IO              # where to log
    loglevel::UInt64          # log level
    no_odes::Int64           # number of ODEs, used for assertion
    no_par::Int64           # number of parameters, used for assertion
    no_left_bc::Int64           # number of boundary conditions on left side
    # used for assertion
    # RHS:
    rhs::RHS_FCN         # Julia-function to call for ODEs right-hand
    # side
    rhs_lprefix::AbstractString  # saved log-prefix for rhs
    rhs_count::Int             # count: number of calls to rhs
    # DRHS:
    Drhs::DRHS_FCN        # Jacobian(s) of rhs
    Drhs_lprefix::AbstractString  # saved log-prefix for Drhs
    Drhs_count::Int             # count: number of calls to Drhs
    # BC:
    bc_fcn::BC_FCN          # Julia-function to call for evaluating
    # boundary conditions
    bc_lprefix::AbstractString  # saved log-prefix for bc
    bc_count::Int             # count: number of calls to bc
    # DBC:
    Dbc::DBC_FCN         # Jacobian(s) of side conditions
    Dbc_lprefix::AbstractString  # saved log-prefix for Dbc
    Dbc_count::Int             # count: number of calls to Dbc
end

"""
# Bvpm2 object for solving boundary value problems

This is the Julia part of the BVP_M-2 (Fortran-)solution object.
For (nearly) all the operations the corresponding Fortran-Proxy
methods are called (call `help_bvpm2_proxy()` to get internal details).

## Boundary value problem (BVP)

BVPs of the following form are considered:

                  1
      y'(x) =  ─────── Sy + f(x, y, p)         for a ≤ x ≤ b   [ODEs]
                x - a


      ga(y(a), p) = 0,     gb(y(b), p) = 0                     [BCs]

* y(x) ∈ ℝᵈ and `d` is also called `no_odes` (the number of ordinary
  differential equations).
* S ∈ ℝᵈˣᵈ is an optional constant matrix (also
  called the singularity term) because the whole term S⋅y/(x-a) has a
  singularity at x=a. If S is not given, then the ODEs are reduced to
  y'(x) = f(x, y, p).
* p ∈ ℝᵐ (with 0≤m) are unknown parameters of the problem. `m` is also
  called `no_par` (the number of parameters).
* f(x, y, p) ∈ ℝᵈ is also called the right-hand side (of the ODEs).
* ga(ya, p) ∈ ℝˡ describes the left boundary conditions. `l` is
  also called `no_left_bc` (the number of the BCs at x=a).
* ga(yb, p) ∈ ℝⁿ describes the right boundary conditions. It is

        n = d + m - l
        n = no_odes + no_par - no_left_bc

## Initial guess and solutions

A Bvpm2 object can be used to represent either an initial guess (for a
BVP like above) or a solution. It is possible to use a solution of a
(different) BVP as initial guess to another BVP.

Such a Bvpm2 object can be in one of the following states:

* `state==0`: object created (and connected to Fortran-object), but
  not initialized, i.e. it does neither represent a guess nor an solution.
* `state==1`: object created, and initialized with an (initial) guess, i.e.
  the object represents a guess.
* `state==2`: object created and a solution was calculated successfully and
  saved in the object, i.e. the object represents a solution.
* `state==-1`: object is not connected to a Fortran-Proxy. Either
  `bvpm2_destroy` was called or at creation time, the connection to the
   Fortran-Proxy couldn't be established, i.e. the object is unusable and
   all associated memory was deallocated.

The following table shows possible actions and the state-transitions
initiated by the actions.

```
╔═══════════════════╤═══════════════════════════╤════════════╤════════════╗
║ Action/Function   │ Description               │state before│state after ║
╠═══════════════════╪═══════════════════════════╪════════════╪════════════╣
║ Bvpm2()           │ create object             │    ---     │     0      ║
╟───────────────────┼───────────────────────────┼────────────┼────────────╢
║ bvpm2_init        │ initialize object with    │     0      │     1      ║
║                   │ initial guess, etc.       │            │            ║
╟───────────────────┼───────────────────────────┼────────────┼────────────╢
║ bvpm2_show_details│ show some details of      │ 0, 1, or 2 │ not changed║
║                   │ (Fortran-)BVP_M-2 sol     │            │            ║
║                   │ object                    │            │            ║
╟───────────────────┼───────────────────────────┼────────────┼────────────╢
║ bvpm2_get_details │ get dict with some details│ -1, 0, 1,  │ not changed║
║                   │ of the Bvpm2 object:      │   or 2     │            ║
║                   │ e.g. state, number of pts │            │            ║
║                   │ in current grid ...       │            │            ║
╟───────────────────┼───────────────────────────┼────────────┼────────────╢
║ bvpm2_get_x       │ return current grid of    │ 1, or 2    │ not changed║
║                   │ the object.               │            │            ║
╟───────────────────┼───────────────────────────┼────────────┼────────────╢
║ bvpm2_get_params  │ return current values of  │ 1, or 2    │ not changed║
║                   │ estimated/calculated      │            │            ║
║                   │ parameters                │            │            ║
╟───────────────────┼───────────────────────────┼────────────┼────────────╢
║ bvpm2_terminate   │ throw away all data and   │ 0, 1, or 2 │      0     ║
║                   │ information. Bring to     │            │            ║
║                   │ state 0.                  │            │            ║
╟───────────────────┼───────────────────────────┼────────────┼────────────╢
║ bvpm2_destroy     │ deallocate all (Fortran-) │ -1, 0, 1,  │     -1     ║
║                   │ resources for this object.│   or 2     │            ║
║                   │                           │            │            ║
╚═══════════════════╧═══════════════════════════╧════════════╧════════════╝
```

There are functions that take an Bvpm2-object `obj_in` as input,
perhaps change `obj_in` and create an additional `obj_out`.

The following table shows possible actions, the change of the state
of `obj_in` and which `obj_out` object is created:

```
╔═══════════════════╤═══════════════════════════╤════════════╤════════════╗
║ Action/Function   │ Description               │obj_in state│  state of  ║
║                   │                           │ from -> to │   obj_out  ║
╠═══════════════════╪═══════════════════════════╪════════════╪════════════╣
║ bvpm2_solve       │ take obj_in as guess. Do  │ not changed│ 0: no      ║
║                   │ not change obj_in.        │            │    success ║
║                   │ Produces obj_out object   │            │            ║
║                   │ representing the solution.│            │ 2: success ║
╟───────────────────┼───────────────────────────┼────────────┼────────────╢
║ bvpm2_copy        │ create deep copy of       │ not changed│ same as    ║
║                   │ obj_in                    │            │ obj_in     ║
╟───────────────────┼───────────────────────────┼────────────┼────────────╢
║ bvpm2_extend      │ extend solution to new    │  2 -> 0    │    1       ║
║                   │ interval as new  guess.   │            │            ║
║                   │ obj_in will be terminated │            │            ║
║                   │ and will be in state 0.   │            │            ║
║                   │ Call bvpm2_copy before, if│            │            ║
║                   │ you need the solution     │            │            ║
║                   │ later on.                 │            │            ║
╚═══════════════════╧═══════════════════════════╧════════════╧════════════╝
```

"""
mutable struct Bvpm2 <: AbstractODESolution{Int64}
    handle::Ptr{Cvoid}
    method_create::Ptr{Cvoid}
    method_copy::Ptr{Cvoid}
    method_terminate::Ptr{Cvoid}
    method_destroy::Ptr{Cvoid}
    method_show::Ptr{Cvoid}
    method_get_details::Ptr{Cvoid}
    method_get_x::Ptr{Cvoid}
    method_init_guess1::Ptr{Cvoid}
    method_init_guess2::Ptr{Cvoid}
    method_init_guess3::Ptr{Cvoid}
    method_solve::Ptr{Cvoid}
    method_eval_s::Ptr{Cvoid}
    method_eval_v::Ptr{Cvoid}
    method_get_params::Ptr{Cvoid}
    method_extend_s::Ptr{Cvoid}
    method_extend_e::Ptr{Cvoid}
end

"""
     function Bvpm2(handle::Ptr{Cvoid})

create bvpm2 object from given handle.
"""
function Bvpm2(handle::Ptr{Cvoid})
    obj = Bvpm2(
        C_NULL, C_NULL, C_NULL, C_NULL, C_NULL, C_NULL, C_NULL, C_NULL,
        C_NULL, C_NULL, C_NULL, C_NULL, C_NULL, C_NULL, C_NULL, C_NULL,
        C_NULL
    )
    get_proxy_methods(obj)
    obj.handle = handle
    return obj
end

"""
     function bvpm2_create_handle(obj::Bvpm2)

create Fortran Proxy.
"""
function bvpm2_create_handle(obj::Bvpm2)
    obj.handle = ccall(obj.method_create, Ptr{Cvoid}, ())
    @assert obj.handle ≠ C_NULL
    return nothing
end

"""
     function Bvpm2()

creates bvpm2 object.
"""
function Bvpm2()
    obj = Bvpm2(C_NULL)
    bvpm2_create_handle(obj)
    return obj
end

"""
get all (proxy-)methods for bvpm2 object.
"""
function get_proxy_methods(obj::Bvpm2)
    (
        obj.method_create,
        obj.method_copy,
        obj.method_terminate,
        obj.method_destroy,
        obj.method_show,
        obj.method_get_details,
        obj.method_get_x,
        obj.method_init_guess1,
        obj.method_init_guess2,
        obj.method_init_guess3,
        obj.method_solve,
        obj.method_eval_s,
        obj.method_eval_v,
        obj.method_get_params,
        obj.method_extend_s,
        obj.method_extend_e,
    ) = getAllMethodPtrs(DL_BVPM2)
    return nothing
end

bvpm2_is_handle_valid(obj::Bvpm2) = obj.handle ≠ C_NULL

"""
tests if Bvpm2-object is "connected" to a Fortran-proxy handle.
"""
function bvpm2_check_handle(obj::Bvpm2)
    if !bvpm2_is_handle_valid(obj)
        throw(
            StateErrorODE(
                string(
                    "Bvpm2 object is not connected to a Fortran-proxy. ",
                    "Either the connection failed or bvpm2_destroy was called before ",
                    "with this Bvpm2 object."
                )
            )
        )
    end
    return nothing
end

"""
tests if the Bvpm2-object is in one of the expected states.

Throws an Error of the state is not expected.

Returns details dict.
"""
function bvpm2_check_state(obj::Bvpm2, expected_states)
    details = bvpm2_get_details(obj)
    state = details["state"]

    if state ∉ expected_states
        throw(
            StateErrorODE(
                string(
                    "Bvpm2 object is in state ", state, ", but I need one of ",
                    "the states ", expected_states
                )
            )
        )
    end

    return details
end

"""
     function bvpm2_terminate(obj::Bvpm2)

Terminates Bvpm2-object. Put in state as if after creation.
"""
function bvpm2_terminate(obj::Bvpm2)
    bvpm2_check_handle(obj)
    ccall(obj.method_terminate, Cvoid, (Ptr{Cvoid},), obj.handle)
    return nothing
end

"""
     function bvpm2_destroy(obj::Bvpm2)

destroys Bvpm2-object. Especially free all (Fortran-)allocated
memory and disconnect from Fortran-Proxy(-handle).
"""
function bvpm2_destroy(obj::Bvpm2)
    if bvpm2_is_handle_valid(obj)
        ccall(obj.method_destroy, Cvoid, (Ptr{Cvoid},), obj.handle)
        obj.handle = C_NULL
    end
    return obj
end

"""
     function bvpm2_copy(obj_in::Bvpm2) -> obj_out

creates a deep copy `obj_out` of the Bvpm2-object `obj_in`.
"""
function bvpm2_copy(obj::Bvpm2)
    bvpm2_check_state(obj, (0, 1, 2))
    new_handle = ccall(
        obj.method_copy, Ptr{Cvoid}, (Ptr{Cvoid},),
        obj.handle
    )
    return Bvpm2(new_handle)
end

"""
     function bvpm2_show_details(obj::Bvpm2)

Debug: call show_details Fortran subroutine.
"""
function bvpm2_show_details(obj::Bvpm2)
    bvpm2_check_handle(obj)
    ccall(obj.method_show, Cvoid, (Ptr{Cvoid},), obj.handle)
    return nothing
end

"""
     function bvpm2_get_details(obj::Bvpm2)

returns dict with information about an Bvpm2 object.
"""
function bvpm2_get_details(obj::Bvpm2)
    if !bvpm2_is_handle_valid(obj)
        return Dict("state" => -1)
    end
    int_slots = zeros(Int64, 16)

    ccall(
        obj.method_get_details, Cvoid,
        (
            Ptr{Cvoid},                     # handle
            Int64, Ref{Int64},              # int_slots_len, int_slots
        ),
        obj.handle,
        length(int_slots), int_slots
    )
    return Dict(
        "handle" => obj.handle,
        "state" => int_slots[1],
        "no_odes" => int_slots[2],
        "no_par" => int_slots[3],
        "no_left_bc" => int_slots[4],
        "no_pts" => int_slots[5],
        "info" => int_slots[6],
        "max_num_subintervals" => int_slots[7],
        "len_iwork" => int_slots[8],
        "len_work" => int_slots[9]
    )
end

function show(io::IO, obj::Bvpm2)
    println(io, typeof(obj))
    details = bvpm2_get_details(obj)
    maxLen = 2 + max(0, map(length, collect(keys(details)))...)
    for key in sort(collect(keys(details)))
        print(io, lpad(key, maxLen), ": ")
        show(io, details[key]); println(io)
    end
    return
end

"""
returns current vector with x-grid of Bvpm2 object.
"""
function bvpm2_get_x(obj::Bvpm2)
    details = bvpm2_check_state(obj, (1, 2))
    x = Vector{Float64}(undef, details["no_pts"])
    error = ccall(
        obj.method_get_x, Int64,
        (Ptr{Cvoid}, Int64, Ref{Float64}),   # handle, x_len, x
        obj.handle, length(x), x
    )
    error ≠ 0 && throw(
        InternalErrorODE(
            string(
                "Sorry. Fortran-Proxy returned error ", error
            )
        )
    )
    return x
end

"""
     function bvpm2_get_params(obj::Bvpm2)

returns current vector with parameters of Bvpm2 object.
"""
function bvpm2_get_params(obj::Bvpm2)
    details = bvpm2_check_state(obj, (1, 2))
    p = Vector{Float64}(undef, details["no_par"])
    if length(p) > 0
        error = ccall(
            obj.method_get_params, Int64,
            (Ptr{Cvoid}, Int64, Ref{Float64}),   # handle, p_len, p
            obj.handle, length(p), p
        )
        error ≠ 0 && throw(
            InternalErrorODE(
                string(
                    "Sorry. Fortran-Proxy returned error ", error
                )
            )
        )
    end
    return p
end

"""
same as bvpm2_get_x.
"""
function getSolutionGrid(sol::Bvpm2)
    return bvpm2_get_x(sol)
end

"""
     function bvpm2_init_tests(obj::Bvpm2, no_odes, no_left_bc,
         x_grid::Vector, parameters::Vector, max_num_subintervals)

init tests for common parameters.
"""
function bvpm2_init_tests(
        obj::Bvpm2, no_odes, no_left_bc,
        x_grid::Vector, parameters::Vector, max_num_subintervals
    )

    details = bvpm2_check_state(obj, (0,))

    try
        no_odes = convert(Int64, no_odes)
        @assert no_odes > 0
    catch e
        throw(
            ArgumentErrorODE(
                "no_odes must be positive integer",
                :no_odes, e
            )
        )
    end

    try
        no_left_bc = convert(Int64, no_left_bc)
        @assert no_left_bc ≥ 0
    catch e
        throw(
            ArgumentErrorODE(
                "no_left_bc must be non-negative integer",
                :no_left_bc, e
            )
        )
    end

    len_x_grid = length(x_grid)
    if len_x_grid <= 2
        throw(
            ArgumentErrorODE(
                string(
                    "x_grid must have length > 2. You must specify an initial grid."
                ),
                :x_grid
            )
        )
    end
    try
        x_grid = getVectorCheckLength(x_grid, Float64, len_x_grid)
        sort!(x_grid)
    catch e
        throw(
            ArgumentErrorODE(
                "cannot convert x_grid to Float64 vector",
                :x_grid, e
            )
        )
    end

    try
        parameters = getVectorCheckLength(
            parameters, Float64,
            length(parameters)
        )
    catch e
        throw(
            ArgumentErrorODE(
                "cannot convert parameters to a Float64 vector",
                :parameters, e
            )
        )
    end

    try
        max_num_subintervals = convert(Int64, max_num_subintervals)
        @assert max_num_subintervals > 0
        @assert max_num_subintervals ≥ length(x_grid) - 1
    catch e
        throw(
            ArgumentErrorODE(
                "max_num_subintervals must be positive integer",
                :max_num_subintervals, e
            )
        )
    end

    return details, no_odes, no_left_bc, x_grid, parameters, max_num_subintervals
end

"""
     function bvpm2_init(obj::Bvpm2,
       no_odes, no_left_bc, x_grid::Vector, constant_guess::Vector,
       parameters::Vector=[], max_num_subintervals=3000)

initialize Bvpm2 object with a constant initial guess.
"""
function bvpm2_init(
        obj::Bvpm2,
        no_odes, no_left_bc, x_grid::Vector, constant_guess::Vector,
        parameters::Vector = [], max_num_subintervals = 3000
    )

    details, no_odes, no_left_bc, x_grid, parameters, max_num_subintervals =
        bvpm2_init_tests(
        obj, no_odes, no_left_bc, x_grid, parameters,
        max_num_subintervals
    )

    try
        constant_guess = getVectorCheckLength(
            constant_guess,
            Float64, no_odes
        )
    catch e
        throw(
            ArgumentErrorODE(
                string(
                    "cannot convert constant_guess to a ",
                    "Float64 vector of length ", no_odes
                ), :constant_guess, e
            )
        )
    end

    ccall(
        obj.method_init_guess1, Cvoid,
        (
            Ptr{Cvoid},                           # handle
            Int64, Int64,                         # no_odes, no_left_bc
            Int64, Ref{Float64},                  # x_len, x
            Int64, Ref{Float64},                  # y_len, y
            Int64, Ref{Float64},                  # p_len, p
            Int64,                                # max_num_subintervals
        ),
        obj.handle,
        no_odes, no_left_bc,
        length(x_grid), x_grid,
        length(constant_guess), constant_guess,
        length(parameters), parameters,
        max_num_subintervals
    )

    return obj
end

"""
     function bvpm2_init(obj::Bvpm2,
       no_odes, no_left_bc, x_grid::Vector, guess::Matrix,
       parameters::Vector=[], max_num_subintervals=3000)

initialize Bvpm2 object with a guess for every state at
every node in x_grid.
"""
function bvpm2_init(
        obj::Bvpm2,
        no_odes, no_left_bc, x_grid::Vector, guess::Matrix,
        parameters::Vector = [], max_num_subintervals = 3000
    )

    details, no_odes, no_left_bc, x_grid, parameters, max_num_subintervals =
        bvpm2_init_tests(
        obj, no_odes, no_left_bc, x_grid, parameters,
        max_num_subintervals
    )
    try
        m, n = size(guess)
        if m ≠ no_odes || n ≠ length(x_grid)
            throw(
                ArgumentErrorODE(
                    string(
                        "guess must be a (no_odes, length(x_grid))=(", no_odes, ", ",
                        length(x_grid), " matrix. But I found a (", m, ", ", n, " matrix."
                    )
                )
            )
        end
        converted_guess = zeros(no_odes, length(x_grid))
        converted_guess[:] = getVectorCheckLength(
            guess[:],
            Float64, no_odes * length(x_grid), false
        )
        guess = converted_guess
    catch e
        throw(
            ArgumentErrorODE(
                string(
                    "cannot convert guess to a ",
                    "Float64 (", no_odes, ", ", length(x_grid), ") matrix"
                ), :guess, e
            )
        )
    end

    ccall(
        obj.method_init_guess2, Cvoid,
        (
            Ptr{Cvoid},                           # handle
            Int64, Int64,                         # no_odes, no_left_bc
            Int64, Ref{Float64},                  # x_len, x
            Int64, Int64, Ref{Float64},           # y_dim1, y_dim2, y
            Int64, Ref{Float64},                  # p_len, p
            Int64,                                # max_num_subintervals
        ),
        obj.handle,
        no_odes, no_left_bc,
        length(x_grid), x_grid,
        size(guess, 1), size(guess, 2), guess,
        length(parameters), parameters,
        max_num_subintervals
    )

    return obj
end

"""
This function calls `guess_fcn` saved in Bvpm2_guess_cbi.
"""
function bvpm2_guess(x, y, cbi::CI) where {CI}
    # lprefix = cbi.guess_lprefix
    # (lio,l)=(cbi.logio,cbi.loglevel)
    # l_guess = l & LOG_GUESS > 0

    # l_guess && println(lio, lprefix, "called with x=", x)
    cbi.guess(x, y)
    # l_guess && println(lio, lprefix, "guess result=", y)
    return nothing
end

"""
This is the guess function given as callback to bvpm2.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.
"""
function unsafe_bvpm2_guess_cb(
        x::Float64, y_len::Int64, y_::Ptr{Float64},
        cbi::CI
    ) where {CI <: Bvpm2_guess_cbi}

    @assert y_len == cbi.no_odes
    y = unsafe_wrap(Array, y_, (y_len,), own = false)
    bvpm2_guess(x, y, cbi)
    return nothing
end

function unsafe_bvpm2_guess_cb_c(cbi::CI) where {CI}
    return @cfunction(
        unsafe_bvpm2_guess_cb, Cvoid,
        (Float64, Int64, Ptr{Float64}, Ref{CI})
    )
end

"""
     function bvpm2_init(obj, no_odes, no_left_bc, x_grid,
                         guess<:Function, parameters,
                         max_num_subintervals=3000)

The guess function must have the form

     function guess(x,y)

where inside the function the guess for position x has to be
stored in y.

initialize Bvpm2 object where the function `guess` is used
to get the guesses for the state at different `x` values.
"""
function bvpm2_init(
        obj::Bvpm2,
        no_odes, no_left_bc, x_grid::Vector, guess::GUESS_FCN,
        parameters::Vector = [], max_num_subintervals = 3000
    ) where {GUESS_FCN <: Function}

    details, no_odes, no_left_bc, x_grid, parameters, max_num_subintervals =
        bvpm2_init_tests(
        obj, no_odes, no_left_bc, x_grid, parameters,
        max_num_subintervals
    )

    # Create callback-info
    cbi = Bvpm2_guess_cbi(no_odes, guess)

    ccall(
        obj.method_init_guess3, Cvoid,
        (
            Ptr{Cvoid},                           # handle
            Int64, Int64,                         # no_odes, no_left_bc
            Int64, Ref{Float64},                  # x_len, x
            Ptr{Cvoid}, Ref{Bvpm2_guess_cbi},     # guess_fcn, guess_fcn_pthrough
            Int64, Ref{Float64},                  # p_len, p
            Int64,                                # max_num_subintervals
        ),
        obj.handle,
        no_odes, no_left_bc,
        length(x_grid), x_grid,
        unsafe_bvpm2_guess_cb_c(cbi), cbi,
        length(parameters), parameters,
        max_num_subintervals
    )

    return obj
end

"""
This function calls `rhs` saved in Bvpm2_solve_cbi.
"""
function bvpm2_rhs(x, y, f, cbi::CI, p = nothing) where {CI}
    lprefix = cbi.rhs_lprefix
    (lio, l) = (cbi.logio, cbi.loglevel)
    l_rhs = l & LOG_RHS > 0

    cbi.rhs_count += 1

    l_rhs && println(lio, lprefix, "called with x=", x, " y=", y, " p=", p)
    if p === nothing
        cbi.rhs(x, y, f)
    else
        cbi.rhs(x, y, p, f)
    end
    l_rhs && println(lio, lprefix, "rhs result=", f)
    return nothing
end

"""
This is the right-hand side given as callback to bvpm2 in the
case where the problem has no unknown parameters.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.
"""
function unsafe_bvpm2_rhs_cb(
        x::Float64, y_len::Int64, y_::Ptr{Float64},
        f_len::Int64, f_::Ptr{Float64}, cbi::CI
    ) where {CI <: Bvpm2_solve_cbi}

    @assert y_len == f_len == cbi.no_odes

    y = unsafe_wrap(Array, y_, (y_len,), own = false)
    f = unsafe_wrap(Array, f_, (f_len,), own = false)
    bvpm2_rhs(x, y, f, cbi)
    return nothing
end

function unsafe_bvpm2_rhs_cb_c(cbi::CI) where {CI}
    return @cfunction(
        unsafe_bvpm2_rhs_cb, Cvoid,
        (Float64, Int64, Ptr{Float64}, Int64, Ptr{Float64}, Ref{CI})
    )
end

"""
This is the right-hand side given as callback to bvpm2 in the
case where the problem has unknown parameters.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.
"""
function unsafe_bvpm2_rhspar_cb(
        x::Float64, y_len::Int64, y_::Ptr{Float64},
        p_len::Int64, p_::Ptr{Float64},
        f_len::Int64, f_::Ptr{Float64}, cbi::CI
    ) where {CI <: Bvpm2_solve_cbi}

    @assert y_len == f_len == cbi.no_odes
    @assert p_len == cbi.no_par

    y = unsafe_wrap(Array, y_, (y_len,), own = false)
    p = unsafe_wrap(Array, p_, (p_len,), own = false)
    f = unsafe_wrap(Array, f_, (f_len,), own = false)
    bvpm2_rhs(x, y, f, cbi, p)
    return nothing
end

function unsafe_bvpm2_rhspar_cb_c(cbi::CI) where {CI}
    return @cfunction(
        unsafe_bvpm2_rhspar_cb, Cvoid,
        (
            Float64, Int64, Ptr{Float64}, Int64, Ptr{Float64},
            Int64, Ptr{Float64}, Ref{CI},
        )
    )
end

"""
This function calls `Drhs` saved in Bvpm2_solve_cbi.
"""
function bvpm2_Drhs(x, y, dfdy, cbi::CI, p = nothing, dfdp = nothing) where {CI}
    lprefix = cbi.Drhs_lprefix
    (lio, l) = (cbi.logio, cbi.loglevel)
    l_Drhs = l & LOG_JAC > 0

    cbi.Drhs_count += 1
    l_Drhs && println(lio, lprefix, "called with x=", x, " y=", y, " p=", p)
    if p === nothing
        cbi.Drhs(x, y, dfdy)
    else
        cbi.Drhs(x, y, p, dfdy, dfdp)
    end
    l_Drhs && println(lio, lprefix, "Drhs result: dfdy=", dfdy, " dfdp=", dfdp)
    return nothing
end

"""
This is the derivative of the right-hand side given as callback to
bvpm2 in the case where the problem has no unknown parameters.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.
"""
function unsafe_bvpm2_Drhs_cb(
        x::Float64, y_len::Int64, y_::Ptr{Float64},
        dfdy_dim1::Int64, dfdy_dim2::Int64, dfdy_::Ptr{Float64},
        cbi::CI
    ) where {CI <: Bvpm2_solve_cbi}

    @assert y_len == cbi.no_odes
    @assert dfdy_dim1 == dfdy_dim2 == cbi.no_odes

    y = unsafe_wrap(Array, y_, (y_len,), own = false)
    dfdy = unsafe_wrap(Array, dfdy_, (dfdy_dim1, dfdy_dim2), own = false)
    bvpm2_Drhs(x, y, dfdy, cbi)
    return nothing
end

function unsafe_bvpm2_Drhs_cb_c(cbi::CI) where {CI}
    return @cfunction(
        unsafe_bvpm2_Drhs_cb, Cvoid,
        (Float64, Int64, Ptr{Float64}, Int64, Int64, Ptr{Float64}, Ref{CI})
    )
end

"""
This is the derivative of the right-hand side given as callback to
bvpm2 in the case where the problem has unknown parameters.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.
"""
function unsafe_bvpm2_Drhspar_cb(
        x::Float64, y_len::Int64, y_::Ptr{Float64},
        p_len::Int64, p_::Ptr{Float64},
        dfdy_dim1::Int64, dfdy_dim2::Int64, dfdy_::Ptr{Float64},
        dfdp_dim1::Int64, dfdp_dim2::Int64, dfdp_::Ptr{Float64},
        cbi::CI
    ) where {CI <: Bvpm2_solve_cbi}

    @assert y_len == cbi.no_odes
    @assert dfdy_dim1 == dfdy_dim2 == cbi.no_odes
    @assert dfdp_dim1 == cbi.no_odes && dfdp_dim2 == cbi.no_par

    y = unsafe_wrap(Array, y_, (y_len,), own = false)
    p = unsafe_wrap(Array, p_, (p_len,), own = false)
    dfdy = unsafe_wrap(Array, dfdy_, (dfdy_dim1, dfdy_dim2), own = false)
    dfdp = unsafe_wrap(Array, dfdp_, (dfdp_dim1, dfdp_dim2), own = false)
    bvpm2_Drhs(x, y, dfdy, cbi, p, dfdp)
    return nothing
end

function unsafe_bvpm2_Drhspar_cb_c(cbi::CI) where {CI}
    return @cfunction(
        unsafe_bvpm2_Drhspar_cb, Cvoid,
        (
            Float64, Int64, Ptr{Float64}, Int64, Ptr{Float64},
            Int64, Int64, Ptr{Float64}, Int64, Int64, Ptr{Float64}, Ref{CI},
        )
    )
end

"""
This function calls `bc` saved in Bvpm2_solve_cbi.
"""
function bvpm2_bc(ya, yb, bca, bcb, cbi::CI, p = nothing) where {CI}
    lprefix = cbi.bc_lprefix
    (lio, l) = (cbi.logio, cbi.loglevel)
    l_bc = l & LOG_BC > 0

    cbi.bc_count += 1
    l_bc && println(lio, lprefix, "called with ya=", ya, " yb=", yb, " p=", p)
    if p === nothing
        cbi.bc_fcn(ya, yb, bca, bcb)
    else
        cbi.bc_fcn(ya, yb, p, bca, bcb)
    end
    l_bc && println(lio, lprefix, "bc result: bca", bca, " bcb=", bcb)
    return nothing
end

"""
This is the boundary-conditions function given as callback
to bvpm2 in the case with no unknown parameters.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.
"""
function unsafe_bvpm2_bc_cb(
        ya_len::Int64, ya_::Ptr{Float64},
        yb_len::Int64, yb_::Ptr{Float64},
        bca_len::Int64, bca_::Ptr{Float64},
        bcb_len::Int64, bcb_::Ptr{Float64}, cbi::CI
    ) where {CI <: Bvpm2_solve_cbi}

    @assert ya_len == yb_len == cbi.no_odes
    @assert bca_len == cbi.no_left_bc
    @assert bcb_len == cbi.no_odes + cbi.no_par - cbi.no_left_bc
    ya = unsafe_wrap(Array, ya_, (ya_len,), own = false)
    yb = unsafe_wrap(Array, yb_, (yb_len,), own = false)
    bca = unsafe_wrap(Array, bca_, (bca_len,), own = false)
    bcb = unsafe_wrap(Array, bcb_, (bcb_len,), own = false)
    bvpm2_bc(ya, yb, bca, bcb, cbi)
    return nothing
end

function unsafe_bvpm2_bc_cb_c(cbi::CI) where {CI}
    return @cfunction(
        unsafe_bvpm2_bc_cb, Cvoid,
        (
            Int64, Ptr{Float64}, Int64, Ptr{Float64},
            Int64, Ptr{Float64}, Int64, Ptr{Float64}, Ref{CI},
        )
    )
end

"""
This is the boundary-conditions function given as callback
to bvpm2 in the case with unknown parameters.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.
"""
function unsafe_bvpm2_bcpar_cb(
        ya_len::Int64, ya_::Ptr{Float64},
        yb_len::Int64, yb_::Ptr{Float64},
        p_len::Int64, p_::Ptr{Float64},
        bca_len::Int64, bca_::Ptr{Float64},
        bcb_len::Int64, bcb_::Ptr{Float64}, cbi::CI
    ) where {CI <: Bvpm2_solve_cbi}

    @assert ya_len == yb_len == cbi.no_odes
    @assert bca_len == cbi.no_left_bc
    @assert bcb_len == cbi.no_odes + cbi.no_par - cbi.no_left_bc
    @assert p_len == cbi.no_par
    ya = unsafe_wrap(Array, ya_, (ya_len,), own = false)
    yb = unsafe_wrap(Array, yb_, (yb_len,), own = false)
    p = unsafe_wrap(Array, p_, (p_len,), own = false)
    bca = unsafe_wrap(Array, bca_, (bca_len,), own = false)
    bcb = unsafe_wrap(Array, bcb_, (bcb_len,), own = false)
    bvpm2_bc(ya, yb, bca, bcb, cbi, p)
    return nothing
end

function unsafe_bvpm2_bcpar_cb_c(cbi::CI) where {CI}
    return @cfunction(
        unsafe_bvpm2_bcpar_cb, Cvoid,
        (
            Int64, Ptr{Float64}, Int64, Ptr{Float64},
            Int64, Ptr{Float64},
            Int64, Ptr{Float64}, Int64, Ptr{Float64}, Ref{CI},
        )
    )
end

"""
This function calls `Dbc` saved in Bvpm2_solve_cbi.
"""
function bvpm2_Dbc(
        ya, yb, dya, dyb, cbi::CI,
        p = nothing, dpa = nothing, dpb = nothing
    ) where {CI}
    lprefix = cbi.bc_lprefix
    (lio, l) = (cbi.logio, cbi.loglevel)
    l_Dbc = l & LOG_JACBC > 0

    cbi.Dbc_count += 1
    l_Dbc && println(lio, lprefix, "called with ya=", ya, " yb=", yb, " p=", p)
    if p === nothing
        cbi.Dbc(ya, yb, dya, dyb)
    else
        cbi.Dbc(ya, yb, dya, dyb, p, dpa, dpb)
    end
    l_Dbc && println(
        lio, lprefix, "bc result: dya", dya, " dyb=", dyb,
        " dpa=", dpa, " dpb=", dpb
    )
    return nothing
end

"""
This is the derivative of the boundary-conditions given as callback
to bvpm2 in the case with no unknown parameters.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.
"""
function unsafe_bvpm2_Dbc_cb(
        ya_len::Int64, ya_::Ptr{Float64}, yb_len::Int64, yb_::Ptr{Float64},
        dya_dim1::Int64, dya_dim2::Int64, dya_::Ptr{Float64},
        dyb_dim1::Int64, dyb_dim2::Int64, dyb_::Ptr{Float64},
        cbi::CI
    ) where {CI <: Bvpm2_solve_cbi}

    @assert ya_len == yb_len == cbi.no_odes
    @assert dya_dim2 == dyb_dim2 == cbi.no_odes
    @assert dya_dim1 == cbi.no_left_bc
    @assert dyb_dim1 == cbi.no_odes + cbi.no_par - cbi.no_left_bc

    ya = unsafe_wrap(Array, ya_, (ya_len,), own = false)
    yb = unsafe_wrap(Array, yb_, (yb_len,), own = false)
    dya = unsafe_wrap(Array, dya_, (dya_dim1, dya_dim2), own = false)
    dyb = unsafe_wrap(Array, dyb_, (dyb_dim1, dyb_dim2), own = false)
    bvpm2_Dbc(ya, yb, dya, dyb, cbi)
    return nothing
end

function unsafe_bvpm2_Dbc_cb_c(cbi::CI) where {CI}
    return @cfunction(
        unsafe_bvpm2_Dbc_cb, Cvoid,
        (
            Int64, Ptr{Float64}, Int64, Ptr{Float64},
            Int64, Int64, Ptr{Float64}, Int64, Int64, Ptr{Float64}, Ref{CI},
        )
    )
end


"""
This is the derivative of the boundary-conditions given as callback
to bvpm2 in the case with unknown parameters.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-arguments.
"""
function unsafe_bvpm2_Dbcpar_cb(
        ya_len::Int64, ya_::Ptr{Float64}, yb_len::Int64, yb_::Ptr{Float64},
        p_len::Int64, p_::Ptr{Float64},
        dya_dim1::Int64, dya_dim2::Int64, dya_::Ptr{Float64},
        dyb_dim1::Int64, dyb_dim2::Int64, dyb_::Ptr{Float64},
        dpa_dim1::Int64, dpa_dim2::Int64, dpa_::Ptr{Float64},
        dpb_dim1::Int64, dpb_dim2::Int64, dpb_::Ptr{Float64},
        cbi::CI
    ) where {CI <: Bvpm2_solve_cbi}

    @assert ya_len == yb_len == cbi.no_odes
    @assert p_len == cbi.no_par
    @assert dya_dim2 == dyb_dim2 == cbi.no_odes
    @assert dpa_dim2 == dpb_dim2 == cbi.no_par
    @assert dya_dim1 == dpa_dim1 == cbi.no_left_bc
    @assert dyb_dim1 == dpb_dim1 == cbi.no_odes + cbi.no_par - cbi.no_left_bc

    ya = unsafe_wrap(Array, ya_, (ya_len,), own = false)
    yb = unsafe_wrap(Array, yb_, (yb_len,), own = false)
    p = unsafe_wrap(Array, p_, (p_len,), own = false)
    dya = unsafe_wrap(Array, dya_, (dya_dim1, dya_dim2), own = false)
    dyb = unsafe_wrap(Array, dyb_, (dyb_dim1, dyb_dim2), own = false)
    dpa = unsafe_wrap(Array, dpa_, (dpa_dim1, dpa_dim2), own = false)
    dpb = unsafe_wrap(Array, dpb_, (dpb_dim1, dpb_dim2), own = false)
    bvpm2_Dbc(ya, yb, dya, dyb, cbi, p, dpa, dpb)
    return nothing
end

function unsafe_bvpm2_Dbcpar_cb_c(cbi::CI) where {CI}
    return @cfunction(
        unsafe_bvpm2_Dbcpar_cb, Cvoid,
        (
            Int64, Ptr{Float64}, Int64, Ptr{Float64},
            Int64, Ptr{Float64},
            Int64, Int64, Ptr{Float64}, Int64, Int64, Ptr{Float64},
            Int64, Int64, Ptr{Float64}, Int64, Int64, Ptr{Float64}, Ref{CI},
        )
    )
end


"""
     function bvpm2_solve(guess_obj::Bvpm2, rhs, bc,
       opt::AbstractOptionsODE) -> (obj_out, retcode, stats)

## Right-hand side for the ODEs: `rhs`

The function `rhs` must have the form:

     function rhs(x, y, f)              [no_par == 0]
     function rhs(x, y, p, f)           [no_par != 0]

where

      x::Float, y::Vector{Float64}(no_odes), p::Vector{Float64}(no_par)
      f::Vector{Float64}(no_odes)

Inside the function, the values of the right-hand side must be saved
in `f`.

## Derivatives of right-hand side: `Drhs`

The function `Drhs` is optional. If not given finite differences are
used to approximate the derivatives. If `Drhs` is given it must have
the form:

     function Drhs(x, y, dfdy)          [no_par == 0]
     function Drhs(x, y, p, dfdy, dfdp) [no_par != 0]

where

      x::Float, y::Vector{Float64}(no_odes), p::Vector{Float64}(no_par)
      dfdy::Matrix{Float64}(no_odes, no_odes)
      dfdp::Matrix{Float64}(no_odes, no_par)

Inside the function, the values of the derivatives must be saved
in `dfdy` and `dfdp`.

## Boundary conditions: `bc`

The function `bc` must have the form:

     function bc(ya, yb, bca, bcb)      [no_par == 0]
     function bc(ya, yb, p, bca, bcb)   [no_par != 0]

where

      ya::Vector{Float64}(no_odes), yb::Vector{Float64}(no_odes),
      p::Vector{Float64}(no_par),
      bca::Vector{Float64}(no_left_bc),
      bcb::Vector{Float64}(no_odes - no_left_bc)

Inside the function, the values of the boundary conditions must be
saved in `bca` and `bcb`.

## Derivatives of the boundary conditions: `Dbc`

The function `Dbc` is optional. If not given finite differences are
used to approximate the derivatives. If `Dbc` is given it must have
the form:

     function Dbc(ya, yb, dya, dyb)                 [no_par == 0]
     function Dbc(ya, yb, dya, dyb, p, dpa, dpb)    [no_par != 0]

where

      ya::Vector{Float64}(no_odes), yb::Vector{Float64}(no_odes),
      p::Vector{Float64}(no_par),
      dya::Matrix{Float64}(no_left_bc, no_odes)
      dyb::Matrix{Float64}(no_odes+no_par-no_left_bc, no_odes)
      dpa::Matrix{Float64}(no_left_bc, no_par)
      dpb::Matrix{Float64}(no_odes+no_par-no_left_bc, no_par)

Inside the function, the values of the derivatives of the boundary
conditions must be saved in `dya`, `dyb`, `dpa` and `dpb`.

## Options `opt`

In `opt` the following options are used:

    ╔═════════════════╤══════════════════════════════════════════╤═════════╗
    ║  Option OPT_…   │ Description                              │ Default ║
    ╠═════════════════╪══════════════════════════════════════════╪═════════╣
    ║ RTOL            │ relative accuracy for solution.          │    1e-6 ║
    ║                 │ solution. Must be a scalar.              │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ METHODCHOICE    │ Choice for IVP-solvers:                  │       4 ║
    ║                 │ 2: Runge-Kutta method of order 2         │         ║
    ║                 │ 4: Runge-Kutta method of order 4         │         ║
    ║                 │ 6: Runge-Kutta method of order 6         │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ DIAGNOSTICOUTPUT│ diagnostic output for bvpm2:             │      -1 ║
    ║                 │   -1 : no output                         │         ║
    ║                 │    0 : only output if computation fails  │         ║
    ║                 │    1 : intermediate output               │         ║
    ║                 │    2 : full output                       │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ ERRORCONTROL    │ determines the error-estimation for      │       1 ║
    ║                 │ which RTOL is used:                      │         ║
    ║                 │    1 : defect                            │         ║
    ║                 │    2 : global error                      │         ║
    ║                 │    3 : defect and then global error      │         ║
    ║                 │    4 : linear combination of defect      │         ║
    ║                 │        and global error                  │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ SINGULARTERM    │ either nothing if the ODEs have no       │ nothing ║
    ║                 │ singular terms at the left boundary or   │         ║
    ║                 │ a constant (d,d) matrix for the          │         ║
    ║                 │ singular term.                           │         ║
    ╚═════════════════╧══════════════════════════════════════════╧═════════╝

## Return-Code `retcode`

`retcode` can have to following values:

      <0: failure
      ≥0: computation successful
"""
function bvpm2_solve(
        guess_obj::Bvpm2, rhs, bc,
        opt::AbstractOptionsODE; Drhs = nothing, Dbc = nothing
    )

    (lio, l, l_g, l_solver, lprefix) = solver_init("bvpm2", opt)

    if l_g
        println(
            lio, lprefix,
            "called with rhs=", rhs, "bc=", bc, "guess_obj=", guess_obj
        )
    end

    # singular-term, method, tol, trace error_control in opt

    details = bvpm2_check_state(guess_obj, (1, 2))
    no_odes = details["no_odes"]
    no_par = details["no_par"]
    no_left_bc = details["no_left_bc"]
    tol = NaN; method = 4; trace = -1; error_control = 1
    si_dim = 0; si_matrix = Matrix{Float64}(undef, 0, 0)

    OPT = nothing
    try
        OPT = OPT_RTOL
        tol = convert(Float64, getOption(opt, OPT, 1.0e-6))
        @assert isscalar(tol) && tol > 0.0

        OPT = OPT_METHODCHOICE
        method = convert(Int64, getOption(opt, OPT, 4))
        @assert method ∈ (2, 4, 6)

        OPT = OPT_DIAGNOSTICOUTPUT
        trace = convert(Int64, getOption(opt, OPT, -1))
        @assert trace ∈ (-1, 0, 1, 2)

        OPT = OPT_ERRORCONTROL
        error_control = convert(Int64, getOption(opt, OPT, 1))
        @assert error_control ∈ (1, 2, 3, 4)

        OPT = OPT_SINGULARTERM
        singular_term = getOption(opt, OPT, nothing)
        if singular_term !== nothing
            singular_term = convert(Matrix{Float64}, singular_term)
            @assert no_odes == size(singular_term, 1) == size(singular_term, 2)
            si_dim = no_odes
            si_matrix = copy(singular_term)
        end
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    error_ret = Vector{Float64}(undef, 5)
    handle_out = [C_NULL]

    if bvpm2_global_cbi !== nothing
        throw(
            ArgumentErrorODE(
                string(
                    "The Fortran solver BVP_M-2 uses ",
                    "global variables during the solution process. Hence this julia ",
                    "module does not support concurrent/nested bvpm2_solve calls. Sorry."
                ),
                :opt
            )
        )
    end
    cbi = nothing; error = 0
    try
        global bvpm2_global_cbi = cbi = Bvpm2_solve_cbi(
            lio, l,
            no_odes, no_par, no_left_bc,
            rhs, "unsafe_bvpm2_rhs: ", 0,
            Drhs !== nothing ? Drhs : dummy_func, "unsafe_bvpm2_Drhs: ", 0,
            bc, "unsafe_bvpm2_b: ", 0,
            Dbc !== nothing ? Dbc : dummy_func, "unsafe_bvpm2_Dbc: ", 0
        )

        if l_solver
            println(
                lio, lprefix, "call Fortran bvpm2_solver ",
                guess_obj.method_solve
            )
        end

        rhs_fcn_ptr = (no_par > 0) ? unsafe_bvpm2_rhspar_cb_c(cbi) :
            unsafe_bvpm2_rhs_cb_c(cbi)
        Drhs_fcn_ptr = Drhs !== nothing ? (
                (no_par > 0) ? unsafe_bvpm2_Drhspar_cb_c(cbi) :
                unsafe_bvpm2_Drhs_cb_c(cbi)
            ) : C_NULL
        bc_fcn_ptr = (no_par > 0) ? unsafe_bvpm2_bcpar_cb_c(cbi) :
            unsafe_bvpm2_bc_cb_c(cbi)
        Dbc_fcn_ptr = Dbc !== nothing ? (
                (no_par > 0) ? unsafe_bvpm2_Dbcpar_cb_c(cbi) :
                unsafe_bvpm2_Dbc_cb_c(cbi)
            ) : C_NULL

        error = ccall(
            guess_obj.method_solve, Int64,
            (
                Ptr{Cvoid}, Ref{Ptr{Cvoid}},          # handle_guess, handle_out
                Ptr{Cvoid}, Ptr{Cvoid},               # rhs_fcn_ptr, bc_fcn_ptr
                Int64, Ptr{Float64},                  # si_dim, si_matrix
                Int64, Float64,                       # method, tol
                Ptr{Cvoid}, Ptr{Cvoid},               # dfdy_fcn_ptr, dbcdy_fcn_ptr
                Int64, Int64,                         # trace, error_control
                Int64, Ptr{Float64},                  # error_ret_len, error_ret
                Ref{Bvpm2_solve_cbi},                 # calls_pthrough
            ),
            guess_obj.handle, handle_out,
            rhs_fcn_ptr, bc_fcn_ptr,
            si_dim, si_matrix,
            method, tol,
            Drhs_fcn_ptr, Dbc_fcn_ptr,
            trace, error_control,
            length(error_ret), error_ret,
            cbi
        )

        if l_solver
            println(
                lio, lprefix, "call Fortran bvpm2_solver ",
                guess_obj.method_solve, " returned ", error
            )
        end
    finally
        global bvpm2_global_cbi = nothing
    end

    error ≠ 0 && throw(
        InternalErrorODE(
            string(
                "Internal error during solve call: error = ", error
            )
        )
    )

    @assert handle_out[1] ≠ C_NULL
    obj_out = Bvpm2(handle_out[1])
    out_details = bvpm2_get_details(obj_out)
    stats = Dict(
        "no_rhs_calls" => cbi.rhs_count,
        "no_jac_calls" => cbi.Drhs_count,
        "no_bc_calls" => cbi.bc_count,
        "no_Dbc_calls" => cbi.Dbc_count,
        "cond" => error_ret[1],
        "cerror" => error_ret[2],
        "reerror" => error_ret[3],
        "hoerror" => error_ret[4],
        "dcerror" => error_ret[5]
    )
    return obj_out, out_details["info"], stats
end

"""
     function bvpm2_extend(sol_obj::Bvpm2, anew, bnew,
              yanew::Vector, ybnew::Vector;
              p_new=[], max_num_subintervals=0)

extends a solution (`state == 2`) to a new interval. Take the
two given states `yanew` and `ybnew` as new states for the new
interval. (If `anew ≥ a` then `yanew` is ignored. If `bnew ≤ b` then
ybnew is ignored.)

You can change the parameter guess also, by using `p_new` and you
can change the maximal number of subintervals, too.

sol_obj will be "terminated". After the call `sol_obj` will be
in state 0. Use `bvpm2_copy` before, if you need the solution afterwards.

A new Bvpm2-object `guess_obj` will be created an returned.
"""
function bvpm2_extend(
        sol_obj::Bvpm2, anew, bnew,
        yanew::Vector, ybnew::Vector;
        p_new::Vector = [], max_num_subintervals = 0
    )

    details = bvpm2_check_state(sol_obj, (2,))
    try
        anew = convert(Float64, anew)
    catch e
        throw(ArgumentErrorODE("Cannot convert anew to Float64", :anew, e))
    end
    try
        bnew = convert(Float64, bnew)
    catch e
        throw(ArgumentErrorODE("Cannot convert bnew to Float64", :bnew, e))
    end
    no_odes = details["no_odes"]
    no_par = details["no_par"]
    try
        yanew = getVectorCheckLength(yanew, Float64, no_odes)
    catch e
        throw(ArgumentErrorODE("Cannot convert yanew", :yanew, e))
    end
    try
        ybnew = getVectorCheckLength(ybnew, Float64, no_odes)
    catch e
        throw(ArgumentErrorODE("Cannot convert ybnew", :ybnew, e))
    end
    if length(p_new) > 0
        try
            p_new = getVectorCheckLength(p_new, Float64, no_par)
        catch e
            throw(ArgumentErrorODE("Cannot convert p_new", :p_new, e))
        end
    end
    try
        max_num_subintervals = convert(Int64, max_num_subintervals)
    catch e
        throw(
            ArgumentErrorODE(
                "Cannot convert max_num_subintervals to Float64",
                :max_num_subintervals, e
            )
        )
    end
    result = [C_NULL]
    error = ccall(
        sol_obj.method_extend_s, Int64,
        (
            Ptr{Cvoid}, Ref{Ptr{Cvoid}},     # handle_in, handle_out
            Float64, Float64,                # anew, bnew
            Int64, Ptr{Float64},             # yanew_len, yanew
            Int64, Ptr{Float64},             # ybnew_len, ybnew
            Int64, Ptr{Float64},             # p_len, p
            Int64,
        ),                         # max_num_subintervals
        sol_obj.handle, result,
        anew, bnew,
        length(yanew), yanew,
        length(ybnew), ybnew,
        length(p_new), p_new,
        max_num_subintervals
    )

    error ≠ 0 && throw(
        InternalErrorODE(
            string(
                "Internal error during extend call: error = ", error
            )
        )
    )

    return Bvpm2(result[1])
end

"""
     function bvpm2_extend(sol_obj::Bvpm2, anew, bnew, order;
              p_new::Vector=[], max_num_subintervals=0)

extends a solution (`state == 2`) to a new interval using
constant (`order==0`) or linear (`order==1`) extrapolation.

You can change the parameter guess also, by using `p_new` and you
can change the maximal number of subintervals, too.

sol_obj will be "terminated". After the call `sol_obj` will be
in state 0. Use `bvpm2_copy` before, if you need the solution afterwards.

A new Bvpm2-object `guess_obj` will be created an returned.
"""
function bvpm2_extend(
        sol_obj::Bvpm2, anew, bnew, order;
        p_new::Vector = [], max_num_subintervals = 0
    )
    details = bvpm2_check_state(sol_obj, (2,))
    try
        anew = convert(Float64, anew)
    catch e
        throw(ArgumentErrorODE("Cannot convert anew to Float64", :anew, e))
    end
    try
        bnew = convert(Float64, bnew)
    catch e
        throw(ArgumentErrorODE("Cannot convert bnew to Float64", :bnew, e))
    end
    try
        order = convert(Int64, order)
        @assert order ∈ (0, 1)
    catch e
        throw(
            ArgumentErrorODE(
                "Cannot convert order to Int64: 0 or 1",
                :order, e
            )
        )
    end
    no_odes = details["no_odes"]
    no_par = details["no_par"]
    if length(p_new) > 0
        try
            p_new = getVectorCheckLength(p_new, Float64, no_par)
        catch e
            throw(ArgumentErrorODE("Cannot convert p_new", :p_new, e))
        end
    end
    result = [C_NULL]
    error = ccall(
        sol_obj.method_extend_e, Int64,
        (
            Ptr{Cvoid}, Ref{Ptr{Cvoid}},     # handle_in, handle_out
            Float64, Float64,                # anew, bnew
            Int64,                           # order
            Int64, Ptr{Float64},             # p_len, p
            Int64,
        ),                         # max_num_subintervals
        sol_obj.handle, result,
        anew, bnew,
        order,
        length(p_new), p_new,
        max_num_subintervals
    )

    error ≠ 0 && throw(
        InternalErrorODE(
            string(
                "Internal error during extend call: error = ", error
            )
        )
    )

    return Bvpm2(result[1])
end

"""
     function evalSolution(sol::Bvpm2, x::Real, z::Vector{Float64},
       dz::Vector{Float64})

Evaluates an already obtained solution `sol` at scalar point `x`.
The values of the solution are saved in `z` which must be a
vector (of length d).
For the vector `dz` there are two cases: If `dz` is a empty vector (of
length 0) then the derivates of z are not calculated, otherwise
`dz` has to be a vector (of length d) where the derivates are
stored.
"""
function evalSolution(
        sol::Bvpm2, x::Real, z::Vector{Float64},
        dz::Vector{Float64} = Vector{Float64}(undef, 0)
    )

    details = bvpm2_check_state(sol, (2,))
    no_odes = details["no_odes"]
    length(z) ≠ no_odes && throw(
        ArgumentErrorODE(
            string(
                "Expected for z a vector of length ", no_odes, ", but found a vector ",
                "with length ", length(z)
            ), :z
        )
    )
    if length(dz) ≠ 0 && length(dz) ≠ no_odes
        throw(
            ArgumentErrorODE(
                string(
                    "Expected for dz a vector of length 0 or ", no_odes, ", but found ",
                    "a vector with length ", length(dz)
                ), :dz
            )
        )
    end
    error = ccall(
        sol.method_eval_s, Int64,
        (
            Ptr{Cvoid}, Float64,                  # handles, x
            Int64, Ptr{Float64},                  # z_len, z
            Int64, Ptr{Float64},                  # dz_len, dz
        ),
        sol.handle, convert(Float64, x),
        length(z), z,
        length(dz), dz
    )

    error ≠ 0 && throw(
        InternalErrorODE(
            string(
                "Internal error during solve call: error = ", error
            )
        )
    )
    return nothing
end

"""
     function evalSolution(sol::Bvpm2, x::Real)  -> z

Allocates vector `z` and calls `evalSolution(sol, x, z)`.
"""
function evalSolution(sol::Bvpm2, x::Real)
    details = bvpm2_check_state(sol, (2,))
    no_odes = details["no_odes"]
    z = Vector{Float64}(no_odes)
    evalSolution(sol, x, z)
    return z
end

"""
     function evalSolution(sol::Bvpm2, x::Vector{Float64},
       z::Matrix{Float64}, dz::Matrix{Float64})

Evaluates an already obtained solution `sol` at scalar point `x`.
The values of the solution are saved in `z` which must be a
vector (of length d).
For the vector `dz` there are two cases: If `dz` is a empty vector (of
length 0) then the derivates of z are not calculated, otherwise
`dz` has to be a vector (of length d) where the derivates are
stored.
"""
function evalSolution(
        sol::Bvpm2, x::Vector{Float64}, z::Matrix{Float64},
        dz::Matrix{Float64} = Matrix{Float64}(undef, 0, 0)
    )

    details = bvpm2_check_state(sol, (2,))
    no_odes = details["no_odes"]
    x_len = length(x)
    size(z) ≠ (no_odes, x_len) && throw(
        ArgumentErrorODE(
            string(
                "Expected for z a (", no_odes, ", ", x_len, ") matrix, but found a (",
                size(z, 1), ", ", size(z, 2), ") matrix "
            ), :z
        )
    )
    if size(dz) ≠ (0, 0) && size(dz) ≠ (no_odes, x_len)
        throw(
            ArgumentErrorODE(
                string(
                    "Expected for dz an empty matrix or a (", no_odes, ", ", x_len, ") ",
                    "matrix, but found a (", size(dz, 1), ", ", size(dz, 2), ") matrix "
                ), :dz
            )
        )
    end
    error = ccall(
        sol.method_eval_v, Int64,
        (
            Ptr{Cvoid},                            # handle
            Int64, Ptr{Float64},                  # x_len, x
            Int64, Int64, Ptr{Float64},           # z_dim1, z_dim2
            Int64, Int64, Ptr{Float64},           # dz_dim1, dz_dim2
        ),
        sol.handle,
        length(x), x,
        size(z, 1), size(z, 2), z,
        size(dz, 1), size(dz, 2), dz
    )

    error ≠ 0 && throw(
        InternalErrorODE(
            string(
                "Internal error during solve call: error = ", error
            )
        )
    )
    return nothing
end

"""
     function evalSolution(sol::Bvpm2, x::Vector{Float64}) -> z

Allocates matrix `z` and calls `evalSolution(sol, x, z)`.
"""
function evalSolution(sol::Bvpm2, x::Vector{Float64})
    details = bvpm2_check_state(sol, (2,))
    no_odes = details["no_odes"]
    x_len = length(x)
    z = Matrix{Float64}(undef, no_odes, x_len)
    evalSolution(sol, x, z)
    return z
end

"""
## Compile BVP_M-2

The julia ODEInterface tries to compile and link the solvers
automatically at the build-time of this module. The following
calls need only be done, if one uses a different compiler and/or if
one wants to change/add some compiler options.

The Fortran source code can be found at:

     http://cs.stmarys.ca/~muir/BVP_SOLVER_Webpage.shtml

See `help_bvpm3_license` for the license information.

### Using `gfortran` and 64bit integers (Linux and Mac)

Here is an example how to compile BVP_M-2 with `Float64` reals (and
`Int64` integers with `gfortran`):

     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o bvp_la-2.o bvp_la-2.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o bvp_m-2.o bvp_m-2.f90
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o bvp_m_proxy.o bvp_m_proxy.f90

The last file `bvp_m_proxy.f90` is a Julia/C-Proxy and is part of this
`ODEInterface` package.

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o bvp_m_proxy.so
              bvp_m_proxy.o bvp_m-2.o bvp_la-2.o
"""
function help_bvpm2_compile()
    return Docs.doc(help_bvpm2_compile)
end

"""
Please call this `help_bvpm2_proxy` function to get an detailed description
of the Fortran-Proxy written for BVP_M-2.
"""
function help_bvpm2_proxy()
    src_file = joinpath(@__DIR__, "bvp_m_proxy.f90")
    markdown = ""
    fh = open(src_file, "r")
    while !eof(fh)
        line = readline(fh)
        if length(line) > 0 && line[1] == '!'
            markdown *= line[
                ((length(line) > 1 && line[2] == ' ') ? 3 : 2):end,
            ] * "\n"
        else
            break
        end
    end
    close(fh)
    return Markdown.parse(markdown)
end

"""
# Licence

BVP_SOLVER, Release 2, with global error estimation and control options.
Copyright (c) 2012, Jason Boisvert, Paul Muir, Ray Spiteri.
Jason Boisvert, Ray Spiteri, Department of Computer Science, University of Saskatchewan.
Paul Muir, Mathematics and Computing Science, Saint Mary's University.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither Saint Mary's University nor Southern Methodist University nor
      the names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY Jason Boisvert, Paul Muir, and Ray Spiteri ''AS IS'' AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Paul Muir and Larry Shampine BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See documentation below for FUNCTION BVP_SOLVER for a description of the changes
to the argument list for BVP_SOLVER.

Copyright (c) 2006, Paul Muir and Larry Shampine.
Paul Muir, Mathematics and Computing Science, Saint Mary's University.
Larry Shampine, Mathematics, Southern Methodist University.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither Saint Mary's University nor Southern Methodist University nor
      the names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY Paul Muir and Larry Shampine ''AS IS'' AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Paul Muir and Larry Shampine BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

L.F. Shampine, P.H. Muir, H. Xu, A user-friendly Fortran BVP solver,
J. Numer. Anal. Indust. Appl. Math., 1, 2006, 201--217.
"""
function help_bvpm2_license()
    return Docs.doc(help_bvpm2_license)
end


# Add information about solvers in global solverInfo-array.
push!(
    solverInfo,
    SolverInfo(
        "bvpm2",
        "Boundary Value Problem Solver with defect and global error control",
        tuple(
            :OPT_RTOL, :OPT_METHODCHOICE, :OPT_DIAGNOSTICOUTPUT,
            :OPT_ERRORCONTROL, :OPT_SINGULARTERM,
        ),
        tuple(
            SolverVariant(
                "bvpm2_i64",
                "Bvpm2 with 64bit integers",
                DL_BVPM2,
                tuple(
                    "create_sol_wrapper_c",
                    "copy_sol_wrapper_c",
                    "terminate_sol_wrapper_c",
                    "destroy_sol_wrapper_c",
                    "show_sol_wrapper_c",
                    "get_sol_wrapper_details_c",
                    "get_sol_wrapper_x_c",
                    "init_guess1_c",
                    "init_guess2_c",
                    "init_guess3_c",
                    "solve_c",
                    "eval_s_sol_c",
                    "eval_v_sol_c",
                    "get_sol_wrapper_params_c",
                    "extend_sol_s_c",
                    "extend_sol_e_c",
                )
            )
        ),
        help_bvpsol_compile,
        help_bvpsol_license,
    )
)

# vim:syn=julia:cc=79:fdm=indent:

# User-friendly method for calling solvers

"""macro for importing odecall."""
macro import_odecall()
    return :(
        using ODEInterface: odecall
    )
end

"""
Solvers where OPT_OUTPUTATTIMES is needed for the get the solution
at predefined times.
"""
const solvers_outputattimes = (ddeabm, ddeabm_i32, ddebdf, ddebdf_i32)

"""
    function odecall(solver, rhs, t::Vector, x0::Vector,
                    opt::AbstractOptionsODE)
        -> (tVec,xVec,retcode,stats)

Calls `solver` with the given right-hand side `rhs`.
There are two cases:

1. `2==length(t)`
1. `2<length(t)`

If `2==length(t)`, then in the output `tVec` consists of the time points the
(adaptive) solver has automatically chosen. And the `xVec` has the
states at this times. So: `tVec` is a `Vector{Float64}(m)` and
`xVec` is a `Array{Float64}(m,length(x0))`.

If `2<length(t)`, then the values in `t` must be strictly ascending
or strictly descending. Then a special output function is used to get
the numerical solution at the given `t`-values. In this case
`tVec` is a `Vector{Float64}(length(t))` and
`xVec` is a `Array{Float64}(length(t),length(x0))`.

If in `opt` a output function is given, then this output function is
also called/used.
"""
function odecall(
        solver, rhs, t::Vector, x0::Vector,
        opt::AbstractOptionsODE
    )
    tLen = length(t)
    tLen < 2 && throw(
        ArgumentErrorODE(
            "t must have 2 or more elements; found $tLen", :t
        )
    )
    try
        t = getVectorCheckLength(t, Real, tLen)
    catch e
        throw(ArgumentErrorODE("Cannot convert to to Vector{Real}", :t, e))
    end

    t0 = t[1];  T = t[end]
    t0 == T && throw(ArgumentErrorODE("t[1]==t[end]", :t))
    d = length(x0)
    locopt = OptionsODE(opt)
    orig_outputfcn = getOption(opt, OPT_OUTPUTFCN, nothing)
    orig_outputmode = getOption(opt, OPT_OUTPUTMODE, OUTPUTFCN_NEVER)

    if 2 == tLen
        tVec = Vector{Float64}()    # we do not know how many steps/points
        xVec = Vector{Float64}()    # the solver will use => tVec and xVec grow

        #             orig    │       local
        #          ───────────┼────────────────
        #             NEVER   │       WODENSE
        #            WODENSE  │       WODENSE
        #             DENSE   │       DENSE
        orig_outputmode != OUTPUTFCN_DENSE &&
            setOption!(locopt, OPT_OUTPUTMODE, OUTPUTFCN_WODENSE)

        # save only grid points of solver in tVec, xVec
        function outputfcn_save(
                reason::OUTPUTFCN_CALL_REASON,
                told::Float64, tnew::Float64, x::Vector{Float64},
                eval_sol_fcn::Function, extra_data::Dict
            )

            if reason == OUTPUTFCN_CALL_STEP
                push!(tVec, tnew); append!(xVec, x)
            end
            if orig_outputmode == OUTPUTFCN_NEVER || orig_outputfcn === nothing
                return OUTPUTFCN_RET_CONTINUE
            else
                return orig_outputfcn(reason, told, tnew, x, eval_sol_fcn, extra_data)
            end
        end
        setOption!(locopt, OPT_OUTPUTFCN, outputfcn_save)
    else
        s = sign(T - t0)   # direction: forward or backward in time
        if any(x -> sign(x) != s, diff(t))
            throw(
                ArgumentErrorODE(
                    string(
                        "Because sign(T-t0)=sign($T-$t0)=$s ",
                        "the vector t has to be ", (T ≥ t0 ? "ascending" : "descending"),
                        ". But this is not the case."
                    ), :t
                )
            )
        end
        # We know the size of tVec and xVec (if the solver completes)
        # If not (e.g. stopped by output function) => init with NaN
        tVec = ones(tLen) * NaN; xVec = ones(tLen * d) * NaN
        tPos = 1  # next position to check in output fcn

        function outputfcn_attimes(
                reason::OUTPUTFCN_CALL_REASON,
                told::Float64, tnew::Float64, x::Vector{Float64},
                eval_sol_fcn::Function, extra_data::Dict
            )
            if (reason == OUTPUTFCN_CALL_STEP)
                tVec[tPos] = tnew
                xVec[(1 + (tPos - 1) * d):(tPos * d)] = x
                tPos += 1
            end
            if orig_outputmode == OUTPUTFCN_NEVER || orig_outputfcn === nothing
                return OUTPUTFCN_RET_CONTINUE
            else
                return orig_outputfcn(reason, told, tnew, x, eval_sol_fcn, extra_data)
            end
        end

        function outputfcn_givent(
                reason::OUTPUTFCN_CALL_REASON,
                told::Float64, tnew::Float64, x::Vector{Float64},
                eval_sol_fcn::Function, extra_data::Dict
            )

            if (reason == OUTPUTFCN_CALL_STEP)
                while (tPos ≤ tLen) &&
                        ((told ≤ t[tPos] ≤ tnew) || (told ≥ t[tPos] ≥ tnew))
                    tVec[tPos] = t[tPos]
                    xVec[(1 + (tPos - 1) * d):(tPos * d)] = eval_sol_fcn(t[tPos])
                    tPos += 1
                end
            end
            if orig_outputmode == OUTPUTFCN_NEVER || orig_outputfcn === nothing
                return OUTPUTFCN_RET_CONTINUE
            else
                return orig_outputfcn(reason, told, tnew, x, eval_sol_fcn, extra_data)
            end
        end
        if solver in solvers_outputattimes
            setOption!(locopt, OPT_OUTPUTMODE, OUTPUTFCN_WODENSE)
            setOption!(locopt, OPT_OUTPUTATTIMES, t[2:(end - 1)])
            setOption!(locopt, OPT_OUTPUTFCN, outputfcn_attimes)
        else
            setOption!(locopt, OPT_OUTPUTMODE, OUTPUTFCN_DENSE)
            setOption!(locopt, OPT_OUTPUTFCN, outputfcn_givent)
        end
    end

    (tout, xout, retcode, stats) = solver(rhs, t0, T, x0, locopt)

    return (tVec, transpose(reshape(xVec, d, length(xVec) ÷ d)), retcode, stats)

end

# vim:syn=julia:cc=79:fdm=indent:

# Check if all the packages are installed or not
cond = "Gadfly" in keys(Pkg.installed()) &&
    "Colors" in keys(Pkg.installed()) &&
    "ODEInterface" in keys(Pkg.installed());
@assert cond "Please check if the following package(s) are installed:\
    Gadfly\
    Colors\
    ODEInterface"

# Load all the required packages
using Gadfly
using Colors
using ODEInterface
@ODEInterface.import_huge
loadODESolvers();

######################## Function for saving plots #################################
# Input:
# fileName = Name of the file where the plot is to be stored
#            (with or without extension)
# f_e = Array containing function evaluations as columns for each solver
# err = Array containing errors as columns for each solver
# solverNames = Array containing the names of solvers used in respective order
# plotSize = size of the plot to be created
#
# Values have been tuned for a graph similar to the one in
# Solving Ordinary Differential Equations I by
# Hairer, Ernst, Nørsett, Syvert P., Wanner, Gerhard
# page: 252
###################################################################################
function savePlotPNG(
        fileName, f_e, err, solverNames,
        plotSize = [30cm, 30cm]
    )

    numOfLayers = length(solverNames)

    if !contains(fileName, ".")
        fileName = string(fileName, ".png")
    end

    plotColorsHex = [
        "#4D4D4D", "#5DA5DA", "#FAA43A", "#60BD68",
        "#F17CB0", "#B2912F", "#B276B2", "#DECF3F", "#F15854",
    ]
    plotColors = [parse(Colorant, c) for c in plotColorsHex]

    majorFontSize = 24pt
    minorFontSize = 20pt
    pointSize = 5pt

    myplot = plot(
        Scale.x_log10, Scale.y_log10,
        Coord.cartesian(xmin = -13, xmax = 0, xflip = true, ymin = 2, ymax = 4.5),
        Guide.manual_color_key("Legend", solverNames, plotColorsHex[1:numOfLayers]),
        Guide.xlabel("error"), Guide.ylabel("#Function Evaluations"),
        Guide.xticks(ticks = [0:-3:-13;]), Guide.yticks(ticks = [2:1:4.5;]),
        Theme(
            major_label_font_size = majorFontSize, panel_stroke = colorant"black",
            minor_label_font_size = minorFontSize, key_title_font_size = majorFontSize,
            key_label_font_size = minorFontSize, key_position = :top, key_max_columns = 1
        )
    )

    for i in 1:numOfLayers
        push!(
            myplot, layer(
                x = err[:, i], y = f_e[:, i], Geom.point, Geom.path,
                Theme(default_color = plotColors[i], default_point_size = pointSize)
            )
        )
    end

    draw(PNG(fileName, plotSize[1], plotSize[2]), myplot)
    return nothing
end

# Define the system of ODEs
function threebody(t, x, dx)
    mu = 0.012277471; ms = 1 - mu
    r1 = vecnorm(x[1:2] - [-mu, 0])
    r2 = vecnorm(x[1:2] - [ms, 0])

    dx[1] = x[3]
    dx[2] = x[4]
    dx[3] = x[1] + 2 * x[4] - ms * (x[1] + mu) / r1^3 - mu * (x[1] - ms) / r2^3
    dx[4] = x[2] - 2 * x[3] - ms * x[2] / r1^3 - mu * x[2] / r2^3

    return nothing
end

# Flag to check if all solvers were successful
printFlag = true;

# Initial conditions
t0 = 0.0; T = 17.06521656015796; x0 = [0.994, 0.0, 0.0, -2.001585106379082];

# Get "reference solution"
opt = OptionsODE(
    OPT_EPS => 1.11e-16, OPT_RHS_CALLMODE => RHS_CALL_INSITU,
    OPT_RTOL => 1.0e-16, OPT_ATOL => 1.0e-16
);
(t, x_ref, retcode, stats) = dop853(threebody, t0, T, x0, opt);

if retcode != 1
    println("Reference solution failed")
else
    # Initialization for the loop
    # f_e = function evaluations
    f_e = zeros(Int32, 89, 3)
    # err = error for last step using infinity norm
    err = zeros(Float64, 89, 3)

    # solverNames = names of the solvers used for the plot
    solverNames = ["DOPRI5", "DOP853", "ODEX"]

    # Compute all the solutions
    for i in 0:88

        # Set up the tolerance
        Tol = 10^(-3 - i / 8)

        # Set up solver options
        opt = OptionsODE(
            OPT_EPS => 1.11e-16, OPT_RHS_CALLMODE => RHS_CALL_INSITU,
            OPT_RTOL => Tol, OPT_ATOL => Tol
        )

        # Solve using DOPRI5
        (t, x, retcode, stats) = dopri5(threebody, t0, T, x0, opt)
        # Check if solver was successful
        if retcode != 1
            printFlag = false
            break
        end
        f_e[i + 1, 1] = stats.vals[13]
        err[i + 1, 1] = norm(x_ref[1:2] - x[1:2], Inf)

        (t, x, retcode, stats) = dop853(threebody, t0, T, x0, opt)
        if retcode != 1
            printFlag = false
            break
        end
        f_e[i + 1, 2] = stats.vals[13]
        err[i + 1, 2] = norm(x_ref[1:2] - x[1:2], Inf)

        (t, x, retcode, stats) = odex(threebody, t0, T, x0, opt)
        if retcode != 1
            printFlag = false
            break
        end
        f_e[i + 1, 3] = stats.vals[13]
        err[i + 1, 3] = norm(x_ref[1:2] - x[1:2], Inf)
    end

    # Save the plot in PNG format
    if printFlag
        savePlotPNG("ArenstorfConvTest", f_e, err, solverNames)
    else
        println("Cannot generate plot due to solver failure.")
    end
end

# Dynamic loading of ODE-Solvers for ODEInterface

import Libdl

"""
macro for importing (un-)load functions.
"""
macro import_dynamicload()
    return :(
        using ODEInterface: loadODESolvers, unloadODESolvers
    )
end

"""
Type describing a dynamically loaded method.
"""
struct MethodDLinfo
    generic_name::AbstractString     # input for trytoloadmethod
    methodname_found::AbstractString     # variant of generic_name found
    method_ptr::Ptr{Cvoid}         # pointer to method/code
    error                                  # error if there was one
end

"""
Type describing the "dynamic parts" of a solver.
"""
struct SolverDLinfo
    libname::AbstractString     # the name of the dynamic library
    libfilepath::AbstractString     # path to lib, result of find_library
    libhandle::Ptr{Cvoid}         # handle of lib, result of dlopen
    # an immutable Dict is missing ...
    methods::Tuple              #   ... Tuple of MethodDLinfo
    error                                  # error if there was one
end

"""
global Dict saving information of all loaded solvers.
"""
global const dlSolversInfo = Dict{AbstractString, SolverDLinfo}()

"""
     function trytoloadlib(name::AbstractString,extrapaths::Vector)

tries to (dynamically) load the given shared library given by name.

if `ame="name"` then all the following variants will be tried:
`"name"`, `"NAME"`, `"Name"`

returns `(ptr,filepath)`
"""
function trytoloadlib(name::AbstractString, extrapaths::Vector)
    ptr = C_NULL

    trylist = [name, uppercase(name), uppercasefirst(name)]
    filepath = Libdl.find_library(trylist, extrapaths)
    if isempty(filepath)
        throw(
            ErrorException(
                "Cannot find one of $trylist in libpaths or in $extrapaths"
            )
        )
    end
    ptr = Libdl.dlopen(filepath)
    return (ptr, filepath)
end

"""
     function trytofindjlllib(name::AbstractString)

tries to find the library-handle and the filepath-info for the given
solver lib-name in the ODEInterface_jll module.

The ODEInterface_jll modules must be loaded before.

returns `(ptr, filepath)`
"""
function trytofindjlllib(name::AbstractString)
    ptr_name = Symbol("lib" * name * "_handle")
    filepath_name = Symbol("lib" * name * "_path")

    # Access ODEInterface_jll - it's imported at module level by loadODESolvers
    # Use @eval to access the module reference
    ptr = @eval getproperty(ODEInterface_jll, $(QuoteNode(ptr_name)))::Ptr{Nothing}
    filepath = @eval getproperty(ODEInterface_jll, $(QuoteNode(filepath_name)))::AbstractString
    return (ptr, filepath)
end

"""
     function trytoloadmethod(libhandle::Ptr{Cvoid},
           method_name::AbstractString) -> (ptr,namefound)

tries to find the given method by name in a dynamically loaded library.

if `method_name="name"` then the following variants will be tried:
`"name"`, `"NAME"`, `"Name"`,
`"name_"`, `"NAME_"`, `"Name_"`,
`"_name"`, `"_NAME"`, `"_Name"`,
`"_name_"`, `"_NAME_"`, `"_Name_"`
"""
function trytoloadmethod(libhandle::Ptr{Cvoid}, method_name::AbstractString)
    namefound = ""
    name_vars = (
        method_name, uppercase(method_name),
        uppercasefirst(method_name),
    )
    trylist = tuple(
        name_vars...,
        map(x -> string(x, "_"), name_vars)...,
        map(x -> string("_", x), name_vars)...
    )
    ptr = C_NULL
    for name in trylist
        ptr = Libdl.dlsym_e(libhandle, name)
        if (ptr != C_NULL)
            namefound = name
            break
        end
    end
    ptr == C_NULL &&
        throw(ErrorException("Cannot find one of the methods $trylist"))
    return (ptr, namefound)
end

"""
     function loadODESolvers(extrapaths::Vector=AbstractString[],
               loadlibnames::Tuple=(); ignore_jll=false )

tries to (dynamically) load the libraries for the solvers.

## case: use ODEInterface_jll
If the julia version is 1.3 or higher and `ignore_jll` is false (the default)
then this method only tries to use `ODEInterface_jll`. In this case
the extrapaths-argument is ignored/useless.

## case: don't use `ODEInterface_jll`
If the julia version is less than 1.3 or `ignore_jll` is true then this
method tries to (dynamically) load the libraries. Then in the
extrapathas argument additional locations/paths to look at can be given.

If the 1st argument is an empty Vector, then the method tries to
find the path of the ODEInterface module and (if successful)
uses this path as `extrapaths`.

## load only some libraries
The 2nd argument is a `Tuple` with libnames of solvers to load.
If it is an empty tuple, then all known solvers will be tried.

If an solver is already successfully loaded, then it will *not* be
loaded again.

returns `Dict` with information about the loaded solvers (and errors).

If a solver cannot be found (or needed methods inside a dynamic library
cannot be found) then the errors are not propagated to the caller. The
errors and exceptions are saved in the returned `Dict`. Why? Using this
way, it is possible to see with one call (and try to load all solvers)
which solvers are found.

You can simply `dump` the values of the output dict to get a human-readable
form of the result or call `help_solversupport()`.

     for k in keys(res); dump(res[k]); end
     ODEInterface.help_solversupport()
"""
function loadODESolvers(
        extrapaths::Vector = AbstractString[],
        loadlibnames::Tuple = (); ignore_jll = false
    )
    if isempty(extrapaths)
        extrapaths = [@__DIR__]
    end
    use_jll = VERSION >= v"1.3" && !ignore_jll
    for solver in solverInfo
        for variant in solver.variants
            libname = variant.libname
            if isempty(loadlibnames) || libname ∈ loadlibnames
                if !haskey(dlSolversInfo, libname) ||
                        nothing ≠ dlSolversInfo[libname].error

                    libhandle = C_NULL; filepath = ""; err = nothing
                    mArray = Vector{MethodDLinfo}()
                    try
                        (libhandle, filepath) = (
                            use_jll ? trytofindjlllib(libname) :
                                trytoloadlib(libname, extrapaths)
                        )
                        for generic_name in variant.methods
                            methodsname_found = ""; method_ptr = C_NULL; merr = nothing
                            try
                                (method_ptr, methodsname_found) =
                                    trytoloadmethod(libhandle, generic_name)
                            catch e
                                merr = e
                            end
                            push!(
                                mArray, MethodDLinfo(
                                    generic_name, methodsname_found, method_ptr, merr
                                )
                            )
                        end
                    catch e
                        err = e
                    end
                    dlSolversInfo[libname] = SolverDLinfo(
                        libname, filepath, libhandle, tuple(mArray...), err
                    )
                end
            end
        end
    end

    return copy(dlSolversInfo)
end

"""
     function unloadODESolvers()

unload all (loaded) solvers.
"""
function unloadODESolvers()
    all_keys = collect(keys(dlSolversInfo))
    for key in all_keys
        libhandle = dlSolversInfo[key].libhandle
        libhandle ≠ C_NULL && Libdl.dlclose(libhandle)
        delete!(dlSolversInfo, key)
    end
    return nothing
end

"""
return all method-pointers for a solver.

tries to return all `method_ptr`s for all methods of a solver.
This method checks if the `method_ptr`s are existent and different
from `C_NULL`. If not then this method tries to load the
`dlname` ODE-Solver with the `loadODESolvers` method and checks again.
If even after this the `method_ptr`s are not found a exception is thrown.

see `loadODESolvers`.
"""
function getAllMethodPtrs(dlname::AbstractString)
    load_tried = false
    ret = Vector{Ptr{Cvoid}}()
    while true
        try
            empty!(ret)
            @assert dlSolversInfo[dlname].error === nothing
            for method in dlSolversInfo[dlname].methods
                @assert method.method_ptr ≠ C_NULL
                push!(ret, method.method_ptr)
            end
            break
        catch e
            if load_tried
                throw(
                    SolverODEnotLoaded(
                        string(
                            "Cannot find method(s) for $(dlname)! ",
                            "I've tried to loadODESolvers(), but it didn't work. ",
                            "Please check ODEInterface.help_solversupport() and ",
                            "call loadODESolvers and check also this output. ",
                            "For further information see also ODEInterface.help_install."
                        )
                    )
                )
            else
                loadODESolvers([], (dlname,)); load_tried = true
            end
        end
    end
    return ret
end

# vim:syn=julia:cc=79:fdm=indent:

using ODEInterface
@ODEInterface.import_huge

loadODESolvers()

opt=OptionsODE(
  OPT_RTOL => 1e-8,
  OPT_ATOL => 1e-3)

(t,x,retcode,stats) = odecall( dopri5, (t,x) -> x, [0,1],[1,2], opt)

println("retcode=$retcode")
println("t=$t");
println("x=",x);
println("stats:");display(stats);println();


# vim:syn=julia:cc=79:fdm=indent:

using ODEInterface
@ODEInterface.import_huge

loadODESolvers()

opt = OptionsODE(
    OPT_RTOL => 1.0e-8,
    OPT_ATOL => 1.0e-3
)

(t, x, retcode, stats) = odecall(
    dopri5_i32, (t, x) -> x,
    collect(linspace(0, 1, 15)), [1, 2], opt
)

println("retcode=$retcode")
println("t=$t");
println("x=", x);
println("stats:");display(stats);println();


# vim:syn=julia:cc=79:fdm=indent:

# This is a "hack" to automatically produce some doc files for github
# using julia's doc-strings.
using Markdown

using ODEInterface
@ODEInterface.import_huge

const NL = "\n"

# takebuf_string deprecation: 358c4419
if VERSION < v"0.6.0-dev+1254"
    buf2str(buf) = takebuf_string(buf)
else
    buf2str(buf) = String(take!(buf))
end

"""
escapes characters with "&#...;" HTML-notation.
"""
function escapeChars(s::AbstractString, toreplace = r"([^a-zA-Z0-9 \n])")
    return replace(s, toreplace => c -> string("&#", Int(c[1]), ";"))
end

formatTable_new_row_for_nl = false

"""
try to convert the Unicode doc-tables to HTML-tables.
"""
function formatTable(io, s::AbstractString)
    table_head = true
    std_line_content = r"^\s*║([^║]+)║\s*$"m
    head_stop = r"^\s*╠[═╪]+╣\s*$"m
    row_stop = r"^\s*(╟[─┼]+╢|╚[═╧]+╝)\s*"m

    write(io, "<table>", NL)

    lines = split(s, "\n")
    columns = Vector{IOBuffer}(undef, length(split(lines[1], "╤")))
    for k in 1:length(columns)
        columns[k] = IOBuffer()
    end
    write_row = false
    for line in lines[2:end]
        mo = match(std_line_content, line)
        if mo !== nothing
            contents = split(mo[1], "│")
            @assert length(contents) == length(columns)
            for (col, content) in zip(columns, contents)
                data = rstrip(content)
                if length(data) > 0
                    write(col, escapeChars(data), NL)
                end
            end
        end
        mo = match(head_stop, line)
        if mo !== nothing
            @assert table_head
            write_row = true
        end
        mo = match(row_stop, line)
        if mo !== nothing
            write_row = true
        end
        if !table_head && formatTable_new_row_for_nl
            write_row = true
        end
        if write_row
            write(io, "<tr>")
            for col in columns
                write(
                    io, table_head ? "<th>" : "<td>",
                    "<pre>", buf2str(col), "</pre>",
                    table_head ? "</th>" : "</td>", NL
                )
            end
            write(io, "</tr>", NL)
            write_row = false; table_head = false
        end
    end
    write(io, "</table>", NL)
    return nothing
end

function formatMDelement(io, e::Markdown.MD)
    for element in e.content
        formatMDelement(io, element)
        write(io, "\n")
    end
    return nothing
end

function formatMDelement(io, code::Markdown.Code)
    table_check = r"^\s*[╔══╤╗]+\s*$"m
    if occursin(table_check, code.code)
        formatTable(io, code.code)
    else
        Markdown.plain(io, code)
    end
    return nothing
end

function formatMDelement(io, rest::Any)
    Markdown.plain(io, rest)
    return nothing
end

function introHeader(io)
    write(
        io, "[ This file was auto-generated from the module's documentation ",
        "included in the doc-strings. Use julia's help system to get ",
        "these information in a nicer output format. ]", NL, NL
    )
    return nothing
end

function docSolverOptions(filename)
    io = open(filename, "w")
    introHeader(io)
    namewomodule = r"\.([^.]+)$"

    for solver in (dopri5, dop853, odex, seulex, rodas, ddeabm, ddebdf)
        solvername = string(solver)
        mo = match(namewomodule, solvername)
        if mo !== nothing
            solvername = mo[1]
        end
        write(io, "# ", solvername, NL, NL)
        formatMDelement(io, Base.Docs.doc(solver))
    end
    # radau5 and radau share same documentation
    write(io, "# radau and radau5", NL, NL)
    formatMDelement(io, Base.Docs.doc(radau))

    # bvpsol
    write(io, "# bvpsol", NL, NL)
    formatMDelement(io, Base.Docs.doc(bvpsol))

    # colnew
    write(io, "# colnew", NL, NL)
    formatMDelement(io, Base.Docs.doc(colnew))

    # bvpm2
    write(io, "# bvpm2", NL, NL)
    formatMDelement(io, Base.Docs.doc(Bvpm2))
    formatMDelement(io, Base.Docs.doc(bvpm2_init))
    formatMDelement(io, Base.Docs.doc(bvpm2_solve))

    close(io)
    return nothing
end

function docstringToFile(filename, docobjs)
    io = open(filename, "w")
    introHeader(io)
    for docobj in docobjs
        md_elem = isa(docobj, Markdown.MD) ? docobj : Base.Docs.doc(docobj)
        formatMDelement(io, md_elem)
        write(io, NL)
    end
    close(io)
    return nothing
end


docSolverOptions("./SolverOptions.md")

formatTable_new_row_for_nl = true
docstringToFile(
    "./OptionOverview.md", [
        ODEInterface.help_options, ODEInterface.help_options(),
    ]
)
formatTable_new_row_for_nl = false

docstringToFile("./OutputFunction.md", [ODEInterface.help_outputfcn])
docstringToFile("./SpecialStructure.md", [ODEInterface.help_specialstructure])
docstringToFile(
    "./CallSolvers.md", [
        ODEInterface.help_callsolvers, ODEInterface.odecall,
    ]
)

# vim:syn=julia:cc=79:fdm=indent:

# Check if all the packages are installed or not
cond = "Gadfly" in keys(Pkg.installed()) &&
"Colors" in keys(Pkg.installed()) &&
"ODEInterface" in keys(Pkg.installed());
@assert cond "Please check if the following package(s) are installed:\
    Gadfly\
    Colors\
    ODEInterface"

# Load all the required packages
using Gadfly
using Colors
using ODEInterface
@ODEInterface.import_huge
loadODESolvers();

######################## Function for saving plots #################################
# Input:
# fileName = Name of the file where the plot is to be stored
#            (with or without extension)
# f_e = Array containing function evaluations as columns for each solver
# err = Array containing erros as columns for each solver
# solverNames = Array containing the names of solvers used in respective order
# plotSize = size of the plot to be created
# 
# Values have been tuned for a graph similar to the one in 
# Solving Ordinary Differential Equations I by
# Hairer, Ernst, Nørsett, Syvert P., Wanner, Gerhard
# page: 252
###################################################################################
function savePlotPNG(fileName,f_e,err,solverNames,
    plotSize=[30cm,30cm])
    
    numOfLayers = length(solverNames);
    
    if !contains(fileName,".")
        fileName = string(fileName,".png");
    end
    
    plotColorsHex = ["#4D4D4D","#5DA5DA","#FAA43A","#60BD68",
        "#F17CB0","#B2912F","#B276B2", "#DECF3F","#F15854"];
    plotColors = [parse(Colorant,c) for c in plotColorsHex];
    
    majorFontSize = 24pt;
    minorFontSize = 20pt;
    pointSize = 5pt;
    
    myplot = plot(Scale.x_log10,Scale.y_log10,
        Coord.cartesian(xflip=true),
        Guide.manual_color_key("Legend",solverNames,plotColorsHex[1:numOfLayers]),
        Guide.xlabel("error"),Guide.ylabel("#Function Evaluations"),
        Guide.xticks(ticks=[0:-3:-13;]),Guide.yticks(ticks=[3:1:5.1;]),
        Theme(major_label_font_size=majorFontSize,panel_stroke=colorant"black",
        minor_label_font_size=minorFontSize,key_title_font_size=majorFontSize,
        key_label_font_size=minorFontSize,key_position=:top,key_max_columns=1));
    
    for i = 1:numOfLayers
        push!(myplot,layer(x=err[:,i],y=f_e[:,i],Geom.point,Geom.path,
        Theme(default_color=plotColors[i],default_point_size=pointSize)));
    end
    
    draw(PNG(fileName,plotSize[1],plotSize[2]),myplot)
    return nothing
end

# Number of subdivisions of the rope
global n = 40;

# Define the system of ODEs
function rope(t,x,dx)
    n2 = n*n; # n^2
    n3by4 = convert(Int64,3*n/4); # 3*n/4
    
    # Force in x-direction
    Fx = 0.4;
    # Force in y-direction
    Fy = cosh(4*t-2.5)^(-4);
    
    # Compute required matrices
    c = -cos(x[1:n-1]-x[2:n]);
    cDiag = [1;2*ones(n-2);3];
    C = spdiagm((c,cDiag,c),(-1,0,1));
    
    d = -sin(x[1:n-1]-x[2:n]);
    D = spdiagm((-d,d),(-1,1));
    
    # Compute the inhomogeneous term
    v = -(n2+n/2-n*[1:n;]).*sin(x[1:n])-n2*sin(x[1:n])*Fx;
    v[1:n3by4] = v[1:n3by4] + n2*cos(x[1:n3by4])*Fy; 
    
    w = D*v+x[n+1:2*n].^2;
    u = C\w;
    
    # Write down the system
    dx[1:n] = x[n+1:2*n];
    dx[n+1:2*n] = C*v + D*u;
    
    return nothing
end

# Initial Conditions
t0 = 0.0; T = 3.723; x0=zeros(2*n);

# Compute the "reference solution"
opt = OptionsODE(OPT_EPS => 1.11e-16,OPT_RHS_CALLMODE => RHS_CALL_INSITU,
OPT_RTOL => 1e-16,OPT_ATOL=>1e-16);
(t,x_ref,retcode,stats) = dop853(rope,t0, T, x0, opt);

if retcode != 1
    println("Reference solution failed")
else
    # Initialization for the loop
    # f_e = function evaluations
    f_e = zeros(Int32,89,3);
    # err = error for last step using infinity norm
    err = zeros(Float64,89,3);

    # solverNames = names of the solvers used for the plot
    solverNames = ["DOPRI5","DOP853","ODEX"];

    # Compute all the solutions
    for i=0:88
        
        # Set up the tolerance
        Tol = 10^(-3-i/8);
        
        # Set up solver options
        opt = OptionsODE(OPT_EPS => 1.11e-16,OPT_RHS_CALLMODE => RHS_CALL_INSITU,
        OPT_RTOL => Tol,OPT_ATOL => Tol);

        # Solve using DOPRI5
        (t,x,retcode,stats) = dopri5(rope,t0, T, x0, opt);
        # Check if solver was successful
        if retcode != 1
            printFlag = false;
            break;
        end
        f_e[i+1,1] = stats.vals[13];
        err[i+1,1] = norm(x_accurate[1:n] - x[1:n],Inf);

        # Solve using DOP853
        (t,x,retcode,stats) = dop853(rope,t0, T, x0, opt);
        # Check if solver was successful
        if retcode != 1
            printFlag = false;
            break;
        end
        f_e[i+1,2] = stats.vals[13];
        err[i+1,2] = norm(x_accurate[1:n] - x[1:n],Inf);

        # Solve using ODEX
        (t,x,retcode,stats) = odex(rope,t0, T, x0, opt);
        # Check if solver was successful
        if retcode != 1
            printFlag = false;
            break;
        end
        f_e[i+1,3] = stats.vals[13];
        err[i+1,3] = norm(x_accurate[1:n] - x[1:n],Inf);
    end

    # Save the plot in PNG format
    if printFlag
        savePlotPNG("RopeConvTest",f_e,err,solverNames);
    else
        println("Cannot generate plot due to solver failure")
    end
end

using ODEInterface
@ODEInterface.import_huge

loadODESolvers()

function myoutputfcn(reason, told, t, x, eval_sol_func, extra_data)
    if reason == OUTPUTFCN_CALL_STEP
        tmid = told + 0.5 * (t - told)
        xmid = eval_sol_func(tmid)
        # xmid ignored, call is just there, to show logging messages
    end
    return OUTPUTFCN_RET_CONTINUE
end

opt = OptionsODE(
    OPT_RTOL => 1.0e-8,
    OPT_ATOL => 1.0e-3,
    OPT_OUTPUTFCN => myoutputfcn,
    OPT_OUTPUTMODE => OUTPUTFCN_DENSE,
    OPT_LOGIO => STDOUT,
    OPT_LOGLEVEL => LOG_GENERAL | LOG_SOLOUT | LOG_EVALSOL,
)

(t, x, retcode, stats) = odecall(dop853, (t, x) -> x, [0, 2], [1, 2], opt)

println("retcode=$retcode")
println("t=$t");
println("x=", x);
println("stats:");display(stats);println();


# vim:syn=julia:cc=79:fdm=indent:

# Functions common for all Dopri-Solvers

"""
Type encapsulating all required data for Dopri-Solver-Callbacks.

We have the typical calling stack:

     dopri5/dop853
         call_julia_output_fcn(  ... INIT ... )
             output_fcn ( ... INIT ...)
         ccall( DOPRI5_/DOP853_ ... )
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_HW1RHSCallback                      │  ⎬ cb. rhs
            │    rhs                                    │  ⎪
            └───────────────────────────────────────────┘  ⎭
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_dopriSoloutCallback                 │  ⎪
            │    call_julia_output_fcn( ... STEP ...)   │  ⎪ cb. solout
            │        output_fcn ( ... STEP ...)         │  ⎬ with eval
            │            eval_sol_fcn                   │  ⎪
            │                ccall(CONTD5_/CONTD8_ ... )│  ⎪
            └───────────────────────────────────────────┘  ⎭
         call_julia_output_fcn(  ... DONE ... )
             output_fcn ( ... DONE ...)
"""
mutable struct DopriInternalCallInfos{
        FInt <: FortranInt,
        RHS_F, OUT_F,
    } <: ODEinternalCallInfos
    logio::IO                    # where to log
    loglevel::UInt64                # log level
    # RHS:
    rhs::RHS_F                 # right-hand-side
    rhs_mode::RHS_CALL_MODE         # how to call rhs
    rhs_lprefix::AbstractString        # saved log-prefix for rhs
    # SOLOUT & output function
    output_mode::OUTPUTFCN_MODE        # what mode for output function
    output_fcn::OUT_F                 # the output function to call
    output_data::Dict                  # extra_data for output_fcn
    out_lprefix::AbstractString        # saved log-prefix for solout
    eval_sol_fcn::Function              # eval_sol_fcn (for output_fcn)
    eval_lprefix::AbstractString        # saved log-prefix for eval_sol
    tOld::Float64               # tOld and
    tNew::Float64               # tNew and
    xNew::Vector{Float64}       # xNew of current solout interval
    cont_i::Vector{FInt}          # argument to contd5/contd8
    cont_s::Vector{Float64}       # argument to contd5/contd8
    cont_con::Ptr{Float64}          # saved pointers for contd5/contd8
    cont_icomp::Ptr{FInt}             # saved pointers for contd5/contd8
    cont_nd::Ptr{FInt}             # saved pointers for contd5/contd8
end

"""
     mutable struct DopriArguments{FInt<:FortranInt} <:
              AbstractArgumentsODESolver{FInt}

Stores Arguments for Dopri solver.

FInt is the Integer type used for the fortran compilation.
"""
mutable struct DopriArguments{FInt <: FortranInt} <: AbstractArgumentsODESolver{FInt}
    N::Vector{FInt}      # Dimension
    FCN::Ptr{Cvoid}        # rhs callback
    t::Vector{Float64}   # start time (and current)
    tEnd::Vector{Float64}   # end time
    x::Vector{Float64}   # initial value (and current state)
    RTOL::Vector{Float64}   # relative tolerance
    ATOL::Vector{Float64}   # absolute tolerance
    ITOL::Vector{FInt}      # switch for RTOL, ATOL
    SOLOUT::Ptr{Cvoid}        # solout callback
    IOUT::Vector{FInt}      # switch for SOLOUT
    WORK::Vector{Float64}   # double working array
    LWORK::Vector{FInt}      # length of WORK
    IWORK::Vector{FInt}      # integer working array
    LIWORK::Vector{FInt}      # length of IWORK
    RPAR::Vector{Float64}   # add. double-array
    IPAR::Ref{DopriInternalCallInfos} # misuse IPAR
    IDID::Vector{FInt}      # Status code
    ## Allow uninitialized construction
    function DopriArguments{FInt}(dummy::FInt) where {FInt}
        return new{FInt}()
    end
end

"""
     function create_dopri_eval_sol_fcn_closure( cbi::CI, d::FInt,
             method_contd::Ptr{Cvoid}) where {FInt<:FortranInt,
                                             CI<:DopriInternalCallInfos}

generates a eval_sol_fcn for dopri5 and dop853.

Why is a closure needed? We need a function `eval_sol_fcn`
that calls `CONTD5_` or `CONTD8_` (with `ccall`).
But `CONTD?_` needs the information for the current state. This
information were saved by `unsafe_dopriSoloutCallback` in the
`DopriInternalCallInfos`. `eval_sol_fcn` needs to get this information.
Here comes `create_dopri_eval_sol_fcn_closure` into play: this function
takes the call-information and generates a `eval_sol_fcn` with this data.

Why doesn't `unsafe_dopriSoloutCallback` generate a closure (then
the current state needs not to be saved in `DopriInternalCallInfos`)?
Because then every call to `unsafe_dopriSoloutCallback` would have
generated a closure function. That's a lot of overhead: 1 closure function
for every solout call. With the strategy above, we have 1 closure function
per ODE-solver-call, i.e. 1 closure function per ODE.

For the typical calling sequence, see `DopriInternalCallInfos`.
"""
function create_dopri_eval_sol_fcn_closure(
        cbi::CI, d::FInt,
        method_contd::Ptr{Cvoid}
    ) where {
        FInt <: FortranInt,
        CI <: DopriInternalCallInfos,
    }

    function eval_sol_fcn_closure(s::Float64)
        (lio, l, lprefix) = (cbi.logio, cbi.loglevel, cbi.eval_lprefix)
        l_eval = l & LOG_EVALSOL > 0

        l_eval && println(lio, lprefix, "called with s=", s)
        cbi.cont_s[1] = s
        result = Vector{Float64}(undef, d)
        if s == cbi.tNew
            result[:] = cbi.xNew
            l_eval && println(lio, lprefix, "not calling contd because s==tNew")
        else
            for k in 1:d
                cbi.cont_i[1] = k
                result[k] = ccall(
                    method_contd, Float64,
                    (Ptr{FInt}, Ptr{Float64}, Ptr{Float64}, Ptr{FInt}, Ptr{FInt}),
                    cbi.cont_i, cbi.cont_s, cbi.cont_con, cbi.cont_icomp, cbi.cont_nd
                )
            end
        end

        l_eval && println(lio, lprefix, "contd returned ", result)
        return result
    end
    return eval_sol_fcn_closure
end

"""
     function unsafe_dopriSoloutCallback(
             nr_::Ptr{FInt}, told_::Ptr{Float64}, t_::Ptr{Float64},
             x_::Ptr{Float64}, n_::Ptr{FInt}, con_::Ptr{Float64},
             icomp_::Ptr{FInt}, nd_::Ptr{FInt}, rpar_::Ptr{Float64},
             cbi::CI, irtrn_::Ptr{FInt}) where {FInt<:FortranInt,
                                                CI<:DopriInternalCallInfos}

This is the solout given as callback to Fortran-dopri.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-pointers.

This function saves the state information of the solver in
`DopriInternalCallInfos`, where they can be found by
the `eval_sol_fcn`, see `create_dopri_eval_sol_fcn_closure`.

Then the user-supplied `output_fcn` is called (which in turn can use
`eval_sol_fcn`, to evaluate the solution at intermediate points).

The return value of the `output_fcn` is propagated to
`DOPRI5_` or `DOP853_`.

For the typical calling sequence, see `DopriInternalCallInfos`.
"""
function unsafe_dopriSoloutCallback(
        nr_::Ptr{FInt}, told_::Ptr{Float64}, t_::Ptr{Float64},
        x_::Ptr{Float64}, n_::Ptr{FInt}, con_::Ptr{Float64},
        icomp_::Ptr{FInt}, nd_::Ptr{FInt}, rpar_::Ptr{Float64},
        cbi::CI, irtrn_::Ptr{FInt}
    ) where {
        FInt <: FortranInt,
        CI <: DopriInternalCallInfos,
    }

    nr = unsafe_load(nr_); told = unsafe_load(told_); t = unsafe_load(t_)
    n = unsafe_load(n_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    irtrn = unsafe_wrap(Array, irtrn_, (1,), own = false)

    (lio, l, lprefix) = (cbi.logio, cbi.loglevel, cbi.out_lprefix)
    l_sol = l & LOG_SOLOUT > 0

    l_sol && println(
        lio, lprefix, "called with nr=", nr, " told=", told,
        " t=", t, " x=", x
    )

    cbi.tOld = told; cbi.tNew = t; cbi.xNew = x
    cbi.cont_con = con_; cbi.cont_icomp = icomp_; cbi.cont_nd = nd_
    cbi.output_data["nr"] = nr

    ret = call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_STEP, told, t, x,
        cbi.eval_sol_fcn
    )

    if ret == OUTPUTFCN_RET_STOP
        irtrn[1] = -1
    elseif ret == OUTPUTFCN_RET_CONTINUE
        irtrn[1] = 0
    elseif ret == OUTPUTFCN_RET_CONTINUE_XCHANGED
        irtrn[1] = 2
    else
        throw(InternalErrorODE(string("Unknown ret=", ret, " of output function")))
    end

    return nothing
end

"""
     function unsafe_dopriSoloutCallback_c(cbi::CI,
             fint_flag::FInt) where {FInt,CI}
        -> C-callable function pointer
"""
function unsafe_dopriSoloutCallback_c(
        cbi::CI,
        fint_flag::FInt
    ) where {FInt, CI}
    return @cfunction(
        unsafe_dopriSoloutCallback, Cvoid, (
            Ptr{FInt},
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64},
            Ptr{FInt}, Ptr{Float64},
            Ptr{FInt}, Ptr{FInt}, Ptr{Float64},
            Ref{CI}, Ptr{FInt},
        )
    )
end

"""
     function dopri_extract_commonOpt(
             t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
             args::DopriArguments{FInt}) where FInt<:FortranInt
           -> (d,nrdense,rhs_mode,output_mode,output_fcn)

calls solver_extract_commonOpt and additionally sets args.ITOL, args.IOUT
"""
function dopri_extract_commonOpt(
        t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
        args::DopriArguments{FInt}
    ) where {FInt <: FortranInt}

    (d, nrdense, scalarFlag, rhs_mode, output_mode, output_fcn) =
        solver_extract_commonOpt(t0, T, x0, opt, args)

    args.ITOL = [scalarFlag ? 0 : 1]
    args.IOUT = [
        FInt(
            output_mode == OUTPUTFCN_NEVER ? 0 :
                (output_mode == OUTPUTFCN_DENSE ? 2 : 1)
        ),
    ]

    return (d, nrdense, rhs_mode, output_mode, output_fcn)
end


# vim:syn=julia:cc=79:fdm=indent:

# Common Functions for calling the output function and for dense output

"""macro for importing enums, functions, etc. for output function call."""
macro import_outputfcn()
    return :(
        using ODEInterface: OUTPUTFCN_CALL_REASON,
            OUTPUTFCN_CALL_INIT, OUTPUTFCN_CALL_STEP, OUTPUTFCN_CALL_DONE,
            OUTPUTFCN_MODE,
            OUTPUTFCN_NEVER, OUTPUTFCN_WODENSE, OUTPUTFCN_DENSE,
            OUTPUTFCN_RETURN_VALUE,
            OUTPUTFCN_RET_STOP,
            OUTPUTFCN_RET_CONTINUE, OUTPUTFCN_RET_CONTINUE_XCHANGED
    )
end

@enum(
    OUTPUTFCN_CALL_REASON,
    OUTPUTFCN_CALL_INIT, OUTPUTFCN_CALL_STEP, OUTPUTFCN_CALL_DONE
)

@doc """
Possible reasons for calling the `OPT_OUTPUTFCN`
"""
OUTPUTFCN_CALL_REASON

@doc """`OPT_OUTPUTFCN` is called for 1st time."""
OUTPUTFCN_CALL_INIT

@doc """
`OPT_OUTPUTFCN` is called after a successful
integration step
"""
OUTPUTFCN_CALL_STEP

@doc """`OPT_OUTPUTFCN` is called for the last time."""
OUTPUTFCN_CALL_DONE

@enum(
    OUTPUTFCN_MODE,
    OUTPUTFCN_NEVER, OUTPUTFCN_WODENSE, OUTPUTFCN_DENSE
)

@doc """Possible mode for calling the `OPT_OUTPUTFCN`.

see `OPT_OUTPUTFCN` and `OPT_OUTPUTMODE`"""
OUTPUTFCN_MODE

@doc """`OPT_OUTPUTFCN` is never called."""
OUTPUTFCN_NEVER

@doc """
`OPT_OUTPUTFCN` is called after every successful step,
but no support for dense output.
"""
OUTPUTFCN_WODENSE

@doc """
`OPT_OUTPUTFCN` is called after every successful step
and dense output is supported.
"""
OUTPUTFCN_DENSE

@enum(
    OUTPUTFCN_RETURN_VALUE,
    OUTPUTFCN_RET_STOP,
    OUTPUTFCN_RET_CONTINUE, OUTPUTFCN_RET_CONTINUE_XCHANGED
)

@doc """Possible return values of an `OPT_OUTPUTFCN`.

see `OPT_OUTPUTFCN` and `OPT_OUTPUTMODE`"""
OUTPUTFCN_RETURN_VALUE

@doc """tell ODE solver to stop."""
OUTPUTFCN_RET_STOP

@doc """tell ODE solver to continue."""
OUTPUTFCN_RET_CONTINUE

@doc """
tell ODE solver to continue and inform the solver, that the
`OUTPUTFCN` has altered the numerical solution.
"""
OUTPUTFCN_RET_CONTINUE_XCHANGED

"""
Output function that does nothing and returns `OUTPUTFCN_RET_CONTINUE`.
"""
function output_fcn_donothing(args...)
    return OUTPUTFCN_RET_CONTINUE
end

"""
(Dummy-)eval_sol_function, throwing an error, telling the caller,
that this is the INIT-call of the output function.
"""
function eval_sol_fcn_init(t)
    throw(
        FunctionCallNotSupported(
            string(
                "The julia output function was called with ",
                "reason == OUTPUTFCN_CALL_INIT. During such an init-call there is no",
                "numerical solution available. Hence: no evaluation is possible."
            )
        )
    )
end

"""
(Dummy-)eval_sol_function, throwing an error, telling the caller,
that no evaluation is possible.
"""
function eval_sol_fcn_noeval(t)
    throw(
        FunctionCallNotSupported(
            string(
                "The evaluation of the numerical solution is not possible. ",
                "OPT_OUTPUTMODE == OUTPUTFCN_DENSE is needed and the solver ",
                "needs to support dense output. That's not the case here."
            )
        )
    )
end

"""
(Dummy-)eval_sol_function, throwing an error, telling the caller,
that this is the DONE-call of the output function.
"""
function eval_sol_fcn_done(t)
    throw(
        FunctionCallNotSupported(
            string(
                "The julia output function was called with ",
                "reason == OUTPUTFCN_CALL_DONE. During such a done-call there is no",
                "numerical solution available. Hence: no evaluation is possible."
            )
        )
    )
end

"""
      function call_julia_output_fcn{CI<:ODEinternalCallInfos}(cbi::CI,
        reason:: OUTPUTFCN_CALL_REASON, told::Float64,t::Float64,
        x::Vector{Float64},eval_sol_fcn::Function)

calls the julia output function with the given arguments.

This is more than a simple call, because this function takes care of
logging, error-checking, etc.
"""
function call_julia_output_fcn(
        cbi::CI,
        reason::OUTPUTFCN_CALL_REASON, told::Float64, t::Float64,
        x::Vector{Float64}, eval_sol_fcn::Function
    ) where {CI <: ODEinternalCallInfos}

    lprefix = "call_julia_output_fcn: "

    (lio, l) = (cbi.logio, cbi.loglevel)
    l_out = l & LOG_OUTPUTFCN > 0

    if l_out
        println(
            lio, lprefix, "calling ", cbi.output_fcn, " with reason=", reason,
            " told=", told, " t=", t, " x=", x, " eval_sol_fcn=", eval_sol_fcn,
            " extra_data=", cbi.output_data
        )
    end
    result = cbi.output_fcn(reason, told, t, x, eval_sol_fcn, cbi.output_data)
    try
        @assert isa(result, OUTPUTFCN_RETURN_VALUE)
    catch e
        throw(
            OutputErrorODE(
                "Result was not an OUTPUTFCN_RETURN_VALUE",
                cbi.output_fcn, e
            )
        )
    end
    l_out && println(lio, lprefix, cbi.output_fcn, " returned ", result)
    return result
end

# vim:syn=julia:cc=79:fdm=indent:

using ODEInterface
using Gadfly
using Colors
@ODEInterface.import_huge
loadODESolvers();

function threebody(t, x, dx)
    return with_bigfloat_precision(113) do
        mu = parse(BigFloat, "0.012277471"); ms = 1 - mu
        r1 = vecnorm(x[1:2] - [-mu, 0])
        r2 = vecnorm(x[1:2] - [ms, 0])
        dx[1] = x[3]
        dx[2] = x[4]
        dx[3] = x[1] + 2 * x[4] - ms * (x[1] + mu) / r1^3 - mu * (x[1] - ms) / r2^3
        dx[4] = x[2] - 2 * x[3] - ms * x[2] / r1^3 - mu * x[2] / r2^3

        return nothing
    end
end

set_bigfloat_precision(113);
opt = OptionsODE(OPT_EPS => 1.11e-16, OPT_RTOL => 1.0e-16, OPT_ATOL => 1.0e-16, OPT_RHS_CALLMODE => RHS_CALL_INSITU);

t0 = 0.0; T = parse(BigFloat, "17.0652165601579625588917206249");
x0 = [0.994, 0.0, 0.0, parse(BigFloat, "-2.00158510637908252240537862224")];

(t, x, retcode, stats) = odecall(dop853, threebody, [t0, T], x0, opt);

plotColors = ["black", "#4d5991", "#4bdf8c"];

arenstorfPlot = plot(
    layer(
        x = x[:, 1], y = x[:, 2], Geom.point,
        Theme(default_point_size = 2pt, default_color = parse(Colorant, plotColors[1])), order = 1
    ),
    layer(
        x = [0], y = [0], Geom.point,
        Theme(default_point_size = 10pt, default_color = parse(Colorant, plotColors[2])), order = 2
    ),
    layer(
        x = [0.994], y = [0], Geom.point,
        Theme(default_point_size = 8pt, default_color = parse(Colorant, plotColors[3])), order = 2
    ),
    Theme(
        major_label_font_size = 30pt, panel_stroke = colorant"black", highlight_width = 0.1pt,
        minor_label_font_size = 28pt, key_title_font_size = 30pt, key_label_font_size = 24pt, key_position = :top,
        key_max_columns = 1
    ),
    Coord.Cartesian(xmin = -1.4, xmax = 1.1), Guide.xlabel("x", orientation = :horizontal),
    Guide.manual_color_key("Legend", ["Spaceship", "Earth", "Moon"], ["black", "#4d5991", "#4bdf8c"])
)

draw(SVGJS(30cm, 30cm), arenstorfPlot)

# Functions for ODE-Solver: Odex

"""Name for Loading odex solver (64bit integers)."""
const DL_ODEX = "odex"

"""Name for Loading odex solver (32bit integers)."""
const DL_ODEX_I32 = "odex_i32"

"""macro for import Odex solver."""
macro import_odex()
    return :(
        using ODEInterface: odex, odex_i32
    )
end

"""macro for import Odex dynamic lib names."""
macro import_DLodex()
    return :(
        using ODEInterface: DL_ODEX, DL_ODEX_I32
    )
end

"""macro for importing Odex help."""
macro import_odex_help()
    return :(
        using ODEInterface: help_odex_compile, help_odex_license
    )
end

"""
Type encapsulating all required data for Odex-Solver-Callbacks.

We have the typical calling stack:

     odex
         call_julia_output_fcn(  ... INIT ... )
             output_fcn ( ... INIT ...)
         ccall( ODEX_ ... )
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_HW1RHSCallback                      │  ⎬ cb. rhs
            │    rhs                                    │  ⎪
            └───────────────────────────────────────────┘  ⎭
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_odexSoloutCallback                  │  ⎪
            │    call_julia_output_fcn( ... STEP ...)   │  ⎪ cb. solout
            │        output_fcn ( ... STEP ...)         │  ⎬ with eval
            │            eval_sol_fcn                   │  ⎪
            │                ccall(CONTEX_ ... )        │  ⎪
            └───────────────────────────────────────────┘  ⎭
         call_julia_output_fcn(  ... DONE ... )
             output_fcn ( ... DONE ...)
"""
mutable struct OdexInternalCallInfos{
        FInt <: FortranInt,
        RHS_F, OUT_F,
    } <: ODEinternalCallInfos
    logio::IO                    # where to log
    loglevel::UInt64                # log level
    # RHS:
    rhs::RHS_F                 # right-hand-side
    rhs_mode::RHS_CALL_MODE         # how to call rhs
    rhs_lprefix::AbstractString        # saved log-prefix for rhs
    # SOLOUT & output function
    output_mode::OUTPUTFCN_MODE        # what mode for output function
    output_fcn::OUT_F                 # the output function to call
    output_data::Dict                  # extra_data for output_fcn
    out_lprefix::AbstractString        # saved log-prefix for solout
    eval_sol_fcn::Function              # eval_sol_fcn
    eval_lprefix::AbstractString        # saved log-prefix for eval_sol
    tOld::Float64               # tOld and
    tNew::Float64               # tNew and
    xNew::Vector{Float64}       # xNew of current solout interval
    cont_i::Vector{FInt}          # argument to contex
    cont_s::Vector{Float64}       # argument to contex
    cont_con::Ptr{Float64}          # saved pointers for contex
    cont_ncon::Ptr{FInt}             # saved pointers for contex
    cont_icomp::Ptr{FInt}             # saved pointers for contex
    cont_nd::Ptr{FInt}             # saved pointers for contex
end

"""
     mutable struct OdexArguments{FInt} <: AbstractArgumentsODESolver{FInt}

Stores Arguments for Odex solver.

FInt is the Integer type used for the fortran compilation.
"""
mutable struct OdexArguments{FInt <: FortranInt} <: AbstractArgumentsODESolver{FInt}
    N::Vector{FInt}      # Dimension
    FCN::Ptr{Cvoid}        # rhs callback
    t::Vector{Float64}   # start time (and current)
    tEnd::Vector{Float64}   # end time
    x::Vector{Float64}   # initial value (and current state)
    H::Vector{Float64}   # initial step size
    RTOL::Vector{Float64}   # relative tolerance
    ATOL::Vector{Float64}   # absolute tolerance
    ITOL::Vector{FInt}      # switch for RTOL, ATOL
    SOLOUT::Ptr{Cvoid}        # solout callback
    IOUT::Vector{FInt}      # switch for SOLOUT
    WORK::Vector{Float64}   # double working array
    LWORK::Vector{FInt}      # length of WORK
    IWORK::Vector{FInt}      # integer working array
    LIWORK::Vector{FInt}      # length of IWORK
    RPAR::Vector{Float64}   # add. double-array
    IPAR::Ref{OdexInternalCallInfos} # misuse IPAR
    IDID::Vector{FInt}      # Status code
    ## Allow uninitialized construction
    function OdexArguments{FInt}(dummy::FInt) where {FInt}
        return new{FInt}()
    end
end

"""
     function unsafe_odexSoloutCallback(
             nr_::Ptr{FInt}, told_::Ptr{Float64}, t_::Ptr{Float64},
             x_::Ptr{Float64}, n_::Ptr{FInt}, con_::Ptr{Float64},
             ncon_::Ptr{FInt}, icomp_::Ptr{FInt}, nd_::Ptr{FInt},
             rpar_::Ptr{Float64}, cbi::CI,
             irtrn_::Ptr{FInt}) where {FInt<:FortranInt,
                                       CI<:OdexInternalCallInfos}

This is the solout given as callback to Fortran-odex.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-pointers.

This function saves the state information of the solver in
`OdexInternalCallInfos`, where they can be found by
the `eval_sol_fcn`, see `create_odex_eval_sol_fcn_closure`.

Then the user-supplied `output_fcn` is called (which in turn can use
`eval_sol_fcn`, to evaluate the solution at intermediate points).

The return value of the `output_fcn` is propagated to `ODEX_`.

For the typical calling sequence, see `OdexInternalCallInfos`.
"""
function unsafe_odexSoloutCallback(
        nr_::Ptr{FInt}, told_::Ptr{Float64}, t_::Ptr{Float64},
        x_::Ptr{Float64}, n_::Ptr{FInt}, con_::Ptr{Float64},
        ncon_::Ptr{FInt}, icomp_::Ptr{FInt}, nd_::Ptr{FInt},
        rpar_::Ptr{Float64}, cbi::CI,
        irtrn_::Ptr{FInt}
    ) where {
        FInt <: FortranInt,
        CI <: OdexInternalCallInfos,
    }

    nr = unsafe_load(nr_); told = unsafe_load(told_); t = unsafe_load(t_)
    n = unsafe_load(n_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    irtrn = unsafe_wrap(Array, irtrn_, (1,), own = false)

    (lio, l, lprefix) = (cbi.logio, cbi.loglevel, cbi.out_lprefix)
    l_sol = l & LOG_SOLOUT > 0

    l_sol && println(
        lio, lprefix, "called with nr=", nr, " told=", told,
        " t=", t, " x=", x
    )

    cbi.tOld = told; cbi.tNew = t; cbi.xNew = x
    cbi.cont_con = con_; cbi.cont_ncon = ncon_; cbi.cont_icomp = icomp_
    cbi.cont_nd = nd_
    cbi.output_data["nr"] = nr

    ret = call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_STEP, told, t, x,
        cbi.eval_sol_fcn
    )
    if ret == OUTPUTFCN_RET_STOP
        irtrn[1] = -1
    elseif ret == OUTPUTFCN_RET_CONTINUE
        irtrn[1] = 0
    elseif ret == OUTPUTFCN_RET_CONTINUE_XCHANGED
        throw(
            FeatureNotSupported(
                string(
                    "Sorry; odex does not support ",
                    "to change the solution inside the output function."
                )
            )
        )
    else
        throw(InternalErrorODE(string("Unknown ret=", ret, " of output function")))
    end

    return nothing
end

"""
     function unsafe_odexSoloutCallback_c(cbi::CI,
             fint_flag::FInt) where {FInt,CI}
"""
function unsafe_odexSoloutCallback_c(
        cbi::CI,
        fint_flag::FInt
    ) where {FInt, CI}
    return @cfunction(
        unsafe_odexSoloutCallback, Cvoid, (
            Ptr{FInt},
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64},
            Ptr{FInt}, Ptr{Float64}, Ptr{FInt},
            Ptr{FInt}, Ptr{FInt}, Ptr{Float64},
            Ref{CI}, Ptr{FInt},
        )
    )
end

"""
     function create_odex_eval_sol_fcn_closure(cbi::CI, d::FInt,
             method_contex::Ptr{Cvoid}) where {FInt<:FortranInt,
                                              CI<:OdexInternalCallInfos}

generates a eval_sol_fcn for odex.

Why is a closure needed? We need a function `eval_sol_fcn`
that calls `CONTEX_` (with `ccall`).
But `CONTEX_` needs the information for the current state. This
information were saved by `unsafe_odexSoloutCallback` in the
`OdexInternalCallInfos`. `eval_sol_fcn` needs to get this information.
Here comes `create_odex_eval_sol_fcn_closure` into play: this function
takes the call information and generates a `eval_sol_fcn` with this data.

Why doesn't `unsafe_odexSoloutCallback` generate a closure (then
the current state needs not to be saved in `OdexInternalCallInfos`)?
Because then every call to `unsafe_odexSoloutCallback` would have
generated a closure function. That's a lot of overhead: 1 closure function
for every solout call. With the strategy above, we have 1 closure function
per ODE-solver-call, i.e. 1 closure function per ODE.

For the typical calling sequence, see `OdexInternalCallInfos`.
"""
function create_odex_eval_sol_fcn_closure(
        cbi::CI, d::FInt,
        method_contex::Ptr{Cvoid}
    ) where {
        FInt <: FortranInt,
        CI <: OdexInternalCallInfos,
    }

    function eval_sol_fcn_closure(s::Float64)
        (lio, l, lprefix) = (cbi.logio, cbi.loglevel, cbi.eval_lprefix)
        l_eval = l & LOG_EVALSOL > 0

        l_eval && println(lio, lprefix, "called with s=", s)
        cbi.cont_s[1] = s
        result = Vector{Float64}(undef, d)
        if s == cbi.tNew
            result[:] = cbi.xNew
            l_eval && println(lio, lprefix, "not calling contex because s==tNew")
        else
            for k in 1:d
                cbi.cont_i[1] = k
                result[k] = ccall(
                    method_contex, Float64,
                    (
                        Ptr{FInt}, Ptr{Float64}, Ptr{Float64}, Ptr{FInt},
                        Ptr{FInt}, Ptr{FInt},
                    ),
                    cbi.cont_i, cbi.cont_s, cbi.cont_con, cbi.cont_ncon,
                    cbi.cont_icomp, cbi.cont_nd
                )
            end
        end

        l_eval && println(lio, lprefix, "contex returned ", result)
        return result
    end
    return eval_sol_fcn_closure
end

"""
     function odex(rhs, t0::Real, T::Real,
                   x0::Vector, opt::AbstractOptionsODE)
         -> (t,x,retcode,stats)

`retcode` can have the following values:

      1: computation successful
      2: computation. successful, but interrupted by output function
     -1: error

main call for using Fortran-odex solver. In `opt` the following
options are used:

    ╔═════════════════╤══════════════════════════════════════════╤═════════╗
    ║  Option OPT_…   │ Description                              │ Default ║
    ╠═════════════════╪══════════════════════════════════════════╪═════════╣
    ║ RTOL         &  │ relative and absolute error tolerances   │    1e-3 ║
    ║ ATOL            │ both scalars or both vectors with the    │    1e-6 ║
    ║                 │ length of length(x0)                     │         ║
    ║                 │ error(xₖ) ≤ OPT_RTOLₖ⋅|xₖ|+OPT_ATOLₖ     │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTFCN       │ output function                          │ nothing ║
    ║                 │ see help_outputfcn                       │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTMODE      │ OUTPUTFCN_NEVER:                         │   NEVER ║
    ║                 │   dont't call OPT_OUTPUTFCN              │         ║
    ║                 │ OUTPUTFCN_WODENSE                        │         ║
    ║                 │   call OPT_OUTPUTFCN, but without        │         ║
    ║                 │   possibility for dense output           │         ║
    ║                 │ OUTPUTFCN_DENSE                          │         ║
    ║                 │   call OPT_OUTPUTFCN with support for    │         ║
    ║                 │   dense output                           │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSTEPS        │ maximal number of allowed steps          │   10000 ║
    ║                 │ OPT_MAXSTEPS > 0                         │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ EPS             │ the rounding unit                        │ 2.3e-16 ║
    ║                 │ 1e-35 < OPT_EPS < 1.0                    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSS           │ maximal step size                        │  T - t0 ║
    ║                 │ OPT_MAXSS ≠ 0                            │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ INITIALSS       │ initial step size guess                  │    1e-4 ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXEXCOLUMN     │ the maximum number of columns in         │       9 ║
    ║                 │ the extrapolation table                  │         ║
    ║                 │ OPT_MAXEXCOLUMN ≥ 3                      │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ STEPSIZESEQUENCE│ switch for the step size sequence        │       4 ║
    ║                 │ 1: 2, 4,  6,  8, 10, 12, 14, 16, …       │ if      ║
    ║                 │ 2: 2, 4,  8, 12, 16, 20, 24, 28, …       │ OUTPUT- ║
    ║                 │ 3: 2, 4,  6,  8, 12, 16, 24, 32, …       │ MODE == ║
    ║                 │ 4: 2, 6, 10, 14, 18, 22, 26, 30, …       │ DENSE;  ║
    ║                 │ 5: 4, 8, 12, 16, 20, 24, 28, 32, …       │ other-  ║
    ║                 │ 1 ≤ OPT_STEPSIZESEQUENCE ≤ 5             │ wise  1 ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSTABCHECKS   │ how many times is the stability check    │       1 ║
    ║                 │ activated at most in one line of the     │         ║
    ║                 │ extrapolation table                      │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSTABCHECKLINE│ stability check is only activated in     │       1 ║
    ║                 │ the lines 1 to MAXMAXSTABCHECKLINE of    │         ║
    ║                 │ the extrapolation table                  │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ DENSEOUTPUTWOEE │ boolean flag: suppress error estimator   │   false ║
    ║                 │ in dense output                          │         ║
    ║                 │ true is only possible, if                │         ║
    ║                 │      OUTPUTMODE == DENSE                 │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ INTERPOLDEGREE  │ determines the degree of interpolation   │       4 ║
    ║                 │ formula:                                 │         ║
    ║                 │ μ = 2*κ - INTERPOLDEGREE + 1             │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ SSREDUCTION     │ step size is reduced by factor if the    │     0.5 ║
    ║                 │ stability check is negative              │         ║
    ║                 │ OPT_EPS < OPT_SSREDUCTION < 1            │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ SSSELECTPAR1 &  │ parameters for step size selection       │    0.02 ║
    ║ SSSELECTPAR2    │ the new step size for the k-th diagonal  │    4.00 ║
    ║                 │ entry is chosen subject to               │         ║
    ║                 │ FMIN/SSSELECTPAR2 ≤ hnewₖ/hold ≤ 1/FMIN  │         ║
    ║                 │ with FMIN = SSSELECTPAR1^(1/(2*k-1))     │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ ORDERDECFRAC &  │ parameters for the order selection       │     0.8 ║
    ║ ORDERINCFRAC    │ decrease order if                        │     0.9 ║
    ║                 │         W(k-1) ≤   W(k)*ORDERDECFRAC     │         ║
    ║                 │ increase order if                        │         ║
    ║                 │         W(k)   ≤ W(k-1)*ORDERINCFRAC     │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OPT_RHO      &  │ safety factors for step control algorithm│    0.94 ║
    ║ OPT_RHO2        │ hnew=h*RHO*(RHO2*TOL/ERR)^(1/(k-1) )     │    0.65 ║
    ╚═════════════════╧══════════════════════════════════════════╧═════════╝

"""
function odex(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return odex_impl(rhs, t0, T, x0, opt, OdexArguments{Int64}(Int64(0)))
end

"""
odex with 32bit integers, see odex.
"""
function odex_i32(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )

    return odex_impl(rhs, t0, T, x0, opt, OdexArguments{Int32}(Int32(0)))
end


"""
     function odex_impl(rhs,
             t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
             args::OdexArguments{FInt}) where {FInt<:FortranInt}

implementation of odex for FInt.
"""
function odex_impl(
        rhs,
        t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
        args::OdexArguments{FInt}
    ) where {FInt <: FortranInt}

    (lio, l, l_g, l_solver, lprefix) = solver_start("odex", rhs, t0, T, x0, opt)

    (method_odex, method_contex) = getAllMethodPtrs(
        (FInt == Int64) ? DL_ODEX : DL_ODEX_I32
    )

    (d, nrdense, scalarFlag, rhs_mode, output_mode, output_fcn) =
        solver_extract_commonOpt(t0, T, x0, opt, args)

    args.ITOL = [scalarFlag ? 0 : 1]
    args.IOUT = [
        FInt(
            output_mode == OUTPUTFCN_NEVER ? 0 :
                (output_mode == OUTPUTFCN_DENSE ? 2 : 1)
        ),
    ]

    OPT = nothing; KM = FInt(0)
    try
        OPT = OPT_MAXEXCOLUMN; KM = convert(FInt, getOption(opt, OPT, 9))
        @assert KM ≥ 3
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    # WORK memory
    args.LWORK = [d * (KM + 5) + 5 * KM + 20 + (2 * KM * (KM + 2) + 5) * nrdense]
    args.WORK = zeros(Float64, args.LWORK[1])

    # IWORK memory
    args.LIWORK = [2 * KM + 21 + nrdense]
    args.IWORK = zeros(FInt, args.LIWORK[1])

    OPT = nothing
    try
        # fill IWORK
        OPT = OPT_MAXSTEPS; args.IWORK[1] = convert(FInt, getOption(opt, OPT, 10000))
        @assert 0 < args.IWORK[1]
        args.IWORK[2] = KM

        OPT = OPT_STEPSIZESEQUENCE
        args.IWORK[3] = convert(
            FInt, getOption(
                opt, OPT,
                output_mode == OUTPUTFCN_DENSE ? 4 : 1
            )
        )
        @assert 1 ≤ args.IWORK[3] ≤ 5

        OPT = OPT_MAXSTABCHECKS; args.IWORK[4] = convert(FInt, getOption(opt, OPT, 1))

        OPT = OPT_MAXSTABCHECKLINE
        args.IWORK[5] = convert(FInt, getOption(opt, OPT, 1))

        OPT = OPT_DENSEOUTPUTWOEE
        supp_flag = convert(Bool, getOption(opt, OPT, false))
        args.IWORK[6] = FInt(supp_flag ? 1 : 0)
        @assert !supp_flag || (supp_flag && output_mode == OUTPUTFCN_DENSE)

        OPT = OPT_INTERPOLDEGREE
        args.IWORK[7] = convert(FInt, getOption(opt, OPT, 4))
        @assert 1 ≤ args.IWORK[7] ≤ 6

        args.IWORK[8] = nrdense

        # fill WORK
        OPT = OPT_EPS; args.WORK[1] = convert(Float64, getOption(opt, OPT, 2.3e-16))
        @assert 1.0e-35 < args.WORK[1] < 1.0

        OPT = OPT_MAXSS; args.WORK[2] = convert(Float64, getOption(opt, OPT, T - t0))
        @assert 0 ≠ args.WORK[2]

        OPT = OPT_SSREDUCTION; args.WORK[3] = convert(Float64, getOption(opt, OPT, 0.5))
        @assert args.WORK[1] < args.WORK[3] < 1.0

        OPT = OPT_SSSELECTPAR1
        args.WORK[4] = convert(Float64, getOption(opt, OPT, 0.02))
        @assert 0 < args.WORK[4]

        OPT = OPT_SSSELECTPAR2
        args.WORK[5] = convert(Float64, getOption(opt, OPT, 4.0))
        @assert 0 < args.WORK[5]

        OPT = OPT_ORDERDECFRAC
        args.WORK[6] = convert(Float64, getOption(opt, OPT, 0.8))
        @assert 0 < args.WORK[6]

        OPT = OPT_ORDERINCFRAC
        args.WORK[7] = convert(Float64, getOption(opt, OPT, 0.9))
        @assert 0 < args.WORK[7]

        OPT = OPT_RHO2
        args.WORK[8] = convert(Float64, getOption(opt, OPT, 0.65))
        @assert 0 < args.WORK[8]

        OPT = OPT_RHO
        args.WORK[9] = convert(Float64, getOption(opt, OPT, 0.94))
        @assert 0 < args.WORK[9]

        # H
        OPT = OPT_INITIALSS
        args.H = [convert(Float64, getOption(opt, OPT, 1.0e-4))]
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    args.RPAR = zeros(Float64, 0)
    args.IDID = zeros(FInt, 1)
    rhs_lprefix = "unsafe_HW1RHSCallback: "
    out_lprefix = "unsafe_odexSoloutCallback: "
    eval_lprefix = "eval_sol_fcn_closure: "

    cbi = OdexInternalCallInfos(
        lio, l, rhs, rhs_mode, rhs_lprefix,
        output_mode, output_fcn,
        Dict(), out_lprefix, eval_sol_fcn_noeval, eval_lprefix,
        NaN, NaN, Vector{Float64}(),
        Vector{FInt}(undef, 1), Vector{Float64}(undef, 1),
        Ptr{Float64}(C_NULL), Ptr{FInt}(C_NULL),
        Ptr{FInt}(C_NULL), Ptr{FInt}(C_NULL)
    )

    if output_mode == OUTPUTFCN_DENSE
        cbi.eval_sol_fcn = create_odex_eval_sol_fcn_closure(cbi, d, method_contex)
    end

    args.FCN = unsafe_HW1RHSCallback_c(cbi, FInt(0))
    args.SOLOUT = output_mode ≠ OUTPUTFCN_NEVER ?
        unsafe_odexSoloutCallback_c(cbi, FInt(0)) :
        @cfunction(dummy_func, Cvoid, ())
    args.IPAR = cbi

    output_mode ≠ OUTPUTFCN_NEVER &&
        call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_INIT,
        args.t[1], args.tEnd[1], args.x, eval_sol_fcn_init
    ) # ignore result

    if l_solver
        println(lio, lprefix, "call Fortran-odex $method_odex with")
        dump(lio, args)
    end

    ccall(
        method_odex, Cvoid,
        (
            Ptr{FInt}, Ptr{Cvoid},                   # N=d, Rightsidefunc
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, # t, x, tEnd
            Ptr{Float64},                             # h
            Ptr{Float64}, Ptr{Float64}, Ptr{FInt},    # RTOL, ATOL, ITOL
            Ptr{Cvoid}, Ptr{FInt},                    # Soloutfunc, IOUT
            Ptr{Float64}, Ptr{FInt},                  # WORK, LWORK
            Ptr{FInt}, Ptr{FInt},                     # IWORK, LIWORK
            Ptr{Float64}, Ref{OdexInternalCallInfos}, # RPAR, IPAR,
            Ptr{FInt},                                # IDID
        ),
        args.N, args.FCN,
        args.t, args.x, args.tEnd,
        args.H,
        args.RTOL, args.ATOL, args.ITOL,
        args.SOLOUT, args.IOUT,
        args.WORK, args.LWORK,
        args.IWORK, args.LIWORK,
        args.RPAR, args.IPAR, args.IDID,
    )

    if l_solver
        println(lio, lprefix, "Fortran-odex $method_odex returned")
        dump(lio, args)
    end

    output_mode ≠ OUTPUTFCN_NEVER &&
        call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_DONE,
        args.t[1], args.tEnd[1], args.x, eval_sol_fcn_done
    ) # ignore result

    l_g && println(lio, lprefix, string("done IDID=", args.IDID[1]))
    stats = Dict{AbstractString, Any}(
        "step_predict" => args.H[1],
        "no_rhs_calls" => args.IWORK[17],
        "no_steps" => args.IWORK[18],
        "no_steps_accepted" => args.IWORK[19],
        "no_steps_rejected" => args.IWORK[20]
    )
    return (args.t[1], args.x, args.IDID[1], stats)
end

"""
## Compile ODEX

The julia ODEInterface tries to compile and link the solvers
automatically at the build-time of this module. The following
calls need only be done, if one uses a different compiler and/or if
one wants to change/add some compiler options.

The Fortran source code can be found at:

     http://www.unige.ch/~hairer/software.html

See `help_odex_license` for the license information.

### Using `gfortran` and 64bit integers (Linux and Mac)

Here is an example how to compile ODEX with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o odex.o odex.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o odex.so odex.o
     gfortran -shared -fPIC -o odex.dylib odex.o

### Using `gfortran` and 64bit integers (Windows)

Here is an example how to compile ODEX with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o odex.o odex.f

In order to get create a shared library (from the object file above) use

     gfortran -shared -o odex.dll odex.o

### Using `gfortran` and 32bit integers (Linux and Mac)

Here is an example how to compile ODEX with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c -fPIC
              -fdefault-real-8 -fdefault-double-8
              -o odex_i32.o   odex.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o odex_i32.so odex_i32.o
     gfortran -shared -fPIC -o odex_i32.dylib odex_i32.o

### Using `gfortran` and 32bit integers (Windows)

Here is an example how to compile ODEX with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c
              -fdefault-real-8 -fdefault-double-8
              -o odex_i32.o   odex.f

In order to get create a shared library (from the object file above) use:

     gfortran -shared -o odex_i32.dll odex_i32.o

"""
function help_odex_compile()
    return Docs.doc(help_odex_compile)
end

function help_odex_license()
    return Docs.doc(help_odex_license)
end

@doc(@doc(hw_license), help_odex_license)

# Add information about solver in global solverInfo-array.
push!(
    solverInfo,
    SolverInfo(
        "odex",
        "GBS Extrapolation-Algorithm based on the explicit midpoint rule",
        tuple(
            :OPT_RTOL, :OPT_ATOL,
            :OPT_OUTPUTMODE, :OPT_OUTPUTFCN,
            :OPT_MAXSTEPS, :OPT_EPS, :OPT_MAXS, :OPT_INITIALSS,
            :OPT_MAXEXCOLUMN, :OPT_STEPSIZESEQUENCE, :OPT_MAXSTABCHECKS,
            :OPT_MAXSTABCHECKLINE, :OPT_DENSEOUTPUTWOEE, :OPT_INTERPOLDEGREE,
            :OPT_SSREDUCTION, :OPT_SSSELECTPAR1, :OPT_SSSELECTPAR2,
            :OPT_ORDERDECFRAC, :OPT_ORDERINCFRAC, :OPT_RHO, :OPT_RHO2,
        ),
        tuple(
            SolverVariant(
                "odex_i64",
                "Odex with 64bit integers",
                DL_ODEX,
                tuple("odex", "contex")
            ),
            SolverVariant(
                "odex_i32",
                "Odex with 32bit integers",
                DL_ODEX_I32,
                tuple("odex", "contex")
            ),
        ),
        help_odex_compile,
        help_odex_license,
    )
)


# vim:syn=julia:cc=79:fdm=indent:

# Functions for ODE-Solver: Seulex

"""Name for Loading seulex solver (64bit integers)."""
const DL_SEULEX = "seulex"

"""Name for Loading seulex solver (32bit integers)."""
const DL_SEULEX_I32 = "seulex_i32"

"""macro for import seulex solver."""
macro import_seulex()
    return :(
        using ODEInterface: seulex, seulex_i32
    )
end

"""macro for import seulex dynamic lib names."""
macro import_DLseulex()
    return :(
        using ODEInterface: DL_SEULEX, DL_SEULEX_I32
    )
end

"""macro for importing Seulex help."""
macro import_seulex_help()
    return :(
        using ODEInterface: help_seulex_compile, help_seulex_license
    )
end

"""
Type encapsulating all required data for Seulex-Solver-Callbacks.

We have the typical calling stack:

     seulex
         call_julia_output_fcn(  ... INIT ... )
             output_fcn ( ... INIT ...)
         ccall( SEULEX_  ... )
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_HW2RHSCallback                      │  ⎬ cb. rhs
            │    rhs                                    │  ⎪
            └───────────────────────────────────────────┘  ⎭
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_seulexSoloutCallback                │  ⎪
            │    call_julia_output_fcn( ... STEP ...)   │  ⎪ cb. solout
            │        output_fcn ( ... STEP ...)         │  ⎬ with eval
            │            eval_sol_fcn                   │  ⎪
            │                ccall(CONTEX_ ... )        │  ⎪
            └───────────────────────────────────────────┘  ⎭
            ┌───────────────────────────────────────────┐  ⎫
            │unsafe_HW1JacCallback:                     │  ⎬ cb. jacobian
            │    call_julia_jac_fcn(             )      │  ⎪
            └───────────────────────────────────────────┘  ⎭
         call_julia_output_fcn(  ... DONE ... )
             output_fcn ( ... DONE ...)
"""
mutable struct SeulexInternalCallInfos{
        FInt <: FortranInt, RHS_F,
        OUT_F, JAC_F,
    } <: ODEinternalCallInfos
    logio::IO                    # where to log
    loglevel::UInt64                # log level
    # special structure
    M1::FInt
    M2::FInt
    # RHS:
    rhs::RHS_F                 # right-hand-side
    rhs_mode::RHS_CALL_MODE         # how to call rhs
    rhs_lprefix::AbstractString        # saved log-prefix for rhs
    # SOLOUT & output function
    output_mode::OUTPUTFCN_MODE        # what mode for output function
    output_fcn::OUT_F                 # the output function to call
    output_data::Dict                  # extra_data for output_fcn
    out_lprefix::AbstractString        # saved log-prefix for solout
    eval_sol_fcn::Function              # eval_sol_fcn
    eval_lprefix::AbstractString        # saved log-prefix for eval_sol
    tOld::Float64               # tOld and
    tNew::Float64               # tNew and
    xNew::Vector{Float64}       # xNew of current solout interval
    cont_i::Vector{FInt}          # argument to contex
    cont_s::Vector{Float64}       # argument to contex
    cont_rc::Ptr{Float64}          # saved pointers for contex
    cont_lrc::Ptr{FInt}             # saved pointers for contex
    cont_ic::Ptr{FInt}             # saved pointers for contex
    cont_lic::Ptr{FInt}             # saved pointers for contex
    # Massmatrix
    massmatrix::AbstractArray{Float64} # saved mass matrix
    # Jacobimatrix
    jacobimatrix::JAC_F                 # function for jacobi matrix
    jacobibandstruct                      # (l,u) bandstructure or nothing
    jac_lprefix::AbstractString        # saved log-prefix for jac
end

"""
     mutable struct SeulexArguments{FInt<:FortranInt} <:
              AbstractArgumentsODESolver{FInt}

Stores Arguments for Seulex solver.

FInt is the Integer type used for the fortran compilation.
"""
mutable struct SeulexArguments{FInt <: FortranInt} <: AbstractArgumentsODESolver{FInt}
    N::Vector{FInt}      # Dimension
    FCN::Ptr{Cvoid}        # rhs callback
    IFCN::Vector{FInt}      # autonomous (0) or not (1)
    t::Vector{Float64}   # start time (and current)
    tEnd::Vector{Float64}   # end time
    x::Vector{Float64}   # initial value (and current state)
    H::Vector{Float64}   # initial step size
    RTOL::Vector{Float64}   # relative tolerance
    ATOL::Vector{Float64}   # absolute tolerance
    ITOL::Vector{FInt}      # switch for RTOL, ATOL
    JAC::Ptr{Cvoid}        # jacobian callback
    IJAC::Vector{FInt}      # jacobian given as callback?
    MLJAC::Vector{FInt}      # lower bandwidth of jacobian
    MUJAC::Vector{FInt}      # upper bandwidth of jacobian
    MAS::Ptr{Cvoid}
    IMAS::Vector{FInt}      # mass matrix given as callback?
    MLMAS::Vector{FInt}      # lower bandwidth of mass matrix
    MUMAS::Vector{FInt}      # upper bandwidth of mass matrix
    SOLOUT::Ptr{Cvoid}        # solout callback
    IOUT::Vector{FInt}      # switch for SOLOUT
    WORK::Vector{Float64}   # double working array
    LWORK::Vector{FInt}      # length of WORK
    IWORK::Vector{FInt}      # integer working array
    LIWORK::Vector{FInt}      # length of IWORK
    RPAR::Vector{Float64}   # add. double-array
    IPAR::Ref{SeulexInternalCallInfos} # misuse IPAR
    IDID::Vector{FInt}      # Status code
    ## Allow uninitialized construction
    function SeulexArguments{FInt}(dummy::FInt) where {FInt}
        return new{FInt}()
    end
end

"""
     function unsafe_seulexSoloutCallback(
             nr_::Ptr{FInt}, told_::Ptr{Float64}, t_::Ptr{Float64},
             x_::Ptr{Float64}, rc_::Ptr{Float64}, lrc_::Ptr{FInt},
             ic_::Ptr{FInt}, lic_::Ptr{FInt}, n_::Ptr{FInt},
             rpar_::Ptr{Float64}, cbi::CI,
             irtrn_::Ptr{FInt}) where {FInt<:FortranInt,
                                       CI<:SeulexInternalCallInfos}

This is the solout given as callback to Fortran-seulex.

The `unsafe` prefix in the name indicates that no validations are
performed on the `Ptr`-pointers.

This function saves the state information of the solver in
`SeulexInternalCallInfos`, where they can be found by
the `eval_sol_fcn`, see `create_seulex_eval_sol_fcn_closure`.

Then the user-supplied `output_fcn` is called (which in turn can use
`eval_sol_fcn`, to evaluate the solution at intermediate points).

The return value of the `output_fcn` is propagated to `SEULEX_`.

For the typical calling sequence, see `SeulexInternalCallInfos`.
"""
function unsafe_seulexSoloutCallback(
        nr_::Ptr{FInt}, told_::Ptr{Float64}, t_::Ptr{Float64},
        x_::Ptr{Float64}, rc_::Ptr{Float64}, lrc_::Ptr{FInt},
        ic_::Ptr{FInt}, lic_::Ptr{FInt}, n_::Ptr{FInt},
        rpar_::Ptr{Float64}, cbi::CI,
        irtrn_::Ptr{FInt}
    ) where {
        FInt <: FortranInt,
        CI <: SeulexInternalCallInfos,
    }

    nr = unsafe_load(nr_); told = unsafe_load(told_); t = unsafe_load(t_)
    n = unsafe_load(n_)
    x = unsafe_wrap(Array, x_, (n,), own = false)
    irtrn = unsafe_wrap(Array, irtrn_, (1,), own = false)

    (lio, l, lprefix) = (cbi.logio, cbi.loglevel, cbi.out_lprefix)
    l_sol = l & LOG_SOLOUT > 0

    l_sol && println(
        lio, lprefix, "called with nr=", nr, " told=", told,
        " t=", t, " x=", x
    )

    cbi.tOld = told; cbi.tNew = t; cbi.xNew = x
    cbi.cont_rc = rc_; cbi.cont_lrc = lrc_
    cbi.cont_ic = ic_; cbi.cont_lic = lic_
    cbi.output_data["nr"] = nr

    ret = call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_STEP, told, t, x,
        cbi.eval_sol_fcn
    )

    if ret == OUTPUTFCN_RET_STOP
        irtrn[1] = -1
    elseif ret == OUTPUTFCN_RET_CONTINUE
        irtrn[1] = 0
    elseif ret == OUTPUTFCN_RET_CONTINUE_XCHANGED
        throw(
            FeatureNotSupported(
                string(
                    "Sorry; seulex does not support ",
                    "to change the solution inside the output function."
                )
            )
        )
    else
        throw(InternalErrorODE(string("Unknown ret=", ret, " of output function")))
    end

    return nothing
end

"""
     function unsafe_seulexSoloutCallback_c(cbi::CI,
             fint_flag::FInt) where {FInt,CI}
"""
function unsafe_seulexSoloutCallback_c(
        cbi::CI,
        fint_flag::FInt
    ) where {FInt, CI}
    return @cfunction(
        unsafe_seulexSoloutCallback, Cvoid, (
            Ptr{FInt},
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64},
            Ptr{Float64}, Ptr{FInt}, Ptr{FInt}, Ptr{FInt},
            Ptr{FInt}, Ptr{Float64}, Ref{CI}, Ptr{FInt},
        )
    )
end

"""
     function create_seulex_eval_sol_fcn_closure(cbi::CI, d::FInt,
             method_contex::Ptr{Cvoid}) where {FInt<:FortranInt,
                                              CI<:SeulexInternalCallInfos}

generates a eval_sol_fcn for seulex.

Why is a closure needed? We need a function `eval_sol_fcn`
that calls `CONTEX_` (with `ccall`).
But `CONTEX_` needs the information for the current state. This
information were saved by `unsafe_seulexSoloutCallback` in the
`SeulexInternalCallInfos`. `eval_sol_fcn` needs to get this information.
Here comes `create_seulex_eval_sol_fcn_closure` into play: this function
takes the call information and generates a `eval_sol_fcn` with this data.

Why doesn't `unsafe_seulexSoloutCallback` generate a closure (then
the current state needs not to be saved in `SeulexInternalCallInfos`)?
Because then every call to `unsafe_seulexSoloutCallback` would have
generated a closure function. That's a lot of overhead: 1 closure function
for every solout call. With the strategy above, we have 1 closure function
per ODE-solver-call, i.e. 1 closure function per ODE.

For the typical calling sequence, see `SeulexInternalCallInfos`.
"""
function create_seulex_eval_sol_fcn_closure(
        cbi::CI, d::FInt,
        method_contex::Ptr{Cvoid}
    ) where {
        FInt <: FortranInt,
        CI <: SeulexInternalCallInfos,
    }

    function eval_sol_fcn_closure(s::Float64)
        (lio, l, lprefix) = (cbi.logio, cbi.loglevel, cbi.eval_lprefix)
        l_eval = l & LOG_EVALSOL > 0

        l_eval && println(lio, lprefix, "called with s=", s)
        cbi.cont_s[1] = s
        result = Vector{Float64}(undef, d)
        if s == cbi.tNew
            result[:] = cbi.xNew
            l_eval && println(lio, lprefix, "not calling contex because s==tNew")
        else
            for k in 1:d
                cbi.cont_i[1] = k
                result[k] = ccall(
                    method_contex, Float64,
                    (
                        Ptr{FInt}, Ptr{Float64}, Ptr{Float64}, Ptr{FInt},
                        Ptr{FInt}, Ptr{FInt},
                    ),
                    cbi.cont_i, cbi.cont_s, cbi.cont_rc, cbi.cont_lrc,
                    cbi.cont_ic, cbi.cont_lic
                )
            end
        end

        l_eval && println(lio, lprefix, "contex returned ", result)
        return result
    end
    return eval_sol_fcn_closure
end

"""
     function seulex(rhs, t0::Real, T::Real,
                     x0::Vector, opt::AbstractOptionsODE)
         -> (t,x,retcode,stats)


`retcode` can have the following values:

      1: computation successful
      2: computation. successful, but interrupted by output function
     -1: computation unsuccessful


main call for using Fortran seulex solver.

This solver support problems with special structure, see
`help_specialstructure`.

In `opt` the following options are used:

    ╔═════════════════╤══════════════════════════════════════════╤═════════╗
    ║  Option OPT_…   │ Description                              │ Default ║
    ╠═════════════════╪══════════════════════════════════════════╪═════════╣
    ║ RHSAUTONOMOUS   │ Flag, if right-hand side is autonomous.  │   false ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ M1 & M2         │ parameter for special structure, see     │       0 ║
    ║                 │ above                                    │      M1 ║
    ║                 │ M1, M2 ≥ 0                               │         ║
    ║                 │ M1 +M2 ≤ length(x0)                      │         ║
    ║                 │ (M1==M2==0) || (M1≠0≠M2)                 │         ║
    ║                 │ M1 % M2 == 0 or M1==0                    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ RTOL         &  │ relative and absolute error tolerances   │    1e-3 ║
    ║ ATOL            │ both scalars or both vectors with the    │    1e-6 ║
    ║                 │ length of length(x0)                     │         ║
    ║                 │ error(xₖ) ≤ OPT_RTOLₖ⋅|xₖ|+OPT_ATOLₖ     │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTFCN       │ output function                          │ nothing ║
    ║                 │ see help_outputfcn                       │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTMODE      │ OUTPUTFCN_NEVER:                         │   NEVER ║
    ║                 │   dont't call OPT_OUTPUTFCN              │         ║
    ║                 │ OUTPUTFCN_WODENSE                        │         ║
    ║                 │   call OPT_OUTPUTFCN, but without        │         ║
    ║                 │   possibility for dense output           │         ║
    ║                 │ OUTPUTFCN_DENSE                          │         ║
    ║                 │   call OPT_OUTPUTFCN with support for    │         ║
    ║                 │   dense output                           │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ LAMBDADENSE     │ parameter λ of dense output              │       0 ║
    ║                 │ OPT_LAMBDADENSE ∈ {0,1}                  │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ EPS             │ the rounding unit                        │   1e-16 ║
    ║                 │ 0 < OPT_EPS < 1.0                        │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ TRANSJTOH       │ The solver transforms the jacobian       │   false ║
    ║                 │ matrix to Hessenberg form.               │         ║
    ║                 │ This option is not supported if the      │         ║
    ║                 │ system is "implicit" (i.e. a mass matrix │         ║
    ║                 │ is given) or if jacobian is banded.      │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSTEPS        │ maximal number of allowed steps          │  100000 ║
    ║                 │ OPT_MAXSTEPS > 0                         │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSS           │ maximal step size                        │  T - t0 ║
    ║                 │ OPT_MAXSS ≠ 0                            │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ INITIALSS       │ initial step size guess                  │    1e-6 ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXEXCOLUMN     │ the maximum number of columns in         │      12 ║
    ║                 │ the extrapolation table                  │         ║
    ║                 │ OPT_MAXEXCOLUMN ≥ 3                      │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ STEPSIZESEQUENCE│ switch for the step size sequence        │       2 ║
    ║                 │ 1: 1, 2, 3, 6, 8, 12, 16, 24, 32, 48, …  │         ║
    ║                 │ 2: 2, 3, 4, 6, 8, 12, 16, 24, 32, 48, …  │         ║
    ║                 │ 3: 1, 2, 3, 4, 5,  6,  7,  8,  9, 10, …  │         ║
    ║                 │ 4: 2, 3, 4, 5, 6,  7,  8,  9, 10, 11, …  │         ║
    ║                 │ 1 ≤ OPT_STEPSIZESEQUENCE ≤ 4             │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ SSSELECTPAR1 &  │ parameters for step size selection       │     0.1 ║
    ║ SSSELECTPAR2    │ the new step size for the k-th diagonal  │     4.0 ║
    ║                 │ entry is chosen subject to               │         ║
    ║                 │ FMIN/SSSELECTPAR2 ≤ hnewₖ/hold ≤ 1/FMIN  │         ║
    ║                 │ with FMIN = SSSELECTPAR1^(1/(k-1))       │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ ORDERDECFRAC &  │ parameters for the order selection       │     0.7 ║
    ║ ORDERINCFRAC    │ decrease order if                        │     0.9 ║
    ║                 │         W(k-1) ≤   W(k)*ORDERDECFRAC     │         ║
    ║                 │ increase order if                        │         ║
    ║                 │         W(k)   ≤ W(k-1)*ORDERINCFRAC     │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ JACRECOMPFACTOR │ decides whether the jacobian should be   │ min(    ║
    ║                 │ recomputed.                              │   1e-4, ║
    ║                 │ small (≈ 0.001): recompute often         │ RTOL[1])║
    ║                 │ large (≈ 0.1): recompute rarely          │         ║
    ║                 │ i.e. this number represents how costly   │         ║
    ║                 │ Jacobia evaluations are.                 │         ║
    ║                 │ OPT_JACRECOMPFACTOR ≠ 0                  │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OPT_RHO      &  │ safety factors for step control algorithm│    0.93 ║
    ║ OPT_RHO2        │ hnew=h*RHO*(RHO2*TOL/ERR)^(1/(k-1) )     │    0.80 ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MASSMATRIX      │ the mass matrix of the problem. If not   │ nothing ║
    ║                 │ given (nothing) then the identity matrix  │         ║
    ║                 │ is used.                                 │         ║
    ║                 │ The size has to be (d-M1)×(d-M1).        │         ║
    ║                 │ It can be an full matrix or a banded     │         ║
    ║                 │ matrix (BandedMatrix).                   │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ JACOBIMATRIX    │ A function providing the Jacobian for    │ nothing ║
    ║                 │ ∂f/∂x or nothing. For nothing the solver │         ║
    ║                 │ uses finite differences to calculate the │         ║
    ║                 │ Jacobian.                                │         ║
    ║                 │ The function has to be of the form:      │         ║
    ║                 │   function (t,x,J) -> nothing       (A)  │         ║
    ║                 │ or for M1>0 & JACOBIBANDSTRUCT ≠ nothing │         ║
    ║                 │   function (t,x,J1,…,JK) -> nothing (B)  │         ║
    ║                 │ with K = 1+M1/M2 and (M1+M2==d)          │         ║
    ║                 │ see help_specialstructure                │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ JACOBIBANDSTRUCT│ A tuple (l,u) describing the banded      │ nothing ║
    ║                 │ structure of the Jacobian or nothing if  │         ║
    ║                 │ the Jacobian is full.                    │         ║
    ║                 │ see help_specialstructure                │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ WORKFORRHS      │ estimated works (complexity) for a call  │     1.0 ║
    ║ WORKFORJAC      │ to                                       │     5.0 ║
    ║ WORKFORDEC      │ WORKFORRHS: right-hand side f            │     1.0 ║
    ║ WORKFORSOL      │ WORKFORJAC: JACOBIMATRIX                 │     1.0 ║
    ║                 │ WORKFORDEC: LU-decomposition             │         ║
    ║                 │ WORKFORSOL: Forward- and Backward subst. │         ║
    ╚═════════════════╧══════════════════════════════════════════╧═════════╝
"""
function seulex(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return seulex_impl(rhs, t0, T, x0, opt, SeulexArguments{Int64}(Int64(0)))
end

"""
seulex with 32bit integers, see seulex.
"""
function seulex_i32(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return seulex_impl(rhs, t0, T, x0, opt, SeulexArguments{Int32}(Int32(0)))
end

function seulex_impl(
        rhs,
        t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
        args::SeulexArguments{FInt}
    ) where {FInt <: FortranInt}

    (lio, l, l_g, l_solver, lprefix) = solver_start("seulex", rhs, t0, T, x0, opt)

    (method_seulex, method_contex) = getAllMethodPtrs(
        (FInt == Int64) ? DL_SEULEX : DL_SEULEX_I32
    )

    (d, nrdense, scalarFlag, rhs_mode, output_mode, output_fcn) =
        solver_extract_commonOpt(t0, T, x0, opt, args)

    args.ITOL = [scalarFlag ? 0 : 1]
    args.IOUT = [
        FInt(
            output_mode == OUTPUTFCN_NEVER ? 0 :
                (output_mode == OUTPUTFCN_DENSE ? 2 : 1)
        ),
    ]

    (M1, M2, NM1) = extractSpecialStructureOpt(d, opt)
    massmatrix = extractMassMatrix(M1, M2, NM1, args, opt)

    (jacobimatrix, jacobibandstruct, jac_lprefix) =
        extractJacobiOpt(d, M1, M2, NM1, args, opt)

    flag_implct = args.IMAS[1] ≠ 0
    flag_jband = args.MLJAC[1] < NM1

    OPT = nothing; KM = FInt(0)
    try
        OPT = OPT_MAXEXCOLUMN; KM = convert(FInt, getOption(opt, OPT, 12))
        @assert KM ≥ 3
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    # WORK memory
    ljac = flag_jband ? 1 + args.MLJAC[1] + args.MUJAC[1] : NM1
    lmas = (!flag_implct) ? 0 :
        (args.MLMAS[1] == NM1) ? NM1 : 1 + args.MLMAS[1] + args.MUMAS[1]
    le = flag_jband ? 1 + 2 * args.MLJAC[1] + args.MUJAC[1] : NM1
    KM2 = 2 + KM * ceil(FInt, (KM + 3) / 2)

    args.LWORK = [
        (M1 == 0) ? d * (ljac + lmas + le + KM + 8) + 4 * KM + 20 + KM2 * nrdense :
            d * (ljac + KM + 8) + NM1 * (lmas + le) + 4 * KM + 20 + KM2 * nrdense,
    ]
    args.WORK = zeros(Float64, args.LWORK[1])

    # IWORK memory
    args.LIWORK = [2 * d + KM + 20 + nrdense]
    args.IWORK = zeros(FInt, args.LIWORK[1])

    try
        OPT = OPT_RHSAUTONOMOUS
        rhsautonomous = convert(Bool, getOption(opt, OPT, false))
        args.IFCN = [rhsautonomous ? 0 : 1]

        OPT = OPT_TRANSJTOH
        transjtoh = convert(Bool, getOption(opt, OPT, false))
        @assert (!transjtoh) ||
            ((!flag_jband) && (!flag_implct))  string(
            "Does not work, if the jacobian is banded or if the system ",
            " has a mass matrix (≠Id)."
        )
        args.IWORK[1] = transjtoh ? 1 : 0

        OPT = OPT_MAXSTEPS; args.IWORK[2] = convert(FInt, getOption(opt, OPT, 100000))
        @assert 0 < args.IWORK[2]

        args.IWORK[3] = KM

        OPT = OPT_STEPSIZESEQUENCE
        args.IWORK[4] = convert(FInt, getOption(opt, OPT, 2))
        @assert 1 ≤ args.IWORK[4] ≤ 4

        OPT = OPT_LAMBDADENSE
        args.IWORK[5] = convert(FInt, getOption(opt, OPT, 0))
        @assert args.IWORK[5] ∈ (0, 1)

        args.IWORK[6] = nrdense

        for k in 1:nrdense
            args.IWORK[20 + k] = k
        end

        args.IWORK[9] = M1
        args.IWORK[10] = M2

        OPT = OPT_EPS; args.WORK[1] = convert(Float64, getOption(opt, OPT, 1.0e-16))
        @assert 0 < args.WORK[1] < 1.0

        OPT = OPT_MAXSS; args.WORK[2] = convert(Float64, getOption(opt, OPT, T - t0))
        @assert 0 ≠ args.WORK[2]

        OPT = OPT_JACRECOMPFACTOR
        args.WORK[3] = convert(Float64, getOption(opt, OPT, min(1.0e-4, args.RTOL[1])))
        @assert !(args.WORK[3] == 0)

        OPT = OPT_SSSELECTPAR1
        args.WORK[4] = convert(Float64, getOption(opt, OPT, 0.1))
        @assert 0 < args.WORK[4]

        OPT = OPT_SSSELECTPAR2
        args.WORK[5] = convert(Float64, getOption(opt, OPT, 4.0))
        @assert 0 < args.WORK[5]

        OPT = OPT_ORDERDECFRAC
        args.WORK[6] = convert(Float64, getOption(opt, OPT, 0.7))
        @assert 0 < args.WORK[6]

        OPT = OPT_ORDERINCFRAC
        args.WORK[7] = convert(Float64, getOption(opt, OPT, 0.9))
        @assert 0 < args.WORK[7]

        OPT = OPT_RHO2
        args.WORK[8] = convert(Float64, getOption(opt, OPT, 0.8))
        @assert 0 < args.WORK[8]

        OPT = OPT_RHO
        args.WORK[9] = convert(Float64, getOption(opt, OPT, 0.93))
        @assert 0 < args.WORK[9]

        OPT = OPT_WORKFORRHS
        args.WORK[10] = convert(Float64, getOption(opt, OPT, 1.0))
        @assert 0 < args.WORK[10]

        OPT = OPT_WORKFORJAC
        args.WORK[11] = convert(Float64, getOption(opt, OPT, 5.0))
        @assert 0 < args.WORK[11]

        OPT = OPT_WORKFORDEC
        args.WORK[12] = convert(Float64, getOption(opt, OPT, 1.0))
        @assert 0 < args.WORK[12]

        OPT = OPT_WORKFORSOL
        args.WORK[13] = convert(Float64, getOption(opt, OPT, 1.0))
        @assert 0 < args.WORK[13]

        OPT = OPT_INITIALSS
        args.H = [convert(Float64, getOption(opt, OPT, 1.0e-6))]
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    args.RPAR = zeros(Float64, 0)
    args.IDID = zeros(FInt, 1)
    rhs_lprefix = "unsafe_HW2RHSCallback: "
    out_lprefix = "unsafe_seulexSoloutCallback: "
    eval_lprefix = "eval_sol_fcn_closure: "

    cbi = SeulexInternalCallInfos(
        lio, l, M1, M2, rhs, rhs_mode, rhs_lprefix,
        output_mode, output_fcn, Dict(),
        out_lprefix, eval_sol_fcn_noeval, eval_lprefix,
        NaN, NaN, Vector{Float64}(), Vector{FInt}(undef, 1),
        Vector{Float64}(undef, 1),
        Ptr{Float64}(C_NULL),
        Ptr{FInt}(C_NULL), Ptr{FInt}(C_NULL), Ptr{FInt}(C_NULL),
        massmatrix === nothing ? zeros(0, 0) : massmatrix,
        jacobimatrix === nothing ? dummy_func : jacobimatrix,
        jacobibandstruct, jac_lprefix
    )

    if output_mode == OUTPUTFCN_DENSE
        cbi.eval_sol_fcn = create_seulex_eval_sol_fcn_closure(
            cbi, d, method_contex
        )
    end

    args.FCN = unsafe_HW2RHSCallback_c(cbi, FInt(0))
    args.SOLOUT = output_mode ≠ OUTPUTFCN_NEVER ?
        unsafe_seulexSoloutCallback_c(cbi, FInt(0)) :
        @cfunction(dummy_func, Cvoid, ())
    args.IPAR = cbi
    args.MAS = unsafe_HW1MassCallback_c(cbi, FInt(0))
    args.JAC = unsafe_HW1JacCallback_c(cbi, FInt(0))

    output_mode ≠ OUTPUTFCN_NEVER &&
        call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_INIT,
        args.t[1], args.tEnd[1], args.x, eval_sol_fcn_init
    ) # ignore result

    if l_solver
        println(lio, lprefix, "call Fortran-seulex $method_seulex with")
        dump(lio, args)
    end

    ccall(
        method_seulex, Cvoid,
        (
            Ptr{FInt}, Ptr{Cvoid}, Ptr{FInt},          # N=d, Rightsidefunc, IFCN
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64},   # t, x, tEnd
            Ptr{Float64},                               # h
            Ptr{Float64}, Ptr{Float64}, Ptr{FInt},      # RTOL, ATOL, ITOL
            Ptr{Cvoid}, Ptr{FInt}, Ptr{FInt}, Ptr{FInt}, # JAC, IJAC, MLJAC, MUJAC
            Ptr{Cvoid}, Ptr{FInt}, Ptr{FInt}, Ptr{FInt}, # MAS, IMAS, MLMAS, MUMAS
            Ptr{Cvoid}, Ptr{FInt},                      # Soloutfunc, IOUT
            Ptr{Float64}, Ptr{FInt},                    # WORK, LWORK
            Ptr{FInt}, Ptr{FInt},                       # IWORK, LIWORK
            Ptr{Float64}, Ref{SeulexInternalCallInfos}, # RPAR, IPAR
            Ptr{FInt},                                  # IDID
        ),
        args.N, args.FCN, args.IFCN,
        args.t, args.x, args.tEnd,
        args.H,
        args.RTOL, args.ATOL, args.ITOL,
        args.JAC, args.IJAC, args.MLJAC, args.MUJAC,
        args.MAS, args.IMAS, args.MLMAS, args.MUMAS,
        args.SOLOUT, args.IOUT,
        args.WORK, args.LWORK,
        args.IWORK, args.LIWORK,
        args.RPAR, args.IPAR, args.IDID,
    )

    if l_solver
        println(lio, lprefix, "Fortran-seulex $method_seulex returned")
        dump(lio, args)
    end

    output_mode ≠ OUTPUTFCN_NEVER &&
        call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_DONE,
        args.t[1], args.tEnd[1], args.x, eval_sol_fcn_done
    ) # ignore result

    l_g && println(lio, lprefix, string("done IDID=", args.IDID[1]))
    stats = Dict{AbstractString, Any}(
        "step_predict" => args.H[1],
        "no_rhs_calls" => args.IWORK[14],
        "no_jac_calls" => args.IWORK[15],
        "no_steps" => args.IWORK[16],
        "no_steps_accepted" => args.IWORK[17],
        "no_steps_rejected" => args.IWORK[18],
        "no_lu_decomp" => args.IWORK[19],
        "no_fw_bw_subst" => args.IWORK[20],
    )
    return (args.t[1], args.x, args.IDID[1], stats)
end

"""
## Compile SEULEX

The julia ODEInterface tries to compile and link the solvers
automatically at the build-time of this module. The following
calls need only be done, if one uses a different compiler and/or if
one wants to change/add some compiler options.

The Fortran source code can be found at:

     http://www.unige.ch/~hairer/software.html

See `help_seulex_license` for the license information.

### Using `gfortran` and 64bit integers (Linux and Mac)

Here is an example how to compile SEULEX with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o dc_lapack.o dc_lapack.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapack.o lapack.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapackc.o lapackc.f
     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o seulex.o seulex.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o seulex.so
              seulex.o dc_lapack.o lapack.o lapackc.o
     gfortran -shared -fPIC -o seulex.dylib
              seulex.o dc_lapack.o lapack.o lapackc.o

### Using `gfortran` and 64bit integers (Windows)

Here is an example how to compile SEULEX with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o dc_lapack.o dc_lapack.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapack.o lapack.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o lapackc.o lapackc.f
     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o seulex.o seulex.f

In order to get create a shared library (from the object file above) use

     gfortran -shared -o seulex.so
              seulex.o dc_lapack.o lapack.o lapackc.o

### Using `gfortran` and 32bit integers (Linux and Mac)

Here is an example how to compile SEULEX with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o dc_lapack_i32.o dc_lapack.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o lapack_i32.o lapack.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o lapackc_i32.o lapackc.f
     gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8
              -o seulex_i32.o seulex.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o seulex_i32.so
               seulex_i32.o dc_lapack_i32.o lapack_i32.o lapackc_i32.o
     gfortran -shared -fPIC -o seulex_i32.dylib
               seulex_i32.o dc_lapack_i32.o lapack_i32.o lapackc_i32.o

### Using `gfortran` and 32bit integers (Windows)

Here is an example how to compile SEULEX with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o dc_lapack_i32.o dc_lapack.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o lapack_i32.o lapack.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o lapackc_i32.o lapackc.f
     gfortran -c -fdefault-real-8 -fdefault-double-8
              -o seulex_i32.o seulex.f

In order to get create a shared library (from the object file above) use:

     gfortran -shared -o seulex_i32.dll
               seulex_i32.o dc_lapack_i32.o lapack_i32.o lapackc_i32.o

"""
function help_seulex_compile()
    return Docs.doc(help_seulex_compile)
end

function help_seulex_license()
    return Docs.doc(help_seulex_license)
end

@doc(@doc(hw_license), help_seulex_license)

# Add information about solvers in global solverInfo-array.
push!(
    solverInfo,
    SolverInfo(
        "seulex",
        "Extrapolation method based on the linearly implicit Eueler method",
        tuple(
            :OPT_RTOL, :OPT_ATOL,
            :OPT_OUTPUTMODE, :OPT_OUTPUTFCN,
            :OPT_M1, :OPT_M2,
            :OPT_RHSAUTONOMOUS,
            :OPT_MASSMATRIX,
            :OPT_JACOBIMATRIX, :OPT_JACOBIBANDSTRUCT,
            :OPT_MAXEXCOLUMN,
            :OPT_TRANSJTOH, :OPT_MAXSTEPS, :OPT_STEPSIZESEQUENCE,
            :OPT_LAMBDADENSE, :OPT_EPS, :OPT_MAXSS, :OPT_JACRECOMPFACTOR,
            :OPT_SSSELECTPAR1, :OPT_SSSELECTPAR2,
            :OPT_ORDERDECFRAC, :OPT_ORDERINCFRAC,
            :OPT_RHO2, :OPT_RHO,
            :OPT_INITIALSS,
            :OPT_WORKFORRHS, :OPT_WORKFORJAC, :OPT_WORKFORDEC,
            :OPT_WORKFORSOL,
        ),
        tuple(
            SolverVariant(
                "seulex_i64",
                "Seulex with 64bit integers",
                DL_SEULEX,
                tuple("seulex", "contex")
            ),
            SolverVariant(
                "seulex_i32",
                "Seulex with 32bit integers",
                DL_SEULEX_I32,
                tuple("seulex", "contex")
            ),
        ),
        help_seulex_compile,
        help_seulex_license,
    )
)

# vim:syn=julia:cc=79:fdm=indent:

# Load all the required packages
using ODEInterface
using ForwardDiff
using Gadfly
using Colors
@ODEInterface.import_huge
loadODESolvers();

# Define the right-hand function for automatic differentiation
function vdpolAD(x)
    return [x[2], ((1 - x[1]^2) * x[2] - x[1]) * 1.0e6]
end

# Define the system for the solver
function vdpol(t, x, dx)
    dx[:] = vdpolAD(x)
    return nothing
end

# Define the Jacobian function using AD
function getJacobian(t, x, J)
    J[:, :] = ForwardDiff.jacobian(vdpolAD, x)
    return nothing
end

# Flag to check whether plot is to be generated and saved or not
# Also checks if all solvers are successful
printFlag = true;

# Initial conditions
t0 = 0.0; T = [1.0:11.0;]; x0 = [2.0, 0.0];

# Get "reference solution"
Tol = 1.0e-14;
# for Tol < 1e-14 we get the error "TOLERANCES ARE TOO SMALL"
opt = OptionsODE(
    OPT_EPS => 1.11e-16, OPT_RTOL => Tol, OPT_ATOL => Tol,
    OPT_RHS_CALLMODE => RHS_CALL_INSITU,
    OPT_JACOBIMATRIX => getJacobian
);

(t, x, retcode, stats) = odecall(seulex, vdpol, [t0, T[end]], x0, opt);
t = [t0;t];
x = [x0';x];

p = plot(
    x = t, y = x[:, 1], Geom.path,
    Theme(
        line_width = 2pt, default_color = colorant"black",
        panel_stroke = colorant"black", key_position = :top,
        key_max_columns = 1, major_label_font_size = 24pt, minor_label_font_size = 22pt,
        key_title_font_size = 22pt, key_label_font_size = 20pt
    ),
    Coord.cartesian(ymin = -2.5, ymax = 2.5, xmin = 0, xmax = 11),
    Guide.xlabel("time (s)"), Guide.ylabel("Position (x)"),
    Guide.xticks(ticks = [0:11;]), Guide.yticks(ticks = [-2:0.5:2;])
);

draw(PNG("../../ImagesAndPDFs/Plots/vdpolPlot.png", 30cm, 20cm), p);

# graphics routine for the output of the state variables and Lagrange
# multipliers for the reentry problem
# following Stoer/Bulirsch 1973

# also suitable for representing the solution of the auxiliary problem with the
# associated initial guesses of the Lagrange multipliers

# output J is an approximation of the value of the functional to be minimized
# along the given trajectory

# authors: Folkmar Bornemann, Vishal Sontakke, 2016/04/23

using Gadfly
include("utility.jl");

function showSolution(t, x, T, aux, plotFlag, color, fName)
    K = 1000
    M = length(t)
    J = 0.0

    for j in 1:(M - 1)

        # calculating the piecewise trajectories

        tSpan = Array{Float64}(K)
        tSpan[:] = linspace(t[j], t[j + 1], K)

        if aux
            # Solver options
            # IVP Solver options
            opt = OptionsODE(
                OPT_RHS_CALLMODE => RHS_CALL_INSITU,
                OPT_RTOL => tol, OPT_ATOL => tol
            )

            (tGrid, xGrid, _, _) =
                odecall(odesolver, aux_f, tSpan, x[:, j], opt)

            xGrid = xGrid'

            if dir == "backward"
                tGrid = 1 - tGrid[end:-1:1]
                xGrid = xGrid[:, end:-1:1, :]
            end
            u = Array{Float64}(length(tGrid))
            for k in 1:length(tGrid)
                (xGrid[4:6, k], u[k]) = multiplier_start(tGrid[k], xGrid[:, k])
            end
        else
            # solver options
            opt = OptionsODE(
                OPT_RHS_CALLMODE => RHS_CALL_INSITU,
                OPT_RTOL => tol, OPT_ATOL => tol
            )

            (tGrid, xGrid, _, _) =
                odecall(odesolver, reentry_f, tSpan, x[:, j], opt)
            xGrid = xGrid'
        end

        # evaluation of Phi, Hamilton function and control
        H = zeros(tGrid)
        Phi = zeros(tGrid)
        u = zeros(tGrid)
        for k in 1:length(H)
            (Phi[k], H[k], u[k]) = utility(xGrid[:, k])
        end

        # trapezoidal rule for the approximation of functions in J in unit time
        for k in 1:(length(tGrid) - 1)
            J = J + 0.5 * T * (tGrid[k + 1] - tGrid[k]) * (Phi[k] + Phi[k + 1])
        end

        # convert units
        xGrid[2, :] = 180 / pi * xGrid[2, :]  # Flight-path angle in Degrees
        xGrid[3, :] = R * xGrid[3, :]       # Height in 1e5 ft

        # plot the 3 state variables and the 3 Lagrange multipliers
        lineWidth = 3pt

        for k in 1:6
            push!(
                plotVar[k + (k > 3)], layer(
                    x = tGrid, y = xGrid[k, :],
                    Geom.line, Theme(line_width = lineWidth, default_color = color)
                )
            )
        end

        # plot the control
        push!(
            plotVar[4], layer(
                x = tGrid, y = 180 / pi * u,
                Geom.line, Theme(line_width = lineWidth, default_color = color)
            )
        )

        # plot the Hamilton-function
        push!(
            plotVar[8], layer(
                x = tGrid, y = H,
                Geom.line, Theme(line_width = lineWidth, default_color = color)
            )
        )
    end

    plotVar[1].coord = Gadfly.Coord.Cartesian(xmin = 0, xmax = 1, ymin = 0.26, ymax = 0.38)
    plotVar[2].coord = Gadfly.Coord.Cartesian(xmin = 0, xmax = 1, ymin = -10, ymax = 6)
    plotVar[3].coord = Gadfly.Coord.Cartesian(xmin = 0, xmax = 1, ymin = 1.5, ymax = 4.5)
    plotVar[4].coord = Gadfly.Coord.Cartesian(xmin = 0, xmax = 1, ymin = -90, ymax = 90)
    plotVar[5].coord = Gadfly.Coord.Cartesian(xmin = 0, xmax = 1, ymin = -2, ymax = -0.4)
    plotVar[6].coord = Gadfly.Coord.Cartesian(xmin = 0, xmax = 1, ymin = -1, ymax = 2.5)
    plotVar[7].coord = Gadfly.Coord.Cartesian(xmin = 0, xmax = 1, ymin = -15, ymax = 15)
    plotVar[8].coord = Gadfly.Coord.Cartesian(xmin = 0, xmax = 1, ymin = -2.5e-10, ymax = 2.5e-10)

    if plotFlag
        minFontSize = 16pt
        majFontSize = 18pt
        for i in 1:8
            plotVar[i].theme = Gadfly.Theme(
                panel_stroke = colorant"black",
                minor_label_font_size = minFontSize,
                major_label_font_size = majFontSize
            )
        end
        draw(PDF(fName, 1855pt, 1001pt), vstack(hstack(plotVar[1], plotVar[2], plotVar[3], plotVar[4]), hstack(plotVar[5], plotVar[6], plotVar[7], plotVar[8])))
    end

    return J
end

# Check if all the packages are installed or not
cond = "Gadfly" in keys(Pkg.installed()) &&
    "Colors" in keys(Pkg.installed()) &&
    "ODEInterface" in keys(Pkg.installed()) &&
    "ForwardDiff" in keys(Pkg.installed());
@assert cond "Please check if the following package(s) are installed:\
    Gadfly\
    Colors\
    ODEInterface\
    ForwardDiff"

# Load all the required packages
using Gadfly
using Colors
using ODEInterface
using ForwardDiff
@ODEInterface.import_huge
loadODESolvers();

######################## Function for saving plots #################################
# Input:
# fileName = Name of the file where the plot is to be stored
#            (with or without extension)
# f_e = Array containing function evaluations as columns for each solver
# err = Array containing errors as columns for each solver
# solverNames = Array containing the names of solvers used in respective order
# plotSize = size of the plot to be created
###################################################################################
function savePlotPNG(
        fileName, f_e, err, solverNames,
        plotSize = [30cm, 30cm]
    )

    numOfLayers = length(solverNames)

    if !contains(fileName, ".")
        fileName = string(fileName, ".png")
    end

    plotColorsHex = [
        "#4D4D4D", "#5DA5DA", "#FAA43A", "#60BD68",
        "#F17CB0", "#B2912F", "#B276B2", "#DECF3F", "#F15854",
    ]
    plotColors = [parse(Colorant, c) for c in plotColorsHex]

    majorFontSize = 24pt
    minorFontSize = 20pt
    pointSize = 5pt

    myplot = plot(
        Scale.x_log10, Scale.y_log10,
        Coord.cartesian(xflip = true, xmin = -11),
        Guide.manual_color_key("Legend", solverNames, plotColorsHex[1:numOfLayers]),
        Guide.xlabel("error"), Guide.ylabel("#Function evaluations"),
        Theme(
            major_label_font_size = majorFontSize, panel_stroke = colorant"black",
            minor_label_font_size = minorFontSize, key_title_font_size = majorFontSize,
            key_label_font_size = minorFontSize, key_position = :top, key_max_columns = 1
        )
    )

    for i in 1:numOfLayers
        push!(
            myplot, layer(
                x = err[:, i], y = f_e[:, i], Geom.point, Geom.path,
                Theme(default_color = plotColors[i], default_point_size = pointSize)
            )
        )
    end

    draw(PNG(fileName, plotSize[1], plotSize[2]), myplot)
    return nothing
end

# Define the right-hand function for automatic differentiation
function vdpolAD(x)
    return [x[2], ((1 - x[1]^2) * x[2] - x[1]) * 1.0e6]
end

# Define the system for the solver
function vdpol(t, x, dx)
    dx[:] = vdpolAD(x)
    return nothing
end

# Define the Jacobian function using AD
function getJacobian(t, x, J)
    J[:, :] = ForwardDiff.jacobian(vdpolAD, x)
    return nothing
end

# Flag to check whether plot is to be generated and saved or not
# Also checks if all solvers are successful
printFlag = true;

# Initial conditions
t0 = 0.0; T = [1.0:11.0;]; x0 = [2.0, 0.0];

# Get "reference solution"
f = open("vdpolRefSol.txt");
lines = readlines(f);

x_ref = Array{Float64}(11);

tmp = Array{Float64}(22);
counter = 1;
for l in lines
    tmp[counter] = parse(Float64, l)
    counter += 1
end

x_ref = tmp[1:2:end];

close(f)

# Store the solver names for plotting
solverNames = ["RADAU", "RADAU5", "SEULEX"];

# Initialize the variables for plots
# f_e = number of function evaluations
f_e = zeros(33, 3);
# err = error wrt ref solution over all time steps and components
err = zeros(33, 3);
# flops = Floating point operations
flops = zeros(33, 3);

# Weights for computing flops
dim = 2; # dimension of the system
flopsRHS = 5; # Counted
flopsLU = ceil(2 * ((dim)^3) / 3); # As per LU algorithm (can be less)
flopsFW_BW = (dim)^2; # As per FW/BW algorithm (can be less)
flopsJac = ceil(1.5 * flopsRHS); # A guess at the moment

for i in 0:32

    # Set the tolerance for current run
    Tol = 10^(-2 - i / 4)

    # Set solver options
    opt = OptionsODE(
        OPT_EPS => 1.11e-16, OPT_ATOL => Tol, OPT_RTOL => Tol,
        OPT_RHS_CALLMODE => RHS_CALL_INSITU,
        OPT_JACOBIMATRIX => getJacobian
    )

    # Store the stats of the last t_end
    # for computing flops
    stats = Dict{AbstractString, Any}

    # Restart the solution for each end time
    # to ensure a more accurate solution
    # compared to dense output

    # Solve using RADAU
    x_radau = Array{Float64}(11)
    for j in 1:11
        (t, x, retcode, stats) = radau(vdpol, t0, T[j], x0, opt)
        # If solver fails do not continue further
        if retcode != 1
            println("Solver RADAU failed")
            printFlag = false
            break
        end
        x_radau[j] = x[1]
        f_e[i + 1, 1] = stats.vals[13]
    end
    # If solver fails do not continue further
    if !printFlag
        break
    end
    err[i + 1, 1] = norm(x_radau - x_ref, Inf)
    flops[i + 1, 1] = stats["no_rhs_calls"] * flopsRHS +
        stats["no_fw_bw_subst"] * flopsFW_BW +
        stats["no_jac_calls"] * flopsJac +
        stats["no_lu_decomp"] * flopsLU

    # Solve using RADAU5
    x_radau5 = Array{Float64}(11)
    for j in 1:11
        (t, x, retcode, stats) = radau5(vdpol, t0, T[j], x0, opt)
        # If solver fails do not continue further
        if retcode != 1
            println("Solver RADAU5 failed")
            printFlag = false
            break
        end
        x_radau5[j] = x[1]
        f_e[i + 1, 2] = stats.vals[13]
    end
    # If solver fails do not continue further
    if !printFlag
        break
    end
    err[i + 1, 2] = norm(x_radau5 - x_ref, Inf)
    flops[i + 1, 2] = stats["no_rhs_calls"] * flopsRHS +
        stats["no_fw_bw_subst"] * flopsFW_BW +
        stats["no_jac_calls"] * flopsJac +
        stats["no_lu_decomp"] * flopsLU

    # Solve using SEULEX
    x_seulex = Array{Float64}(11)
    for j in 1:11
        (t, x, retcode, stats) = seulex(vdpol, t0, T[j], x0, opt)
        # If solver fails do not continue further
        if retcode != 1
            println("Solver seulex failed")
            printFlag = false
            break
        end
        x_seulex[j] = x[1]
        f_e[i + 1, 3] = stats.vals[13]
    end
    # If solver fails do not continue further
    if !printFlag
        break
    end
    # Get the error over all the components and
    err[i + 1, 3] = norm(x_seulex - x_ref, Inf)
    flops[i + 1, 3] = stats["no_rhs_calls"] * flopsRHS +
        stats["no_fw_bw_subst"] * flopsFW_BW +
        stats["no_jac_calls"] * flopsJac +
        stats["no_lu_decomp"] * flopsLU
end

# Save the plot in PNG format
# if all the solvers were successful
if printFlag
    savePlotPNG("vdpolPrecisionTest", f_e, err, solverNames)
else
    println("Plot cannot be generated due to failure")
end

## Old reference solution
Tol = 1.0e-14;
# for Tol < 1e-14 we get the error "TOLERANCES ARE TOO SMALL"
opt = OptionsODE(
    OPT_EPS => 1.11e-16, OPT_RTOL => Tol, OPT_ATOL => Tol,
    OPT_RHS_CALLMODE => RHS_CALL_INSITU,
    OPT_JACOBIMATRIX => getJacobian
);

# Store only the desired component
# Here, only the first component is desired
# The second component is the first derivative of the first component
# due to the fact that it is a second order system.
# Hence error will be taken over the first component only.
x_ref = Array{Float64}(11);

for i in 1:11
    (t, x, retcode, stats) = seulex(vdpol, t0, T[i], x0, opt)
    if retcode != 1
        printFlag = false
        break
    end
    x_ref[i] = x[1]
end

# Functions for ODE-Solver: Dop853

"""Name for Loading dop853 solver (64bit integers)."""
const DL_DOP853 = "dop853"

"""Name for Loading dop853 solver (32bit integers)."""
const DL_DOP853_I32 = "dop853_i32"

"""macro for import Dop853 solver."""
macro import_dop853()
    return :(
        using ODEInterface: dop853, dop853_i32
    )
end

"""macro for import Dop853 dynamic lib names."""
macro import_DLdop853()
    return :(
        using ODEInterface: DL_DOP853, DL_DOP853_I32
    )
end

"""macro for importing Dopri5 help."""
macro import_dop853_help()
    return :(
        using ODEInterface: help_dop853_compile, help_dop853_license
    )
end

"""
    function dop853(rhs, t0::Real, T::Real,
                    x0::Vector, opt::AbstractOptionsODE)
         -> (t,x,retcode,stats)

`retcode` can have the following values:

      1: computation successful
      2: computation. successful, but interrupted by output function
     -1: input is not consistent
     -2: larger OPT_MAXSTEPS is needed
     -3: step size becomes too small
     -4: problem is probably stiff (interrupted)

main call for using Fortran-dopri5 solver. In `opt` the following
options are used:

    ╔═════════════════╤══════════════════════════════════════════╤═════════╗
    ║  Option OPT_…   │ Description                              │ Default ║
    ╠═════════════════╪══════════════════════════════════════════╪═════════╣
    ║ RTOL     &      │ relative and absolute error tolerances   │    1e-3 ║
    ║ ATOL            │ both scalars or both vectors with the    │    1e-6 ║
    ║                 │ length of length(x0)                     │         ║
    ║                 │ error(xₖ) ≤ OPT_RTOLₖ⋅|xₖ|+OPT_ATOLₖ     │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTFCN       │ output function                          │ nothing ║
    ║                 │ see help_outputfcn                       │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ OUTPUTMODE      │ OUTPUTFCN_NEVER:                         │   NEVER ║
    ║                 │   dont't call OPT_OUTPUTFCN              │         ║
    ║                 │ OUTPUTFCN_WODENSE                        │         ║
    ║                 │   call OPT_OUTPUTFCN, but without        │         ║
    ║                 │   possibility for dense output           │         ║
    ║                 │ OUTPUTFCN_DENSE                          │         ║
    ║                 │   call OPT_OUTPUTFCN with support for    │         ║
    ║                 │   dense output                           │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSTEPS        │ maximal number of allowed steps          │  100000 ║
    ║                 │ OPT_MAXSTEPS > 0                         │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ STEST           │ stiffness test                           │    1000 ║
    ║                 │ done after every step number k*OPT_STEST │         ║
    ║                 │ OPT_STEST < 0 for turning test off       │         ║
    ║                 │ OPT_STEST ≠ 0                            │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ EPS             │ the rounding unit                        │ 2.3e-16 ║
    ║                 │ 1e-35 < OPT_EPS < 1.0                    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ RHO             │ safety factor in step size predcition    │     0.9 ║
    ║                 │ 1e-4  < OPT_RHO < 1.0                    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ SSMINSEL   &    │ parameters for step size selection       │   0.333 ║
    ║ SSMAXSEL        │ The new step size is chosen subject to   │     6.0 ║
    ║                 │ the restriction                          │         ║
    ║                 │ OPT_SSMINSEL ≤ hnew/hold ≤ OPT_SSMAXSEL  │         ║
    ║                 │ OPT_SSMINSEL, OPT_SSMAXSEL > 0           │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ SSBETA          │ β for stabilized step size control       │     0.0 ║
    ║                 │ OPT_SSBETA ≤ 0.2                         │         ║
    ║                 │ if OPT_SSBETA < 0 then OPT_SSBETA = 0    │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ MAXSS           │ maximal step size                        │  T - t0 ║
    ║                 │ OPT_MAXSS ≠ 0                            │         ║
    ╟─────────────────┼──────────────────────────────────────────┼─────────╢
    ║ INITIALSS       │ initial step size                        │     0.0 ║
    ║                 │ if OPT_INITIALSS == 0 then a initial     │         ║
    ║                 │ guess is computed                        │         ║
    ╚═════════════════╧══════════════════════════════════════════╧═════════╝

"""
function dop853(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return dop853_impl(rhs, t0, T, x0, opt, DopriArguments{Int64}(Int64(0)))
end

"""
dop853 with 32bit integers, see dop853
"""
function dop853_i32(
        rhs, t0::Real, T::Real,
        x0::Vector, opt::AbstractOptionsODE
    )
    return dop853_impl(rhs, t0, T, x0, opt, DopriArguments{Int32}(Int32(0)))
end

"""
     function dop853_impl(rhs,
             t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
             args::DopriArguments{FInt}) where {FInt<:FortranInt}

implementation of dop853 for FInt.
"""
function dop853_impl(
        rhs,
        t0::Real, T::Real, x0::Vector, opt::AbstractOptionsODE,
        args::DopriArguments{FInt}
    ) where {FInt <: FortranInt}

    (lio, l, l_g, l_solver, lprefix) = solver_start("dop853", rhs, t0, T, x0, opt)

    (method_dop853, method_contd8) = getAllMethodPtrs(
        (FInt == Int64) ? DL_DOP853 : DL_DOP853_I32
    )

    (d, nrdense, rhs_mode, output_mode, output_fcn) =
        dopri_extract_commonOpt(t0, T, x0, opt, args)

    # WORK memory
    args.LWORK = [11 * d + 8 * nrdense + 21]
    args.WORK = zeros(Float64, args.LWORK[1])

    # IWORK memory
    args.LIWORK = [nrdense + 21]
    args.IWORK = zeros(FInt, args.LIWORK[1])

    # fill IWORK
    OPT = nothing
    try
        OPT = OPT_MAXSTEPS; args.IWORK[1] = convert(FInt, getOption(opt, OPT, 100000))
        @assert 0 < args.IWORK[1]
        args.IWORK[2] = 1        # choice for coefficients
        args.IWORK[3] = -1       # don't print anything
        OPT = OPT_STEST; args.IWORK[4] = convert(FInt, getOption(opt, OPT_STEST, 1000))
        @assert 0 ≠ args.IWORK[4]
        args.IWORK[5] = nrdense
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    # fill WORK
    try
        OPT = OPT_EPS; args.WORK[1] = convert(Float64, getOption(opt, OPT, 2.3e-16))
        @assert 1.0e-35 < args.WORK[1] < 1.0
        OPT = OPT_RHO; args.WORK[2] = convert(Float64, getOption(opt, OPT, 0.9))
        @assert 1.0e-4 < args.WORK[2] < 1.0
        OPT = OPT_SSMINSEL; args.WORK[3] = convert(Float64, getOption(opt, OPT, 0.333))
        @assert 0.0 < args.WORK[3]
        OPT = OPT_SSMAXSEL; args.WORK[4] = convert(Float64, getOption(opt, OPT, 6.0))
        @assert 0.0 < args.WORK[4]
        OPT = OPT_SSBETA; args.WORK[5] = convert(Float64, getOption(opt, OPT, 0.0))
        @assert args.WORK[5] ≤ 0.2
        OPT = OPT_MAXSS; args.WORK[6] = convert(Float64, getOption(opt, OPT, T - t0))
        @assert 0 ≠ args.WORK[6]
        OPT = OPT_INITIALSS; args.WORK[7] = convert(Float64, getOption(opt, OPT, 0.0))
    catch e
        throw(ArgumentErrorODE("Option '$OPT': Not valid", :opt, e))
    end

    args.RPAR = zeros(Float64, 0)
    args.IDID = zeros(FInt, 1)
    rhs_lprefix = "unsafe_HW1RHSCallback: "
    out_lprefix = "unsafe_dopriSoloutCallback: "
    eval_lprefix = "eval_sol_fcn_closure: "

    cbi = DopriInternalCallInfos(
        lio, l, rhs, rhs_mode, rhs_lprefix,
        output_mode, output_fcn,
        Dict(), out_lprefix, eval_sol_fcn_noeval, eval_lprefix,
        NaN, NaN, Vector{Float64}(),
        Vector{FInt}(undef, 1), Vector{Float64}(undef, 1),
        Ptr{Float64}(C_NULL), Ptr{FInt}(C_NULL), Ptr{FInt}(C_NULL)
    )

    if output_mode == OUTPUTFCN_DENSE
        cbi.eval_sol_fcn = create_dopri_eval_sol_fcn_closure(cbi, d, method_contd8)
    end

    args.FCN = unsafe_HW1RHSCallback_c(cbi, FInt(0))
    args.SOLOUT = output_mode ≠ OUTPUTFCN_NEVER ?
        unsafe_dopriSoloutCallback_c(cbi, FInt(0)) :
        @cfunction(dummy_func, Cvoid, ())
    args.IPAR = cbi

    output_mode ≠ OUTPUTFCN_NEVER &&
        call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_INIT,
        args.t[1], args.tEnd[1], args.x, eval_sol_fcn_init
    ) # ignore result

    if l_solver
        println(lio, lprefix, "call Fortran-dop853 $method_dop853 with")
        dump(lio, args)
    end

    ccall(
        method_dop853, Cvoid,
        (
            Ptr{FInt}, Ptr{Cvoid},                    # N=d, Rightsidefunc
            Ptr{Float64}, Ptr{Float64}, Ptr{Float64},  # t, x, tEnd
            Ptr{Float64}, Ptr{Float64}, Ptr{FInt},     # RTOL, ATOL, ITOL
            Ptr{Cvoid}, Ptr{FInt},                     # Soloutfunc, IOUT
            Ptr{Float64}, Ptr{FInt},                   # WORK, LWORK
            Ptr{FInt}, Ptr{FInt},                      # IWORK, LIWORK
            Ptr{Float64}, Ref{DopriInternalCallInfos}, # RPAR, IPAR,
            Ptr{FInt},                                 #  IDID
        ),
        args.N, args.FCN,
        args.t, args.x, args.tEnd,
        args.RTOL, args.ATOL, args.ITOL,
        args.SOLOUT, args.IOUT,
        args.WORK, args.LWORK,
        args.IWORK, args.LIWORK,
        args.RPAR, args.IPAR, args.IDID,
    )

    if l_solver
        println(lio, lprefix, "Fortran-dop853 $method_dop853 returned")
        dump(lio, args)
    end

    output_mode ≠ OUTPUTFCN_NEVER &&
        call_julia_output_fcn(
        cbi, OUTPUTFCN_CALL_DONE,
        args.t[1], args.tEnd[1], args.x, eval_sol_fcn_done
    ) # ignore result

    l_g && println(lio, lprefix, string("done IDID=", args.IDID[1]))
    stats = Dict{AbstractString, Any}(
        "step_predict" => args.WORK[7],
        "no_rhs_calls" => args.IWORK[17],
        "no_steps" => args.IWORK[18],
        "no_steps_accepted" => args.IWORK[19],
        "no_steps_rejected" => args.IWORK[20]
    )
    return (args.t[1], args.x, args.IDID[1], stats)

end

"""
## Compile DOP853

The julia ODEInterface tries to compile and link the solvers
automatically at the build-time of this module. The following
calls need only be done, if one uses a different compiler and/or if
one wants to change/add some compiler options.

The Fortran source code can be found at:

     http://www.unige.ch/~hairer/software.html

See `help_dop853_license` for the license information.

### Using `gfortran` and 64bit integers (Linux and Mac)

Here is an example how to compile DOP853 with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fPIC -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o dop853.o dop853.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o dop853.so dop853.o
     gfortran -shared -fPIC -o dop853.dylib dop853.o

### Using `gfortran` and 64bit integers (Windows)

Here is an example how to compile DOP853 with `Float64` reals and
`Int64` integers with `gfortran`:

     gfortran -c -fdefault-integer-8
              -fdefault-real-8 -fdefault-double-8
              -o dop853.o dop853.f

In order to get create a shared library (from the object file above) use

     gfortran -shared -o dop853.dll dop853.o

### Using `gfortran` and 32bit integers (Linux and Mac)

Here is an example how to compile DOP853 with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c -fPIC
              -fdefault-real-8 -fdefault-double-8
              -o dop853_i32.o   dop853.f

In order to get create a shared library (from the object file above) use
one of the forms below (1st for Linux, 2nd for Mac):

     gfortran -shared -fPIC -o dop853_i32.so dop853_i32.o
     gfortran -shared -fPIC -o dop853_i32.dylib dop853_i32.o

### Using `gfortran` and 32bit integers (Windows)

Here is an example how to compile DOP853 with `Float64` reals and
`Int32` integers with `gfortran`:

     gfortran -c
              -fdefault-real-8 -fdefault-double-8
              -o dop853_i32.o   dop853.f

In order to get create a shared library (from the object file above) use:

     gfortran -shared -o dop853_i32.dll dop853_i32.o

"""
function help_dop853_compile()
    return Docs.doc(help_dop853_compile)
end

function help_dop853_license()
    return Docs.doc(help_dop853_license)
end

@doc(@doc(hw_license), help_dop853_license)

# Add information about solver in global solverInfo-array.
push!(
    solverInfo,
    SolverInfo(
        "dop853",
        "Runge-Kutta method of order 8(5,3) due to Dormand & Prince",
        tuple(
            :OPT_RTOL, :OPT_ATOL,
            :OPT_OUTPUTMODE, :OPT_OUTPUTFCN,
            :OPT_MAXSTEPS, :OPT_STEST, :OPT_EPS, :OPT_RHO,
            :OPT_SSMINSEL, :OPT_SSMAXSEL, :OPT_SSBETA,
            :OPT_MAXSS, :OPT_INITIALSS
        ),
        tuple(
            SolverVariant(
                "dop853_i64",
                "Dop853 with 64bit integers",
                DL_DOP853,
                tuple("dop853", "contd8")
            ),
            SolverVariant(
                "dop853_i32",
                "Dop853 with 32bit integers",
                DL_DOP853_I32,
                tuple("dop853", "contd8")
            ),
        ),
        help_dop853_compile,
        help_dop853_license,
    )
)


# vim:syn=julia:cc=79:fdm=indent:

# Load required packages
using Gadfly
using Colors
using ODEInterface
using HDF5
@ODEInterface.import_huge
loadODESolvers();

# Number of subdivisions of the rope
global n = 40;

# Define the system of ODEs
function rope(t, x, dx)
    n2 = n * n  # n^2
    n3by4 = convert(Int64, 3 * n / 4)  # 3*n/4

    # Force in x-direction
    Fx = 0.4
    # Force in y-direction
    Fy = cosh(4 * t - 2.5)^(-4)

    # Compute required matrices
    c = -cos(x[1:(n - 1)] - x[2:n])
    cDiag = [1;2 * ones(n - 2);3]
    C = spdiagm((c, cDiag, c), (-1, 0, 1))

    d = -sin(x[1:(n - 1)] - x[2:n])
    D = spdiagm((-d, d), (-1, 1))

    # Compute the inhomogeneous term
    v = -(n2 + n / 2 - n * [1:n;]) .* sin(x[1:n]) - n2 * sin(x[1:n]) * Fx
    v[1:n3by4] = v[1:n3by4] + n2 * cos(x[1:n3by4]) * Fy

    w = D * v + x[(n + 1):(2 * n)] .^ 2
    u = C \ w

    # Write down the system
    dx[1:n] = x[(n + 1):(2 * n)]
    dx[(n + 1):(2 * n)] = C * v + D * u

    return nothing
end

# Initial Conditions
t0 = 0.0; T = 3.723; x0 = zeros(2 * n);

# Compute the "reference solution"
opt = OptionsODE(
    OPT_EPS => 1.11e-16, OPT_RHS_CALLMODE => RHS_CALL_INSITU,
    OPT_RTOL => 1.0e-16, OPT_ATOL => 1.0e-16
);
(t, x_ref, retcode, stats) = odecall(dop853, rope, [t0, T], x0, opt);

x = zeros(length(t), n + 1);
y = zeros(length(t), n + 1);
l = 1 / n;

for j in 1:length(t)
    for i in 1:n
        x[j, i + 1] = x[j, i] + l * sin(x_ref[j, i])
        y[j, i + 1] = y[j, i] + l * cos(x_ref[j, i])
    end
end

h5write("ropePlotx.h5", "x", x)
h5write("ropePloty.h5", "y", y)
h5write("ropePlott.h5", "t", t)

# right hand side of the ODE system for the auxiliary boundary value problem
# with the given control 'u' for the reentry problem
# following Stoer/Bulirsch 1973

# authors: Folkmar Bornemann, Vishal Sontakke, 2016/04/23

function aux_f(t, x, dx)
    if dir == "forward"
        aux_f_(t, x, dx)
    elseif dir == "backward"
        tmp = zeros(dx)
        aux_f_(1 - t, x, tmp)
        dx[:] = -tmp
    end

    return nothing
end

function aux_f_(t, x, dx)

    p = x[4:5]
    T = x[6]

    # begin of the part generated by Maple

    t5 = atan(alpha * (p[2] - t))
    u = p[1] * t5
    t7 = Sm * rho0
    t9 = x[3]
    t11 = exp(-beta * R * t9)
    t12 = x[1]
    t13 = t12^2
    t17 = cos(u)
    t23 = x[2]
    t24 = sin(t23)
    t26 = 0.1e1 + t9
    t27 = t26^2
    t28 = 0.1e1 / t27
    dx[1] = T * (-t7 * t11 * t13 * (c[1] - c[2] * t17) / 0.2e1 - g * t24 * t28)
    t34 = sin(u)
    t38 = cos(t23)
    t40 = 0.1e1 / R
    dx[2] = T * (t7 * t11 * t12 * c[3] * t34 / 0.2e1 + t12 * t38 * t40 / t26 - g * t38 / t12 * t28)
    dx[3] = T * t12 * t24 * t40
    dx[4] = 0.0e0
    dx[5] = 0.0e0
    dx[6] = 0.0e0

    return nothing
end

# boundary conditions for the reentry problem
# following Stoer/Bulirsch 1973

# authors: Folkmar Bornemann, Vishal Sontakke, 2016/04/23

function reentry_bc(xa, xb, r)

    lambda = xb[4:6]

    r[1] = xa[1] - v0
    r[2] = xa[2] - gamma0
    r[3] = xa[3] - h0

    r[4] = xb[1] - v1
    r[5] = xb[2] - gamma1
    r[6] = xb[3] - h1

    # begin of the part generated by Maple

    t1 = lambda[2]
    t2 = c[3]
    t4 = lambda[1]
    t6 = xb[1]
    t7 = 0.1e1 / t6
    t9 = c[2]
    u = atan(t1 * t2 / t4 * t7 / t9)
    t13 = t6^2
    t16 = xb[3]
    t18 = exp(-beta * R * t16)
    t20 = sqrt(rho0 * t18)
    t23 = Sm * rho0
    t26 = cos(u)
    t32 = xb[2]
    t33 = sin(t32)
    t35 = 0.1e1 + t16
    t36 = t35^2
    t37 = 0.1e1 / t36
    t43 = sin(u)
    t47 = cos(t32)
    t49 = 0.1e1 / R
    r[7] = 0.1e2 * t13 * t6 * t20 + t4 * (-t23 * t18 * t13 * (c[1] - t9 * t26) / 0.2e1 - g * t33 * t37) + t1 * (t23 * t18 * t6 * t2 * t43 / 0.2e1 + t6 * t47 * t49 / t35 - g * t47 * t7 * t37) + lambda[3] * t6 * t33 * t49
    return nothing
end

using ODEInterface
@ODEInterface.import_huge

# We look at the boundary value problem
#
#                       sin⁴(x)
#    ε⋅y'(x) = sin²(x)-λ──────  ;   y(-π/2)=y(π/2)=1
#                         y
#
# Here ε is given (e.g. ε=0.1) and λ is an unknown parameter: λ'=0
#
# We use colsys/colnew and a "homotopy": starting with ε=1.0, using this
# solution as start-guess for ε=0.5, then using this as start guess
# for ε=0.2 and then ε=0.1

a, b = -pi / 2, pi / 2
orders = [1, 1]
ζ = [a, b]

found_pyplot = true
try
    using PyPlot
catch
    found_pyplot = false
end

global ε = nothing
global ε_old = nothing
global sol_old = nothing

function rhs(x, z, f)
    s² = sin(x)^2
    f[1] = (s² - z[2] * s² * s² / z[1]) / ε
    return f[2] = 0.0
end

function Drhs(x, z, df)
    df[:] = 0.0
    s⁴ = sin(x)^4
    df[1, 1] = z[2] * s⁴ / (z[1]^2)
    return df[1, 2] = -s⁴ / z[1]
end

function bc(i, z, bc)
    return bc[1] = z[1] - 1.0
end

function Dbc(i, z, dbc)
    dbc[1] = 1.0
    return dbc[2] = 0.0
end

function initial_guess(x, z, dmz)
    z[1] = 0.5
    z[2] = 1.0
    return rhs(x, z, dmz)
end

opt = OptionsODE(
    "example 6",
    OPT_BVPCLASS => 2, OPT_COLLOCATIONPTS => 7,
    OPT_RTOL => [1.0e-4, 1.0e-4], OPT_MAXSUBINTERVALS => 200
)
xx = collect(linspace(a, b, 400));

sol = nothing
for ε in [1.0, 0.5, 0.2, 0.1]
    guess = sol_old !== nothing ? sol_old : initial_guess
    sol, retcode, stats = colnew([a, b], orders, ζ, rhs, Drhs, bc, Dbc, guess, opt)
    @printf("ε=%g, retcode=%i\n", ε, retcode)
    @assert retcode > 0
    zz_new = evalSolution(sol, xx)
    if sol_old === nothing
        zz_old = copy(zz_new); zz_old[:, 1] = 0.5; zz_old[:, 2] = NaN
    else
        zz_old = evalSolution(sol_old, xx)
    end
    if found_pyplot
        plot(xx, zz_old[:, 1], xx, zz_new[:, 1]);grid(true)
    end
    sol_old = sol; ε_old = ε
end

xx = collect(linspace(a, b, 9))
zz = evalSolution(sol, xx)
println("Solution at some points:")

display([ xx' ; zz[:, 1]' ])
println()

# vim:syn=julia:cc=79:fdm=indent:

# Load the required packages
using ODE
using JLD
using ForwardDiff

# Set precision to quadruple precision (QP)
# QP has 113 bits of precision
set_bigfloat_precision(113);

# Number of subdivisions of the rope
global n = 40;

# Define the right-hand function
function rope(t, x)

    n2 = n * n  # n^2
    n3by4 = convert(Int64, 3 * n / 4)  # 3*n/4

    # Force in x-direction
    Fx = parse(BigFloat, "0.4")
    # Force in y-direction
    Fy = cosh(4 * t - 2.5)^(-4)

    # Compute required matrices
    c = -cos(x[1:(n - 1)] - x[2:n])
    cDiag = [
        one(BigFloat);
        2 * ones(BigFloat, n - 2);
        3 * one(BigFloat)
    ]
    C = spdiagm((c, cDiag, c), (-1, 0, 1))

    d = -sin(x[1:(n - 1)] - x[2:n])
    D = spdiagm((-d, d), (-1, 1))

    # Compute the inhomogeneous term
    v = -(n2 + n / 2 - n * [1:n;]) .* sin(x[1:n]) - n2 * sin(x[1:n]) * Fx
    v[1:n3by4] = v[1:n3by4] + n2 * cos(x[1:n3by4]) * Fy

    w = D * v + x[(n + 1):(2 * n)] .^ 2
    u = C \ w

    # Write down the system
    return [x[(n + 1):(2 * n)], C * v + D * u]
end

# Set up the initial conditions
t0 = zero(BigFloat);
T = parse(BigFloat, "3.723");
x0 = zeros(BigFloat, 2 * n);

# Set the tolerance
Tol = parse(BigFloat, "1e-33");

# Solve and get the solution at T = tEnd
(t_rope, x_tmp_rope) = ode78(
    rope, x0, [t0;T];
    reltol = Tol, abstol = Tol, points = :specified
);

x_ref = Array{BigFloat}(n);

x_ref[:] = x_tmp_rope[2, 1][1:n];

save("refSolRope.jld", "x_ref", x_ref);

#!/bin/bash
if [[ $target == *mingw* ]] ; then

# dopri
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dopri5.o ./dopri5.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dopri5_i32.o ./dopri5.f
gfortran -shared -o ./dopri5.dll ./dopri5.o
gfortran -shared -o ./dopri5_i32.dll ./dopri5_i32.o
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dop853.o ./dop853.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dop853_i32.o ./dop853.f
gfortran -shared -o ./dop853.dll ./dop853.o
gfortran -shared -o ./dop853_i32.dll ./dop853_i32.o

# odex
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./odex.o ./odex.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./odex_i32.o ./odex.f
gfortran -shared -o ./odex.dll ./odex.o
gfortran -shared -o ./odex_i32.dll ./odex_i32.o

# lapack
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dc_lapack.o ./dc_lapack.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dc_lapack_i32.o ./dc_lapack.f
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./lapack.o ./lapack.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./lapack_i32.o ./lapack.f
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./lapackc.o ./lapackc.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./lapackc_i32.o ./lapackc.f

# radau
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./radau5.o ./radau5.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./radau5_i32.o ./radau5.f
gfortran -shared -o ./radau5.dll ./radau5.o ./dc_lapack.o ./lapack.o ./lapackc.o
gfortran -shared -o ./radau5_i32.dll ./radau5_i32.o ./dc_lapack_i32.o ./lapack_i32.o ./lapackc_i32.o
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./radau.o ./radau.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./radau_i32.o ./radau.f
gfortran -shared -o ./radau.dll ./radau.o ./dc_lapack.o ./lapack.o ./lapackc.o
gfortran -shared -o ./radau_i32.dll ./radau_i32.o ./dc_lapack_i32.o ./lapack_i32.o ./lapackc_i32.o

# seulex
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./seulex.o ./seulex.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./seulex_i32.o ./seulex.f
gfortran -shared -o ./seulex.dll ./seulex.o ./dc_lapack.o ./lapack.o ./lapackc.o
gfortran -shared -o ./seulex_i32.dll ./seulex_i32.o ./dc_lapack_i32.o ./lapack_i32.o ./lapackc_i32.o

# rodas
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./rodas.o ./rodas.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./rodas_i32.o ./rodas.f
gfortran -shared -o ./rodas.dll ./rodas.o ./dc_lapack.o ./lapack.o ./lapackc.o
gfortran -shared -o ./rodas_i32.dll ./rodas_i32.o ./dc_lapack_i32.o ./lapack_i32.o ./lapackc_i32.o

# slatec
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./slatec.o ./slatec.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./slatec_i32.o ./slatec.f

# ddeabm
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ddeabm.o ./ddeabm.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ddeabm_i32.o ./ddeabm.f
gfortran -shared -o ./ddeabm.dll ./ddeabm.o ./slatec.o
gfortran -shared -o ./ddeabm_i32.dll ./ddeabm_i32.o ./slatec_i32.o

# ddebdf
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ddebdf.o ./ddebdf.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ddebdf_i32.o ./ddebdf.f
gfortran -shared -o ./ddebdf.dll ./ddebdf.o ./slatec.o
gfortran -shared -o ./ddebdf_i32.dll ./ddebdf_i32.o ./slatec_i32.o

# bvpsol
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./bvpsol.o ./bvpsol.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./bvpsol_i32.o ./bvpsol.f
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./linalg_bvpsol.o ./linalg_bvpsol.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./linalg_bvpsol_i32.o ./linalg_bvpsol.f
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./zibconst.o ./zibconst.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./zibconst_i32.o ./zibconst.f
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ma28_bvpsol.o ./ma28_bvpsol.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ma28_bvpsol_i32.o ./ma28_bvpsol.f
gfortran -shared -o ./bvpsol.dll ./bvpsol.o ./linalg_bvpsol.o ./zibconst.o ./ma28_bvpsol.o
gfortran -shared -o ./bvpsol_i32.dll ./bvpsol_i32.o ./linalg_bvpsol_i32.o ./zibconst_i32.o ./ma28_bvpsol_i32.o

# colnew
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./colnew.o ./colnew.f
gfortran -c -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./colnew_i32.o ./colnew.f
gfortran -shared -o ./colnew.dll ./colnew.o
gfortran -shared -o ./colnew_i32.dll ./colnew_i32.o

# bvpm2
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./bvp_la-2.o ./bvp_la-2.f
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -std=f2008 -o ./bvp_m-2.o ./bvp_m-2.f90
gfortran -c -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -Wall -Wextra -Wimplicit-interface -std=f2008ts -o ./bvp_m_proxy.o ./bvp_m_proxy.f90
gfortran -shared -o ./bvp_m_proxy.dll ./bvp_m_proxy.o ./bvp_m-2.o ./bvp_la-2.o
cp *.dll $libdir



elif [[ $target == *apple* ]] ; then

# dopri
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dopri5.o ./dopri5.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dopri5_i32.o ./dopri5.f
gfortran -shared -fPIC -o ./dopri5.dylib ./dopri5.o
gfortran -shared -fPIC -o ./dopri5_i32.dylib ./dopri5_i32.o
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dop853.o ./dop853.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dop853_i32.o ./dop853.f
gfortran -shared -fPIC -o ./dop853.dylib ./dop853.o
gfortran -shared -fPIC -o ./dop853_i32.dylib ./dop853_i32.o

# odex
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./odex.o ./odex.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./odex_i32.o ./odex.f
gfortran -shared -fPIC -o ./odex.dylib ./odex.o
gfortran -shared -fPIC -o ./odex_i32.dylib ./odex_i32.o

# lapack
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dc_lapack.o ./dc_lapack.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dc_lapack_i32.o ./dc_lapack.f
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./lapack.o ./lapack.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./lapack_i32.o ./lapack.f
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./lapackc.o ./lapackc.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./lapackc_i32.o ./lapackc.f

# radau
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./radau5.o ./radau5.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./radau5_i32.o ./radau5.f
gfortran -shared -fPIC -o ./radau5.dylib ./radau5.o ./dc_lapack.o ./lapack.o ./lapackc.o
gfortran -shared -fPIC -o ./radau5_i32.dylib ./radau5_i32.o ./dc_lapack_i32.o ./lapack_i32.o ./lapackc_i32.o
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./radau.o ./radau.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./radau_i32.o ./radau.f
gfortran -shared -fPIC -o ./radau.dylib ./radau.o ./dc_lapack.o ./lapack.o ./lapackc.o
gfortran -shared -fPIC -o ./radau_i32.dylib ./radau_i32.o ./dc_lapack_i32.o ./lapack_i32.o ./lapackc_i32.o

# seulex
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./seulex.o ./seulex.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./seulex_i32.o ./seulex.f
gfortran -shared -fPIC -o ./seulex.dylib ./seulex.o ./dc_lapack.o ./lapack.o ./lapackc.o
gfortran -shared -fPIC -o ./seulex_i32.dylib ./seulex_i32.o ./dc_lapack_i32.o ./lapack_i32.o ./lapackc_i32.o

# rodas
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./rodas.o ./rodas.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./rodas_i32.o ./rodas.f
gfortran -shared -fPIC -o ./rodas.dylib ./rodas.o ./dc_lapack.o ./lapack.o ./lapackc.o
gfortran -shared -fPIC -o ./rodas_i32.dylib ./rodas_i32.o ./dc_lapack_i32.o ./lapack_i32.o ./lapackc_i32.o

# slatec
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./slatec.o ./slatec.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./slatec_i32.o ./slatec.f

# ddeabm
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ddeabm.o ./ddeabm.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ddeabm_i32.o ./ddeabm.f
gfortran -shared -fPIC -o ./ddeabm.dylib ./ddeabm.o ./slatec.o
gfortran -shared -fPIC -o ./ddeabm_i32.dylib ./ddeabm_i32.o ./slatec_i32.o

# ddebdf
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ddebdf.o ./ddebdf.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ddebdf_i32.o ./ddebdf.f
gfortran -shared -fPIC -o ./ddebdf.dylib ./ddebdf.o ./slatec.o
gfortran -shared -fPIC -o ./ddebdf_i32.dylib ./ddebdf_i32.o ./slatec_i32.o

# bvpsol
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./bvpsol.o ./bvpsol.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./bvpsol_i32.o ./bvpsol.f
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./linalg_bvpsol.o ./linalg_bvpsol.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./linalg_bvpsol_i32.o ./linalg_bvpsol.f
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./zibconst.o ./zibconst.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./zibconst_i32.o ./zibconst.f
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ma28_bvpsol.o ./ma28_bvpsol.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ma28_bvpsol_i32.o ./ma28_bvpsol.f
gfortran -shared -fPIC -o ./bvpsol.dylib ./bvpsol.o ./linalg_bvpsol.o ./zibconst.o ./ma28_bvpsol.o
gfortran -shared -fPIC -o ./bvpsol_i32.dylib ./bvpsol_i32.o ./linalg_bvpsol_i32.o ./zibconst_i32.o ./ma28_bvpsol_i32.o

# colnew
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./colnew.o ./colnew.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./colnew_i32.o ./colnew.f
gfortran -shared -fPIC -o ./colnew.dylib ./colnew.o
gfortran -shared -fPIC -o ./colnew_i32.dylib ./colnew_i32.o

# bvpm2
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./bvp_la-2.o ./bvp_la-2.f
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -std=f2008 -o ./bvp_m-2.o ./bvp_m-2.f90
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -Wall -Wextra -Wimplicit-interface -std=f2008ts -o ./bvp_m_proxy.o ./bvp_m_proxy.f90
gfortran -shared -fPIC -o ./bvp_m_proxy.dylib ./bvp_m_proxy.o ./bvp_m-2.o ./bvp_la-2.o
cp *.dylib $libdir



else

# dopri
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dopri5.o ./dopri5.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dopri5_i32.o ./dopri5.f
gfortran -shared -fPIC -o ./dopri5.so ./dopri5.o
gfortran -shared -fPIC -o ./dopri5_i32.so ./dopri5_i32.o
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dop853.o ./dop853.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dop853_i32.o ./dop853.f
gfortran -shared -fPIC -o ./dop853.so ./dop853.o
gfortran -shared -fPIC -o ./dop853_i32.so ./dop853_i32.o

# odex
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./odex.o ./odex.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./odex_i32.o ./odex.f
gfortran -shared -fPIC -o ./odex.so ./odex.o
gfortran -shared -fPIC -o ./odex_i32.so ./odex_i32.o

# lapack
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dc_lapack.o ./dc_lapack.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./dc_lapack_i32.o ./dc_lapack.f
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./lapack.o ./lapack.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./lapack_i32.o ./lapack.f
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./lapackc.o ./lapackc.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./lapackc_i32.o ./lapackc.f

# radau
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./radau5.o ./radau5.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./radau5_i32.o ./radau5.f
gfortran -shared -fPIC -o ./radau5.so ./radau5.o ./dc_lapack.o ./lapack.o ./lapackc.o
gfortran -shared -fPIC -o ./radau5_i32.so ./radau5_i32.o ./dc_lapack_i32.o ./lapack_i32.o ./lapackc_i32.o
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./radau.o ./radau.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./radau_i32.o ./radau.f
gfortran -shared -fPIC -o ./radau.so ./radau.o ./dc_lapack.o ./lapack.o ./lapackc.o
gfortran -shared -fPIC -o ./radau_i32.so ./radau_i32.o ./dc_lapack_i32.o ./lapack_i32.o ./lapackc_i32.o

# seulex
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./seulex.o ./seulex.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./seulex_i32.o ./seulex.f
gfortran -shared -fPIC -o ./seulex.so ./seulex.o ./dc_lapack.o ./lapack.o ./lapackc.o
gfortran -shared -fPIC -o ./seulex_i32.so ./seulex_i32.o ./dc_lapack_i32.o ./lapack_i32.o ./lapackc_i32.o

# rodas
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./rodas.o ./rodas.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./rodas_i32.o ./rodas.f
gfortran -shared -fPIC -o ./rodas.so ./rodas.o ./dc_lapack.o ./lapack.o ./lapackc.o
gfortran -shared -fPIC -o ./rodas_i32.so ./rodas_i32.o ./dc_lapack_i32.o ./lapack_i32.o ./lapackc_i32.o

# slatec
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./slatec.o ./slatec.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./slatec_i32.o ./slatec.f

# ddeabm
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ddeabm.o ./ddeabm.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ddeabm_i32.o ./ddeabm.f
gfortran -shared -fPIC -o ./ddeabm.so ./ddeabm.o ./slatec.o
gfortran -shared -fPIC -o ./ddeabm_i32.so ./ddeabm_i32.o ./slatec_i32.o

# ddebdf
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ddebdf.o ./ddebdf.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ddebdf_i32.o ./ddebdf.f
gfortran -shared -fPIC -o ./ddebdf.so ./ddebdf.o ./slatec.o
gfortran -shared -fPIC -o ./ddebdf_i32.so ./ddebdf_i32.o ./slatec_i32.o

# bvpsol
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./bvpsol.o ./bvpsol.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./bvpsol_i32.o ./bvpsol.f
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./linalg_bvpsol.o ./linalg_bvpsol.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./linalg_bvpsol_i32.o ./linalg_bvpsol.f
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./zibconst.o ./zibconst.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./zibconst_i32.o ./zibconst.f
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ma28_bvpsol.o ./ma28_bvpsol.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./ma28_bvpsol_i32.o ./ma28_bvpsol.f
gfortran -shared -fPIC -o ./bvpsol.so ./bvpsol.o ./linalg_bvpsol.o ./zibconst.o ./ma28_bvpsol.o
gfortran -shared -fPIC -o ./bvpsol_i32.so ./bvpsol_i32.o ./linalg_bvpsol_i32.o ./zibconst_i32.o ./ma28_bvpsol_i32.o

# colnew
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./colnew.o ./colnew.f
gfortran -c -fPIC -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./colnew_i32.o ./colnew.f
gfortran -shared -fPIC -o ./colnew.so ./colnew.o
gfortran -shared -fPIC -o ./colnew_i32.so ./colnew_i32.o

# bvpm2
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -w -std=legacy -o ./bvp_la-2.o ./bvp_la-2.f
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -std=f2008 -o ./bvp_m-2.o ./bvp_m-2.f90
gfortran -c -fPIC -fdefault-integer-8 -fdefault-real-8 -fdefault-double-8 -Wall -Wextra -Wimplicit-interface -std=f2008ts -o ./bvp_m_proxy.o ./bvp_m_proxy.f90
gfortran -shared -fPIC -o ./bvp_m_proxy.so ./bvp_m_proxy.o ./bvp_m-2.o ./bvp_la-2.o
cp *.so $libdir



fi

[ This file was auto-generated from the module's documentation included in the doc-strings. Use julia's help system to get these informations in a nicer output format. ]

# dopri5

```
function dopri5(rhs, t0::Real, T::Real,
                x0::Vector, opt::AbstractOptionsODE)
     -> (t,x,retcode,stats)
```

`retcode` can have the following values:

```
  1: computation successful
  2: computation. successful, but interrupted by output function
 -1: input is not consistent
 -2: larger OPT_MAXSTEPS is needed
 -3: step size becomes too small
 -4: problem is probably stiff (interrupted)
```

main call for using Fortran-dopri5 solver. In `opt` the following options are used:

<table>
<tr><th><pre>  Option
</pre></th>
<th><pre> Description
</pre></th>
<th><pre> Default
</pre></th>
</tr>
<tr><td><pre> RTOL     &#38;
 ATOL
</pre></td>
<td><pre> relative and absolute error tolerances
 both scalars or both vectors with the
 length of length&#40;x0&#41;
 error&#40;x&#8342;&#41; &#8804; OPT&#95;RTOL&#8342;&#8901;&#124;x&#8342;&#124;&#43;OPT&#95;ATOL&#8342;
</pre></td>
<td><pre>    1e&#45;3
    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> OUTPUTFCN
</pre></td>
<td><pre> output function
 see help&#95;outputfcn
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> OUTPUTMODE
</pre></td>
<td><pre> OUTPUTFCN&#95;NEVER&#58;
   dont&#39;t call OPT&#95;OUTPUTFCN
 OUTPUTFCN&#95;WODENSE
   call OPT&#95;OUTPUTFCN&#44; but without
   possibility for dense output
 OUTPUTFCN&#95;DENSE
   call OPT&#95;OUTPUTFCN with support for
   dense output
</pre></td>
<td><pre>   NEVER
</pre></td>
</tr>
<tr><td><pre> MAXSTEPS
</pre></td>
<td><pre> maximal number of allowed steps
 OPT&#95;MAXSTEPS &#62; 0
</pre></td>
<td><pre>  100000
</pre></td>
</tr>
<tr><td><pre> STEST
</pre></td>
<td><pre> stiffness test
 done after every step number k&#42;OPT&#95;STEST
 OPT&#95;STEST &#60; 0 for turning test off
 OPT&#95;STEST &#8800; 0
</pre></td>
<td><pre>    1000
</pre></td>
</tr>
<tr><td><pre> EPS
</pre></td>
<td><pre> the rounding unit
 1e&#45;35 &#60; OPT&#95;EPS &#60; 1&#46;0
</pre></td>
<td><pre> 2&#46;3e&#45;16
</pre></td>
</tr>
<tr><td><pre> RHO
</pre></td>
<td><pre> safety factor in step size predcition
 1e&#45;4  &#60; OPT&#95;RHO &#60; 1&#46;0
</pre></td>
<td><pre>     0&#46;9
</pre></td>
</tr>
<tr><td><pre> SSMINSEL   &#38;
 SSMAXSEL
</pre></td>
<td><pre> parameters for step size selection
 The new step size is chosen subject to
 the restriction
 OPT&#95;SSMINSEL &#8804; hnew&#47;hold &#8804; OPT&#95;SSMAXSEL
 OPT&#95;SSMINSEL&#44; OPT&#95;SSMAXSEL &#62; 0
</pre></td>
<td><pre>     0&#46;2
    10&#46;0
</pre></td>
</tr>
<tr><td><pre> SSBETA
</pre></td>
<td><pre> &#946; for stabilized step size control
 OPT&#95;SSBETA &#8804; 0&#46;2
 if OPT&#95;SSBETA &#60; 0 then OPT&#95;SSBETA &#61; 0
</pre></td>
<td><pre>    0&#46;04
</pre></td>
</tr>
<tr><td><pre> MAXSS
</pre></td>
<td><pre> maximal step size
 OPT&#95;MAXSS &#8800; 0
</pre></td>
<td><pre>  T &#45; t0
</pre></td>
</tr>
<tr><td><pre> INITIALSS
</pre></td>
<td><pre> initial step size
 if OPT&#95;INITIALSS &#61;&#61; 0 then a initial
 guess is computed
</pre></td>
<td><pre>     0&#46;0
</pre></td>
</tr>
</table>



# dop853

```
function dop853(rhs, t0::Real, T::Real,
                x0::Vector, opt::AbstractOptionsODE)
     -> (t,x,retcode,stats)
```

`retcode` can have the following values:

```
  1: computation successful
  2: computation. successful, but interrupted by output function
 -1: input is not consistent
 -2: larger OPT_MAXSTEPS is needed
 -3: step size becomes too small
 -4: problem is probably stiff (interrupted)
```

main call for using Fortran-dopri5 solver. In `opt` the following options are used:

<table>
<tr><th><pre>  Option OPT&#95;&#8230;
</pre></th>
<th><pre> Description
</pre></th>
<th><pre> Default
</pre></th>
</tr>
<tr><td><pre> RTOL     &#38;
 ATOL
</pre></td>
<td><pre> relative and absolute error tolerances
 both scalars or both vectors with the
 length of length&#40;x0&#41;
 error&#40;x&#8342;&#41; &#8804; OPT&#95;RTOL&#8342;&#8901;&#124;x&#8342;&#124;&#43;OPT&#95;ATOL&#8342;
</pre></td>
<td><pre>    1e&#45;3
    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> OUTPUTFCN
</pre></td>
<td><pre> output function
 see help&#95;outputfcn
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> OUTPUTMODE
</pre></td>
<td><pre> OUTPUTFCN&#95;NEVER&#58;
   dont&#39;t call OPT&#95;OUTPUTFCN
 OUTPUTFCN&#95;WODENSE
   call OPT&#95;OUTPUTFCN&#44; but without
   possibility for dense output
 OUTPUTFCN&#95;DENSE
   call OPT&#95;OUTPUTFCN with support for
   dense output
</pre></td>
<td><pre>   NEVER
</pre></td>
</tr>
<tr><td><pre> MAXSTEPS
</pre></td>
<td><pre> maximal number of allowed steps
 OPT&#95;MAXSTEPS &#62; 0
</pre></td>
<td><pre>  100000
</pre></td>
</tr>
<tr><td><pre> STEST
</pre></td>
<td><pre> stiffness test
 done after every step number k&#42;OPT&#95;STEST
 OPT&#95;STEST &#60; 0 for turning test off
 OPT&#95;STEST &#8800; 0
</pre></td>
<td><pre>    1000
</pre></td>
</tr>
<tr><td><pre> EPS
</pre></td>
<td><pre> the rounding unit
 1e&#45;35 &#60; OPT&#95;EPS &#60; 1&#46;0
</pre></td>
<td><pre> 2&#46;3e&#45;16
</pre></td>
</tr>
<tr><td><pre> RHO
</pre></td>
<td><pre> safety factor in step size predcition
 1e&#45;4  &#60; OPT&#95;RHO &#60; 1&#46;0
</pre></td>
<td><pre>     0&#46;9
</pre></td>
</tr>
<tr><td><pre> SSMINSEL   &#38;
 SSMAXSEL
</pre></td>
<td><pre> parameters for step size selection
 The new step size is chosen subject to
 the restriction
 OPT&#95;SSMINSEL &#8804; hnew&#47;hold &#8804; OPT&#95;SSMAXSEL
 OPT&#95;SSMINSEL&#44; OPT&#95;SSMAXSEL &#62; 0
</pre></td>
<td><pre>   0&#46;333
     6&#46;0
</pre></td>
</tr>
<tr><td><pre> SSBETA
</pre></td>
<td><pre> &#946; for stabilized step size control
 OPT&#95;SSBETA &#8804; 0&#46;2
 if OPT&#95;SSBETA &#60; 0 then OPT&#95;SSBETA &#61; 0
</pre></td>
<td><pre>     0&#46;0
</pre></td>
</tr>
<tr><td><pre> MAXSS
</pre></td>
<td><pre> maximal step size
 OPT&#95;MAXSS &#8800; 0
</pre></td>
<td><pre>  T &#45; t0
</pre></td>
</tr>
<tr><td><pre> INITIALSS
</pre></td>
<td><pre> initial step size
 if OPT&#95;INITIALSS &#61;&#61; 0 then a initial
 guess is computed
</pre></td>
<td><pre>     0&#46;0
</pre></td>
</tr>
</table>



# odex

```
 function odex(rhs, t0::Real, T::Real,
               x0::Vector, opt::AbstractOptionsODE)
     -> (t,x,retcode,stats)
```

`retcode` can have the following values:

```
  1: computation successful
  2: computation. successful, but interrupted by output function
 -1: error
```

main call for using Fortran-odex solver. In `opt` the following options are used:

<table>
<tr><th><pre>  Option OPT&#95;&#8230;
</pre></th>
<th><pre> Description
</pre></th>
<th><pre> Default
</pre></th>
</tr>
<tr><td><pre> RTOL         &#38;
 ATOL
</pre></td>
<td><pre> relative and absolute error tolerances
 both scalars or both vectors with the
 length of length&#40;x0&#41;
 error&#40;x&#8342;&#41; &#8804; OPT&#95;RTOL&#8342;&#8901;&#124;x&#8342;&#124;&#43;OPT&#95;ATOL&#8342;
</pre></td>
<td><pre>    1e&#45;3
    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> OUTPUTFCN
</pre></td>
<td><pre> output function
 see help&#95;outputfcn
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> OUTPUTMODE
</pre></td>
<td><pre> OUTPUTFCN&#95;NEVER&#58;
   dont&#39;t call OPT&#95;OUTPUTFCN
 OUTPUTFCN&#95;WODENSE
   call OPT&#95;OUTPUTFCN&#44; but without
   possibility for dense output
 OUTPUTFCN&#95;DENSE
   call OPT&#95;OUTPUTFCN with support for
   dense output
</pre></td>
<td><pre>   NEVER
</pre></td>
</tr>
<tr><td><pre> MAXSTEPS
</pre></td>
<td><pre> maximal number of allowed steps
 OPT&#95;MAXSTEPS &#62; 0
</pre></td>
<td><pre>   10000
</pre></td>
</tr>
<tr><td><pre> EPS
</pre></td>
<td><pre> the rounding unit
 1e&#45;35 &#60; OPT&#95;EPS &#60; 1&#46;0
</pre></td>
<td><pre> 2&#46;3e&#45;16
</pre></td>
</tr>
<tr><td><pre> MAXSS
</pre></td>
<td><pre> maximal step size
 OPT&#95;MAXSS &#8800; 0
</pre></td>
<td><pre>  T &#45; t0
</pre></td>
</tr>
<tr><td><pre> INITIALSS
</pre></td>
<td><pre> initial step size guess
</pre></td>
<td><pre>    1e&#45;4
</pre></td>
</tr>
<tr><td><pre> MAXEXCOLUMN
</pre></td>
<td><pre> the maximum number of columns in
 the extrapolation table
 OPT&#95;MAXEXCOLUMN &#8805; 3
</pre></td>
<td><pre>       9
</pre></td>
</tr>
<tr><td><pre> STEPSIZESEQUENCE
</pre></td>
<td><pre> switch for the step size sequence
 1&#58; 2&#44; 4&#44;  6&#44;  8&#44; 10&#44; 12&#44; 14&#44; 16&#44; &#8230;
 2&#58; 2&#44; 4&#44;  8&#44; 12&#44; 16&#44; 20&#44; 24&#44; 28&#44; &#8230;
 3&#58; 2&#44; 4&#44;  6&#44;  8&#44; 12&#44; 16&#44; 24&#44; 32&#44; &#8230;
 4&#58; 2&#44; 6&#44; 10&#44; 14&#44; 18&#44; 22&#44; 26&#44; 30&#44; &#8230;
 5&#58; 4&#44; 8&#44; 12&#44; 16&#44; 20&#44; 24&#44; 28&#44; 32&#44; &#8230;
 1 &#8804; OPT&#95;STEPSIZESEQUENCE &#8804; 5
</pre></td>
<td><pre>       4
 if
 OUTPUT&#45;
 MODE &#61;&#61;
 DENSE&#59;
 other&#45;
 wise  1
</pre></td>
</tr>
<tr><td><pre> MAXSTABCHECKS
</pre></td>
<td><pre> how many times is the stability check
 activated at most in one line of the
 extrapolation table
</pre></td>
<td><pre>       1
</pre></td>
</tr>
<tr><td><pre> MAXSTABCHECKLINE
</pre></td>
<td><pre> stability check is only activated in
 the lines 1 to MAXMAXSTABCHECKLINE of
 the extrapolation table
</pre></td>
<td><pre>       1
</pre></td>
</tr>
<tr><td><pre> DENSEOUTPUTWOEE
</pre></td>
<td><pre> boolean flag&#58; suppress error estimator
 in dense output
 true is only possible&#44; if
      OUTPUTMODE &#61;&#61; DENSE
</pre></td>
<td><pre>   false
</pre></td>
</tr>
<tr><td><pre> INTERPOLDEGREE
</pre></td>
<td><pre> determines the degree of interpolation
 formula&#58;
 &#956; &#61; 2&#42;&#954; &#45; INTERPOLDEGREE &#43; 1
</pre></td>
<td><pre>       4
</pre></td>
</tr>
<tr><td><pre> SSREDUCTION
</pre></td>
<td><pre> step size is reduced by factor if the
 stability check is negative
 OPT&#95;EPS &#60; OPT&#95;SSREDUCTION &#60; 1
</pre></td>
<td><pre>     0&#46;5
</pre></td>
</tr>
<tr><td><pre> SSSELECTPAR1 &#38;
 SSSELECTPAR2
</pre></td>
<td><pre> parameters for step size selection
 the new step size for the k&#45;th diagonal
 entry is chosen subject to
 FMIN&#47;SSSELECTPAR2 &#8804; hnew&#8342;&#47;hold &#8804; 1&#47;FMIN
 with FMIN &#61; SSSELECTPAR1&#94;&#40;1&#47;&#40;2&#42;k&#45;1&#41;&#41;
</pre></td>
<td><pre>    0&#46;02
    4&#46;00
</pre></td>
</tr>
<tr><td><pre> ORDERDECFRAC &#38;
 ORDERINCFRAC
</pre></td>
<td><pre> parameters for the order selection
 decrease order if
         W&#40;k&#45;1&#41; &#8804;   W&#40;k&#41;&#42;ORDERDECFRAC
 increase order if
         W&#40;k&#41;   &#8804; W&#40;k&#45;1&#41;&#42;ORDERINCFRAC
</pre></td>
<td><pre>     0&#46;8
     0&#46;9
</pre></td>
</tr>
<tr><td><pre> OPT&#95;RHO      &#38;
 OPT&#95;RHO2
</pre></td>
<td><pre> safety factors for step control algorithm
 hnew&#61;h&#42;RHO&#42;&#40;RHO2&#42;TOL&#47;ERR&#41;&#94;&#40;1&#47;&#40;k&#45;1&#41; &#41;
</pre></td>
<td><pre>    0&#46;94
    0&#46;65
</pre></td>
</tr>
</table>



# seulex

```
 function seulex(rhs, t0::Real, T::Real,
                 x0::Vector, opt::AbstractOptionsODE)
     -> (t,x,retcode,stats)
```

`retcode` can have the following values:

```
  1: computation successful
  2: computation. successful, but interrupted by output function
 -1: computation unsuccessful
```

main call for using Fortran seulex solver.

This solver support problems with special structure, see `help_specialstructure`.

In `opt` the following options are used:

<table>
<tr><th><pre>  Option OPT&#95;&#8230;
</pre></th>
<th><pre> Description
</pre></th>
<th><pre> Default
</pre></th>
</tr>
<tr><td><pre> RHSAUTONOMOUS
</pre></td>
<td><pre> Flag&#44; if right&#45;hand side is autonomous&#46;
</pre></td>
<td><pre>   false
</pre></td>
</tr>
<tr><td><pre> M1 &#38; M2
</pre></td>
<td><pre> parameter for special structure&#44; see
 above
 M1&#44; M2 &#8805; 0
 M1 &#43;M2 &#8804; length&#40;x0&#41;
 &#40;M1&#61;&#61;M2&#61;&#61;0&#41; &#124;&#124; &#40;M1&#8800;0&#8800;M2&#41;
 M1 &#37; M2 &#61;&#61; 0 or M1&#61;&#61;0
</pre></td>
<td><pre>       0
      M1
</pre></td>
</tr>
<tr><td><pre> RTOL         &#38;
 ATOL
</pre></td>
<td><pre> relative and absolute error tolerances
 both scalars or both vectors with the
 length of length&#40;x0&#41;
 error&#40;x&#8342;&#41; &#8804; OPT&#95;RTOL&#8342;&#8901;&#124;x&#8342;&#124;&#43;OPT&#95;ATOL&#8342;
</pre></td>
<td><pre>    1e&#45;3
    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> OUTPUTFCN
</pre></td>
<td><pre> output function
 see help&#95;outputfcn
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> OUTPUTMODE
</pre></td>
<td><pre> OUTPUTFCN&#95;NEVER&#58;
   dont&#39;t call OPT&#95;OUTPUTFCN
 OUTPUTFCN&#95;WODENSE
   call OPT&#95;OUTPUTFCN&#44; but without
   possibility for dense output
 OUTPUTFCN&#95;DENSE
   call OPT&#95;OUTPUTFCN with support for
   dense output
</pre></td>
<td><pre>   NEVER
</pre></td>
</tr>
<tr><td><pre> LAMBDADENSE
</pre></td>
<td><pre> parameter &#955; of dense output
 OPT&#95;LAMBDADENSE &#8712; &#123;0&#44;1&#125;
</pre></td>
<td><pre>       0
</pre></td>
</tr>
<tr><td><pre> EPS
</pre></td>
<td><pre> the rounding unit
 0 &#60; OPT&#95;EPS &#60; 1&#46;0
</pre></td>
<td><pre>   1e&#45;16
</pre></td>
</tr>
<tr><td><pre> TRANSJTOH
</pre></td>
<td><pre> The solver transforms the jacobian
 matrix to Hessenberg form&#46;
 This option is not supported if the
 system is &#34;implicit&#34; &#40;i&#46;e&#46; a mass matrix
 is given&#41; or if jacobian is banded&#46;
</pre></td>
<td><pre>   false
</pre></td>
</tr>
<tr><td><pre> MAXSTEPS
</pre></td>
<td><pre> maximal number of allowed steps
 OPT&#95;MAXSTEPS &#62; 0
</pre></td>
<td><pre>  100000
</pre></td>
</tr>
<tr><td><pre> MAXSS
</pre></td>
<td><pre> maximal step size
 OPT&#95;MAXSS &#8800; 0
</pre></td>
<td><pre>  T &#45; t0
</pre></td>
</tr>
<tr><td><pre> INITIALSS
</pre></td>
<td><pre> initial step size guess
</pre></td>
<td><pre>    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> MAXEXCOLUMN
</pre></td>
<td><pre> the maximum number of columns in
 the extrapolation table
 OPT&#95;MAXEXCOLUMN &#8805; 3
</pre></td>
<td><pre>      12
</pre></td>
</tr>
<tr><td><pre> STEPSIZESEQUENCE
</pre></td>
<td><pre> switch for the step size sequence
 1&#58; 1&#44; 2&#44; 3&#44; 6&#44; 8&#44; 12&#44; 16&#44; 24&#44; 32&#44; 48&#44; &#8230;
 2&#58; 2&#44; 3&#44; 4&#44; 6&#44; 8&#44; 12&#44; 16&#44; 24&#44; 32&#44; 48&#44; &#8230;
 3&#58; 1&#44; 2&#44; 3&#44; 4&#44; 5&#44;  6&#44;  7&#44;  8&#44;  9&#44; 10&#44; &#8230;
 4&#58; 2&#44; 3&#44; 4&#44; 5&#44; 6&#44;  7&#44;  8&#44;  9&#44; 10&#44; 11&#44; &#8230;
 1 &#8804; OPT&#95;STEPSIZESEQUENCE &#8804; 4
</pre></td>
<td><pre>       2
</pre></td>
</tr>
<tr><td><pre> SSSELECTPAR1 &#38;
 SSSELECTPAR2
</pre></td>
<td><pre> parameters for step size selection
 the new step size for the k&#45;th diagonal
 entry is chosen subject to
 FMIN&#47;SSSELECTPAR2 &#8804; hnew&#8342;&#47;hold &#8804; 1&#47;FMIN
 with FMIN &#61; SSSELECTPAR1&#94;&#40;1&#47;&#40;k&#45;1&#41;&#41;
</pre></td>
<td><pre>     0&#46;1
     4&#46;0
</pre></td>
</tr>
<tr><td><pre> ORDERDECFRAC &#38;
 ORDERINCFRAC
</pre></td>
<td><pre> parameters for the order selection
 decrease order if
         W&#40;k&#45;1&#41; &#8804;   W&#40;k&#41;&#42;ORDERDECFRAC
 increase order if
         W&#40;k&#41;   &#8804; W&#40;k&#45;1&#41;&#42;ORDERINCFRAC
</pre></td>
<td><pre>     0&#46;7
     0&#46;9
</pre></td>
</tr>
<tr><td><pre> JACRECOMPFACTOR
</pre></td>
<td><pre> decides whether the jacobian should be
 recomputed&#46;
 small &#40;&#8776; 0&#46;001&#41;&#58; recompute often
 large &#40;&#8776; 0&#46;1&#41;&#58; recompute rarely
 i&#46;e&#46; this number represents how costly
 Jacobia evaluations are&#46;
 OPT&#95;JACRECOMPFACTOR &#8800; 0
</pre></td>
<td><pre> min&#40;
   1e&#45;4&#44;
 RTOL&#91;1&#93;&#41;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;RHO      &#38;
 OPT&#95;RHO2
</pre></td>
<td><pre> safety factors for step control algorithm
 hnew&#61;h&#42;RHO&#42;&#40;RHO2&#42;TOL&#47;ERR&#41;&#94;&#40;1&#47;&#40;k&#45;1&#41; &#41;
</pre></td>
<td><pre>    0&#46;93
    0&#46;80
</pre></td>
</tr>
<tr><td><pre> MASSMATRIX
</pre></td>
<td><pre> the mass matrix of the problem&#46; If not
 given &#40;nothing&#41; then the identiy matrix
 is used&#46;
 The size has to be &#40;d&#45;M1&#41;&#215;&#40;d&#45;M1&#41;&#46;
 It can be an full matrix or a banded
 matrix &#40;BandedMatrix&#41;&#46;
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> JACOBIMATRIX
</pre></td>
<td><pre> A function providing the Jacobian for
 &#8706;f&#47;&#8706;x or nothing&#46; For nothing the solver
 uses finite differences to calculate the
 Jacobian&#46;
 The function has to be of the form&#58;
   function &#40;t&#44;x&#44;J&#41; &#45;&#62; nothing       &#40;A&#41;
 or for M1&#62;0 &#38; JACOBIBANDSTRUCT &#8800; nothing
   function &#40;t&#44;x&#44;J1&#44;&#8230;&#44;JK&#41; &#45;&#62; nothing &#40;B&#41;
 with K &#61; 1&#43;M1&#47;M2 and &#40;M1&#43;M2&#61;&#61;d&#41;
 see help&#95;specialstructure
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> JACOBIBANDSTRUCT
</pre></td>
<td><pre> A tuple &#40;l&#44;u&#41; describing the banded
 structure of the Jacobian or nothing if
 the Jacobian is full&#46;
 see help&#95;specialstructure
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> WORKFORRHS
 WORKFORJAC
 WORKFORDEC
 WORKFORSOL
</pre></td>
<td><pre> estimated works &#40;complexity&#41; for a call
 to
 WORKFORRHS&#58; right&#45;hand side f
 WORKFORJAC&#58; JACOBIMATRIX
 WORKFORDEC&#58; LU&#45;decomposition
 WORKFORSOL&#58; Forward&#45; and Backward subst&#46;
</pre></td>
<td><pre>     1&#46;0
     5&#46;0
     1&#46;0
     1&#46;0
</pre></td>
</tr>
</table>



# rodas

```
  function rodas(rhs, t0::Real, T::Real,
                 x0::Vector, opt::AbstractOptionsODE)
     -> (t,x,retcode,stats)
```

`retcode` can have the following values:

```
  1: computation successful
  2: computation. successful, but interrupted by output function
 -1: computation unsuccessful
```

main call for using Fortran rodas solver.

This solver support problems with special structure, see `help_specialstructure`.

In `opt` the following options are used:

<table>
<tr><th><pre>  Option OPT&#95;&#8230;
</pre></th>
<th><pre> Description
</pre></th>
<th><pre> Default
</pre></th>
</tr>
<tr><td><pre> RHSAUTONOMOUS
</pre></td>
<td><pre> Flag&#44; if right&#45;hand side is autonomous&#46;
</pre></td>
<td><pre>   false
</pre></td>
</tr>
<tr><td><pre> M1 &#38; M2
</pre></td>
<td><pre> parameter for special structure&#44; see
 above
 M1&#44; M2 &#8805; 0
 M1 &#43;M2 &#8804; length&#40;x0&#41;
 &#40;M1&#61;&#61;M2&#61;&#61;0&#41; &#124;&#124; &#40;M1&#8800;0&#8800;M2&#41;
 M1 &#37; M2 &#61;&#61; 0 or M1&#61;&#61;0
</pre></td>
<td><pre>       0
      M1
</pre></td>
</tr>
<tr><td><pre> RTOL         &#38;
 ATOL
</pre></td>
<td><pre> relative and absolute error tolerances
 both scalars or both vectors with the
 length of length&#40;x0&#41;
 error&#40;x&#8342;&#41; &#8804; OPT&#95;RTOL&#8342;&#8901;&#124;x&#8342;&#124;&#43;OPT&#95;ATOL&#8342;
</pre></td>
<td><pre>    1e&#45;3
    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> OUTPUTFCN
</pre></td>
<td><pre> output function
 see help&#95;outputfcn
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> OUTPUTMODE
</pre></td>
<td><pre> OUTPUTFCN&#95;NEVER&#58;
   dont&#39;t call OPT&#95;OUTPUTFCN
 OUTPUTFCN&#95;WODENSE
   call OPT&#95;OUTPUTFCN&#44; but without
   possibility for dense output
 OUTPUTFCN&#95;DENSE
   call OPT&#95;OUTPUTFCN with support for
   dense output
</pre></td>
<td><pre>   NEVER
</pre></td>
</tr>
<tr><td><pre> EPS
</pre></td>
<td><pre> the rounding unit
 0 &#60; OPT&#95;EPS &#60; 1&#46;0
</pre></td>
<td><pre>   1e&#45;16
</pre></td>
</tr>
<tr><td><pre> METHODCHOICE
</pre></td>
<td><pre> Choice of coefficients&#58;
 1&#58; Hairer&#44; Wanner&#58; Solving ODE II&#44;
    page 452
 2&#58; same as 1&#44; with different params
 3&#58; G&#46; Steinbach &#40;1993&#41;
</pre></td>
<td><pre>       1
</pre></td>
</tr>
<tr><td><pre> MAXSTEPS
</pre></td>
<td><pre> maximal number of allowed steps
 OPT&#95;MAXSTEPS &#62; 0
</pre></td>
<td><pre>  100000
</pre></td>
</tr>
<tr><td><pre> MAXSS
</pre></td>
<td><pre> maximal step size
 OPT&#95;MAXSS &#8800; 0
</pre></td>
<td><pre>  T &#45; t0
</pre></td>
</tr>
<tr><td><pre> INITIALSS
</pre></td>
<td><pre> initial step size guess
</pre></td>
<td><pre>    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> STEPSIZESTRATEGY
</pre></td>
<td><pre> Switch for step size strategy
   1&#58; mod&#46; predictive controller
      &#40;Gustafsson&#41;
   2&#58; classical step size control
</pre></td>
<td><pre>       1
</pre></td>
</tr>
<tr><td><pre> OPT&#95;RHO
</pre></td>
<td><pre> safety factor for step control algorithm
 0&#46;001 &#60; OPT&#95;RHO &#60; 1&#46;0
</pre></td>
<td><pre>     0&#46;9
</pre></td>
</tr>
<tr><td><pre> SSMINSEL   &#38;
 SSMAXSEL
</pre></td>
<td><pre> parameters for step size selection
 The new step size is chosen subject to
 the restriction
 OPT&#95;SSMINSEL &#8804; hnew&#47;hold &#8804; OPT&#95;SSMAXSEL
 OPT&#95;SSMINSEL &#8804; 1&#44; OPT&#95;SSMAXSEL &#8805; 1
</pre></td>
<td><pre>     0&#46;2
     6&#46;0
</pre></td>
</tr>
<tr><td><pre> RHSTIMEDERIV
</pre></td>
<td><pre> A function providing the time derivative
 &#8706;f&#47;&#8706;t of the right&#45;hand side or nothing&#46;
 If the value given is nothing the solver
 uses finite differences to approximate
 &#8706;f&#47;&#8706;t&#46;
 Obviously this options is only relevant
 for non&#45;autonomous problems&#46;
 The function has to be of the form&#58;
   function &#40;t&#44;x&#44;dfdt&#41; &#45;&#62; nothing
 Even if the problem has special structure
 &#40;M1&#62;0&#44; see help&#95;specialstructure&#41; x and
 dfdt are always vectors with full length&#44;
 i&#46;e&#46; length&#40;x&#41;&#61;&#61;length&#40;dfdt&#41;&#61;&#61;length&#40;x0&#41;&#46;
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> JACOBIMATRIX
</pre></td>
<td><pre> A function providing the Jacobian for
 &#8706;f&#47;&#8706;x or nothing&#46; For nothing the solver
 uses finite differences to calculate the
 Jacobian&#46;
 The function has to be of the form&#58;
   function &#40;t&#44;x&#44;J&#41; &#45;&#62; nothing       &#40;A&#41;
 or for M1&#62;0 &#38; JACOBIBANDSTRUCT &#8800; nothing
   function &#40;t&#44;x&#44;J1&#44;&#8230;&#44;JK&#41; &#45;&#62; nothing &#40;B&#41;
 with K &#61; 1&#43;M1&#47;M2 and &#40;M1&#43;M2&#61;&#61;d&#41;
 see help&#95;specialstructure
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> JACOBIBANDSTRUCT
</pre></td>
<td><pre> A tuple &#40;l&#44;u&#41; describing the banded
 structure of the Jacobian or nothing if
 the Jacobian is full&#46;
 see help&#95;specialstructure
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> MASSMATRIX
</pre></td>
<td><pre> the mass matrix of the problem&#46; If not
 given &#40;nothing&#41; then the identiy matrix
 is used&#46;
 The size has to be &#40;d&#45;M1&#41;&#215;&#40;d&#45;M1&#41;&#46;
 It can be an full matrix or a banded
 matrix &#40;BandedMatrix&#41;&#46;
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
</table>



# ddeabm

```
 function ddeabm(rhs, t0::Real, T::Real,
                 x0::Vector, opt::AbstractOptionsODE)
     -> (t,x,retcode,stats)
```

`retcode` can have the following values:

```
  1: computation successful
  2: computation. successful, but interrupted by output function
 <0: error
```

main call for using Fortran-ddeabm solver. In `opt` the following options are used:

<table>
<tr><th><pre>  Option OPT&#95;&#8230;
</pre></th>
<th><pre> Description
</pre></th>
<th><pre> Default
</pre></th>
</tr>
<tr><td><pre> RTOL         &#38;
 ATOL
</pre></td>
<td><pre> relative and absolute error tolerances
 both scalars or both vectors with the
 length of length&#40;x0&#41;
 error&#40;x&#8342;&#41; &#8804; OPT&#95;RTOL&#8342;&#8901;&#124;x&#8342;&#124;&#43;OPT&#95;ATOL&#8342;
</pre></td>
<td><pre>    1e&#45;3
    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> OUTPUTFCN
</pre></td>
<td><pre> output function
 see help&#95;outputfcn
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> OUTPUTMODE
</pre></td>
<td><pre> OUTPUTFCN&#95;NEVER&#58;
   dont&#39;t call OPT&#95;OUTPUTFCN
 OUTPUTFCN&#95;WODENSE
   call OPT&#95;OUTPUTFCN either
   &#40;a&#41; either for all intermediate steps
       choosen by the solver or
   &#40;b&#41; at the times given in the option
       OPT&#95;OUTPUTATTIMES
 OUTPUTFCN&#95;DENSE
   is &#42;not&#42; supported&#33;
   but see OUTPUTATTIMES for an
   alternative approach
</pre></td>
<td><pre>   NEVER
</pre></td>
</tr>
<tr><td><pre> OUTPUTATTIMES
</pre></td>
<td><pre> If OPT&#95;OUTPUTMODE is OUTPUTFCN&#95;WODENSE
 then one can specify with this vector
 the time points where the OPT&#95;OUTPUTFCN
 should be called&#46;
 All values of OPT&#95;OUTPUTATTIMES &#42;must&#42;
 be sorted &#40;ascending&#44; if T&#62;t0&#44; and
 descending&#44; if T&#60;t0&#41; and they must be
 between t0 and T&#46;
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> TSTOP
</pre></td>
<td><pre> tell the solver&#44; that it is not
 permissable to integrate past the point
 TSTOP&#46; If TSTOP is NaN then the solver
 may integrate past T and interpolate the
 result at T&#46; Sometimes there are
 right&#45;hand sides&#44; where this is not
 possible&#46;
</pre></td>
<td><pre>     NaN
</pre></td>
</tr>
<tr><td><pre> MAXSTEPS
</pre></td>
<td><pre> maximal number of allowed steps
 &#40;allowed intermediate steps&#41;
 between t0&#44; T and the values given
 in OPT&#95;OUTPUTATTIMES&#46;
 The value will be rounded up to a
 multiple of 500&#46;
 OPT&#95;MAXSTEPS &#62; 0
</pre></td>
<td><pre>  100000
</pre></td>
</tr>
</table>



# ddebdf

```
 function ddebdf(rhs, t0::Real, T::Real,
                 x0::Vector, opt::AbstractOptionsODE)
     -> (t,x,retcode,stats)
```

`retcode` can have the following values:

```
  1: computation successful
  2: computation. successful, but interrupted by output function
 <0: error
```

main call for using Fortran-ddebdf solver. In `opt` the following options are used:

<table>
<tr><th><pre>  Option OPT&#95;&#8230;
</pre></th>
<th><pre> Description
</pre></th>
<th><pre> Default
</pre></th>
</tr>
<tr><td><pre> RTOL         &#38;
 ATOL
</pre></td>
<td><pre> relative and absolute error tolerances
 both scalars or both vectors with the
 length of length&#40;x0&#41;
 error&#40;x&#8342;&#41; &#8804; OPT&#95;RTOL&#8342;&#8901;&#124;x&#8342;&#124;&#43;OPT&#95;ATOL&#8342;
</pre></td>
<td><pre>    1e&#45;3
    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> OUTPUTFCN
</pre></td>
<td><pre> output function
 see help&#95;outputfcn
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> OUTPUTMODE
</pre></td>
<td><pre> OUTPUTFCN&#95;NEVER&#58;
   dont&#39;t call OPT&#95;OUTPUTFCN
 OUTPUTFCN&#95;WODENSE
   call OPT&#95;OUTPUTFCN either
   &#40;a&#41; either for all intermediate steps
       choosen by the solver or
   &#40;b&#41; at the times given in the option
       OPT&#95;OUTPUTATTIMES
 OUTPUTFCN&#95;DENSE
   is &#42;not&#42; supported&#33;
   but see OUTPUTATTIMES for an
   alternative approach
</pre></td>
<td><pre>   NEVER
</pre></td>
</tr>
<tr><td><pre> OUTPUTATTIMES
</pre></td>
<td><pre> If OPT&#95;OUTPUTMODE is OUTPUTFCN&#95;WODENSE
 then one can specify with this vector
 the time points where the OPT&#95;OUTPUTFCN
 should be called&#46;
 All values of OPT&#95;OUTPUTATTIMES &#42;must&#42;
 be sorted &#40;ascending&#44; if T&#62;t0&#44; and
 descending&#44; if T&#60;t0&#41; and they must be
 between t0 and T&#46;
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> TSTOP
</pre></td>
<td><pre> tell the solver&#44; that it is not
 permissable to integrate past the point
 TSTOP&#46; If TSTOP is NaN then the solver
 may integrate past T and interpolate the
 result at T&#46; Sometimes there are
 right&#45;hand sides&#44; where this is not
 possible&#46;
</pre></td>
<td><pre>     NaN
</pre></td>
</tr>
<tr><td><pre> MAXSTEPS
</pre></td>
<td><pre> maximal number of allowed steps
 &#40;allowed intermediate steps&#41;
 between t0&#44; T and the values given
 in OPT&#95;OUTPUTATTIMES&#46;
 The value will be rounded up to a
 multiple of 500&#46;
 OPT&#95;MAXSTEPS &#62; 0
</pre></td>
<td><pre>  100000
</pre></td>
</tr>
<tr><td><pre> JACOBIMATRIX
</pre></td>
<td><pre> A function providing the Jacobian for
 &#8706;f&#47;&#8706;x or nothing&#46; For nothing the solver
 uses finite differences to calculate the
 Jacobian&#46;
 The function has to be of the form&#58;
   function &#40;t&#44;x&#44;J&#41; &#45;&#62; nothing
 Depending on OPT&#95;JACOBIBANDSTRUCT the
 argument J will then by a full or a
 banded matrix&#44; where the user&#45;given
 function has to fill in the entries&#46;
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> JACOBIBANDSTRUCT
</pre></td>
<td><pre> A tuple &#40;l&#44;u&#41; describing the banded
 structure of the Jacobian or nothing if
 the Jacobian is full&#46;
 Even if the option JACOBIMATRIX is empty&#44;
 the solver will perform much better if
 the Jacobian matrix is banded and the
 code is told this&#46;
 see also help of BandedMatrix
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
</table>



# radau and radau5

```
 function radau(rhs, t0::Real, T::Real,
                 x0::Vector, opt::AbstractOptionsODE)
     -> (t,x,retcode,stats)

 function radau5(rhs, t0::Real, T::Real,
                 x0::Vector, opt::AbstractOptionsODE)
     -> (t,x,retcode,stats)
```

`retcode` can have the following values:

```
  1: computation successful
  2: computation. successful, but interrupted by output function
 -1: input is not consistent
 -2: larger OPT_MAXSTEPS is needed
 -3: step size becomes too small
 -4: matrix is repeatedly singular
```

main call for using Fortran radau or radau5 solver.

This solver support problems with special structure, see `help_specialstructure`.

Remark: Because radau and radau5 are collocation methods, there is no difference in the computational costs for OUTPUTFCN*WODENSE and OUTPUTFCN*DENSE.

In `opt` the following options are used:

<table>
<tr><th><pre>  Option OPT&#95;&#8230;
</pre></th>
<th><pre> Description
</pre></th>
<th><pre> Default
</pre></th>
</tr>
<tr><td><pre> M1 &#38; M2
</pre></td>
<td><pre> parameter for special structure&#44; see
 above
 M1&#44; M2 &#8805; 0
 M1 &#43;M2 &#8804; length&#40;x0&#41;
 &#40;M1&#61;&#61;M2&#61;&#61;0&#41; &#124;&#124; &#40;M1&#8800;0&#8800;M2&#41;
 M1 &#37; M2 &#61;&#61; 0 or M1&#61;&#61;0
</pre></td>
<td><pre>       0
      M1
</pre></td>
</tr>
<tr><td><pre> RTOL         &#38;
 ATOL
</pre></td>
<td><pre> relative and absolute error tolerances
 both scalars or both vectors with the
 length of length&#40;x0&#41;
 error&#40;x&#8342;&#41; &#8804; OPT&#95;RTOL&#8342;&#8901;&#124;x&#8342;&#124;&#43;OPT&#95;ATOL&#8342;
</pre></td>
<td><pre>    1e&#45;3
    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> OUTPUTFCN
</pre></td>
<td><pre> output function
 see help&#95;outputfcn
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> OUTPUTMODE
</pre></td>
<td><pre> OUTPUTFCN&#95;NEVER&#58;
   dont&#39;t call OPT&#95;OUTPUTFCN
 OUTPUTFCN&#95;WODENSE
   call OPT&#95;OUTPUTFCN&#44; but without
   possibility for dense output
 OUTPUTFCN&#95;DENSE
   call OPT&#95;OUTPUTFCN with support for
   dense output
</pre></td>
<td><pre>   NEVER
</pre></td>
</tr>
<tr><td><pre> EPS
</pre></td>
<td><pre> the rounding unit
 1e&#45;19 &#60; OPT&#95;EPS &#60; 1&#46;0
</pre></td>
<td><pre>   1e&#45;16
</pre></td>
</tr>
<tr><td><pre> TRANSJTOH
</pre></td>
<td><pre> The solver transforms the jacobian
 matrix to Hessenberg form&#46;
 This option is not supported if the
 system is &#34;implicit&#34; &#40;i&#46;e&#46; a mass matrix
 is given&#41; or if jacobian is banded&#46;
</pre></td>
<td><pre>   false
</pre></td>
</tr>
<tr><td><pre> MAXNEWTONITER
</pre></td>
<td><pre> maximum number of Newton iterations for
 the solution of the implicit system in
 each step&#46;
 for radau&#58; MAXNEWTONITER &#43; &#40;NS&#45;3&#41;&#42;2&#46;5
   where NS is number of current stages
 for radau5&#58;     OPT&#95;MAXNEWTONITER &#62; 0
 for radau&#58; 50 &#62; OPT&#95;MAXNEWTONITER &#62; 0
</pre></td>
<td><pre>       7
</pre></td>
</tr>
<tr><td><pre> NEWTONSTARTZERO
</pre></td>
<td><pre> if &#96;false&#96;&#44; the extrapolated collocation
 solution is taken as starting vector for
 Newton&#39;s method&#46; If &#96;true&#96; zero starting
 values are used&#46; The latter is
 recommended if Newton&#39;s method has
 difficulties with convergence&#46;
</pre></td>
<td><pre>   false
</pre></td>
</tr>
<tr><td><pre> NEWTONSTOPCRIT
</pre></td>
<td><pre> only for radau5&#58;
 Stopping criterion for Newton&#39;s method&#46;
 Smaller values make the code slower&#44; but
 safer&#46;
 Default&#58;
  max&#40;10&#42;OPT&#95;EPS&#47;OPT&#95;RTOL&#91;1&#93;&#44;
       min&#40;0&#46;03&#44;sqrt&#40;OPT&#95;RTOL&#91;1&#93;&#41;&#41;&#41;
 OPT&#95;NEWTONSTOPCRIT &#62; OPT&#95;EPS&#47;OPT&#95;RTOL&#91;1&#93;
</pre></td>
<td><pre> see
   left
</pre></td>
</tr>
<tr><td><pre> DIMOFIND1VAR  &#38;
 DIMOFIND2VAR  &#38;
 DIMOFIND3VAR
</pre></td>
<td><pre> For differential&#45;algebraic systems of
 index &#62; 1&#46; The right&#45;hand side should be
 written such that the index 1&#44;2&#44;3
 variables appear in this order&#46;
 DIMOFINDzVAR&#58; number of index z vars&#46;
 &#8721; DIMOFINDzVAR &#61;&#61; length&#40;x0&#41;
</pre></td>
<td><pre> len&#40;x0&#41;
       0
       0
</pre></td>
</tr>
<tr><td><pre> MAXSTEPS
</pre></td>
<td><pre> maximal number of allowed steps
 OPT&#95;MAXSTEPS &#62; 0
</pre></td>
<td><pre>  100000
</pre></td>
</tr>
<tr><td><pre> MAXSS
</pre></td>
<td><pre> maximal step size
 OPT&#95;MAXSS &#8800; 0
</pre></td>
<td><pre>  T &#45; t0
</pre></td>
</tr>
<tr><td><pre> INITIALSS
</pre></td>
<td><pre> initial step size guess
</pre></td>
<td><pre>    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> MINSTAGES     &#38;
 MAXSTAGES
</pre></td>
<td><pre> only for radau&#58;
 minimal and maximal number of stages&#46;
 The order is given by&#58; 2&#8901;stages&#45;1
 MINSTAGES&#44;MAXSTAGES &#8712; &#40;1&#44;3&#44;5&#44;7&#41;
 MINSTAGES &#8804; MAXSTAGES
</pre></td>
<td><pre>       3
       7
</pre></td>
</tr>
<tr><td><pre> INITSTAGES
</pre></td>
<td><pre> only for radau&#58;
 number of stages to start with&#46;
 MINSTAGES &#8804; INITSTAGES &#8804; MAXSTAGES
</pre></td>
<td><pre>MINSTAGES
</pre></td>
</tr>
<tr><td><pre> STEPSIZESTRATEGY
</pre></td>
<td><pre> Switch for step size strategy
   1&#58; mod&#46; predictive controller
      &#40;Gustafsson&#41;
   2&#58; classical step size control
</pre></td>
<td><pre>       1
</pre></td>
</tr>
<tr><td><pre> OPT&#95;RHO
</pre></td>
<td><pre> safety factor for step control algorithm
 0&#46;001 &#60; OPT&#95;RHO &#60; 1&#46;0
</pre></td>
<td><pre>     0&#46;9
</pre></td>
</tr>
<tr><td><pre> JACRECOMPFACTOR
</pre></td>
<td><pre> decides whether the jacobian should be
 recomputed&#46;
 &#60;0&#58; recompute after every accepted step
 small &#40;&#8776; 0&#46;001&#41;&#58; recompute often
 large &#40;&#8776; 0&#46;1&#41;&#58; recompute rarely
 i&#46;e&#46; this number represents how costly
 Jacobia evaluations are&#46;
 OPT&#95;JACRECOMPFACTOR &#8800; 0
</pre></td>
<td><pre>   0&#46;001
</pre></td>
</tr>
<tr><td><pre> FREEZESSLEFT  &#38;
 FREEZESSRIGHT
</pre></td>
<td><pre> Step size freezing&#58; If
 FREEZESSLEFT &#60; hnew&#47;hold &#60; FREEZESSRIGHT
 then the step size is not changed&#46; This
 saves&#44; together with a large
 JACRECOMPFACTOR&#44; LU&#45;decompositions and
 computing time for large systems&#46;
 small systems&#58;
    FREEZESSLEFT  &#8776; 1&#46;0
    FREEZESSRIGHT &#8776; 1&#46;2
 large full systems&#58;
    FREEZESSLEFT  &#8776; 0&#46;99
    FREEZESSRIGHT &#8776; 2&#46;0
 OPT&#95;FREEZESSLEFT  &#8804; 1&#46;0
 OPT&#95;FREEZESSRIGHT &#8805; 1&#46;0
</pre></td>
<td><pre>     1&#46;0
     1&#46;2
</pre></td>
</tr>
<tr><td><pre> SSMINSEL   &#38;
 SSMAXSEL
</pre></td>
<td><pre> parameters for step size selection
 The new step size is chosen subject to
 the restriction
 OPT&#95;SSMINSEL &#8804; hnew&#47;hold &#8804; OPT&#95;SSMAXSEL
 OPT&#95;SSMINSEL &#8804; 1&#44; OPT&#95;SSMAXSEL &#8805; 1
</pre></td>
<td><pre>     0&#46;2
     8&#46;0
</pre></td>
</tr>
<tr><td><pre> MASSMATRIX
</pre></td>
<td><pre> the mass matrix of the problem&#46; If not
 given &#40;nothing&#41; then the identiy matrix
 is used&#46;
 The size has to be &#40;d&#45;M1&#41;&#215;&#40;d&#45;M1&#41;&#46;
 It can be an full matrix or a banded
 matrix &#40;BandedMatrix&#41;&#46;
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> JACOBIMATRIX
</pre></td>
<td><pre> A function providing the Jacobian for
 &#8706;f&#47;&#8706;x or nothing&#46; For nothing the solver
 uses finite differences to calculate the
 Jacobian&#46;
 The function has to be of the form&#58;
   function &#40;t&#44;x&#44;J&#41; &#45;&#62; nothing       &#40;A&#41;
 or for M1&#62;0 &#38; JACOBIBANDSTRUCT &#8800; nothing
   function &#40;t&#44;x&#44;J1&#44;&#8230;&#44;JK&#41; &#45;&#62; nothing &#40;B&#41;
 with K &#61; 1&#43;M1&#47;M2 and &#40;M1&#43;M2&#61;&#61;d&#41;
 see help&#95;specialstructure
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> JACOBIBANDSTRUCT
</pre></td>
<td><pre> A tuple &#40;l&#44;u&#41; describing the banded
 structure of the Jacobian or nothing if
 the Jacobian is full&#46;
 see help&#95;specialstructure
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
<tr><td><pre> ORDERDECFACTOR &#38;
 ORDERINCFACTOR
</pre></td>
<td><pre> only for radau&#58;
 Order is decreased&#44; if the contractivity
 factor is smaller than ORDERDECFACTOR&#46;
 Order is increased&#44; if the contractivity
 factor is larger than ORDERINCFACTOR&#46;
 ORDERDECFACTOR &#62; ORDERINCFACTOR &#62; 0
</pre></td>
<td><pre>     0&#46;8
   0&#46;002
</pre></td>
</tr>
<tr><td><pre> ORDERDECSTEPFAC1
 ORDERDECSTEPFAC2
</pre></td>
<td><pre> only for radau&#58;
 the order is only decreased if the
 stepsize ratio satisfies
  ORDERDECSTEPFAC2 &#8804; hnew&#47;hold &#8804;
               ORDERDECSTEPFAC1
 0 &#60; ORDERDECSTEPFAC2 &#60; ORDERDECSTEPFAC1
</pre></td>
<td><pre>     1&#46;2
     0&#46;8
</pre></td>
</tr>
</table>



# bvpsol

```
 function bvpsol(rhs, bc,
   t::Vector, x::Matrix, odesolver, opt::AbstractOptionsODE)
     -> (t,x,retcode,stats)
```

The `bc` has to be a function of the following form:

```
 function bc(xa,xb,r) -> nothing
```

It has to calculate the residual for the boundary conditions and save them in `r`.

`t` is a Vector with all the multiple-shooting nodes.

`x` gives the initial guess for all multiple-shooting nodes. Hence `size(x,2)==length(t)`.

`odesolver`: Either `nothing`: then the internal solver of `bvpsol` is used. Or `odesolver` is a ode-solver (like `dopri5`, `dop853`, `seulex`, etc.).

`retcode` can have the following values:

```
  >0: computation successful: number of iterations
  -1:        Iteration stops at stationary point for OPT_SOLMETHOD==0
             Gaussian elimination failed due to singular
             Jacobian for OPT_SOLMETHOD==1
  -2: Iteration stops after OPT_MAXSTEPS
  -3: Integrator failed to complete the trajectory
  -4: Gauss Newton method failed to converge
  -5: Given initial values inconsistent with separable linear bc
  -6:        Iterative refinement faild to converge for OPT_SOLMETHOD==0
             Termination since multiple shooting condition or
             condition of Jacobian is too bad for OPT_SOLMETHOD==1
  -7: wrong EPS (should not happen; checked by ODEInterface module)
  -8: Condensing algorithm for linear block system fails, try
      OPT_SOLMETHOD==1
  -9: Sparse linear solver failed
 -10: Real or integer work-space exhausted
 -11: Rank reduction failed - resulting rank is zero
```

In `opt` the following options are used:

<table>
<tr><th><pre>  Option OPT&#95;&#8230;
</pre></th>
<th><pre> Description
</pre></th>
<th><pre> Default
</pre></th>
</tr>
<tr><td><pre> RTOL
</pre></td>
<td><pre> relative accuracy for soltuion
</pre></td>
<td><pre>    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> MAXSTEPS
</pre></td>
<td><pre> maximum permitted number of iteration
 steps
</pre></td>
<td><pre>      40
</pre></td>
</tr>
<tr><td><pre> BVPCLASS
</pre></td>
<td><pre> boundary value problem classification&#58;
 0&#58; linear
 1&#58; nonlinear with good initial data
 2&#58; highly nonlinear &#38; bad initial data
 3&#58; highly nonlinear &#38; bad initial data &#38;
    initial rank reduction to separable
    linear boundary conditions
</pre></td>
<td><pre>       2
</pre></td>
</tr>
<tr><td><pre> SOLMETHOD
</pre></td>
<td><pre> switch for solution method
 0&#58; use local linear solver with
    condensing algorithm
 1&#58; use global sparse linear solver
</pre></td>
<td><pre>       0
</pre></td>
</tr>
<tr><td><pre> IVPOPT
</pre></td>
<td><pre> An OptionsODE&#45;object with the options
 for the solver of the initial value
 problem&#46;
 In this OptionsODE&#45;object bvpsol changes
 OPT&#95;MAXSS&#44; OPT&#95;INITIALSS&#44; OPT&#95;RTOL
 to give the IVP&#45;solver solution hints&#46;
</pre></td>
<td><pre> empty
 options
</pre></td>
</tr>
<tr><td><pre> RHS&#95;CALLMODE
</pre></td>
<td><pre> see help&#95;callsolvers&#40;&#41;
</pre></td>
<td><pre></pre></td>
</tr>
</table>



# colnew

```
  function colnew(interval::Vector, orders::Vector, ζ::Vector,
    rhs, Drhs,
    bc, Dbc, guess, opt::AbstractOptionsODE)
      -> (sol, retcode, stats)
```

Solve multi-point boundary value problem with colnew.

ζ∊ℝᵈ with a ≤ ζ(1)=ζ₁ ≤ ζ(2)=ζ₂ ≤ ⋯ ≤ ζ(d) ≤ b are the (time-)points were side/boundary conditions are given:

```
       bc₁   bc₂       bc₃                 bcⱼ(ζⱼ, z(x(ζⱼ))) = 0
        ∙     ∙         ∙  ⋯

  ├─────┼─────┼─────────┼─....───┼─────┤
 t=a  t=ζ(1) t=ζ(2)    t=ζ(3)  t=ζ(d)  t=b
```

for the n ODEs        ∂xᵢ       ──────  = xᵢ⁽ᵐ⁽ⁱ⁾⁾ = fᵢ(t, z(x(t))          (i=1,2,…,n)   [*]       ∂tᵐ⁽ⁱ⁾

where the i-th ODE has order m(i). [x(t)∊ℝⁿ].

z is the transformation to first order: z(x(t))∊ℝᵈ is the "first-order" state one gets if the n ODEs [*] are transformed to a first-order system:

```
 z(x(t)) = ( x₁(t), x₁'(t), x₁''(t), …, x₁⁽ᵐ⁽¹⁾⁻¹⁾,
             x₂(t), x₂'(t), x₂''(t), …, x₂⁽ᵐ⁽²⁾⁻¹⁾,
             ⋯                                    ,
             xₙ(t), xₙ'(t), xₙ''(t), …, xₙ⁽ᵐ⁽ⁿ⁾⁻¹⁾  )
```

Hence one has the requirement: ∑m(i) = d.

The boundary-/side-conditions at the points ζⱼ=ζ(j) are given in the form

```
 bcⱼ(ζⱼ, z(x(ζⱼ))) = 0                         (j=1,2,…,d)
```

Restrictions (in the colnew code):

  * at maximum 20 ODEs: n ≤ 20
  * at maximum 40 dimensions: d ≤ 40
  * The orders m(i) have to satisfy: 1 ≤ m(i) ≤ 4   for all i=1,2,…,n.

All (Julia-)callback-functions (like rhs, etc.) use the in-situ call-mode, i.e. they have to write the result in a preallocated vector.

## rhs

`rhs` must be a function of the form

```
function rhs(t, z, f)
```

with the input data: t (scalar) time and z∈ℝᵈ (z=z(x(t))). The values of the right-hand side have to be saved in f: f∈ℝⁿ! Only the non-trivial parts of the right-hand side must be calculated.

## Drhs

`Drhs` must be a function of the form

```
function Drhs(t, z, df)
```

with the input data: t (scalar) time and z∈ℝᵈ (z=z(x(t))). The values of the jacobian of the right-hand side have to be saved in df: df∈ℝⁿˣᵈ!

```
           ∂fᵢ
df(i,j) = ─────      (i=1,…,n;  j=1,…,d)
           ∂zⱼ
```

## bc

`bc` must be a function of the form

```
function bc(i, z, bc)
```

with the input data: integer index i and z∈ℝᵈ (z=z(x(t))). The scalar(!) value of the i-th side-condition (at time ζ(i)) has to be saved in bc, which is a vector of length 1.

## Dbc

`Dbc` must be a function of the form

```
function Dbc(i, z, dbc)
```

with the input data: integer index i and z∈ℝᵈ (z=z(x(t))). The  values of the derivative of the i-th side-condition (at time ζ(i)) has to be saved in dbc:

```
          ∂bcᵢ
dbc(j) = ─────      (j=1,…,d)
          ∂zⱼ
```

## guess

`guess` can be `nothing`, i.e. no initial guess given. Or `guess` can be the sol return value of an earilier call of `colnew`. In such a case the former mesh and the former solution is taken as an initial guess (or is coarsen, see `OPT_COARSEGUESSGRID`).

Or `guess` is a function of the form

```
function guess(t, z, dmx)
```

with the input data t∈[a,b]. Guesses are needed for the following values: z=z(x(t))∈ℝᵈ and

```
          ∂xᵢ
dmx(i) = ────────      (i=1,…,n)
          ∂tᵐ⁽ⁱ⁾
```

## return values

`sol` is a solution object which can be evaluated with the `evalSolution` functions. Or you can ask for the (final) grid of the solution with `getSolutionGrid`.

`retcode` can have to following values:

```
  >0: computation successful
   0: collocation matrix is singular
  -1: the expected no. of subintervals exceeds storage
      (try to increase `OPT_MAXSUBINTERVALS`)
  -2: the nonlinear iteration has not converged
  -3: there is an input data error
```

In `opt` the following options are used:

<table>
<tr><th><pre>  Option OPT&#95;&#8230;
</pre></th>
<th><pre> Description
</pre></th>
<th><pre> Default
</pre></th>
</tr>
<tr><td><pre> BVPCLASS
</pre></td>
<td><pre> boundary value problem classification&#58;
 0&#58; linear
 1&#58; nonlinear and regular
 2&#58; nonlinear and &#34;extra sensitive&#34;
    &#40;first relax factor is rstart and the
    nonlinear iteration does not rely
    on past convergence&#41;
 3&#58; fail&#45;early&#58; return immediately upon
    &#40;a&#41; two successive non&#45;convergences
        or
    &#40;b&#41; after obtaining an error estimate
        for the first time
</pre></td>
<td><pre>       1
</pre></td>
</tr>
<tr><td><pre> RTOL
</pre></td>
<td><pre> relative &#42;and&#42; absolute accuracy for
 solution&#46; Must be a vector of length d&#46;
 If a scalar is given &#40;like the default
 value of 1e&#45;6&#41; then the vector
    RTOL&#42;ones&#40;Float64&#44; d&#41;
 is generated&#46;
 Some entries can be NaN&#33; If an entry
 is NaN&#44; then no error checking is done
 for this component&#46;
</pre></td>
<td><pre>    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> COLLOCATIONPTS
</pre></td>
<td><pre> number &#40;&#61;k&#41; of collocation points per
 sub&#45;interval&#46;
 Requirement&#58;
   orders&#91;i&#93; &#8804; k &#8804; 7
 Default&#58;
   k &#61; max&#40; max&#40;orders&#41;&#43;1&#44; 5&#45;max&#40;orders&#41; &#41;
</pre></td>
<td><pre> see left
</pre></td>
</tr>
<tr><td><pre> SUBINTERVALS
</pre></td>
<td><pre> Either a positive integer scalar or a
 vector of &#40;Float&#41;&#45;times&#58;
 &#40;a&#41; scalar&#58; use a &#34;uniform&#45;like&#34; initial
 grid with the given integer as number
 of subintervals&#46;
 Why &#34;uniform&#45;like&#34; and not &#34;uniform&#34;&#63;
 Because all values of &#950; and all values of
 OPT&#95;ADDGRIDPOINTS have to be in the grid&#46;
 If the scalar is too small for all this
 values it is increased &#40;internally&#41;&#46;
 &#40;b&#41; vector&#58; all points must be inside
 the interval &#40;a&#44;b&#41;&#46; Then this points
 are used as initial grid&#46; Values of &#950;&#44;
 OPT&#95;ADDGRIDPOINTS and a and b are added
 automatically by this interface&#46;
 If the guess is an solution object&#44;
 then this grid saved there is used
 &#40;and not the values given in
 &#96;OPT&#95;SUBINTERVALS&#96;&#41;&#46;
</pre></td>
<td><pre>       5
</pre></td>
</tr>
<tr><td><pre> FREEZEINTERVALS
</pre></td>
<td><pre> Only used if OPT&#95;SUBINTERVALS is a
 vector&#46; In this case this flags indicates
 if colnew is allowed to adaptively
 change the grid&#46;
 If true&#44; all grid adaption is turned off
 and no mesh selection is done&#46;
</pre></td>
<td><pre>   false
</pre></td>
</tr>
<tr><td><pre> MAXSUBINTERVALS
</pre></td>
<td><pre> number of maximal subintervals&#46;
</pre></td>
<td><pre>      50
</pre></td>
</tr>
<tr><td><pre> COARSEGUESSGRID
</pre></td>
<td><pre> If &#96;guess&#96; is an solution obtained by a
 former call of &#96;colnew&#96;&#44; then this
 solution is taken as guess&#44; and the mesh
 provided by this solution is taken twice
 as coarse&#46;
</pre></td>
<td><pre>    true
</pre></td>
</tr>
<tr><td><pre> DIAGNOSTICOUTPUT
</pre></td>
<td><pre> diagnostic output for colnew&#58;
   &#45;1 &#58; full diagnostic printout
    0 &#58; selected printout
    1 &#58; no printout
</pre></td>
<td><pre>       1
</pre></td>
</tr>
<tr><td><pre> ADDGRIDPOINTS
</pre></td>
<td><pre> additional points that are always added
 to every &#40;time&#45;&#41;grid&#46;
 Every grid contains all values in &#950; and
 the values in the interval argument&#46;
</pre></td>
<td><pre>      &#91;&#93;
</pre></td>
</tr>
</table>



# bvpm2

# Bvpm2 object for solving boundary value problems

This is the Julia part of the BVP*M-2 (Fortran-)solution object. For (nearly) all the operations the corresponding Fortran-Proxy methods are called (call `help*bvpm2_proxy()` to get internal details).

## Boundary value problem (BVP)

BVPs of the following form are considered:

```
              1
  y'(x) =  ─────── Sy + f(x, y, p)         for a ≤ x ≤ b   [ODEs]
            x - a


  ga(y(a), p) = 0,     gb(y(b), p) = 0                     [BCs]
```

  * y(x) ∈ ℝᵈ and `d` is also called `no_odes` (the number of ordinary differential equations).
  * S ∈ ℝᵈˣᵈ is an optional constant matrix (also called the singularity term) because the whole term S⋅y/(x-a) has a singularity at x=a. If S is not given, then the ODEs are reduced to y'(x) = f(x, y, p).
  * p ∈ ℝᵐ (with 0≤m) are unknown parameters of the problem. `m` is also called `no_par` (the number of parameters).
  * f(x, y, p) ∈ ℝᵈ is also called the right-hand side (of the ODEs).
  * ga(ya, p) ∈ ℝˡ describes the left boundary conditions. `l` is also called `no_left_bc` (the number of the BCs at x=a).
  * ga(yb, p) ∈ ℝⁿ describes the right boundary conditions. It is

    ```
      n = d + m - l
      n = no_odes + no_par - no_left_bc
    ```

## Initial guess and solutions

A Bvpm2 object can be used to represent either an initial guess (for a BVP like above) or a solution. It is possible to use a solution of a (different) BVP as initial guess to another BVP.

Such a Bvpm2 object can be in one of the following states:

  * `state==0`: object created (and connected to Fortran-object), but not initialized, i.e. it does neither represent a guess nor an solution.
  * `state==1`: object created, and initialized with an (initial) guess, i.e. the object represents a guess.
  * `state==2`: object created and a solution was calculated successfully and saved in the object, i.e. the object represents a solution.
  * `state==-1`: object is not connected to a Fortran-Proxy. Either `bvpm2_destroy` was called or at creation time, the connection to the  Fortran-Proxy couldn't be established, i.e. the object is unusable and  all associated memory was deallocated.

The following table shows possible actions and the state-transitions initiated by the actions.

<table>
<tr><th><pre> Action&#47;Function
</pre></th>
<th><pre> Description
</pre></th>
<th><pre>state before
</pre></th>
<th><pre>state after
</pre></th>
</tr>
<tr><td><pre> Bvpm2&#40;&#41;
</pre></td>
<td><pre> create object
</pre></td>
<td><pre>    &#45;&#45;&#45;
</pre></td>
<td><pre>     0
</pre></td>
</tr>
<tr><td><pre> bvpm2&#95;init
</pre></td>
<td><pre> initialize object with
 initial guess&#44; etc&#46;
</pre></td>
<td><pre>     0
</pre></td>
<td><pre>     1
</pre></td>
</tr>
<tr><td><pre> bvpm2&#95;show&#95;details
</pre></td>
<td><pre> show some details of
 &#40;Fortran&#45;&#41;BVP&#95;M&#45;2 sol
 object
</pre></td>
<td><pre> 0&#44; 1&#44; or 2
</pre></td>
<td><pre> not changed
</pre></td>
</tr>
<tr><td><pre> bvpm2&#95;get&#95;details
</pre></td>
<td><pre> get dict with some details
 of the Bvpm2 object&#58;
 e&#46;g&#46; state&#44; number of pts
 in current grid &#46;&#46;&#46;
</pre></td>
<td><pre> &#45;1&#44; 0&#44; 1&#44;
   or 2
</pre></td>
<td><pre> not changed
</pre></td>
</tr>
<tr><td><pre> bvpm2&#95;get&#95;x
</pre></td>
<td><pre> return current grid of
 the object&#46;
</pre></td>
<td><pre> 1&#44; or 2
</pre></td>
<td><pre> not changed
</pre></td>
</tr>
<tr><td><pre> bvpm2&#95;get&#95;params
</pre></td>
<td><pre> return current values of
 estimated&#47;calculated
 parameters
</pre></td>
<td><pre> 1&#44; or 2
</pre></td>
<td><pre> not changed
</pre></td>
</tr>
<tr><td><pre> bvpm2&#95;terminate
</pre></td>
<td><pre> throw away all data and
 information&#46; Bring to
 state 0&#46;
</pre></td>
<td><pre> 0&#44; 1&#44; or 2
</pre></td>
<td><pre>      0
</pre></td>
</tr>
<tr><td><pre> bvpm2&#95;destroy
</pre></td>
<td><pre> deallocate all &#40;Fortran&#45;&#41;
 resources for this object&#46;
</pre></td>
<td><pre> &#45;1&#44; 0&#44; 1&#44;
   or 2
</pre></td>
<td><pre>     &#45;1
</pre></td>
</tr>
</table>

There are functions that take an Bvpm2-object `obj_in` as input, perhaps change `obj_in` and create an additonal `obj_out`.

The following table shows possible actions, the change of the state of `obj_in` and which `obj_out` object is created:

<table>
<tr><th><pre> Action&#47;Function
</pre></th>
<th><pre> Description
</pre></th>
<th><pre>obj&#95;in state
 from &#45;&#62; to
</pre></th>
<th><pre>  state of
   obj&#95;out
</pre></th>
</tr>
<tr><td><pre> bvpm2&#95;solve
</pre></td>
<td><pre> take obj&#95;in as guess&#46; Do
 not change obj&#95;in&#46;
 Produces obj&#95;out object
 representing the solution&#46;
</pre></td>
<td><pre> not changed
</pre></td>
<td><pre> 0&#58; no
    success
 2&#58; success
</pre></td>
</tr>
<tr><td><pre> bvpm2&#95;copy
</pre></td>
<td><pre> create deep copy of
 obj&#95;in
</pre></td>
<td><pre> not changed
</pre></td>
<td><pre> same as
 obj&#95;in
</pre></td>
</tr>
<tr><td><pre> bvpm2&#95;extend
</pre></td>
<td><pre> extend solution to new
 interval as new  guess&#46;
 obj&#95;in will be terminated
 and will be in state 0&#46;
 Call bvpm2&#95;copy before&#44; if
 you need the solution
 later on&#46;
</pre></td>
<td><pre>  2 &#45;&#62; 0
</pre></td>
<td><pre>    1
</pre></td>
</tr>
</table>



```
 function Bvpm2(handle::Ptr{Cvoid})
```

create bvpm2 object from given handle.



```
 function Bvpm2()
```

creates bvpm2 object.



```
 function bvpm2_init(obj::Bvpm2,
   no_odes, no_left_bc, x_grid::Vector, constant_guess::Vector,
   parameters::Vector=[], max_num_subintervals=3000)
```

initialize Bvpm2 object with a constant intial guess.



```
 function bvpm2_init(obj::Bvpm2,
   no_odes, no_left_bc, x_grid::Vector, guess::Matrix,
   parameters::Vector=[], max_num_subintervals=3000)
```

initialize Bvpm2 object with a guess for every state at every node in x_grid.



```
 function bvpm2_init(obj, no_odes, no_left_bc, x_grid,
                     guess<:Function, parameters,
                     max_num_subintervals=3000)
```

The guess function must have the form

```
 function guess(x,y)
```

where inside the function the guess for position x has to be stored in y.

initialize Bvpm2 object where the function `guess` is used to get the guesses for the state at different `x` values.



```
 function bvpm2_solve(guess_obj::Bvpm2, rhs, bc,
   opt::AbstractOptionsODE) -> (obj_out, retcode, stats)
```

## Right-hand side for the ODEs: `rhs`

The function `rhs` must have the form:

```
 function rhs(x, y, f)              [no_par == 0]
 function rhs(x, y, p, f)           [no_par != 0]
```

where

```
  x::Float, y::Vector{Float64}(no_odes), p::Vector{Float64}(no_par)
  f::Vector{Float64}(no_odes)
```

Inside the function, the values of the right-hand side must be saved in `f`.

## Derivatives of right-hand side: `Drhs`

The function `Drhs` is optional. If not given finite differences are used to approximate the derivatives. If `Drhs` is given it must have the form:

```
 function Drhs(x, y, dfdy)          [no_par == 0]
 function Drhs(x, y, p, dfdy, dfdp) [no_par != 0]
```

where

```
  x::Float, y::Vector{Float64}(no_odes), p::Vector{Float64}(no_par)
  dfdy::Matrix{Float64}(no_odes, no_odes)
  dfdp::Matrix{Float64}(no_odes, no_par)
```

Inside the function, the values of the derivatives must be saved in `dfdy` and `dfdp`.

## Boundary conditions: `bc`

The function `bc` must have the form:

```
 function bc(ya, yb, bca, bcb)      [no_par == 0]
 function bc(ya, yb, p, bca, bcb)   [no_par != 0]
```

where

```
  ya::Vector{Float64}(no_odes), yb::Vector{Float64}(no_odes),
  p::Vector{Float64}(no_par),
  bca::Vector{Float64}(no_left_bc),
  bcb::Vector{Float64}(no_odes - no_left_bc)
```

Inside the function, the values of the boundary conditions must be saved in `bca` and `bcb`.

## Derivatives of the boundary conditons: `Dbc`

The function `Dbc` is optional. If not given finite differences are used to approximate the derivatives. If `Dbc` is given it must have the form:

```
 function Dbc(ya, yb, dya, dyb)                 [no_par == 0]
 function Dbc(ya, yb, dya, dyb, p, dpa, dpb)    [no_par != 0]
```

where

```
  ya::Vector{Float64}(no_odes), yb::Vector{Float64}(no_odes),
  p::Vector{Float64}(no_par),
  dya::Matrix{Float64}(no_left_bc, no_odes)
  dyb::Matrix{Float64}(no_odes+no_par-no_left_bc, no_odes)
  dpa::Matrix{Float64}(no_left_bc, no_par)
  dpb::Matrix{Float64}(no_odes+no_par-no_left_bc, no_par)
```

Inside the function, the values of the derivatives of the boundary conditions must be saved in `dya`, `dyb`, `dpa` and `dpb`.

## Options `opt`

In `opt` the following options are used:

<table>
<tr><th><pre>  Option OPT&#95;&#8230;
</pre></th>
<th><pre> Description
</pre></th>
<th><pre> Default
</pre></th>
</tr>
<tr><td><pre> RTOL
</pre></td>
<td><pre> relative accuracy for solution&#46;
 solution&#46; Must be a scalar&#46;
</pre></td>
<td><pre>    1e&#45;6
</pre></td>
</tr>
<tr><td><pre> METHODCHOICE
</pre></td>
<td><pre> Choice for IVP&#45;solvers&#58;
 2&#58; Runge&#45;Kutta method of order 2
 4&#58; Runge&#45;Kutta method of order 4
 6&#58; Runge&#45;Kutta method of order 6
</pre></td>
<td><pre>       4
</pre></td>
</tr>
<tr><td><pre> DIAGNOSTICOUTPUT
</pre></td>
<td><pre> diagnostic output for bvpm2&#58;
   &#45;1 &#58; no output
    0 &#58; only output if computation fails
    1 &#58; intermediate output
    2 &#58; full output
</pre></td>
<td><pre>      &#45;1
</pre></td>
</tr>
<tr><td><pre> ERRORCONTROL
</pre></td>
<td><pre> determines the error&#45;estimation for
 which RTOL is used&#58;
    1 &#58; defect
    2 &#58; global error
    3 &#58; defect and then global error
    4 &#58; linear combination of defect
        and global error
</pre></td>
<td><pre>       1
</pre></td>
</tr>
<tr><td><pre> SINGULARTERM
</pre></td>
<td><pre> either nothing if the ODEs have no
 singular terms at the left boundary or
 a constant &#40;d&#44;d&#41; matrix for the
 singular term&#46;
</pre></td>
<td><pre> nothing
</pre></td>
</tr>
</table>

## Return-Code `retcode`

`retcode` can have to following values:

```
  <0: failure
  ≥0: computation successful
```

[ This file was auto-generated from the module's documentation included in the doc-strings. Use julia's help system to get these information in a nicer output format. ]

## Calling the Solvers

There are two ways of calling the solvers.

1. A calling convention close to the original Fortran-call, trying to provide/expose all the features the Fortran-codes have.
2. A simplified version, closer to odecalls like in MATLAB.

### The full-featured calling-method

All ODE-solvers have the same calling convention:

```
(t,x,retcode,stats) =
    odesolver(rhs, t0::Real, T::Real,
              x0::Vector, opt::AbstractOptionsODErhs)

function rhs(t::Float64,x::Vector{Float64}) -> Vector{Float64}
    if OPT_RHS_CALLMODE == RHS_CALL_RETURNS_ARRAY

function rhs(t::Float64,x::Vector{Float64},dx::Vector{Float64})
    if OPT_RHS_CALLMODE == RHS_CALL_INSITU
```

The input arguments are:

1. a julia function `rhs` for evaluating the right-hand side of the ODE, see below. It's OK to return something, that `convert` can transform to a `Vector{Float64}`.
2. the initial time `t0`. `(t0,x0)` is the initial value of the initial value problem.
3. the final time `T`.
4. the initial state `x0`. `(t0,x0)` is the initial value of the initial value problem.
5. further parameters/options in `opt` for the solver and for the interface. There is a separate section for the explanation of the options, see help_options.

The output arguments are:

1. `t` the *last* time for which the solution has been computed (if the whole computation was successful, then `t==T`)
2. `x` the numerical solation at time `t`
3. `retcode` the return code of the solver (interpretation is solver dependent)

There are two possible ways to provide the Julia right-hand side:

```
function rhs(t::Float64,x::Vector{Float64}) -> Vector{Float64}
```

This is used, if `OPT_RHS_CALLMODE == RHS_CALL_RETURNS_ARRAY`. So you can use anonymous functions like `(t,x) -> x` as right-hand sides. But this form has a price: every time the right-hand side is called, a temporary Array is created (the result). The form

```
function rhs(t::Float64,x::Vector{Float64},dx::Vector{Float64})
             -> nothing
```

used if `OPT_RHS_CALLMODE == RHS_CALL_INSITU` does not have this problem. But the right-hand side must be a function filling in the values of `x'` in `dx`.

### The simplified version

There is a simplified calling convention (using the methods above) to provide a method like odecalls in MATLAB, see `odecall`.




```
function odecall(solver, rhs, t::Vector, x0::Vector,
                opt::AbstractOptionsODE)
    -> (tVec,xVec,retcode,stats)
```

Calls `solver` with the given right-hand side `rhs`. There are two cases:

1. `2==length(t)`
2. `2<length(t)`

If `2==length(t)`, then in the output `tVec` consists of the time points the (adaptive) solver has automatically chosen. And the `xVec` has the states at this times. So: `tVec` is a `Vector{Float64}(m)` and `xVec` is a `Array{Float64}(m,length(x0))`.

If `2<length(t)`, then the values in `t` must be strictly ascending or strictly descending. Then a special output function is used to get the numerical solution at the given `t`-values. In this case `tVec` is a `Vector{Float64}(length(t))` and `xVec` is a `Array{Float64}(length(t),length(x0))`.

If in `opt` a output function is given, then this output function is also called/used.

[ This file was auto-generated from the module's documentation included in the doc-strings. Use julia's help system to get these informations in a nicer output format. ]

## The `opt` Argument: the Options

All options are handled by `OptionsODE`. See `OptionsODE` how to query, set and change options.

There are the following classes of options.

1. Options for this ODEInterface (common for all solvers)
2. Options for the ODE solvers

### Options of this ODEInterface

  * `OPT_RHS_CALLMODE`: There are two possible ways to call the Julia right-hand side: `RHS_CALL_RETURNS_ARRAY` and `RHS_CALL_INSITU`, see `help_callsolvers` for an explanation. difference.
  * `OPT_LOGIO`: This option sets the `IO` that is used for logging messages
  * `OPT_LOGLEVEL`: This is a bitmask for activating different logging messages. The following bitmasks are available.

    ```
       LOG_NOTHING     log nothing
       LOG_GENERAL     log some general information,
                       especially the main julia call of the solver
       LOG_RHS         log all calls of the right-hand side
       LOG_SOLVERARGS  log the arguments for the C-/Fortran-calls
                       before and after the call
       LOG_OUTPUTFCN   log calls of the julia output function
       LOG_SOLOUT      log calls of the solution output routine
       LOG_EVALSOL     log calls of the eval_sol_fcn
       LOG_MASS        log call(s) of the mass function
       LOG_JAC         log calls of the jacobian function of RHS
       LOG_BC          log calls of the boundary condition function
       LOG_BVPIVPSOL   log (during boundary value problems) calls to
                       initial value solvers
       LOG_RHSDT       log calls of the right-hand side time-derivative
       LOG_JACBC       log calls of the jacobian of the boundary condition
       LOG_GUESS       log calls to the guess function
       LOG_ALL         all of the above
    ```

### Options for the solvers

Different solvers support different options. All the options a solver supports are listed in the help-command of the specific solver, e.g. `help_dopri5`.

To get an overview, what options are supported by what solvers, call `ODEInterface.help_options()`.




## Solvers

1. bvpm2
2. bvpsol
3. colnew
4. ddeabm
5. ddebdf
6. dop853
7. dopri5
8. odex
9. radau
10. radau5
11. rodas
12. seulex

## Options used by Solvers

<table>
<tr><th><pre>        Option
</pre></th>
<th><pre> 1
</pre></th>
<th><pre> 2
</pre></th>
<th><pre> 3
</pre></th>
<th><pre> 4
</pre></th>
<th><pre> 5
</pre></th>
<th><pre> 6
</pre></th>
<th><pre> 7
</pre></th>
<th><pre> 8
</pre></th>
<th><pre> 9
</pre></th>
<th><pre>10
</pre></th>
<th><pre>11
</pre></th>
<th><pre>12
</pre></th>
</tr>
<tr><td><pre> OPT&#95;ADDGRIDPOINTS
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;ATOL
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;BVPCLASS
</pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;COARSEGUESSGRID
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;COLLOCATIONPTS
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;DENSEOUTPUTWOEE
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;DIAGNOSTICOUTPUT
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;DIMOFIND1VAR
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;DIMOFIND2VAR
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;DIMOFIND3VAR
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;EPS
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;ERRORCONTROL
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;FREEZEINTERVALS
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;FREEZESSLEFT
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;FREEZESSRIGHT
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;INITIALSS
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;INITSTAGES
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;INTERPOLDEGREE
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;IVPOPT
</pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;JACOBIBANDSTRUCT
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;JACOBIMATRIX
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;JACRECOMPFACTOR
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;LAMBDADENSE
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;M1
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;M2
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;MASSMATRIX
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;MAXEXCOLUMN
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;MAXNEWTONITER
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;MAXS
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;MAXSS
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;MAXSTABCHECKLINE
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;MAXSTABCHECKS
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;MAXSTAGES
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;MAXSTEPS
</pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;MAXSUBINTERVALS
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;METHODCHOICE
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;MINSTAGES
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;NEWTONSTARTZERO
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;NEWTONSTOPCRIT
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;ORDERDECFACTOR
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;ORDERDECFRAC
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;ORDERDECSTEPFAC1
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;ORDERDECSTEPFAC2
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;ORDERINCFACTOR
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;ORDERINCFRAC
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;OUTPUTATTIMES
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;OUTPUTFCN
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;OUTPUTMODE
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;RHO
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;RHO2
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;RHSAUTONOMOUS
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;RHSTIMEDERIV
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;RHS&#95;CALLMODE
</pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;RTOL
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;SINGULARTERM
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;SOLMETHOD
</pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;SSBETA
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;SSMAXSEL
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;SSMINSEL
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;SSREDUCTION
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;SSSELECTPAR1
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;SSSELECTPAR2
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;STEPSIZESEQUENCE
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;STEPSIZESTRATEGY
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;STEST
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;SUBINTERVALS
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;TRANSJTOH
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;TSTOP
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre> &#10004;
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
<tr><td><pre> OPT&#95;WORKFORDEC
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;WORKFORJAC
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;WORKFORRHS
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre> OPT&#95;WORKFORSOL
</pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre> &#10004;
</pre></td>
</tr>
<tr><td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
<td><pre></pre></td>
</tr>
</table>

```@meta
CurrentModule = ODEInterface
```

# ODEInterface.jl

`ODEInterface.jl` provides direct Julia wrappers around the supported Fortran
initial-value ODE solvers. `ODEInterfaceDiffEq.jl` adapts these wrappers to the
SciML `solve` interface; use this package directly when configuring the native
solver options and callback protocol.

```@docs
ODEInterface
```

## Initial-value solvers

Each solver accepts `rhs`, an initial and final time, an initial state, and an
`OptionsODE` object. The right-hand side below uses the default return-array
calling convention.

The names below are `public`, not exported, so bring in the ones you need
explicitly (or reach them as `ODEInterface.dopri5`).

```jldoctest
julia> using ODEInterface: OptionsODE, dopri5

julia> rhs(t, u) = u;

julia> t, u, retcode, stats = dopri5(rhs, 0.0, 1.0, [1.0], OptionsODE("example"));

julia> retcode
1
```

```@docs
OptionsODE
dopri5
dop853
odex
seulex
radau
radau5
rodas
ddeabm
ddebdf
```

## Callback protocol

These values configure the direct-wrapper callback protocol. They are primarily
useful to packages that adapt ODEInterface solvers to another solving API.

```@docs
RHS_CALL_INSITU
OUTPUTFCN_CALL_REASON
OUTPUTFCN_CALL_STEP
OUTPUTFCN_WODENSE
OUTPUTFCN_DENSE
OUTPUTFCN_RET_CONTINUE
OUTPUTFCN_RET_CONTINUE_XCHANGED
```

[ This file was auto-generated from the module's documentation included in the doc-strings. Use julia's help system to get these information in a nicer output format. ]

## Special Structure

Some solvers (e.g. radau5 and radau) supports ODEs with a "special structure". In this context an ODE has special structure if there exists M1>0 and M2>0 and M1 = M⋅M2 for some integer M and

```
             x'(k) = x(k+M2)   for all k = 1,…,M1            (*)
```

There are the options `OPT_M1` and `OPT_M2` to tell the solvers, if the ODE has this special structure. In this case only the non-trivial parts of the right-hand side, of the mass matrix and of the Jacobian matrix had to be supplied.

If an ODE has the special structure, then the right-hand side for `OPT_RHS_CALLMODE == RHS_CALL_RETURNS_ARRAY` has to return a vector of length d-M1 because the right-hand side for the first M1 entries are known from (*). For `OPT_RHS_CALLMODE == RHS_CALL_INSITU` the right-hand side gets (a reference) to the array of length d, but only the last d-M1 components need to be filled in.

The mass matrix has the form

```
     ⎛ 1    │    ⎞ ⎫
     ⎜  ⋱   │    ⎟ ⎪
     ⎜   ⋱  │    ⎟ ⎬ M1
     ⎜    ⋱ │    ⎟ ⎪
M =  ⎜     1│    ⎟ ⎭
     ⎜──────┼────⎟
     ⎜      │    ⎟ ⎫
     ⎜      │ M̃  ⎟ ⎬ d-M1
     ⎝      │    ⎠ ⎭
```

Then there has to be only the (d-M1)×(d-M1) matrix M̃ in `OPT_MASSMATRIX`. Of course, M̃ can be banded. Then `OPT_MASSMATRIX` is a `BandedMatrix` with lower bandwidth < d-M1.

If an ODE has the special structure, then the Jacobian matrix has the form

```
     ⎛0   1      ⎞ ⎫
     ⎜ ⋱   ⋱     ⎟ ⎪
     ⎜  ⋱   ⋱    ⎟ ⎬ M1
     ⎜   ⋱   ⋱   ⎟ ⎪
J =  ⎜    0   1  ⎟ ⎭
     ⎜───────────⎟
     ⎜           ⎟ ⎫
     ⎜      J̃    ⎟ ⎬ d-M1
     ⎝           ⎠ ⎭
```

Then there has to be only the (d-M1)×d matrix J̃ in `OPT_JACOBIMATRIX`. In this case banded Jacobian matrices are only supported for the case M1 + M2 == d. Then in this case J̃ is divided into d/M2 = 1+(M1/M2) blocks of the size M2×M2. All this blocks can be banded with a (common) lower bandwidth < M2.

The option `OPT_JACOBIBANDSTRUCT` is used to describe the banded structure of the Jacobian. It is eigher `nothing` if the Jacobian is full or a tuple `(l,u)` with the lower and upper bandwidth.

The function for providing the Jacobian for ∂f/∂x can have the following forms:

```
 function (t,x,J)       -> nothing       (A)
 function (t,x,J1,…,JK) -> nothing       (B)
```

The following table shows when `OPT_JACOBIMATRIX` has the form (A) and when it has the form (B):

<table>
<tr><th><pre></pre></th>
<th><pre> JACOBIBANDSTRUCT &#61;&#61; nothing
</pre></th>
<th><pre> JACOBIBANDSTRUCT &#61;&#61; &#40;l&#44;u&#41;
</pre></th>
</tr>
<tr><td><pre> M1&#61;&#61;0
</pre></td>
<td><pre> &#40;A&#41;&#44; J full&#44; size&#58; d&#215;d
</pre></td>
<td><pre> &#40;A&#41; J &#40;l&#44;u&#41;&#45;banded&#44; size d&#215;d
</pre></td>
</tr>
<tr><td><pre> M1&#62;0
</pre></td>
<td><pre> &#40;A&#41;&#44; J full&#44; size&#58; &#40;d&#45;M1&#41;&#215;d
</pre></td>
<td><pre> &#40;B&#41; J1&#44;&#8230;&#44;JK &#40;l&#44;u&#41;&#45;banded
     each with size M2&#215;M2 and
     K &#61; 1 &#43; M1&#47;M2
     M1 &#43; M2 &#61;&#61; d
</pre></td>
</tr>
</table>

[ This file was auto-generated from the module's documentation included in the doc-strings. Use julia's help system to get these informations in a nicer output format. ]

## `OPT_OUTPUTMODE`

This option determines if the `OPT_OUTPUTFCN` is called, and if dense output (the `eval_sol_fcn`) is prepared/supported.

  * `OUTPUTFCN_NEVER`: don't call the output function
  * `OUTPUTFCN_WODENSE`: call the output function, but `eval_sol_fcn` is not used
  * `OUTPUTFCN_DENSE`: call the output function and prepare `eval_sol_fcn`

## `OPT_OUTPUTFCN`

```
 function outputfcn(reason::OUTPUTFCN_CALL_REASON,
  told::Float64,t::Float64, x::Vector{Float64},eval_sol_fcn::Function,
  extra_data::Dict)  -> OUTPUTFCN_RETURN_VALUE
```

A (julia) function that is called

1. at beginning of the solution process with `reason == OUTPUTFCN_CALL_INIT`, `told=t0`, `t`=`T`, `x=x0`, `eval_sol_fcn` a dummy function throwing an error if called, `extra_data` a `Dict` persistent until the last call of the output function. The return value is *ignored*.
2. after every successfull integration step with `reason == OUTPUTFCN_CALL_STEP`, `[told,t]` the time interval of the last step, `x` the numerical solution at time `t`, `eval_sol_fcn` a function to evaluate the solution in `t1 ∊ [told,t]`, if requested by `OPT_OUTPUTMODE`, otherwise a call to this function will result in an error.
3. at the end (after the last step) with `reason == OUTPUTFCN_CALL_DONE`. The return value is *ignored*.

With `eval_sol_fcn`

```
    function eval_sol_fcn(t1::Float64) -> Vector{Float64}
```

the numerical solution can be evaluted in the time interval `[told,t]` (if `OPT_OUTPUTMODE == OUTPUTFCN_DENSE`).

If supported by the solver, the numerical solution may be changed in the `outputfcn` (if `reason == OUTPUTFCN_CALL_STEP`) and the solver continues the process with the changed solution. The return value `OUTPUTFCN_RET_CONTINUE_XCHANGED` indicates this. `OUTPUTFCN_RET_CONTINUE` tells the solver to continue (without changes in `x`) and `OUTPUTFCN_RET_STOP` tells the solver to stop the solver.
